REM Program: Hex Editor v8.0a r7.0a Main Module PD 2017.
REM Author: Erik Jon Oredson
REM Release: 11/08/2017
REM Status: Public Domain
REM Email: eoredson@gmail.com
REM Urls: www.filegate.net

REM v8.0a r1.0a
REM   Initial port to 32-bit.

REM v8.0a r2.0a updates 04/14/2016:
REM   Edited misspelled NETPATHEXISTS.
REM   Removed Control-Break Inkey$ checking.
REM   Fixes Delete/Insert for RMDIR/MKDIR in DirBox.
REM   Replaces all Shells to DIR with FindFile functions.
REM   Replace Shell to VOL with GetVolumeInformation function.
REM   Modify command line for temp directory creation override.

REM v8.0a r3.0a updates 05/17/2016:
REM   Adds [DRIVETYPE] to DriveType.
REM   Prepends 0 to some .0 B display.
REM   Fixes RETURN in SUB ExcludeList.
REM   Adds call to DisplayCriticalError to Error.Routine
REM   Reformats some hexidecimal display outputs.
REM   No longer ignores floppy drive list in file menu box.

REM v8.0a r3.0a updates 05/25/2016:
REM   Forces only directory in dir box in file menu box to a '.' when
REM    cdrom drive exists but has no media loaded.
REM   Displays drive does not exist when removable drive other than
REM    cdrom has no media.
REM   Repairs left mouse button click in DropDownMenu/ViewFiles
REM    for outside of menu box.
REM   Adds MouseWheel/MouseButtons to FileMenuBoxMove/FileMenuBoxHelp.

REM v8.0a r4.0a updates 06/20/2016:
REM   Traps Ctrl-E character in FileMenuBox.
REM   Restores background color in CriticalErrorTrap.
REM   Adds missing declaration to MouseTime variable.
REM   Fixes timing of call to _EXIT function.
REM   Adds 1.2 second delay to ctrl-c for break trap.
REM   Changes some single precision values to 1,048,576.
REM   Adds FILELISTEXISTS function.

REM v8.0a r5.0a updates 02/24/2017:
REM   Replaces all GetModuleFilename with _CWD$
REM   Forces default directory to StartDir$
REM   Fixes mouse coordinate before mouse button.
REM   Changes print from LPT to LPRINT.
REM   Replaces MKDIR/RMDIR/KILL with library calls.

REM v8.0a r6.0a updates 07/12/2017:
REM   Replaces shell to screensaver to internal library call.
REM   Repairs parameter call to CreateDirectory.

REM v8.0a r7.0a updates 11/08/2017:
REM   Loads filenames with ? characters in them.
REM   Adds insert to createfile in filebox in file menu box.
REM   Now recursively deletes directory in delete in dirbox in file menu box.
REM   Replaces all KILL with DeleteFileA.

' initialize all default variables as integer.
DEFINT A-Z

' load all arrays during runtime.
REM $DYNAMIC

' declare multiple file structure.
TYPE FileType
    AsciiValue AS INTEGER
    ASCIIZ AS STRING * 260
    Buffer AS STRING * 1
    CopyPositionEnd AS DOUBLE
    CopyPositionPivot AS DOUBLE
    CopyPositionStart AS DOUBLE
    CurrentMarker AS SINGLE
    CurrentUndo AS SINGLE
    CurrentWindow2 AS INTEGER
    Filename AS STRING * 12
    FileAttribute AS INTEGER
    FileByte AS STRING * 1
    FileDisplay AS INTEGER
    FileLength AS DOUBLE
    FileLocked AS INTEGER
    FilePage AS DOUBLE
    FilePosition AS DOUBLE
    Handle AS INTEGER
    MarkerCount AS SINGLE
    Netpath AS STRING * 260
    PageColumn AS DOUBLE
    PageRow AS DOUBLE
    ScreenRow AS INTEGER
    ShortFilename AS STRING * 260
    StoreSearchString AS STRING * 260
END TYPE

' declare windows filename/directory structure.
TYPE WinFileType
    Name AS STRING * 260 ' asciiz
END TYPE

' declare marker filename structure.
TYPE MarkerFileType
    Markers1 AS STRING * 72
END TYPE

' declare byte undo filename structure.
TYPE UndoFileType
    UndoByte1 AS STRING * 18
    UndoPosition1 AS STRING * 72
END TYPE

' declare multi array process filenames.
DIM SHARED MultiFilename1(1 TO 9) AS STRING
DIM SHARED MultiFilenames(1 TO 9) AS STRING

' declare undo structure.
DIM SHARED UndoFile AS UndoFileType

' declare undo variables.
DIM SHARED CurrentUndo AS SINGLE, UndoToggle AS INTEGER

' declare marker structure.
DIM SHARED MarkerFile AS MarkerFileType

' declare marker variables.
DIM SHARED CurrentMarker AS SINGLE, NewMarker AS SINGLE
DIM SHARED MarkerCount AS SINGLE, MarkerPosition AS SINGLE

' declare menu area storage arrays.
DIM SHARED Area1(24, 44) AS INTEGER, Area2(24, 44) AS INTEGER

' declare ascii character variables.
DIM SHARED Hline AS INTEGER, Vline AS INTEGER
DIM SHARED ULcorner AS INTEGER, URcorner AS INTEGER
DIM SHARED LLcorner AS INTEGER, LRcorner AS INTEGER

' declare temporary file position variables.
DIM SHARED FileDisplay AS INTEGER, FileDisplay2 AS INTEGER
DIM SHARED FileDisplayX AS INTEGER, ScreenRowX AS INTEGER
DIM SHARED Low AS DOUBLE, High AS DOUBLE, HeapSortOff AS INTEGER
DIM SHARED TempPosition AS DOUBLE, TempPosition1 AS DOUBLE
DIM SHARED TempPosition2 AS DOUBLE, TempPosition3 AS DOUBLE
DIM SHARED TempFiles(1 TO 9) AS STRING

' declare files/dirs maximum variables.
DIM SHARED SortMax AS SINGLE, SortMax2 AS SINGLE

' declare common program variables.
DIM SHARED AsciiValue AS INTEGER, AsciiValue2 AS INTEGER
DIM SHARED ASCIIValue3 AS DOUBLE, HexValue AS DOUBLE
DIM SHARED CurrentWindow AS INTEGER, CurrentWindow2 AS INTEGER
DIM SHARED PageColumn AS DOUBLE, PageRow AS DOUBLE
DIM SHARED ScreenDrawn AS INTEGER, ScreenRow AS INTEGER
DIM SHARED StatusMessage AS STRING, SupportedCall AS INTEGER

' declare common validity check variables.
DIM SHARED AllowWildCard AS INTEGER
DIM SHARED ValidFunction AS INTEGER, ValidASCIIValue AS INTEGER
DIM SHARED ValidString AS INTEGER, ValidHexValue AS INTEGER
DIM SHARED ValidByteString AS INTEGER, NumBytes AS INTEGER

' declare filename/file position variables.
DIM SHARED BlockByte AS STRING * 32767, Column AS DOUBLE
DIM SHARED Column2 AS DOUBLE, DumpFile AS STRING, ExcludeFile AS STRING
DIM SHARED FileDumped AS INTEGER, Filename AS STRING
DIM SHARED FileByte AS STRING * 1, FileBytePosition AS DOUBLE
DIM SHARED FileLength AS DOUBLE, FilePage AS DOUBLE
DIM SHARED FilePosition AS DOUBLE, FilePosition2 AS DOUBLE
DIM SHARED FirstByte AS DOUBLE, FilePage2 AS DOUBLE
DIM SHARED LastByte AS DOUBLE, LastPage AS DOUBLE
DIM SHARED NewByte AS DOUBLE, NextByte AS DOUBLE
DIM SHARED NextLine AS DOUBLE, NextPage AS DOUBLE
DIM SHARED NewPosition AS DOUBLE, NewPosition2 AS DOUBLE
DIM SHARED PageColumn2 AS DOUBLE, PageRow2 AS DOUBLE
DIM SHARED SeekPosition AS DOUBLE, SeekPosition2 AS DOUBLE
DIM SHARED ShortFilename AS STRING, StorePosition AS DOUBLE

' declare file search position variables.
DIM SHARED SearchBytePosition AS DOUBLE, StoreNumBytes AS INTEGER
DIM SHARED StoreSearchPosition AS DOUBLE, StoreSearchString AS STRING
DIM SHARED StoreSearchMulti AS INTEGER

' declare all long filename common variables.
DIM SHARED ASCIIZ AS STRING * 260, ASCIIZ2 AS STRING * 260
DIM SHARED Buffer AS STRING * 1, ConfigFile AS STRING
DIM SHARED Directory.ASCIIZ AS STRING, ErrorTrap AS INTEGER
DIM SHARED FileAttribute AS INTEGER, FileLocked AS INTEGER
DIM SHARED FileDateTime AS STRING, FileSwitch AS INTEGER
DIM SHARED FileSize AS DOUBLE, FileSizeType AS INTEGER
DIM SHARED Handle AS INTEGER, QuietSwitch AS INTEGER
DIM SHARED Quote AS STRING, Windows.Detected AS INTEGER
DIM SHARED Write.Error AS INTEGER, Node AS INTEGER

' declare all common mouse variables.
DIM SHARED MouseX AS INTEGER, MouseY AS INTEGER
DIM SHARED MouseButton1 AS INTEGER, MouseButton2 AS INTEGER
DIM SHARED MouseButton3 AS INTEGER, MouseWheel AS INTEGER
DIM SHARED Reset1 AS INTEGER, Time1 AS SINGLE, MouseTime AS SINGLE
DIM SHARED WheelReverse AS INTEGER

' declare filename variables for file menu box.
DIM SHARED Ambiguate AS INTEGER, AmbiguateSwitch AS INTEGER
DIM SHARED Attribute AS INTEGER, ASCIIZ3 AS STRING * 260
DIM SHARED Current.Drive AS INTEGER, Drive.Box.Line AS INTEGER
DIM SHARED Default.Drive AS INTEGER, Last.Drive AS INTEGER
DIM SHARED Num.Dirs AS SINGLE, Num.Files AS SINGLE

' declare Alt-n keys array.
DIM SHARED Keys(1 TO 26) AS INTEGER

' declare filename sort variables for file menu box.
DIM SHARED FileSort AS INTEGER, DirSort AS INTEGER, Millisecond AS INTEGER

' declare requirement filename attribute bit variables for file menu box.
DIM SHARED RequireReadOnly AS INTEGER, RequireHidden AS INTEGER
DIM SHARED RequireSystem AS INTEGER, RequireArchive AS INTEGER

' declare requirement directory attribute bit variables for file menu box.
DIM SHARED RequireDirReadOnly AS INTEGER, RequireDirHidden AS INTEGER
DIM SHARED RequireDirSystem AS INTEGER, RequireDirArchive AS INTEGER

' declare sort structure for file menu box.
DIM SHARED WinFileStruc AS WinFileType

' declare menu screen location offsets for file menu box.
DIM SHARED Xcoor AS INTEGER, Ycoor AS INTEGER

' declare menu variables for DropDownMenu.
DIM SHARED CurrentMenu AS INTEGER, CurrentMenuSelection AS INTEGER

' declare variables for copy/paste.
DIM SHARED CopyByte AS STRING * 1, CopyStart AS DOUBLE
DIM SHARED CopyPositionEnd AS DOUBLE, CopyPositionPivot AS DOUBLE
DIM SHARED CopyPositionStart AS DOUBLE

' declare structure for multiple files.
DIM SHARED File(1 TO 9) AS FileType

' declare multiple file variables.
DIM SHARED CurrentFile AS INTEGER, NumberFiles AS INTEGER

' declare temp file share variables.
DIM SHARED Process.Number AS INTEGER
DIM SHARED Share.Count AS INTEGER ' count violations
DIM SHARED InErrorFlag AS INTEGER

' temp directory
DIM SHARED DRX AS STRING

' fast exit variable
DIM SHARED FastExit AS INTEGER

' declare color variables.
DIM SHARED Black AS INTEGER, Blue AS INTEGER, Cyan AS INTEGER
DIM SHARED Green AS INTEGER, Magenta AS INTEGER, Plain AS INTEGER
DIM SHARED Red AS INTEGER, White AS INTEGER, Yellow AS INTEGER
DIM SHARED BackGround AS INTEGER, BackGround2 AS INTEGER

' declare network path variables.
DIM SHARED CurrentNetPath AS STRING * 260, DefaultNetPath AS STRING * 260
DIM SHARED StartDir AS STRING

' internal debug variables.
DIM SHARED Debug AS INTEGER, Debug2 AS INTEGER, Debug3 AS INTEGER

' additional display purposes.
DIM SHARED DirLoadMessage AS STRING, FileLoadMessage AS STRING

' declare default printer port variable.
DIM SHARED PrinterPort AS INTEGER

' declare error variables.
DIM SHARED Check.Disk AS INTEGER
DIM SHARED Disk.Ready AS INTEGER

' allow unprintable characters.
DIM SHARED CharPrint AS INTEGER

' declare constants.
CONST Nul = ""
CONST False = 0
CONST SFalse = 0!
CONST DFalse = 0#
CONST True = -1

' declare author constants.
CONST Author$ = "Erik Jon Oredson"
CONST Email = "eoredson@gmail.com"
CONST Version = "v8.0a"
CONST Release = "r7.0a"
CONST Program = "Hex Editor"
CONST Publish = "11/08/2017"
CONST Status = "Public Domain"
CONST Urls = "www.filegate.net"

' declare maximum files/processes.
CONST MaxFiles = 9 ' should not be changed
CONST MaxProcesses = 9 ' should not be changed
CONST MaxViolations = 1024 ' maximum share violations

' declare maximum files/dirs values for file menu box.
CONST MaxPrecision = 1048576! ' maximum files/dirs
CONST MaxPrecision1 = 1024! ' maximum kilos of files/dirs
CONST MaxPrecision2 = 1! ' maximum megs of files/dirs

' declare library constants.
CONST MAX_PATH = 260
CONST INVALID_HANDLE_VALUE = -1

' declare library structures.
TYPE FILETIME
    dwLowDateTime AS _UNSIGNED LONG
    dwHighDateTime AS _UNSIGNED LONG
END TYPE

TYPE SYSTEMTIME
    wYear AS INTEGER
    wMonth AS INTEGER
    wDayOfWeek AS INTEGER
    wDay AS INTEGER
    wHour AS INTEGER
    wMinute AS INTEGER
    wSecond AS INTEGER
    wMilliseconds AS INTEGER
END TYPE

TYPE WIN32_FIND_DATA
    dwFileAttributes AS _UNSIGNED LONG
    ftCreationTime AS FILETIME
    ftLastAccessTime AS FILETIME
    ftLastWriteTime AS FILETIME
    nFileSizeHigh AS _UNSIGNED LONG
    nFileSizeLow AS _UNSIGNED LONG
    dwReserved0 AS _UNSIGNED LONG
    dwReserved1 AS _UNSIGNED LONG
    cFileName AS STRING * MAX_PATH
    cAlternateFileName AS STRING * 14
END TYPE

' declare external kernel libraries.
DECLARE DYNAMIC LIBRARY "kernel32"
    FUNCTION FindFirstFileA~%& (BYVAL lpFileName~%&, BYVAL lpFindFileData~%&)
    FUNCTION FindNextFileA& (BYVAL hFindFile~%&, BYVAL lpFindFileData~%&)
    FUNCTION FindClose& (BYVAL hFindFile~%&)
    FUNCTION FileTimeToSystemTime& (lpFileTime AS FILETIME, lpSystemTime AS SYSTEMTIME)
    FUNCTION GetVolumeInformationA& (lpRootPathName$, lpVolumeNameBuffer$, BYVAL nVolumeNameSize~&, lpVolumeSerialNumber~&, lpMaximumComponentLength~&, lpFileSystemFlags~&, lpFileSystemNameBuffer$, BYVAL nFileSystemNameSize&)

    FUNCTION DeleteFileA% (F$)
    FUNCTION RemoveDirectoryA% (F$)
    FUNCTION CreateDirectoryA% (F$, BYVAL X&&)
    FUNCTION SetCurrentDirectoryA% (f$)
    FUNCTION CloseHandle& (BYVAL hfile AS _OFFSET)
    FUNCTION GetLastError& ()
    FUNCTION FormatMessageA& (BYVAL f AS LONG, f$, BYVAL e AS LONG, BYVAL d AS LONG, g$, BYVAL s AS LONG, h$)
END DECLARE

' declare external libraries.
DECLARE LIBRARY
    FUNCTION CreateFile& (filename$, BYVAL access&, BYVAL sharing&, BYVAL sec_attr%&, BYVAL create&, BYVAL flags&, BYVAL template%&)
    FUNCTION GetFileAttributes& (f$)
    FUNCTION SetFileAttributes& (f$, BYVAL a&)
    FUNCTION GetDriveType& (d$)
    FUNCTION GetShortPathName& (InP$, OutP$, BYVAL length&)
END DECLARE

' declare external libraries.
DECLARE DYNAMIC LIBRARY "user32"
    FUNCTION SendMessageA%& (BYVAL hWnd%&, BYVAL Msg~&, BYVAL wParam~%&, BYVAL lParam%&)
END DECLARE

' declare screen saver call constants
CONST wm_syscommand = &H112&
CONST sc_screensave = &HF140&

' declare library variables.
DIM SHARED finddata AS WIN32_FIND_DATA, hfind AS _UNSIGNED _OFFSET
DIM SHARED SysTime AS SYSTEMTIME, DriveType AS STRING

' declare error trap.
ON ERROR GOTO Error.Routine

' scancodes for Alt-A to Alt-Z.
DATA 30,48,46,32,18,33,34,35,23,36
DATA 37,38,50,49,24,25,16,19,31,20
DATA 22,47,17,45,21,44

' read Alt-<key> data.
FOR Var = 1 TO 26
    READ Keys(Var)
NEXT

' force default path
x$ = _STARTDIR$
StartDir$ = x$
IF RIGHT$(StartDir$, 1) <> "\" THEN
    StartDir$ = StartDir$ + "\"
END IF
f$ = x$ + CHR$(0)
x = SetCurrentDirectoryA(f$)

' start timer trap.
ON TIMER(1) GOSUB Timer.Trap
TIMER ON
VarQ = _EXIT

' declare window title.
_TITLE "HEXEDIT"

' check command line node.
CommandLine$ = COMMAND$
IF LEFT$(CommandLine$, 1) = "/" THEN
    Var$ = MID$(CommandLine$, 2, 1)
    CommandLine$ = MID$(CommandLine$, 3)
    IF Var$ >= "1" AND Var$ <= "9" THEN
        Node = INT(VAL(Var$))
    END IF
END IF

' intialize some variables.
CALL InitVars

' initialize server name.
CALL StoreServerName

' read config file.
CALL ReadConfigFile(Filename)

' get current drive/directory.
CALL GetDrive(Drive.Number, Directory$)

' init undo/marker file.
CALL OpenUndoFile(VarQ)

' check bad filename.
IF VarQ THEN
    GOTO Error.Exit
END IF

' init paste file.
CALL InitializePaste(VarQ)

' check bad filename.
IF VarQ THEN
    GOTO Error.Exit
END IF

' reset menu filename flag.
IsMenuFile = False

' check startup config edit file.
IF Filename <> Nul THEN
    CommandLine$ = Filename
    GOTO StartFile
END IF

' check command line.
SELECT CASE COMMAND$
    CASE "/?", "-?"
        GOTO BootUsage
END SELECT

' check command line filename.
IF CommandLine$ <> Nul THEN
    GOTO StartFile
END IF

' filename entry starts here.
BeginFile:

' read information from file menu box.
CALL Menu(NetPath2$, Drive$, Directory$, FileSpec1$, FileSpec2$)

' store current menu box netpath.
NetPath$ = NetPath2$

' reset menu filename flag.
IsMenuFile = True

' check filename.
IF FileSpec2$ = Nul THEN
    ' verify a file open already.
    IF NumberFiles >= 1 THEN
        ASCIIZ = File(CurrentFile).ASCIIZ
        GOTO TopProgram
    END IF

    ' exit program.
    GOTO BootUsage
END IF

' construct filename from menu box.
IF NetPath$ = Nul THEN
    IF Directory$ = Nul THEN
        Filename = Drive$ + ":\" + FileSpec2$
    ELSE
        Filename = Drive$ + ":\" + Directory$ + "\" + FileSpec2$
    END IF
ELSE
    IF Directory$ = Nul THEN
        Filename = NetPath$ + "\" + FileSpec2$
    ELSE
        Filename = NetPath$ + "\" + Directory$ + "\" + FileSpec2$
    END IF
END IF

' store filename from menu box.
CommandLine$ = Filename

' filename entry loop starts here.
StartFile:

' start filename entry loop.
DO
    ' check filenames
    IF CommandLine$ = Nul THEN
        EXIT DO
    END IF

    ' get filename from command line.
    CommandLine$ = RTRIM$(CommandLine$)
    CommandLine$ = LTRIM$(CommandLine$)

    ' check menu filename returned.
    IF IsMenuFile THEN
        Filename = CommandLine$
        CommandLine$ = Nul
    END IF

    ' parse command line
    IF IsMenuFile = False THEN
        IF LEFT$(CommandLine$, 1) = Quote THEN
            Var = INSTR(2, CommandLine$, Quote)
            IF Var = False THEN
                GOTO BeginFile
            END IF
            Filename = LEFT$(CommandLine$, Var - 1)
            Filename = MID$(Filename, 2)
            IF Filename = Nul THEN
                GOTO BeginFile
            END IF
            CommandLine$ = MID$(CommandLine$, Var + 1)
        ELSE
            Var = INSTR(CommandLine$, " ")
            IF Var THEN
                Filename = LEFT$(CommandLine$, Var - 1)
                CommandLine$ = MID$(CommandLine$, Var + 1)
            ELSE
                Filename = CommandLine$
                CommandLine$ = Nul
            END IF
        END IF
    END IF

    ' trim filename.
    Filename = RTRIM$(Filename)
    Filename = LTRIM$(Filename)

    ' check long filename in quotes.
    IF LEFT$(Filename, 1) = Quote THEN
        IF RIGHT$(Filename, 1) = Quote THEN
            Filename = MID$(Filename, 2)
            Filename = LEFT$(Filename, LEN(Filename) - 1)
        END IF
    END IF

    ' check max files.
    IF NumberFiles = MaxFiles THEN
        EXIT DO
    END IF

    ' check filenames.
    Var3$ = Filename
    DO
        ' check multiple filenames.
        Var3 = INSTR(Var3$, CHR$(13))
        IF Var3 THEN
            Var$ = LEFT$(Var3$, Var3 - 1)
            Var3$ = MID$(Var3$, Var3 + 1)
        ELSE
            IF LEN(Var3$) THEN
                Var$ = Var3$
                Var3$ = Nul
            ELSE
                EXIT DO
            END IF
        END IF

        ' check filelist exists.
        Var4$ = FILELISTEXISTS(Var$)
        IF LEN(Var4$) THEN
            ' open filelist filename.
            Check.Disk = True
            Disk.Ready = False
            x2 = FREEFILE
            OPEN Var4$ FOR INPUT AS #x2
            Check.Disk = False
            IF Disk.Ready = False THEN

                ' read filelist files.
                DO UNTIL EOF(x2)
                    LINE INPUT #x2, Var$
                    Var$ = RTRIM$(Var$)
                    Var$ = LTRIM$(Var$)
                    IF LEN(Var$) THEN

                        ' check max files.
                        IF NumberFiles = MaxFiles THEN
                            EXIT DO
                        END IF

                        ' load file.
                        GOSUB LoadMultipleFile
                    END IF
                LOOP
                CLOSE #x2
            END IF
        ELSE
            ' load file.
            GOSUB LoadMultipleFile
        END IF
    LOOP
LOOP

' check files loaded.
IF NumberFiles = False THEN
    GOTO BeginFile
END IF

' main program loop starts here.
TopProgram:

' reset mouse activity.
CALL ClearMouse

' setup editing screen.
GOSUB RedrawScreen0
CALL LocateCursor2

' keyboard/mouse input loop starts here.
StartLoop:

' keyboard/mouse input loop.
DO
    ' check for keypress or mouse activity.
    CharInput$ = Nul
    DO
        _LIMIT 100
        ' store keyboard buffer.
        CharInput$ = INKEY$
        IF LEN(CharInput$) THEN
            EXIT DO
        END IF

        ' call mouse subroutine.
        Z = MouseDriver
        IF MouseWheel = -1 THEN
            IF WheelReverse THEN
                CharInput$ = CHR$(0) + CHR$(80) ' down
            ELSE
                CharInput$ = CHR$(0) + CHR$(72) ' up
            END IF
            MouseWheel = 0
            EXIT DO
        END IF
        IF MouseWheel = 1 THEN
            IF WheelReverse THEN
                CharInput$ = CHR$(0) + CHR$(72) ' up
            ELSE
                CharInput$ = CHR$(0) + CHR$(80) ' down
            END IF
            MouseWheel = 0
            EXIT DO
        END IF
        IF MouseButton1 THEN
            GOSUB MouseMove1
        ELSE
            IF MouseButton2 THEN
                GOSUB MouseMove2
            ELSE
                IF MouseButton3 THEN ' redraw screen
                    CALL MultiFileFunction(2)
                    GOSUB RedrawScreen0
                ELSE
                    IF MouseX OR MouseY THEN
                        GOSUB MoveMouse
                    END IF
                END IF
            END IF
        END IF
    LOOP
    CALL LocateCursor2

    ' get shift state.
    DEF SEG = &H40
    ShiftFlag = PEEK(&H17)
    DEF SEG

    ' store shift state.
    LeftShift = ShiftFlag AND 1 ' left shift.
    RightShift = ShiftFlag AND 2 ' right shift.

    ' check shift flags.
    IF LeftShift OR RightShift THEN
        ' parse the key.
        SELECT CASE LEN(CharInput$)
            CASE 1
                SELECT CASE ASC(CharInput$)
                    CASE 124 ' | FirstFile
                        GOSUB GotoFirstFile
                    CASE 35 ' # LastFile
                        GOSUB GotoLastFile
                    CASE 33 ' ! = display page/row/column.
                        GOSUB DisplayData1
                    CASE 34 ' " = display file path.
                        GOSUB DisplayPath
                    CASE 63 ' ? = display filelength\undos.
                        GOSUB DisplayInfo
                    CASE 123 ' { = display paste entries.
                        GOSUB DisplayPasteUndos
                    CASE 126 ' ~ = display last page\markers.
                        GOSUB DisplayLengths
                    CASE 8, 60 ' Backspace/< file left.
                        GOSUB GotoPreviousFile
                    CASE 62 ' > file right
                        GOSUB GotoNextFile
                    CASE 43 ' + = list range of markers.
                        IF FileLength THEN
                            CALL MultiFileFunction(2)
                            CALL Marker(1)
                            IF ValidFunction THEN
                                GOSUB RedrawScreen0
                            END IF
                        END IF
                        ' byte hilighting functions.
                    CASE 52 ' Shift-Left
                        IF FileLength THEN
                            CALL MouseButton1Drag(1)
                        END IF
                    CASE 54 ' Shift-Right
                        IF FileLength THEN
                            CALL MouseButton1Drag(2)
                        END IF
                    CASE 56 ' Shift-Up
                        IF FileLength THEN
                            CALL MouseButton1Drag(3)
                        END IF
                    CASE 50 ' Shift-Down
                        IF FileLength THEN
                            CALL MouseButton1Drag(4)
                        END IF
                    CASE 57 ' Shift-PageUp
                        IF FileLength THEN
                            CALL MouseButton1Drag(5)
                        END IF
                    CASE 51 ' Shift-PageDown
                        IF FileLength THEN
                            CALL MouseButton1Drag(6)
                        END IF
                    CASE 49 ' Shift-End
                        IF FileLength THEN
                            CALL MouseButton1Drag(7)
                        END IF
                    CASE 55 ' Shift-Home
                        IF FileLength THEN
                            CALL MouseButton1Drag(8)
                        END IF
                    CASE ELSE ' Unknown key.
                        GOSUB HelpLine
                END SELECT
            CASE 2
                SELECT CASE ASC(RIGHT$(CharInput$, 1))
                    CASE 15 ' Shift-Tab = Toggle window.
                        IF FileLength THEN
                            GOSUB TabWindow
                        END IF
                        ' byte hilighting functions.
                    CASE 75 ' Shift-Left
                        IF FileLength THEN
                            CALL MouseButton1Drag(1)
                        END IF
                    CASE 77 ' Shift-Right
                        IF FileLength THEN
                            CALL MouseButton1Drag(2)
                        END IF
                    CASE 72 ' Shift-Up
                        IF FileLength THEN
                            CALL MouseButton1Drag(3)
                        END IF
                    CASE 80 ' Shift-Down
                        IF FileLength THEN
                            CALL MouseButton1Drag(4)
                        END IF
                    CASE 73 ' Shift-PageUp
                        IF FileLength THEN
                            CALL MouseButton1Drag(5)
                        END IF
                    CASE 81 ' Shift-PageDown
                        IF FileLength THEN
                            CALL MouseButton1Drag(6)
                        END IF
                    CASE 79 ' Shift-End
                        IF FileLength THEN
                            CALL MouseButton1Drag(7)
                        END IF
                    CASE 71 ' Shift-Home
                        IF FileLength THEN
                            CALL MouseButton1Drag(8)
                        END IF
                    CASE ELSE ' Unknown key.
                        GOSUB HelpLine
                END SELECT
        END SELECT
    ELSE
        ' parse the key.
        SELECT CASE LEN(CharInput$)
            CASE 1 ' single ascii key.
                SELECT CASE ASC(CharInput$)
                    CASE 5 ' Control-E = TestError
                        IF Debug THEN
                            V = SQR(-1) ' test syntax error.
                        END IF
                    CASE 9 ' Tab = Toggle window.
                        IF FileLength THEN
                            GOSUB TabWindow
                        END IF
                    CASE 13 ' Enter = Change byte value.
                        IF FileLocked THEN
                            CALL DisplayX
                            CALL LockedFile
                        ELSE
                            IF FileLength = 0 THEN
                                Byte2 = 0
                                GOSUB AppendIt
                            END IF
                            IF FileLength THEN
                                GOSUB ChangeHexValue
                            END IF
                        END IF
                    CASE 27 ' Escape = Start drop down menu.
                        IF CurrentMenu <> 1 THEN
                            ' remove hilight menu tab.
                            Colorf2 White, 0
                            CALL DisplayTab(CurrentMenu)
                        END IF
                        CurrentMenu = 1
                        CurrentMenuSelection = 1
                        GOTO Menu2
                    CASE 59 ' ; = display hilight range.
                        GOSUB DisplayCopy
                    CASE 49 ' 1 = Add marker.
                        IF FileLength THEN
                            CALL Marker(2)
                        END IF
                    CASE 50 ' 2 = Add marker value.
                        IF FileLength THEN
                            CALL Marker(3)
                        END IF
                    CASE 51 ' 3 = Delete marker.
                        IF FileLength THEN
                            CALL Marker(4)
                        END IF
                    CASE 52 ' 4 = Delete specified marker.
                        IF FileLength THEN
                            CALL Marker(5)
                        END IF
                    CASE 53 ' 5 = Jump to previous marker.
                        IF FileLength THEN
                            CALL Marker(6)
                        END IF
                    CASE 54 ' 6 = Jump to current marker.
                        IF FileLength THEN
                            CALL Marker(7)
                        END IF
                    CASE 55 ' 7 = Jump to next marker.
                        IF FileLength THEN
                            CALL Marker(8)
                        END IF
                    CASE 56 ' 8 = Jump to specified marker.
                        IF FileLength THEN
                            CALL Marker(9)
                        END IF
                    CASE 57 ' 9 = List all markers.
                        IF FileLength THEN
                            CALL MultiFileFunction(2)
                            CALL Marker(10)
                            GOSUB RedrawScreen0
                        END IF
                    CASE 48 ' 0 = List specified markers.
                        IF FileLength THEN
                            CALL Marker(11)
                        END IF
                    CASE 45 ' - = List marker of value.
                        IF FileLength THEN
                            CALL MultiFileFunction(2)
                            CALL Marker(12)
                            GOSUB RedrawScreen0
                        END IF
                    CASE 61 ' = = Delete range of markers.
                        IF FileLength THEN
                            CALL Marker(13)
                        END IF
                    CASE 91 ' [ = Delete all markers.
                        IF FileLength THEN
                            CALL Marker(14)
                        END IF
                    CASE 93 ' ] = Delete markers of specified values.
                        IF FileLength THEN
                            CALL Marker(15)
                        END IF
                        ' toggle debug.
                    CASE 4 ' Control-D = Toggle debug variable.
                        GOSUB ToggleDebug
                    CASE 6 ' Control-F = Toggle debug2 variable.
                        GOSUB ToggleDebug2
                    CASE 7 ' Control-G = Toggle debug3 variable.
                        GOSUB ToggleDebug3
                        ' clipboard functions.
                    CASE 3 ' Control-C = Copy paste area.
                        IF FileLength THEN
                            _DELAY 1.2 ' delay for break
                            CALL Clipboard2(1)
                        END IF
                    CASE 22 ' Control-V = Paste area.
                        IF FileLength THEN
                            CALL Clipboard2(2)
                        END IF
                    CASE 24 ' Control-X = Undo current paste.
                        IF FileLength THEN
                            CALL Clipboard2(3)
                        END IF
                    CASE 26 ' Control-Z = Undo all pastes.
                        IF FileLength THEN
                            CALL Clipboard2(4)
                        END IF
                        ' remaining control functions.
                    CASE 19 ' Control-S = Windows screen saver.
                        GOSUB SaveShell
                    CASE 20 ' Control-T = Toggle search string storage variable.
                        GOSUB ToggleSearch
                        ' remaining functions.
                    CASE 32 ' Space = Display author and help key.
                        GOSUB DisplayAuthor
                    CASE 8, 127 ' Backspace/Control-BackSpace = Goto previous file.
                        GOSUB GotoPreviousFile
                    CASE ELSE ' Unknown key.
                        GOSUB HelpLine2
                END SELECT
            CASE 2 ' extended ascii key.
                SELECT CASE ASC(RIGHT$(CharInput$, 1))
                    CASE 94, 130 ' Control-F1/Alt-- = Display Date/Time
                        GOSUB DisplayData2
                    CASE 95, 131 ' Control-F2/Alt-= = Display loaded files.
                        GOSUB DisplayData3
                    CASE 30 ' Alt-A = Append multiple bytes.
                        IF FileLocked THEN
                            CALL DisplayX
                            CALL LockedFile
                        ELSE
                            GOSUB AppendByte
                        END IF
                    CASE 48 ' Alt-B = Append multiple null bytes.
                        IF FileLocked THEN
                            CALL DisplayX
                            CALL LockedFile
                        ELSE
                            GOSUB AppendNullBytes
                        END IF
                    CASE 46 ' Alt-C = ANSI Chart.
                        GOSUB ANSIChart
                    CASE 32 ' Alt-D = HEX screen dump.
                        IF FileLength THEN
                            GOSUB DumpScreen
                        END IF
                    CASE 18 ' Alt-E = HEX file dump.
                        IF FileLength THEN
                            GOSUB DumpHEXFile
                        END IF
                    CASE 33, 148 ' Alt-F/Control-Tab = Start drop down menu.
                        IF CurrentMenu <> 1 THEN
                            ' remove hilight menu tab.
                            Colorf2 White, 0
                            CALL DisplayTab(CurrentMenu)
                        END IF
                        CurrentMenu = 1
                        CurrentMenuSelection = 1
                        GOTO Menu2
                    CASE 34 ' Alt-G = Append multiple specified bytes.
                        IF FileLocked THEN
                            CALL DisplayX
                            CALL LockedFile
                        ELSE
                            GOSUB AppendAnyByte
                        END IF
                    CASE 35 ' Alt-H = HEX chart.
                        GOSUB HEXChart
                    CASE 36 ' Alt-J = Jump to byte.
                        IF FileLength THEN
                            GOSUB JumpByte
                        END IF
                    CASE 38 ' Alt-L = Jump to page.
                        IF FileLength THEN
                            GOSUB JumpPage
                        END IF
                    CASE 50 ' Alt-M = Append ASCII string.
                        IF FileLocked THEN
                            CALL DisplayX
                            CALL LockedFile
                        ELSE
                            GOSUB AppendASCII
                        END IF
                    CASE 49, 66, 101 ' Alt-N/F8/Control-F8 = Load new file.
                        IF NumberFiles = MaxFiles THEN
                            StatusMessage = "Maximum of" + STR$(MaxFiles) + " files open."
                            CALL DisplayStatus2
                        ELSE
                            CALL MultiFileFunction(2)
                            GOSUB NewFile
                            GOTO BeginFile
                        END IF
                    CASE 24 ' Alt-O = Print help screens.
                        GOSUB PrintHelp
                    CASE 25 ' Alt-P = HEX screen print.
                        IF FileLength THEN
                            GOSUB PrintScreen
                        END IF
                    CASE 16 ' Alt-Q = Display help screens.
                        GOSUB DisplayHelp
                    CASE 19 ' Alt-R = Redraw screen.
                        CALL MultiFileFunction(2)
                        GOSUB RedrawScreen0
                    CASE 20 ' Alt-T = HEX file print.
                        IF FileLength THEN
                            GOSUB PrintFile
                        END IF
                    CASE 22 ' Alt-U = Undo last byte change.
                        IF FileLength THEN
                            GOSUB UndoByte
                        END IF
                    CASE 17, 67, 102 ' Alt-W/F9/Control-F9 = Close current file.
                        GOSUB CloseCurrentFile
                        IF NumberFiles = False THEN
                            GOSUB NewFile
                            GOTO BeginFile
                        END IF
                    CASE 45 ' Alt-X = Exit program.
                        EXIT DO ' exit program.
                    CASE 21, 63 ' Alt-Y/F5 = Toggle right window.
                        IF FileLength THEN
                            GOSUB ToggleRight
                        END IF
                    CASE 44 ' Alt-Z = Undo all byte changes.
                        IF FileLength THEN
                            GOSUB UndoAll
                        END IF
                    CASE 129 ' Alt-0 = Close all files/Return to File Menu Box.
                        GOSUB CloseAllFiles
                        GOSUB NewFile
                        NumberFiles = False
                        GOTO BeginFile
                    CASE 59, 141 ' F1/Control-Up = Toggle filename display.
                        FileDisplay = NOT FileDisplay
                        IF FileDisplay = False THEN
                            CALL DisplayFileTitle
                        ELSE
                            GOSUB DisplayScreen3
                        END IF
                    CASE 60, 145 ' F2/Control-Down = Toggle bottom row help keys.
                        ScreenRow = NOT ScreenRow
                        CALL MultiFileFunction(2)
                        GOSUB RedrawScreen0
                    CASE 37, 61 ' Alt-K/F3 = Search ascii string.
                        IF FileLength THEN
                            GOSUB SearchASCII
                        END IF
                        ' Alt-S/F4/Control-F4 = Search multiple bytes.
                    CASE 31, 62, 97
                        IF FileLength THEN
                            GOSUB SearchBytes
                        END IF
                        ' Alt-Right/F6/Control-F6 = Goto next file.
                    CASE 157, 64, 99
                        GOSUB GotoNextFile
                        ' Alt-Left/F7/Control-F7 = Goto previous file.
                    CASE 155, 65, 100
                        GOSUB GotoPreviousFile
                        ' Alt-V/Ctrl-F10/F10 = View files.
                    CASE 47, 103, 68
                        CALL Viewfiles(Var)
                        IF Var > False THEN
                            NextFile = Var
                            GOSUB SearchFile3
                        END IF
                        CALL DisplayFilename
                    CASE 96 ' Control-F3 = Continue search.
                        IF FileLength THEN
                            GOSUB ContinueSearch
                        END IF
                        ' F11/Control-F11/Alt-F11 = Drop to DOS.
                    CASE 133, 137, 139
                        GOSUB DOSshell
                        ' Alt-I/F12/Control-F12/Alt-F12 = DOS Command.
                    CASE 23, 134, 138, 140
                        GOSUB DOScommand
                        ' Control-Keypad-5/Control-F5 = Select Specific Filename.
                    CASE 143, 98
                        GOSUB SearchFile2
                    CASE 76, 113 ' Keypad-5/Alt-F10 = Hex/Dec calculator.
                        GOSUB HEXCalculator
                    CASE 104 TO 112 ' Alt-F1 to Alt-F9 = Select File.
                        NextFile = ASC(RIGHT$(CharInput$, 1)) - 103
                        GOSUB SearchFile3
                    CASE 120 TO 128 ' Alt-1 to Alt-9 = Select file.
                        NextFile = ASC(RIGHT$(CharInput$, 1)) - 119
                        GOSUB SearchFile3
                    CASE 82 ' Insert = Change string value.
                        IF FileLocked THEN
                            CALL DisplayX
                            CALL LockedFile
                        ELSE
                            GOSUB ChangeASCIIValues
                        END IF
                    CASE 83 ' Delete = Change HEX string.
                        IF FileLocked THEN
                            CALL DisplayX
                            CALL LockedFile
                        ELSE
                            GOSUB ChangeHEXValues
                        END IF
                    CASE 72 ' Up
                        IF FileLength THEN
                            GOSUB CursorUp
                        END IF
                    CASE 80 ' Down
                        IF FileLength THEN
                            GOSUB CursorDown
                        END IF
                    CASE 75 ' Left
                        IF FileLength THEN
                            GOSUB CursorLeft
                        END IF
                    CASE 77 ' Right
                        IF FileLength THEN
                            GOSUB CursorRight
                        END IF
                    CASE 152, 73, 132 ' Alt-Up/PageUp/Control-PageUp
                        IF FileLength THEN
                            GOSUB PageUp
                        END IF
                    CASE 160, 81, 118 ' Alt-Down/PageDown/Control-PageDown
                        IF FileLength THEN
                            GOSUB PageDown
                        END IF
                    CASE 79 ' End
                        IF FileLength THEN
                            GOSUB EndKey
                        END IF
                    CASE 71 ' Home
                        IF FileLength THEN
                            GOSUB HomeKey
                        END IF
                    CASE 142, 74, 115 ' Control-Keypad-/Alt-Keypad-/Control-Left
                        IF FileLength THEN
                            GOSUB CtrlLeftKey
                        END IF
                    CASE 144, 78, 116 ' Control-Keypad+/Alt-Keypad+/Control-Right
                        IF FileLength THEN
                            GOSUB CtrlRightKey
                        END IF
                    CASE 117 ' Control-End
                        IF FileLength THEN
                            GOSUB CtrlEndKey
                        END IF
                    CASE 119 ' Control-Home
                        IF FileLength THEN
                            GOSUB CtrlHomeKey
                        END IF
                    CASE ELSE ' Unknown key.
                        GOSUB HelpLine3
                END SELECT
        END SELECT
    END IF
    CALL LocateCursor2
LOOP

' stop program.
StopLabel:

' clear hilighted byte.
CALL ClearPageByte

' clear status areas.
CALL ClearStatus
GOSUB DisplayScreen3

' display goodbye message.
Colorf2 Yellow, 0
Locatef 2, 4, 0
Z$ = "You have been using a public domain program written by "
Z$ = Z$ + Author$ + ".."
Z$ = LEFT$(Z$, 74)
Printf Z$
Locatef 2, 4, 0

' clear file menu tab.
IF CurrentMenu THEN
    Colorf2 White, 0
    CALL DisplayTab(CurrentMenu)
END IF

' remove bottom lines of screen.
FOR Var = 21 TO 24
    Locatef Var, 1, 0
    Printf SPACE$(78)
NEXT
Locatef 21, 1, 0
Colorf Magenta
Printf " " + CHR$(LLcorner) + STRING$(75, Hline) + CHR$(LRcorner)

' goto end of program.
GOTO StopLoop
END

' load filespec.
LoadMultipleFile:
' check max files.
IF NumberFiles = MaxFiles THEN
    RETURN
END IF

' trim filename.
Filename = Var$
Filename = RTRIM$(Filename)
Filename = LTRIM$(Filename)

' check long filename in quotes.
IF LEFT$(Filename, 1) = Quote THEN
    IF RIGHT$(Filename, 1) = Quote THEN
        Filename = MID$(Filename, 2)
        Filename = LEFT$(Filename, LEN(Filename) - 1)
    END IF
END IF

' check wildcard characters.
IF INSTR(Filename, "?") OR INSTR(Filename, "*") THEN
    ' store filename drive/directory
    D$ = Nul
    C$ = Nul
    N$ = Nul
    x$ = Nul
    ' get netpath
    IF LEFT$(Filename, 2) = "\\" THEN
        Net1 = INSTR(3, Filename, "\")
        IF Net1 THEN
            Net2 = INSTR(Net1 + 1, Filename, "\")
            IF Net2 THEN
                N$ = LEFT$(Filename, Net2 - 1)
                Filename = MID$(Filename, Net2)
            END IF
        END IF
    END IF
    ' get directory
    FOR Var = LEN(Filename) TO 1 STEP -1
        IF MID$(Filename, Var, 1) = "\" THEN
            D$ = LEFT$(Filename, Var)
            x$ = MID$(Filename, Var + 1)
            EXIT FOR
        END IF
    NEXT
    ' restore filename
    IF N$ <> Nul THEN
        Filename = N$ + D$ + x$
    END IF
    ' get drive
    IF MID$(Filename, 2, 1) = ":" THEN
        C$ = LEFT$(Filename, 2)
        D$ = MID$(D$, 3)
    END IF
    ' check pathname
    IF C$ = Nul THEN
        IF D$ = Nul THEN
            Var$ = _CWD$
            C$ = LEFT$(Var$, 2)
            D$ = MID$(Var$, 3)
        END IF
    END IF

    ' clear filename array.
    FOR VarZ = 1 TO MaxFiles
        TempFiles(VarZ) = Nul
    NEXT
    ' store filename array.
    VarZ = False
    Filename = Filename + CHR$(0)
    hfind = FindFirstFileA(_OFFSET(Filename), _OFFSET(finddata))
    IF hfind <> INVALID_HANDLE_VALUE THEN
        DO
            x$ = finddata.cFileName
            VarX = INSTR(x$, CHR$(0))
            IF VarX THEN
                x$ = LEFT$(x$, VarX - 1)
            END IF
            IF LEN(x$) THEN
                Attr = finddata.dwFileAttributes
                IF (Attr AND &H10) = &H0 THEN
                    IF VarZ < MaxFiles THEN
                        VarZ = VarZ + 1
                        IF N$ = Nul THEN
                            IF RIGHT$(D$, 1) = "\" THEN
                                TempFiles(VarZ) = C$ + D$ + x$
                            ELSE
                                TempFiles(VarZ) = C$ + D$ + "\" + x$
                            END IF
                        ELSE
                            IF D$ = Nul THEN
                                TempFiles(VarZ) = N$ + "\" + x$
                            ELSE
                                TempFiles(VarZ) = N$ + "\" + D$ + x$
                            END IF
                        END IF
                    ELSE
                        EXIT DO
                    END IF
                END IF
            END IF
        LOOP WHILE FindNextFileA(hfind, _OFFSET(finddata))
        x = FindClose(hfind)
    END IF

    ' load filename array.
    FOR VarZ = 1 TO MaxFiles
        IF RTRIM$(TempFiles(VarZ)) <> "" THEN
            ' check max files.
            IF NumberFiles = MaxFiles THEN
                RETURN
            END IF
            Filename = RTRIM$(TempFiles(VarZ))
            GOSUB LoadNewFile
        END IF
    NEXT
ELSE
    ' load single file.
    GOSUB LoadNewFile
END IF
RETURN

' loads filename.
LoadNewFile:
' check max files.
IF NumberFiles = MaxFiles THEN
    RETURN
END IF

' store filename.
ASCIIZ = Filename + CHR$(0)

' open/create file.
GOSUB OpenFile

' check open error.
IF ValidFile THEN

    ' get netpath
    GOSUB ParseNetPath

    ' conanicalize filename.
    GOSUB ShortFilename

    ' get length of file.
    CALL GetFileLength(Handle)

    ' get exclusion list.
    GOSUB CheckFile

    ' check excluded file.
    IF VarP THEN
        ' close handle.
        GOSUB CloseFile

        ' restore current file.
        GOSUB RestoreCurrentFile
        RETURN
    END IF

    ' initialize new file.
    GOSUB InitFile

    ' init paste files.
    CALL InitPasteFiles(VarQ)

    ' check bad paste filename.
    IF VarQ THEN
        GOTO Error.Exit
    END IF
END IF
RETURN

' initialize new file.
InitFile:
NumberFiles = NumberFiles + 1
CurrentFile = NumberFiles
CALL MultiFileFunction(1)
GOSUB RestoreCurrentFile
RETURN

' check file exclusion list.
CheckFile:
VarP = False
Filename2$ = ExcludeFile
Var = INSTR(Filename2$, "?")
IF Var THEN
    MID$(Filename2$, Var, 1) = MID$(STR$(Process.Number), 2)
END IF
ASCIIZ3 = ASCIIZ
ASCIIZ = Filename2$ + CHR$(0)
CALL GetShortFilename(Short.Filename$)
ASCIIZ = ASCIIZ3
Filename2$ = Short.Filename$
IF _FILEEXISTS(Filename2$) THEN
    Check.Disk = True
    Disk.Ready = False
    x3 = FREEFILE
    OPEN Filename2$ FOR INPUT AS #x3
    Check.Disk = False
    IF Disk.Ready THEN
        RETURN
    END IF
    Y2$ = Filename
    Y2$ = UCASE$(Y2$)
    FOR Y = LEN(Y2$) TO 1 STEP -1
        IF MID$(Y2$, Y, 1) = "\" THEN
            Y2$ = MID$(Y2$, Y + 1)
            EXIT FOR
        END IF
    NEXT
    DO UNTIL EOF(x3)
        LINE INPUT #x3, Y1$
        Y1$ = LTRIM$(Y1$)
        Y1$ = RTRIM$(Y1$)
        Y1$ = UCASE$(Y1$)
        IF LEFT$(Y1$, 1) = Quote THEN
            Y1$ = MID$(Y1$, 2)
            IF RIGHT$(Y1$, 1) = Quote THEN
                Y1$ = LEFT$(Y1$, LEN(Y1$) - 1)
            END IF
        END IF
        Y1$ = LTRIM$(Y1$)
        Y1$ = RTRIM$(Y1$)
        IF LEN(Y1$) THEN
            IF INSTR(Y1$, " ") = False THEN
                ' check excluded file in filename.
                CALL CheckExcluded(Y1$, Y2$, Exclude.File%)
                IF Exclude.File% THEN
                    VarP = True
                    EXIT DO
                END IF
            END IF
        END IF
    LOOP
END IF
CLOSE #x3
RETURN

' search specific file name.
'   allows ? and * characters.
SearchFile2:
CALL ClearStatus
Printf "Enter filename?"
Var1$ = LineInput$(2, 20, 10)
IF LEN(Var1$) THEN
    FOR NextFile = CurrentFile + 1 TO NumberFiles
        Var2$ = RTRIM$(File(NextFile).Filename)
        IF LEN(Var2$) THEN
            CALL InstrSUB(VarX, Var2$, Var1$)
            IF VarX THEN
                GOTO SearchFile3
            END IF
        END IF
    NEXT
    FOR NextFile = 1 TO CurrentFile
        Var2$ = RTRIM$(File(NextFile).Filename)
        IF LEN(Var2$) THEN
            CALL InstrSUB(VarX, Var2$, Var1$)
            IF VarX THEN
                GOTO SearchFile3
            END IF
        END IF
    NEXT
END IF
StatusMessage = "File not found."
CALL DisplayStatus2
RETURN

' select specific file number.
SearchFile3:
IF NextFile <= NumberFiles THEN
    CALL MultiFileFunction(2)
    CurrentFile = NextFile
    GOSUB RestoreCurrentFile
    GOSUB RedrawScreen2
END IF
RETURN

' goto next file.
GotoNextFile:
IF NumberFiles = 1 THEN
    RETURN
END IF
CALL MultiFileFunction(2)
CurrentFile = CurrentFile + 1
IF CurrentFile > NumberFiles THEN
    CurrentFile = 1
END IF
GOSUB RestoreCurrentFile
GOSUB RedrawScreen2
RETURN

' goto previous file.
GotoPreviousFile:
IF NumberFiles = 1 THEN
    RETURN
END IF
CALL MultiFileFunction(2)
CurrentFile = CurrentFile - 1
IF CurrentFile = False THEN
    CurrentFile = NumberFiles
END IF
GOSUB RestoreCurrentFile
GOSUB RedrawScreen2
RETURN

' goto first file.
GotoFirstFile:
IF CurrentFile = 1 THEN
    RETURN
END IF
CALL MultiFileFunction(2)
CurrentFile = 1
GOSUB RestoreCurrentFile
GOSUB RedrawScreen2
RETURN

' goto last file.
GotoLastFile:
IF CurrentFile = NumberFiles THEN
    RETURN
END IF
CALL MultiFileFunction(2)
CurrentFile = NumberFiles
GOSUB RestoreCurrentFile
GOSUB RedrawScreen2
RETURN

' close current file.
CloseCurrentFile:
GOSUB CloseFile
GOSUB PackFileArray
RETURN

' pack file arrays and structures.
PackFileArray:
' pack file array.
FOR Var = CurrentFile TO MaxFiles - 1
    File(Var) = File(Var + 1)
NEXT

' pack paste files.
CALL Pack.Files1

' pack undo file.
CALL Pack.Arrays1

' pack marker file.
CALL Pack.Arrays2

' reduce files by one.
NumberFiles = NumberFiles - 1

' check remaining files.
IF NumberFiles > False THEN
    ' reset current file.
    IF CurrentFile > NumberFiles THEN
        CurrentFile = NumberFiles
    END IF

    ' restore current file.
    GOSUB RestoreCurrentFile
    GOSUB RedrawScreen2
END IF
RETURN

' prepare for new file.
NewFile:
' reset window.
CLS
Locatef 1, 1, 1
Printf "Loading.."
CurrentWindow = False
CurrentWindow2 = False
ScreenDrawn = False
Locatef 24, 1, 1
Colorf Plain
RETURN

' restore current file variables.
RestoreCurrentFile:
IF NumberFiles = 0 THEN
    RETURN
END IF
CALL MultiFileFunction(3)
CALL OpenPasteFiles(VarQ)
IF VarQ THEN
    GOTO Error.Exit
END IF
CALL DisplayScreen
IF FileDisplay = False THEN
    CALL DisplayFileTitle
    _TITLE "HEXEDIT - " + File(CurrentFile).Filename
ELSE
    GOSUB DisplayScreen3
END IF
RETURN

' display command line instructions.
BootUsage:
CALL DisplayBootUsage
Colorf Plain
GOTO StopProgram

' display ANSI charts.
ANSIChart:
CALL DisplayChart(1)
GOTO EndChart
' display HEX charts.
HEXChart:
CALL DisplayChart(2)
GOTO EndChart
' display HEX calculator.
HEXCalculator:
CALL HexCalc
EndChart:
CALL MultiFileFunction(2)
GOSUB RedrawScreen0
RETURN

' toggles state of search string storage variable.
ToggleSearch:
StoreSearchMulti = NOT StoreSearchMulti
CALL DisplayX
Colorf White
IF StoreSearchMulti THEN
    Printf "Store search string on."
ELSE
    Printf "Store search string off."
END IF
CALL LocateCursor2
RETURN

' toggles state of debug variable.
ToggleDebug:
Debug = NOT Debug
CALL DisplayX
Colorf White
IF Debug THEN
    Printf "Debug on."
ELSE
    Printf "Debug off."
END IF
CALL LocateCursor2
RETURN

' toggles state of debug2 variable.
ToggleDebug2:
Debug2 = NOT Debug2
CALL DisplayX
Colorf White
IF Debug2 THEN
    Printf "Debug2 on."
ELSE
    Printf "Debug2 off."
END IF
CALL LocateCursor2
RETURN

' toggles state of debug3 variable.
ToggleDebug3:
Debug3 = NOT Debug3
CALL DisplayX
Colorf White
IF Debug3 THEN
    Printf "Debug3 on."
ELSE
    Printf "Debug3 off."
END IF
CALL LocateCursor2
RETURN

' function for unknown ascii key.
HelpLine2:
CALL DisplayX
Colorf White
IF Debug THEN
    Printf MID$(STR$(ASC(CharInput$)), 2) + ": "
END IF
GOTO HelpLineX

' function for unknown scan key.
HelpLine3:
CALL DisplayX
Colorf White
IF Debug THEN
    Printf MID$(STR$(ASC(RIGHT$(CharInput$, 1))), 2) + ": "
END IF
GOTO HelpLineX

' function for unknown key.
HelpLine:
CALL DisplayX
Colorf White
HelpLineX:
Printf "Type Alt-Q for Help, Alt-O to print Help."
CALL LocateCursor2
RETURN

' displays help screens.
DisplayHelp:
CALL MultiFileFunction(2)
CALL HelpScreen
GOSUB RedrawScreen0
RETURN

' function for ? key.
DisplayInfo:
CALL DisplayX
Colorf White
IF FileLength = False THEN
    CALL LockedFile
    RETURN
END IF
Attr$ = Nul
IF (FileAttribute AND 1) = 1 THEN
    Attr$ = Attr$ + "o"
END IF
IF (FileAttribute AND 2) = 2 THEN
    Attr$ = Attr$ + "h"
END IF
IF (FileAttribute AND 4) = 4 THEN
    Attr$ = Attr$ + "s"
END IF
IF (FileAttribute AND 32) = 32 THEN
    Attr$ = Attr$ + "a"
END IF
IF LEN(Attr$) THEN
    Printf "(" + Attr$ + ") "
END IF
IF CurrentWindow2 = False THEN
    Printf "(Length: " + FormatX$(FileLength, 1) + ") "
ELSE
    Printf "(Length: " + RIGHT$("000000000000" + HEX$(FileLength - 1), 12) + "x) "
END IF
CALL LocateCursor2
RETURN

' function for space key.
DisplayAuthor:
CALL DisplayX
Colorf White
Printf "Author: " + Author$ + " Type Alt-Q for help."
CALL LocateCursor2
RETURN

' function for ! key.
DisplayData1:
CALL DisplayX
Colorf White
IF FileLength = False THEN
    CALL LockedFile
    RETURN
END IF
TempPosition3 = FilePosition
CALL FormatPosition1
CALL LocateCursor2
RETURN

' function for Alt-- key.
DisplayData2:
CALL DisplayX
Colorf White
Printf clock$
CALL LocateCursor2
RETURN

' function for Alt-= key.
DisplayData3:
CALL DisplayX
Colorf White
Printf "Loaded Files:" + STR$(NumberFiles) + " "
Printf "Last Drive: " + CHR$(Last.Drive + 64) + ":"
CALL LocateCursor2
RETURN

' function for ~ key.
DisplayLengths:
CALL DisplayX
Colorf White
IF FileLength = False THEN
    CALL LockedFile
    RETURN
END IF
FilePage2 = INT((FileLength - 1) / 320) + 1
IF CurrentWindow2 = False THEN
    Printf "(Last page: " + FormatX$(CDBL(FilePage2 - 1), 1) + ") "
ELSE
    Printf "(Last page: " + RIGHT$("00000000" + HEX$(FilePage2 - 1), 8) + "x) "
END IF
' count markers
Var1! = SFalse
FOR Var2! = 1! TO MarkerCount
    IF Markers#(Var2!) > 0# THEN
        Var1! = Var1! + 1!
    END IF
NEXT
Printf "(Markers: " + FormatX$(CDBL(Var1!), 1) + ")"
CALL LocateCursor2
RETURN

' function for ; key.
DisplayCopy:
CALL DisplayX
Colorf White
IF FileLength = False THEN
    CALL LockedFile
    RETURN
END IF
IF CurrentWindow2 = False THEN
    Printf "(Copy position: "
    Printf FormatX$(CDBL(CopyPositionStart), 1) + " - "
    Printf FormatX$(CDBL(CopyPositionEnd), 1) + ") "
ELSE
    Printf "(CopyPosition: "
    IF CopyPositionStart = False AND CopyPositionEnd = False THEN
        Printf "00000000H - 00000000H) "
    ELSE
        Printf RIGHT$("00000000" + HEX$(CopyPositionStart - 1), 8) + "x - "
        Printf RIGHT$("00000000" + HEX$(CopyPositionEnd - 1), 8) + "x) "
    END IF
END IF
CALL LocateCursor2
RETURN

' { = display paste undos.
DisplayPasteUndos:
CALL DisplayX
Colorf White
IF FileLength = False THEN
    CALL LockedFile
    RETURN
END IF
ByteEntries = 0%
IF LOF(5) > 0 THEN
    GET #5, 1, CopyByte
    ByteEntries = ASC(CopyByte) * 16 ^ 2
    GET #5, 2, CopyByte
    ByteEntries = ByteEntries + ASC(CopyByte)
END IF
Printf FormatX$(CDBL(ByteEntries), 1) + " "
IF ByteEntries = 1% THEN
    Printf "paste undo stored."
ELSE
    Printf "paste undos stored."
END IF
CALL LocateCursor2
RETURN

' " = display path of file being edited.
DisplayPath:
CALL ClearStatus
N$ = RTRIM$(CurrentNetPath)
Z$ = RTRIM$(ShortFilename)
IF N$ <> Nul THEN
    IF MID$(Z$, 2, 1) = ":" THEN
        Z$ = MID$(Z$, 3)
    END IF
END IF
CALL Deconcatenate(N$, Z$, 64)
Var = LEN(Z$)
DO
    Var = Var - 1
    IF Var = False THEN
        Z$ = Nul
        EXIT DO
    END IF
    IF MID$(Z$, Var, 1) = "\" THEN
        Z$ = LEFT$(Z$, Var)
        EXIT DO
    END IF
LOOP
IF Z$ = Nul THEN
    Z$ = "\"
END IF
Printf "Editing path: " + Z$ + " "
FileDisplay2 = True
CALL LocateCursor2
RETURN

' redraw editing screen
RedrawScreen0:
ScreenDrawn = True
GOSUB RestoreCurrentFile
GOTO RedrawScreen2
RedrawScreen1:
ScreenDrawn = True
CALL DisplayScreen
RedrawScreen2:
CALL DisplayFilename
CALL DisplayHexPage
CALL DisplayPageByte
IF FileDisplay = False THEN
    CALL DisplayFileTitle
ELSE
    GOSUB DisplayScreen3
END IF
CALL RestoreHilightBytes
RETURN

' display filename border area.
DisplayScreen3:
CALL DisplayScreen3X
CALL LocateCursor2
RETURN

' search file for ascii string.
SearchASCII:
CALL SearchFile(0, FoundString)
GOTO FinishSearch
' search file for hex string.
SearchBytes:
CALL SearchFile(1, FoundString)
GOTO FinishSearch
' continue previous search.
ContinueSearch:
IF RTRIM$(StoreSearchString) = Nul THEN
    StatusMessage = "No search string specified."
    CALL DisplayStatus2
    RETURN
END IF
CALL SearchFile(2, FoundString)
' display search results.
FinishSearch:
' check byte comparison.
IF FoundString = True THEN
    FilePosition = SearchBytePosition
    CALL CalculatePosition1
    IF LastPage <> FilePage THEN
        CALL DisplayHexPage
    END IF
END IF
CALL DisplayPageByte
IF FoundString = False THEN
    StatusMessage = "String not found."
    CALL DisplayStatus2
    RETURN
END IF
CALL DisplayFilename
RETURN

' dump screen of current page of hex/ascii values to file.
DumpScreen:
' open dumpfile.
GOSUB OpenDumpFile
IF ValidFile = False THEN
    RETURN
END IF
' write screen.
CALL DumpSub(1, x2)
Var = 1
GOSUB DumpIt
RETURN

' dump file of current hex/ascii values to file.
DumpHEXFile:
' open dumpfile.
GOSUB OpenDumpFile
IF ValidFile = False THEN
    RETURN
END IF
' write file.
CALL DumpSub(2, x2)
Var = 3
IF FileDumped THEN
    Var = 2
END IF
GOSUB DumpIt
RETURN

' display dump info.
DumpIt:
' redisplay page.
CALL DisplayPageByte
' conanicalize filename.
Filename2$ = Conanicalize$(DumpFile)
Var2 = INSTR(Filename2$, "?")
IF Var2 THEN
    MID$(Filename2$, Var2, 1) = MID$(STR$(Process.Number), 2)
END IF
' display filename.
SELECT CASE Var
    CASE 1
        StatusMessage = "Screen dumped to: '" + Filename2$ + "'."
    CASE 2
        StatusMessage = "File dumped to: '" + Filename2$ + "'."
    CASE 3
        StatusMessage = "Partial file dumped to: '" + Filename2$ + "'."
END SELECT
CALL DisplayStatus1
RETURN

' open dumpfile.
OpenDumpFile:
Column = False
ColumnSpace = False
HexLine$ = Nul
HexLine2$ = Nul

x2 = FREEFILE
ErrorTrap = False
ValidFile = True

' store filename.
Filename2$ = DumpFile
Var = INSTR(Filename2$, "?")
IF Var THEN
    MID$(Filename2$, Var, 1) = MID$(STR$(Process.Number), 2)
END IF

' open filename for append.
OPEN Filename2$ FOR APPEND AS #x2
IF ErrorTrap THEN
    CALL MultiFileFunction(2)
    GOSUB RedrawScreen0
    ValidFile = False
END IF
RETURN

' print screen of current page of hex/ascii values to printer.
PrintScreen:

' start print.
CALL PrintSub(1)
CALL DisplayPageByte
StatusMessage = "Screen dumped to printer."
CALL DisplayStatus1
RETURN

' print file of current hex/ascii values to printer.
PrintFile:

' start print.
CALL PrintSub(2)
CALL DisplayPageByte
IF FileDumped THEN
    StatusMessage = "File dumped to printer."
ELSE
    StatusMessage = "Partial file dumped to printer."
END IF
CALL DisplayStatus1
RETURN

' print help screens.
PrintHelp:

' start print.
CALL PrintSub(3)
CALL DisplayFilename
RETURN

' add multiple specified byte to file and locate there.
AppendAnyByte:
CALL ClearStatus
Printf "Enter number of bytes?"
ByteString$ = LineInput$(2, 27, 10)
IF LEN(ByteString$) = False THEN
    StatusMessage = "Invalid append bytes."
    CALL DisplayStatus2
    RETURN
END IF
IF UCASE$(LEFT$(ByteString$, 1)) = "H" THEN
    CALL CheckHexValue(ByteString$)
    IF ValidHexValue = False THEN
        RETURN
    END IF
    NumBytes2# = HexValue - 1#
ELSE
    CALL CheckASCIIValue(ByteString$)
    IF ValidASCIIValue = False THEN
        RETURN
    END IF
    NumBytes2# = ASCIIValue3
END IF
CALL ClearStatus
ValidByteString = False
Printf "Enter hex byte?"
ByteString$ = LineInput$(2, 20, 2)
IF LEN(ByteString$) = 2 THEN
    AllowWildCard = False
    CALL CheckHexBytes(ByteString$)
    IF ValidByteString THEN
        Byte2 = VAL("&H" + ByteString$)
    END IF
END IF
IF ValidByteString = False THEN
    StatusMessage = "Invalid append hex value."
    CALL DisplayStatus2
    RETURN
END IF
CALL DisplayX
Colorf White
Printf " Appending specified bytes to file:"
CursorLocation = 53 + LEN(RTRIM$(Filename))
GOTO AppendBytes2

' add multiple null bytes to file and locate there.
AppendNullBytes:
CALL ClearStatus
Printf "Enter number of bytes?"
ByteString$ = LineInput$(2, 27, 10)
IF LEN(ByteString$) = False THEN
    StatusMessage = "Invalid append bytes."
    CALL DisplayStatus2
    RETURN
END IF
IF UCASE$(LEFT$(ByteString$, 1)) = "H" THEN
    CALL CheckHexValue(ByteString$)
    IF ValidHexValue = False THEN
        RETURN
    END IF
    NumBytes2# = HexValue - 1#
ELSE
    CALL CheckASCIIValue(ByteString$)
    IF ValidASCIIValue = False THEN
        RETURN
    END IF
    NumBytes2# = ASCIIValue3
END IF
Byte2 = False
CALL DisplayX
Colorf White
Printf " Appending null bytes to file:"
CursorLocation = 48 + LEN(RTRIM$(Filename))

' append bytes past end of file.
AppendBytes2:
LastPage = FilePage
CALL ClearPageByte
PercentDisplayed! = SFalse
Locatef 2, CursorLocation, 0
Printf " 0%"
BlockBytes# = INT(NumBytes2# / 32767#)
RemainingBytes# = NumBytes2# MOD 32767#
' write 32767 byte blocks.
IF BlockBytes# > 0# THEN
    BlockByte = STRING$(32767, CHR$(Byte2))
    FOR Byte1# = 1# TO BlockBytes#
        IF INKEY$ = CHR$(27) THEN
            GOTO EndAppend
        END IF
        SeekPosition = FileLength + 1#
        FileLength = FileLength + 32767#
        CALL LseekFile
        GOSUB WriteBlockFile
        IF Write.Error THEN
            CALL GetFileLength(Handle)
            SeekPosition = FileLength
            CALL LseekFile
            GOTO EndAppend
        END IF
        FilePosition = FileLength
        CALL CalculatePosition1
        PercentCopied! = INT(CSNG(Byte1# / BlockBytes#) * 100!)
        IF PercentCopied! > PercentDisplayed! THEN
            Locatef 2, CursorLocation, 0
            Printf STR$(PercentCopied!) + "%"
            PercentDisplayed! = PercentCopied!
        END IF
    NEXT
END IF
' write remaining bytes.
PercentDisplayed! = SFalse
Locatef 2, CursorLocation, 0
Printf " 0%  "
IF RemainingBytes# > 0# THEN
    FileByte = CHR$(Byte2)
    FOR Byte1# = 1# TO RemainingBytes#
        FileLength = FileLength + 1#
        SeekPosition = FileLength
        CALL LseekFile
        CALL WriteFile
        IF Write.Error THEN
            CALL GetFileLength(Handle)
            SeekPosition = FileLength
            CALL LseekFile
            GOTO EndAppend
        END IF
        FilePosition = FileLength
        CALL CalculatePosition1
        IF LastPage = FilePage THEN
            CALL ClearPageByte
        END IF
        PercentCopied! = INT(CSNG(Byte1# / RemainingBytes#) * 100!)
        IF PercentCopied! > PercentDisplayed! THEN
            Locatef 2, CursorLocation, 0
            Printf STR$(PercentCopied!) + "%"
            PercentDisplayed! = PercentCopied!
        END IF
    NEXT
END IF
EndAppend:
CALL CalculatePosition1
IF LastPage <> FilePage THEN
    LastPage = FilePage
    CALL DisplayHexPage
END IF
CALL DisplayPageByte
CALL DisplayFilename
RETURN

' add multiple bytes of an ASCII string to file and locate there.
AppendASCII:
CALL ClearStatus
Printf "Enter ASCII string?"
ByteString$ = LineInput$(2, 24, 53)
IF LEN(ByteString$) = False THEN
    StatusMessage = "Invalid append string."
    CALL DisplayStatus2
    RETURN
END IF
NumBytes = LEN(ByteString$)
CALL AsciiToHex2(ByteString$)
GOTO StartAppend

' add multiple bytes to file and locate there.
'   left window specifies space-separated hex byte pairs,
'   right window specifies space-separated 3-byte ascii pairs.
AppendByte:
CALL ClearStatus
IF CurrentWindow = False THEN
    Printf "Enter hex byte(s)?"
    ByteString$ = LineInput$(2, 23, 55)
    IF LEFT$(ByteString$, 1) = "+" THEN
        ByteString$ = MID$(ByteString$, 2)
        CALL CheckAsciiBytes(ByteString$)
    ELSE
        AllowWildCard = False
        CALL CheckHexBytes(ByteString$)
    END IF
ELSE
    Printf "Enter ascii byte(s)?"
    ByteString$ = LineInput$(2, 25, 53)
    IF UCASE$(LEFT$(ByteString$, 1)) = "H" THEN
        ByteString$ = MID$(ByteString$, 2)
        AllowWildCard = False
        CALL CheckHexBytes(ByteString$)
    ELSE
        CALL CheckAsciiBytes(ByteString$)
    END IF
END IF
IF ValidByteString = False THEN
    StatusMessage = "Invalid append string."
    CALL DisplayStatus2
    RETURN
END IF

' append the byte string.
StartAppend:
LastPage = FilePage
FOR Byte1 = 1 TO NumBytes
    CALL ClearPageByte
    Byte$ = MID$(ByteString$, (Byte1 - 1) * 2 + 1, 2)
    Byte2 = VAL("&H" + Byte$)
    GOSUB AppendIt
    IF ValidAppend = False THEN
        EXIT FOR
    END IF
NEXT
CALL DisplayFilename
RETURN

' appends a byte to file.
AppendIt:
ValidAppend = False
FileByte = CHR$(Byte2)
FileLength = FileLength + 1#
SeekPosition = FileLength
CALL LseekFile
CALL WriteFile
IF Write.Error THEN
    CALL GetFileLength(Handle)
    SeekPosition = FileLength
    CALL LseekFile
    CALL DisplayPageByte
    RETURN
END IF
ValidAppend = True
FilePosition = FileLength
CALL CalculatePosition1
IF LastPage <> FilePage THEN
    LastPage = FilePage
    CALL DisplayHexPage
END IF
CALL DisplayPageByte
RETURN

' jump to page position in file.
JumpPage:
CALL ClearStatus
Printf "Enter page position?"
ByteString$ = LineInput$(2, 25, 10)
IF UCASE$(LEFT$(ByteString$, 1)) = "H" THEN
    CALL CheckHexValue(ByteString$)
    IF ValidHexValue = False THEN
        RETURN
    END IF
    NextPage = HexValue
ELSE
    CALL CheckASCIIValue(ByteString$)
    IF ValidASCIIValue = False THEN
        RETURN
    END IF
    NextPage = ASCIIValue3
END IF
' check the new page is there to jump to.
TempPosition3 = (NextPage - 1) * 320 + 1
IF TempPosition3 >= 1 AND TempPosition3 <= FileLength THEN
    CALL ClearPageByte
    LastPage = FilePage
    ' preserve current row, column.
    FilePosition = TempPosition3
    TempPosition2 = FilePosition + (PageRow - 1) * 20 + PageColumn - 1
    IF TempPosition2 <= FileLength THEN
        FilePosition = TempPosition2
    ELSE
        FilePosition = FileLength
    END IF
    CALL CalculatePosition1
    IF LastPage <> FilePage THEN
        CALL DisplayHexPage
    END IF
    CALL DisplayPageByte
    CALL DisplayFilename
    RETURN
END IF
StatusMessage = "Invalid page."
CALL DisplayStatus2
RETURN

' jump to a byte position in file.
JumpByte:
CALL ClearStatus
Printf "Enter file position?"
ByteString$ = LineInput$(2, 25, 10)
IF UCASE$(LEFT$(ByteString$, 1)) = "H" THEN
    CALL CheckHexValue(ByteString$)
    IF ValidHexValue = False THEN
        RETURN
    END IF
    NewByte = HexValue
ELSE
    CALL CheckASCIIValue(ByteString$)
    IF ValidASCIIValue = False THEN
        RETURN
    END IF
    NewByte = ASCIIValue3
END IF
IF NewByte >= 1 AND NewByte <= FileLength THEN
    IF NewByte <> FilePosition THEN
        CALL ClearPageByte
        LastPage = FilePage
        FilePosition = NewByte
        CALL CalculatePosition1
        IF LastPage <> FilePage THEN
            CALL DisplayHexPage
        END IF
        CALL DisplayPageByte
    END IF
    CALL DisplayFilename
    RETURN
END IF
StatusMessage = "Invalid byte."
CALL DisplayStatus2
RETURN

' undo a byte from stored arrays of previous position/byte value.
UndoByte:
IF CurrentUndo = 0! THEN
    StatusMessage = "No bytes to restore."
    CALL DisplayStatus2
    RETURN
END IF
IF CurrentUndo > 0! THEN
    NextUndo! = CurrentUndo
    GOSUB UndoIt
END IF
RETURN

' undo all bytes from stored arrays of previous position/byte value.
UndoAll:
IF CurrentUndo = 0! THEN
    StatusMessage = "No bytes to restore."
    CALL DisplayStatus2
    RETURN
END IF
IF CurrentUndo > 0! THEN
    TotalUndos! = CurrentUndo
    FOR NextUndo! = TotalUndos! TO 1! STEP -1
        GOSUB UndoIt
    NEXT
END IF
RETURN

' Undo one byte.
UndoIt:
CALL ClearPageByte
LastPage = FilePage
FileByte = CHR$(UndoByte%(NextUndo!))
FilePosition = UndoPosition#(NextUndo!)
CurrentUndo = CurrentUndo - 1!
SeekPosition = FilePosition
CALL LseekFile
CALL WriteFile
CALL CalculatePosition1
IF LastPage <> FilePage THEN
    LastPage = FilePage
    CALL DisplayHexPage
END IF
CALL DisplayPageByte
RETURN

REM Cursor key routines:

' move cursor up.
CursorUp:
IF PageRow - 1 >= 1 THEN
    CALL ClearPageByte
    PageRow = PageRow - 1
    FilePosition = FilePosition - 20
    CALL DisplayPageByte
    RETURN
END IF
CALL ClearPageByte
CALL DisplayPageByte
RETURN

' move cursor down.
CursorDown:
IF PageRow + 1 <= 16 THEN
    IF FilePosition + 20 <= FileLength THEN
        CALL ClearPageByte
        PageRow = PageRow + 1
        FilePosition = FilePosition + 20
        IF FilePosition > FileLength THEN
            PageColumn = PageColumn - 1
            FilePosition = FilePosition - 1
        END IF
        CALL DisplayPageByte
        RETURN
    END IF
END IF
CALL ClearPageByte
CALL DisplayPageByte
RETURN

' move cursor left.
CursorLeft:
IF PageColumn - 1 >= 1 THEN
    IF CopyPositionStart > False THEN
        IF PageColumn = 20 THEN
            CALL ClearPageByte
            CALL DisplayPageByte
            RETURN
        END IF
        IF FilePosition = FileLength THEN
            CALL ClearPageByte
            CALL DisplayPageByte
            RETURN
        END IF
    END IF
    CALL ClearPageByte
    PageColumn = PageColumn - 1
    FilePosition = FilePosition - 1
    CALL DisplayPageByte
ELSE
    CALL ClearPageByte
    IF PageColumn > 1 THEN
        PageColumn = 1
        FilePosition = FilePosition - 1
    END IF
    CALL DisplayPageByte
END IF
RETURN

' move cursor right.
CursorRight:
IF PageColumn + 1 <= 20 THEN
    IF FilePosition + 1 <= FileLength THEN
        CALL ClearPageByte
        IF PageColumn < 20 THEN
            IF FilePosition + 1 <= FileLength THEN
                PageColumn = PageColumn + 1
                FilePosition = FilePosition + 1
            END IF
        END IF
        CALL DisplayPageByte
        RETURN
    END IF
END IF
CALL ClearPageByte
CALL DisplayPageByte
RETURN

' end key.
EndKey:
' set to column 20
IF PageColumn < 20 THEN
    ' check column 20 is positioned before end of file
    IF FilePosition - PageColumn + 20 <= FileLength THEN
        CALL ClearPageByte
        FilePosition = FilePosition - PageColumn + 20
        PageColumn = 20
        CALL DisplayPageByte
    ELSE
        ' position end of file
        CALL ClearPageByte
        FilePosition = FileLength
        CALL CalculatePosition1
        CALL DisplayPageByte
    END IF
ELSE
    CALL ClearPageByte
    CALL DisplayPageByte
    CALL LocateCursor
END IF
RETURN

' home key.
HomeKey:
IF PageColumn > 1 THEN
    CALL ClearPageByte
    FilePosition = FilePosition - PageColumn + 1
    PageColumn = 1
    CALL DisplayPageByte
ELSE
    CALL ClearPageByte
    IF PageColumn > 1 THEN
        PageColumn = 1
        FilePosition = FilePosition - 1
    END IF
    CALL DisplayPageByte
    CALL LocateCursor
END IF
RETURN

' control-left key.
CtrlLeftKey:
NewColumn = False
SELECT CASE PageColumn
    CASE 2, 3, 4
        NewColumn = 1
    CASE 5
        NewColumn = 4
    CASE 6, 7, 8
        NewColumn = 5
    CASE 9
        NewColumn = 8
    CASE 10, 11, 12
        NewColumn = 9
    CASE 13
        NewColumn = 12
    CASE 14, 15, 16
        NewColumn = 13
    CASE 17
        NewColumn = 16
    CASE 18, 19, 20
        NewColumn = 17
END SELECT
IF NewColumn > False THEN
    CALL ClearPageByte
    FilePosition = FilePosition - PageColumn + NewColumn
    PageColumn = NewColumn
    CALL DisplayPageByte
END IF
RETURN

' control-right key.
CtrlRightKey:
NewColumn = False
SELECT CASE PageColumn
    CASE 1, 2, 3
        NewColumn = 4
    CASE 4
        NewColumn = 5
    CASE 5, 6, 7
        NewColumn = 8
    CASE 8
        NewColumn = 9
    CASE 9, 10, 11
        NewColumn = 12
    CASE 12
        NewColumn = 13
    CASE 13, 14, 15
        NewColumn = 16
    CASE 16
        NewColumn = 17
    CASE 17, 18, 19
        NewColumn = 20
END SELECT
IF NewColumn THEN
    ' check new column is positioned before end of file
    IF FilePosition - PageColumn + NewColumn <= FileLength THEN
        CALL ClearPageByte
        FilePosition = FilePosition - PageColumn + NewColumn
        PageColumn = NewColumn
        CALL DisplayPageByte
    ELSE
        ' position end of file
        CALL ClearPageByte
        FilePosition = FileLength
        CALL CalculatePosition1
        CALL DisplayPageByte
    END IF
END IF
RETURN

' control-end key.
CtrlEndKey:
IF FilePosition <> FileLength THEN
    LastPage = FilePage
    CALL ClearPageByte
    FilePosition = FileLength
    CALL CalculatePosition1
    IF LastPage <> FilePage THEN
        CALL DisplayHexPage
    END IF
    CALL DisplayPageByte
ELSE
    CALL ClearPageByte
    CALL DisplayPageByte
    CALL LocateCursor
END IF
RETURN

' control-home key.
CtrlHomeKey:
IF FilePosition <> 1 THEN
    LastPage = FilePage
    CALL ClearPageByte
    FilePosition = 1
    CALL CalculatePosition1
    IF LastPage <> FilePage THEN
        CALL DisplayHexPage
    END IF
    CALL DisplayPageByte
END IF
RETURN

' move one page up.
PageUp:
' check there is a page to move up.
IF FilePosition - 320 >= 1 THEN
    FilePage = FilePage - 1
    FilePosition = FilePosition - 320
    CALL DisplayHexPage
    CALL DisplayPageByte
ELSE
    ' check there is a first position on the first page to move up to.
    IF FilePosition > 1 THEN
        CALL ClearPageByte
        PageRow = 1
        PageColumn = 1
        FilePosition = 1
        CALL DisplayPageByte
    ELSE
        CALL ClearPageByte
        CALL DisplayPageByte
        CALL LocateCursor
    END IF
END IF
RETURN

' move one page down.
PageDown:
' check there is a page to move down.
IF FilePosition + 320 <= FileLength THEN
    FilePage = FilePage + 1
    FilePosition = FilePosition + 320
    CALL DisplayHexPage
    CALL DisplayPageByte
ELSE
    ' check there is a last position on the last page to move down to.
    IF FilePosition < FileLength THEN
        CALL ClearPageByte
        FilePosition = FileLength
        CALL CalculatePosition1
        CALL DisplayHexPage
        CALL DisplayPageByte
    ELSE
        CALL ClearPageByte
        CALL DisplayPageByte
        CALL LocateCursor
    END IF
END IF
RETURN

REM More routines:

' switch editing windows.
TabWindow:
IF CurrentWindow2 = False THEN
    CurrentWindow = NOT CurrentWindow
    CALL DisplayPosition
    CALL LocateCursor2
END IF
RETURN

' switch right editing window.
ToggleRight:
CurrentWindow = False
CurrentWindow2 = NOT CurrentWindow2
CALL RedrawRightWindow
CALL DisplayPageByte
RETURN

' change the byte value at the current position.
'   change by hex value in left window,
'   by ascii value in right window.
'   overrides with +255 in left window,
'   and with hff in right window.
ChangeHexValue:
CALL ClearStatus
FileByte = Nul
ValidByteString = False
IF CurrentWindow = False THEN
    Printf "Enter hex byte value?"
    ByteString$ = LineInput$(2, 26, 4)
    IF LEFT$(ByteString$, 1) = "+" THEN
        ByteString$ = MID$(ByteString$, 2)
        IF LEN(ByteString$) = 3 THEN
            NewValue = INT(VAL(ByteString$))
            IF NewValue >= False AND NewValue <= 255 THEN
                ValidByteString = True
                FileByte = CHR$(NewValue)
            END IF
        END IF
    ELSE
        IF LEN(ByteString$) = 2 THEN
            AllowWildCard = False
            CALL CheckHexBytes(ByteString$)
            IF ValidByteString THEN
                NewValue = VAL("&H" + ByteString$)
                FileByte = CHR$(NewValue)
            END IF
        END IF
    END IF
ELSE
    Printf "Enter ascii byte value?"
    ByteString$ = LineInput$(2, 28, 4)
    IF UCASE$(LEFT$(ByteString$, 1)) = "H" THEN
        ByteString$ = MID$(ByteString$, 2)
        IF LEN(ByteString$) = 2 THEN
            AllowWildCard = False
            CALL CheckHexBytes(ByteString$)
            IF ValidByteString THEN
                NewValue = VAL("&H" + ByteString$)
                FileByte = CHR$(NewValue)
            END IF
        END IF
    ELSE
        IF LEN(ByteString$) = 3 THEN
            NewValue = INT(VAL(ByteString$))
            IF NewValue >= False AND NewValue <= 255 THEN
                ValidByteString = True
                FileByte = CHR$(NewValue)
            END IF
        END IF
    END IF
END IF
IF ValidByteString = False THEN
    StatusMessage = "Invalid byte."
    CALL DisplayStatus2
    RETURN
END IF
GOSUB StoreUndo
SeekPosition = FilePosition
CALL LseekFile
CALL WriteFile
CALL DisplayPageByte
CALL DisplayFilename
RETURN

' change the ascii values with string starting at the current position.
ChangeASCIIValues:
CALL ClearStatus
Printf "Enter ascii value(s)?"
ByteString$ = LineInput$(2, 26, 52)
IF LEN(ByteString$) = False THEN
    StatusMessage = "Invalid ascii string."
    CALL DisplayStatus2
    RETURN
END IF
' init file.
IF FileLength = 0 THEN
    Byte2 = 0
    GOSUB AppendIt
    IF ValidAppend = False THEN
        RETURN
    END IF
ELSE
    ' store all current values.
    StorePosition = FilePosition
    FOR NumberBytes = 1 TO LEN(ByteString$)
        SeekPosition = FilePosition
        CALL LseekFile
        CALL ReadFile
        FileByte = Buffer
        AsciiValue = ASC(FileByte)
        GOSUB StoreUndo
        IF FilePosition = FileLength THEN
            EXIT FOR
        END IF
        FilePosition = FilePosition + 1
    NEXT
    FilePosition = StorePosition
END IF
' write ascii string.
ValidAppend = True
FOR NumberBytes = 1 TO LEN(ByteString$)
    IF FilePosition > FileLength THEN
        Byte2 = 0
        GOSUB AppendIt
        IF ValidAppend = False THEN
            EXIT FOR
        END IF
    END IF
    FileByte = MID$(ByteString$, NumberBytes, 1)
    SeekPosition = FilePosition
    CALL LseekFile
    CALL WriteFile
    CALL CalculatePosition1
    IF LastPage <> FilePage THEN
        LastPage = FilePage
        CALL DisplayHexPage
    END IF
    CALL ClearPageByte
    FilePosition = FilePosition + 1
NEXT
IF ValidAppend THEN
    FilePosition = FilePosition - 1
END IF
CALL DisplayPageByte
CALL DisplayFilename
RETURN

' change the hex values with string starting at the current position.
ChangeHEXValues:
CALL ClearStatus
Printf "Enter HEX value(s)?"
ByteString$ = LineInput$(2, 24, 54)
IF LEN(ByteString$) = False THEN
    StatusMessage = "Invalid hex string."
    CALL DisplayStatus2
    RETURN
END IF
' check hex string.
AllowWildCard = False
CALL CheckHexBytes(ByteString$)
IF ValidByteString = False THEN
    StatusMessage = "Invalid hex string."
    CALL DisplayStatus2
    RETURN
END IF
' init file.
IF FileLength = 0 THEN
    Byte2 = 0
    GOSUB AppendIt
    IF ValidAppend = False THEN
        RETURN
    END IF
ELSE
    ' store all current values.
    StorePosition = FilePosition
    FOR NumberBytes = 1 TO LEN(ByteString$) STEP 2
        SeekPosition = FilePosition
        CALL LseekFile
        CALL ReadFile
        FileByte = Buffer
        AsciiValue = ASC(FileByte)
        GOSUB StoreUndo
        IF FilePosition = FileLength THEN
            EXIT FOR
        END IF
        FilePosition = FilePosition + 1
    NEXT
    FilePosition = StorePosition
END IF
' write hex string.
ValidAppend = True
FOR NumberBytes = 1 TO LEN(ByteString$) STEP 2
    IF FilePosition > FileLength THEN
        Byte2 = 0
        GOSUB AppendIt
        IF ValidAppend = False THEN
            EXIT FOR
        END IF
    END IF
    FileByte = CHR$(VAL("&H" + MID$(ByteString$, NumberBytes, 2)))
    SeekPosition = FilePosition
    CALL LseekFile
    CALL WriteFile
    CALL CalculatePosition1
    IF LastPage <> FilePage THEN
        LastPage = FilePage
        CALL DisplayHexPage
    END IF
    CALL ClearPageByte
    FilePosition = FilePosition + 1
NEXT
IF ValidAppend THEN
    FilePosition = FilePosition - 1
END IF
CALL DisplayPageByte
CALL DisplayFilename
RETURN

' record the current byte position and value,
'   increment the number of undos in record structure array.
StoreUndo:
IF CurrentUndo < 1048576! THEN
    CurrentUndo = CurrentUndo + 1!
    GET #6, CurrentUndo, UndoFile
    MID$(UndoFile.UndoByte1, (CurrentFile - 1) * 2 + 1, 2) = MKI$(AsciiValue)
    MID$(UndoFile.UndoPosition1, (CurrentFile - 1) * 8 + 1, 8) = MKD$(FilePosition)
    PUT #6, CurrentUndo, UndoFile
END IF
RETURN

REM Drop down input menu.

Menu2:
CALL DropDownMenu
IF CurrentMenu = False THEN
    CALL LocateCursor
    GOTO StartLoop
END IF
SELECT CASE CurrentMenu
    CASE 1
        SELECT CASE CurrentMenuSelection
            CASE 1 ' Alt-N  Open new file
                IF NumberFiles < MaxFiles THEN
                    CALL MultiFileFunction(2)
                    GOSUB NewFile
                    GOTO BeginFile
                END IF
            CASE 2 ' Alt-W  Close file
                GOSUB CloseCurrentFile
                IF NumberFiles = False THEN
                    GOSUB NewFile
                    GOTO BeginFile
                END IF
            CASE 3 ' Alt-0  Close All Files
                GOSUB CloseAllFiles
                GOSUB NewFile
                NumberFiles = False
                GOTO BeginFile
            CASE 4 ' Alt-V  View files
                CALL Viewfiles(Var)
                IF Var > False THEN
                    NextFile = Var
                    GOSUB SearchFile3
                END IF
                CALL DisplayFilename
            CASE 5 ' Alt-Y  Toggle window
                IF FileLength THEN
                    GOSUB ToggleRight
                END IF
            CASE 6 ' Alt-X  Exit program
                GOTO StopLabel
        END SELECT
    CASE 2
        SELECT CASE CurrentMenuSelection
            CASE 1 ' Alt-C  ANSI Chart
                GOSUB ANSIChart
            CASE 2 ' Alt-H  HEX Chart
                GOSUB HEXChart
        END SELECT
    CASE 3
        IF FileLength THEN
            SELECT CASE CurrentMenuSelection
                CASE 1 ' Alt-D  HEX Screen Dump
                    GOSUB DumpScreen
                CASE 2 ' Alt-E  HEX File Dump
                    GOSUB DumpHEXFile
            END SELECT
        END IF
    CASE 4
        SELECT CASE CurrentMenuSelection
            CASE 1 ' Alt-A  Append bytes
                GOSUB AppendByte
            CASE 2 ' Alt-M  Append ASCII string
                GOSUB AppendASCII
            CASE 3 ' Alt-R  Redraw screen
                CALL MultiFileFunction(2)
                GOSUB RedrawScreen0
            CASE 4 ' Alt-U  Undo last byte
                IF FileLength THEN
                    GOSUB UndoByte
                END IF
            CASE 5 ' Alt-Z  Undo All bytes
                IF FileLength THEN
                    GOSUB UndoAll
                END IF
        END SELECT
    CASE 5
        IF FileLength THEN
            SELECT CASE CurrentMenuSelection
                CASE 1 ' Alt-J  Jump to byte
                    GOSUB JumpByte
                CASE 2 ' Alt-L  Jump to page
                    GOSUB JumpPage
            END SELECT
        END IF
    CASE 6
        IF FileLength THEN
            SELECT CASE CurrentMenuSelection
                CASE 1 ' Alt-P  HEX Screen Print
                    GOSUB PrintScreen
                CASE 2 ' Alt-T  HEX File Print
                    GOSUB PrintFile
            END SELECT
        END IF
    CASE 7
        IF FileLength THEN
            SELECT CASE CurrentMenuSelection
                CASE 1 ' Alt-K  Search for string
                    GOSUB SearchASCII
                CASE 2 ' Alt-S  Search for bytes
                    GOSUB SearchBytes
            END SELECT
        END IF
END SELECT
CALL LocateCursor
GOTO StartLoop

REM Long filename open routine:

REM Open file in Windows.
REM Create file if nonexistent.
REM Returns:
REM   ValidFile=True if open successful.
REM   FileLocked=True if file locked.

OpenFile:
ErrorTrap = False
FileLocked = False
ValidFile = False
FileAttribute = False
Check.Disk = True
Disk.Ready = False
Handle = FREEFILE
OPEN Filename FOR BINARY SHARED AS #Handle
Check.Disk = False
IF Disk.Ready THEN
    RETURN
END IF
ValidFile = True
' get file attribute.
FileAttribute = GetFileAttr(ASCIIZ)
' check file is read-only.
IF (FileAttribute AND 1) = 1 THEN
    FileLocked = True
END IF
RETURN

REM close all files.
CloseAllFiles:
FOR Var = 1 TO NumberFiles
    Handle = File(Var).Handle
    FileLocked = File(Var).FileLocked
    FileLength = File(Var).FileLength
    IF Handle THEN
        GOSUB CloseFile
    END IF
NEXT
RETURN

REM close file.
CloseFile:
CLOSE #Handle
Handle = 0
RETURN

REM write byte block to file.
WriteBlockFile:
Share.Count = 0
IF FileLocked THEN
    Write.Error = True
    RETURN
END IF
Write.Error = False
Check.Disk = True
Disk.Ready = False
SeekPosition2 = SeekPosition + 1
SEEK Handle, SeekPosition2
PUT Handle, , BlockByte
Check.Disk = False
IF Disk.Ready THEN
    Write.Error = True
END IF
RETURN

REM get netpath from filename
ParseNetPath: ' \\server\share\filename.ext
NetPath$ = Nul
IF LEFT$(Filename, 2) = "\\" THEN
    Net1 = INSTR(3, Filename, "\")
    IF Net1 THEN
        Net2 = INSTR(Net1 + 1, Filename, "\")
        IF Net2 THEN
            NetPath$ = LEFT$(Filename, Net2 - 1)
        END IF
    END IF
END IF
RETURN

REM conanicalize filename for display purposes.
ShortFilename:
' read ambiguated 8.3 filename.
ASCIIZ3 = ASCIIZ
CALL GetShortFilename(Short.Filename$)
ASCIIZ = ASCIIZ3

' store 64-byte filename.
Filename = Short.Filename$
ShortFilename = Filename
CurrentNetPath = NetPath$

' read conanicalized 8.3 filename.
Filename = Conanicalize$(Filename)
RETURN

REM Shell routines:

REM Run DOS shell.
DOSshell:
CALL MultiFileFunction(2)
Colorf Plain
CLS
Printf "Type 'Exit' to return to editor.."
Locatef 2, 1, 1
SHELL
GOSUB RedrawScreen0
RETURN

REM Run screen saver.
SaveShell:
s%& = SendMessageA(&HFFFF&, wm_syscommand, sc_screensave, 0&)
CALL MultiFileFunction(2)
Colorf Plain
CLS
Printf "Press any key to return to editor.."
Locatef 2, 1, 1
DO
    _LIMIT 100
    IF INKEY$ <> "" THEN
        EXIT DO
    END IF
LOOP
GOSUB RedrawScreen0
RETURN

REM Run DOS command in shell.
DOScommand:
CALL MultiFileFunction(2)
CALL ClearStatus
Printf "Enter DOS command?"
InputString$ = LineInput$(2, 23, 55)
IF LEN(InputString$) THEN
    ' open filename.
    x2 = FREEFILE
    DOSfilename$ = "DOSEXIT" + MID$(STR$(Process.Number), 2) + ".BAT"
    OPEN DOSfilename$ FOR OUTPUT SHARED AS #x2

    ' write DOS commands.
    PRINT #x2, InputString$
    PRINT #x2, "PAUSE"
    PRINT #x2, "EXIT"
    CLOSE #x2

    ' clear screen
    Colorf Plain
    CLS

    ' shell to batch file.
    SHELL DOSfilename$
END IF
GOSUB RedrawScreen0
RETURN

REM Mouse routines:

' move mouse cursor for mouseover.
MoveMouse:
' check mouse boundaries.
IF MouseX = 1 THEN
    NewMenuSelection = False
    SELECT CASE MouseY
        CASE 6 TO 9 ' File
            NewMenuSelection = 1
        CASE 16 TO 21 ' Charts
            NewMenuSelection = 2
        CASE 26 TO 29 ' Dump
            NewMenuSelection = 3
        CASE 36 TO 39 ' Edit
            NewMenuSelection = 4
        CASE 46 TO 49 ' Jump
            NewMenuSelection = 5
        CASE 56 TO 60 ' Print
            NewMenuSelection = 6
        CASE 64 TO 69 ' Search
            NewMenuSelection = 7
    END SELECT
    IF NewMenuSelection > False THEN
        IF NewMenuSelection <> CurrentMenu THEN
            IF CurrentMenu > False THEN
                ' remove hilight menu tab.
                Colorf2 White, 0
                CALL DisplayTab(CurrentMenu)
            END IF
        END IF
        CurrentMenu = NewMenuSelection
        CurrentMenuSelection = 1
    END IF
    ' hilight menu tab.
    IF CurrentMenu > False THEN
        Colorf2 White, 1
        CALL DisplayTab(CurrentMenu)
    END IF
    CALL LocateCursor2
    RETURN
END IF

' clear file menu tab.
IF CurrentMenu THEN
    Colorf2 White, 0
    CALL DisplayTab(CurrentMenu)
END IF

' move to new byte.
IF MouseX > 3 AND MouseX < 20 THEN
    IF MouseY > 5 AND MouseY < 50 THEN
        VarX = SCREEN(MouseX, MouseY)
        IF VarX <> 32 THEN
            NewPosition = CalculatePosition3#
            IF NewPosition <> FilePosition THEN
                CALL ClearPageByte
                FilePosition = NewPosition
                CALL CalculatePosition1
                CALL DisplayPageByte
                CALL DisplayFilename
            END IF
        END IF
    END IF
END IF
RETURN

' process left mouse button click.
MouseMove1:
' stop program.
IF MouseX = 3 AND MouseY = 77 THEN
    GOTO StopLabel
END IF
' help screen.
IF MouseX = 4 AND MouseY = 77 THEN
    GOSUB DisplayHelp
    RETURN
END IF
' page up.
IF MouseX = 4 AND MouseY = 52 THEN
    IF FileLength THEN
        GOSUB PageUp
    END IF
    RETURN
END IF
' page down.
IF MouseX = 20 AND MouseY = 52 THEN
    IF FileLength THEN
        GOSUB PageDown
    END IF
    RETURN
END IF
' line up.
IF MouseX = 5 AND MouseY = 52 THEN
    IF FileLength THEN
        GOSUB CursorUp
    END IF
    RETURN
END IF
' line down.
IF MouseX = 19 AND MouseY = 52 THEN
    IF FileLength THEN
        GOSUB CursorDown
    END IF
    RETURN
END IF
' select drop down menu.
IF MouseX = 1 THEN
    SELECT CASE MouseY
        CASE 6 TO 9 ' File
            NewMenuSelection = 1
        CASE 16 TO 21 ' Charts
            NewMenuSelection = 2
        CASE 26 TO 29 ' Dump
            NewMenuSelection = 3
        CASE 36 TO 39 ' Edit
            NewMenuSelection = 4
        CASE 46 TO 49 ' Jump
            NewMenuSelection = 5
        CASE 56 TO 60 ' Print
            NewMenuSelection = 6
        CASE 64 TO 69 ' Search
            NewMenuSelection = 7
        CASE ELSE
            RETURN
    END SELECT
    IF NewMenuSelection <> CurrentMenu THEN
        IF CurrentMenu > False THEN
            ' remove hilight menu tab.
            Colorf2 White, 0
            CALL DisplayTab(CurrentMenu)
        END IF
    END IF
    CurrentMenu = NewMenuSelection
    CurrentMenuSelection = 1
    ' hilight menu tab.
    Colorf2 White, 1
    CALL DisplayTab(CurrentMenu)
    ' jump to file menu.
    GOTO Menu2
    RETURN
END IF
IF MouseX > 3 AND MouseX < 20 THEN
    IF MouseY > 5 AND MouseY < 50 THEN
        VarX = SCREEN(MouseX, MouseY)
        IF VarX <> 32 THEN
            IF FileLocked THEN
                CALL DisplayX
                CALL LockedFile
                RETURN
            END IF
            IF FileLength THEN
                GOSUB ChangeHexValue
            END IF
        END IF
    END IF
END IF
RETURN

' process right mouse button click/drag.
MouseMove2:
IF MouseX > 3 AND MouseX < 20 THEN
    IF MouseY > 5 AND MouseY < 50 THEN
        VarX = SCREEN(MouseX, MouseY)
        IF VarX <> 32 THEN
            NewPosition = CalculatePosition3#
            CopyStart = NewPosition
            DO
                IF MouseX OR MouseY THEN
                    IF MouseY > 5 AND MouseY < 50 THEN
                        IF MouseX > 3 AND MouseX < 20 THEN
                            CALL MouseButton1Drag(0)
                        ELSE
                            IF MouseX = 3 THEN
                                CALL MouseButton1Drag(9) ' pageup
                            ELSE
                                IF MouseX = 20 THEN
                                    CALL MouseButton1Drag(10) ' pagedown
                                END IF
                            END IF
                        END IF
                    END IF
                END IF
                Z = MouseDriver
            LOOP UNTIL MouseButton2 = 0
        END IF
    END IF
END IF
RETURN

' timer ctrl-break trap.
Timer.Trap:
VarQ = _EXIT
IF VarQ THEN ' Control-Break
    CLS
    ' delete process filenames.
    CALL Delete.Process
    SYSTEM
END IF
RETURN

' critical error trap.
Error.Routine:
' trap error cascade.
IF InErrorFlag THEN
    SYSTEM
END IF

' check error return type.
ErrorTrap = ERR
IF Check.Disk THEN
    Disk.Ready = ERR
    RESUME NEXT
END IF

' check share violations.
IF ERR = 70 THEN
    Share.Count = Share.Count + 1
    IF Share.Count < MaxViolations THEN
        RESUME
    END IF
END IF
ScreenDrawn = False

' store background color of bottom row.
BG = SCREEN(25, 1, 1) \ 16

' display critical error.
Colorf White
Locatef 25, 1, 0
Printf "Error" + STR$(ERR) + ": "
CALL DisplayCriticalError(ErrorTrap)
Printf ": IDE" + STR$(_ERRORLINE) + " Press R(etry), C(ontinue), Q(uit):"

' get keypress.
DO
    _LIMIT 100
    ErrorRespond$ = INKEY$

    ' parse key.
    SELECT CASE LCASE$(ErrorRespond$)
        CASE "r"
            Printf "r"
            Colorf2 7, BG
            Locatef 25, 1, 0
            Printf SPACE$(79)
            Colorf2 7, 0
            RESUME
        CASE "c"
            Printf "c"
            Colorf2 7, BG
            Locatef 25, 1, 0
            Printf SPACE$(79)
            Colorf2 7, 0
            RESUME NEXT
        CASE "q"
            Printf "q"
            Colorf2 7, BG
            Locatef 25, 1, 0
            Printf SPACE$(79)
            Colorf2 7, 0
            RESUME StopLoop
    END SELECT
LOOP
CALL Delete.Process
END 2

' end of program.
StopLoop:
' close all files.
GOSUB CloseAllFiles

' stop program.
StopProgram:
Colorf2 7, 0

' delete process filenames.
CALL Delete.Process

' reset mouse activity.
CALL ClearMouse

' terminate program.
IF FastExit THEN
    SYSTEM
ELSE
    END 0
END IF

' terminal error exits here.
Error.Exit:
' display error.
Colorf2 White, 0
CLS
Printf "Hex Editor " + Version + " " + Release + " critical error trap:"
Colorf Yellow
Locatef CSRLIN + 1, 1, 0
CALL DisplayCriticalError(ErrorTrap)
Printf "."
Locatef CSRLIN + 1, 1, 0
Printf "Err:" + STR$(ERR) + " IDE:" + STR$(_ERRORLINE) + " Press R(etry), C(ontinue), Q(uit):"
Colorf Plain
' delete process filenames.
CALL Delete.Process
END 2

' Def FNclock$=Format$(Now,"ddd dd mmm yy\, hh:mma/p")
FUNCTION clock$
    ' mm-dd-yyyy hh:mm:ss

    M = VAL(LEFT$(DATE$, 2))
    D = VAL(MID$(DATE$, 4, 2))
    Y = VAL(RIGHT$(DATE$, 2))
    IF M < 3 THEN M = M + 12: Y = Y - 1
    W = ((13 * M + 3) \ 5 + D + Y + Y \ 4 - Y \ 100 + Y \ 400 + 1) MOD 7
    clock$ = MID$("SunMonTueWedThuFriSat", W * 3 + 1, 3)
    clock$ = clock$ + " " + MID$(DATE$, 4, 2) ' dd

    T = (VAL(MID$(DATE$, 1, 2)) - 1) * 3 + 1
    clock$ = clock$ + " " + MID$("JanFebMarAprMayJunJulAugSepOctNovDec", T, 3)

    clock$ = clock$ + " " + MID$(DATE$, 9, 2) ' yy
    T = VAL(LEFT$(TIME$, 2))
    IF T > 11 THEN T = T - 12
    IF T = 0 THEN T = 12
    clock$ = clock$ + ", " + RIGHT$("00" + LTRIM$(STR$(T)), 2) ' hh
    clock$ = clock$ + ":" + MID$(TIME$, 4, 2) ' mm

    T = VAL(LEFT$(TIME$, 2))
    IF T < 12 THEN
        clock$ = clock$ + "a"
    ELSE
        clock$ = clock$ + "p"
    END IF
END FUNCTION

REM Subroutines:
REM   CalculatePosition1    --  calculate screen values given file position.
REM   CalculatePosition2    --  calculate screen values given variable.
REM   Colorf            --  specialized color function.
REM   Colorf2           --  specialized color function.
REM   DisplayBootUsage  --  display boot usage.
REM   DisplayScreen     --  display main editing screen.
REM   DisplayScreen2    --  display screen border.
REM   Deconcatenate     --  deconcatenates filename.
REM   DropDownMenu      --  starts top drop down menu.
REM   DisplayTab        --  redraws menu tab.
REM   DisplayCriticalError  --  display error trap message.
REM   ExcludeList       --  gets exluded filelist for menu.
REM   GetDrive          --  reads default drive/directory.
REM   InitializePaste   --  initialize paste file.
REM   InitPasteFiles    --  init paste files for new file.
REM   InitVars          --  inits some startup variables.
REM   Locatef           --  specialized locate function.
REM   MultiFileFunction     --  routine to process multiple files.
REM   OpenUndoFile      --  open undo/marker file.
REM   OpenPasteFiles    --  open paste files.
REM   Printf            --  specialized print function.
REM   ReadConfigFile    --  search for and read configure file.
REM   StoreServerName   --  stores default server name.

REM Gets default drive/directory.
SUB GetDrive (Drive.Number, Directory$)
    ' store current directory.
    Directory.ASCIIZ = _CWD$
    Directory$ = Directory.ASCIIZ
    Drive.Number = ASC(LEFT$(Directory$, 1)) - 65 ' 0=a, 1=b, ..
    IF MID$(Directory$, 2, 1) = ":" THEN
        Directory$ = MID$(Directory$, 3)
    END IF
    IF LEFT$(Directory$, 1) = "\" THEN
        Directory$ = MID$(Directory$, 2)
    END IF
END SUB

REM Store default server name.
SUB StoreServerName
    ' store default server name.
    Var$ = ENVIRON$("COMPUTERNAME")
    IF LEN(Var$) THEN
        DefaultNetPath = Var$
    END IF
END SUB

REM Subroutine to init variables.
SUB InitVars
    ' init a quote symbol.
    Quote = CHR$(34)

    ' reset default printer port.
    PrinterPort = 1

    ' reset default string store variable.
    StoreSearchMulti = True

    ' init screen colors.
    Black = 0
    Blue = 9
    Cyan = 11
    Green = 10
    Magenta = 13
    Plain = 7
    Red = 12
    White = 15
    Yellow = 14
    BackGround = 1
    BackGround2 = 1

    ' init ascii characters.
    Hline = 205
    Vline = 186
    ULcorner = 201
    URcorner = 187
    LLcorner = 200
    LRcorner = 188

    ' check for Windows loaded.
    IF INSTR(_OS$, "[WINDOWS]") THEN
        Windows.Detected = True
        IF INSTR(_OS$, "[ANDROID]") THEN
            Windows.Detected = False
        END IF
    END IF

    ' check windows.
    IF Windows.Detected = 0 THEN
        SYSTEM
    END IF

    ' store mouse timing.
    MouseTime = 1!

    ' store max file menu box files.
    SortMax = 32768!
    SortMax2 = 16384!

    ' get default drives.
    CALL GetDrives

    ' check temp directory.
    FX$ = "C:\TEMP"
    IF Node THEN
        FX$ = "C:\TEMP" + LTRIM$(STR$(Node))
    END IF
    IF _DIREXISTS(FX$) = 0 THEN
        IF _FILEEXISTS(FX$) THEN
            G$ = FX$ + CHR$(0)
            x = DeleteFileA(G$)
        END IF
        G$ = FX$ + CHR$(0)
        x = CreateDirectoryA(G$, 0)
    END IF
    DRX = FX$ + "\"

    ' init filename variables.
    ConfigFile = "hexedit.cfg"
    Var$ = ENVIRON$("CONFIGFILE")
    IF LEN(Var$) THEN
        IF INSTR(Var$, ":") THEN
            Eat$ = Nul
        ELSE
            IF INSTR(Var$, "\") THEN
                Eat$ = Nul
            ELSE
                ConfigFile = Var$
            END IF
        END IF
    END IF
    DumpFile = "hexedit.dmp"
    Var$ = ENVIRON$("DUMPFILE")
    IF LEN(Var$) THEN
        IF INSTR(Var$, ":") THEN
            Eat$ = Nul
        ELSE
            IF INSTR(Var$, "\") THEN
                Eat$ = Nul
            ELSE
                DumpFile = Var$
            END IF
        END IF
    END IF
    ExcludeFile = "hexedit.exd"
    Var$ = ENVIRON$("EXCLUDEFILE")
    IF LEN(Var$) THEN
        IF INSTR(Var$, ":") THEN
            Eat$ = Nul
        ELSE
            IF INSTR(Var$, "\") THEN
                Eat$ = Nul
            ELSE
                ExcludeFile = Var$
            END IF
        END IF
    END IF
END SUB

REM subroutine to send string of characters to screen.
SUB Printf (Var1$)
    FOR VarX = 1 TO LEN(Var1$)
        VarY = ASC(MID$(Var1$, VarX, 1))
        PRINT CHR$(VarY);
    NEXT
END SUB

REM subroutine stores recent color change.
SUB Colorf (Var)
    COLOR Var
END SUB

REM subroutine stores recent color change.
SUB Colorf2 (Var1, Var2)
    COLOR Var1, Var2
END SUB

REM subroutine sets cursor position.
SUB Locatef (Var1, Var2, Var3)
    ' test end of page.
    IF Var1 > 24 THEN
        ' scroll screen.
        PRINT ;
    END IF
    LOCATE Var1, Var2, Var3
END SUB

REM subroutine to access multiple file structure.
REM input variable:
REM   Var = 1 init new file.
REM   Var = 2 store current file.
REM   Var = 3 restore current file.
SUB MultiFileFunction (Var)
    SELECT CASE Var
        CASE 1 ' Init new file.
            File(CurrentFile).AsciiValue = False
            File(CurrentFile).ASCIIZ = ASCIIZ
            File(CurrentFile).Buffer = CHR$(0)
            File(CurrentFile).CopyPositionEnd = 0
            File(CurrentFile).CopyPositionPivot = 0
            File(CurrentFile).CopyPositionStart = 0
            File(CurrentFile).CurrentMarker = 0!
            File(CurrentFile).CurrentUndo = 0!
            File(CurrentFile).CurrentWindow2 = 0
            File(CurrentFile).FileDisplay = FileDisplayX
            File(CurrentFile).Filename = Filename
            File(CurrentFile).FileAttribute = FileAttribute
            File(CurrentFile).FileByte = CHR$(0)
            File(CurrentFile).FileLength = FileLength
            File(CurrentFile).FileLocked = FileLocked
            File(CurrentFile).FilePage = 1
            File(CurrentFile).FilePosition = 1
            File(CurrentFile).Handle = Handle
            File(CurrentFile).MarkerCount = 0!
            File(CurrentFile).Netpath = CurrentNetPath
            File(CurrentFile).PageColumn = 1
            File(CurrentFile).PageRow = 1
            File(CurrentFile).ScreenRow = ScreenRowX
            File(CurrentFile).ShortFilename = ShortFilename
            File(CurrentFile).StoreSearchString = ""
        CASE 2 ' Store current file.
            File(CurrentFile).AsciiValue = AsciiValue
            File(CurrentFile).ASCIIZ = ASCIIZ
            File(CurrentFile).Buffer = Buffer
            File(CurrentFile).CopyPositionEnd = CopyPositionEnd
            File(CurrentFile).CopyPositionPivot = CopyPositionPivot
            File(CurrentFile).CopyPositionStart = CopyPositionStart
            File(CurrentFile).CurrentMarker = CurrentMarker
            File(CurrentFile).CurrentUndo = CurrentUndo
            File(CurrentFile).CurrentWindow2 = CurrentWindow2
            File(CurrentFile).FileDisplay = FileDisplay
            File(CurrentFile).Filename = Filename
            File(CurrentFile).FileAttribute = FileAttribute
            File(CurrentFile).FileByte = FileByte
            File(CurrentFile).FileLength = FileLength
            File(CurrentFile).FileLocked = FileLocked
            File(CurrentFile).FilePage = FilePage
            File(CurrentFile).FilePosition = FilePosition
            File(CurrentFile).Handle = Handle
            File(CurrentFile).MarkerCount = MarkerCount
            File(CurrentFile).Netpath = CurrentNetPath
            File(CurrentFile).PageColumn = PageColumn
            File(CurrentFile).PageRow = PageRow
            File(CurrentFile).ScreenRow = ScreenRow
            File(CurrentFile).ShortFilename = ShortFilename
            File(CurrentFile).StoreSearchString = StoreSearchString
        CASE 3 ' Restore current file.
            AsciiValue = File(CurrentFile).AsciiValue
            ASCIIZ = File(CurrentFile).ASCIIZ
            Buffer = File(CurrentFile).Buffer
            CopyPositionEnd = 0
            CopyPositionPivot = 0
            CopyPositionStart = 0
            CurrentMarker = File(CurrentFile).CurrentMarker
            CurrentUndo = File(CurrentFile).CurrentUndo
            CurrentWindow2 = File(CurrentFile).CurrentWindow2
            FileDisplay = File(CurrentFile).FileDisplay
            Filename = File(CurrentFile).Filename
            FileAttribute = File(CurrentFile).FileAttribute
            FileByte = File(CurrentFile).FileByte
            FileLength = File(CurrentFile).FileLength
            FileLocked = File(CurrentFile).FileLocked
            FilePage = File(CurrentFile).FilePage
            FilePosition = File(CurrentFile).FilePosition
            Handle = File(CurrentFile).Handle
            MarkerCount = File(CurrentFile).MarkerCount
            CurrentNetPath = File(CurrentFile).Netpath
            PageColumn = File(CurrentFile).PageColumn
            PageRow = File(CurrentFile).PageRow
            ScreenRow = File(CurrentFile).ScreenRow
            ShortFilename = File(CurrentFile).ShortFilename
            IF StoreSearchMulti THEN
                StoreSearchString = File(CurrentFile).StoreSearchString
            END IF
    END SELECT
END SUB

REM subroutine to open undo/marker files,
REM   also counts opened hexedit processes.

SUB OpenUndoFile (Var2)
    ' reset process counter.
    Var = False
    Var2 = False

    ' get valid path for file.
    MultiFilename1(1) = Nul
    MultiFilename1(2) = Nul

    ' start counter loop.
    DO
        ' make temp filename with counter.
        V1$ = DRX + "UNDOBYTE.DA" + MID$(STR$(Var), 2)

        ' check file exists.
        CLOSE #6
        IF _FILEEXISTS(V1$) = 0 THEN
            OPEN V1$ FOR RANDOM AS #6 LEN = LEN(UndoFile)
            MultiFilename1(1) = V1$
            EXIT DO
        END IF

        ' increment process counter.
        Var = Var + 1

        ' check maximum processes open.
        IF Var > MaxProcesses THEN ' needs to be 1 to 9.
            Var2 = True
            ErrorTrap = 90
            EXIT SUB
        END IF
    LOOP

    ' store process number.
    Process.Number = Var

    ' make temp filename with process number.
    V1$ = DRX + "MARKERS1.DA" + MID$(STR$(Process.Number), 2)
    CLOSE #7
    OPEN V1$ FOR RANDOM AS #7 LEN = LEN(MarkerFile)
    MultiFilename1(2) = V1$
END SUB

REM subroutine to initialize paste file.
SUB InitializePaste (Var2)
    Var2 = False
    ' make temp filename with process number.
    V1$ = DRX + "COPYFILE.DA" + MID$(STR$(Process.Number), 2)
    MultiFilename1(3) = Nul
    CLOSE #4
    ' check file exists.
    IF _FILEEXISTS(V1$) THEN
        G$ = V1$ + CHR$(0)
        x = DeleteFileA(G$)
    END IF
    MultiFilename1(3) = V1$
END SUB

REM subroutine to open paste files.
SUB OpenPasteFiles (Var2)
    Var2 = False
    ' make filename with process number.
    V1$ = DRX + "COPYFILE.DA" + MID$(STR$(Process.Number), 2)
    ' make filename with process number and file number.
    V2$ = DRX + "UNDOFIL" + MID$(STR$(Process.Number), 2) + ".DA" + MID$(STR$(CurrentFile), 2)
    ' open files.
    CLOSE #4, #5
    OPEN V1$ FOR RANDOM AS #4 LEN = 1
    OPEN V2$ FOR RANDOM AS #5 LEN = 1
    MultiFilenames(CurrentFile) = V2$
END SUB

REM subroutine to init paste files for new file.
SUB InitPasteFiles (Var2)
    ' make filename with process number.
    V1$ = DRX + "COPYFILE.DA" + MID$(STR$(Process.Number), 2)
    ' make filename with process number and file number.
    V2$ = DRX + "UNDOFIL" + MID$(STR$(Process.Number), 2) + ".DA" + MID$(STR$(CurrentFile), 2)
    ' attempt to open file.
    CLOSE #4, #5
    OPEN V1$ FOR RANDOM AS #4 LEN = 1
    IF _FILEEXISTS(V2$) THEN
        G$ = V2$ + CHR$(0)
        x = DeleteFileA(G$)
    END IF
    OPEN V2$ FOR RANDOM AS #5 LEN = 1
    MultiFilenames(CurrentFile) = V2$
END SUB

REM Position calculation routines follow:

' displays cell position in string format type 1.
SUB FormatPosition1
    CALL CalculatePosition2
    IF CurrentWindow2 = False THEN
        Printf "(page: " + FormatX$(CDBL(FilePage2 - 1), 1) + ","
    ELSE
        Printf "(page: " + RIGHT$("00000000" + HEX$(FilePage2 - 1), 8) + "x,"
    END IF
    Printf " row:" + MID$(STR$(PageRow2), 2) + ","
    Printf " column:" + MID$(STR$(PageColumn2), 2) + ")"
END SUB

' calculate current screen page number, row, and column, given file position.
SUB CalculatePosition1
    FilePage = INT((FilePosition - 1) / 320) + 1
    PageRow = INT((FilePosition - (FilePage - 1) * 320 - 1) / 20) + 1
    PageColumn = INT((FilePosition - (FilePage - 1) * 320) - (PageRow - 1) * 20)
END SUB

' calculate screen page number, row, and column, given variable.
SUB CalculatePosition2
    IF TempPosition3 = DFalse THEN
        FilePage2 = False
        PageRow2 = False
        PageColumn2 = False
    ELSE
        FilePage2 = INT((TempPosition3 - 1) / 320) + 1
        PageRow2 = INT((TempPosition3 - (FilePage2 - 1) * 320 - 1) / 20) + 1
        PageColumn2 = INT((TempPosition3 - (FilePage2 - 1) * 320) - (PageRow2 - 1) * 20)
    END IF
END SUB

REM Subroutine to get environment variable settings,
REM   and read custom config file variables.

SUB ReadConfigFile (Var$)
    ' check for ambiguation variable.
    IF ENVIRON$("AMBIGUATE") <> Nul THEN
        AmbiguateSwitch = True
    END IF

    ' check for screen row variable.
    IF ENVIRON$("HEXSCREEN") <> Nul THEN
        ScreenRow = True
    END IF

    ' check for heap sort variable.
    IF ENVIRON$("HEXSORT") <> Nul THEN
        HeapSortOff = True
    END IF

    ' check for fast exit to system variable.
    IF ENVIRON$("FASTEXIT") <> Nul THEN
        FastExit = True
    END IF

    ' check for character ascii print variable.
    IF ENVIRON$("CHARPRINT") <> Nul THEN
        CharPrint = True
    END IF

    ' check for mouse wheel reversal variable.
    IF ENVIRON$("REVERSEWHEEL") <> Nul THEN
        WheelReverse = True
    END IF

    ' check for file date/time variable.
    IF ENVIRON$("FILESWITCH") <> Nul THEN
        X = INT(VAL(ENVIRON$("FILESWITCH")))
        SELECT CASE X
            CASE 0, 1, 2
                FileSwitch = X
        END SELECT
    END IF

    ' check for file menu box filesize display.
    IF ENVIRON$("FILESIZE") <> Nul THEN
        X$ = ENVIRON$("FILESIZE")
        SELECT CASE X$
            CASE "0", "B"
                FileSizeType = 0
            CASE "1", "K"
                FileSizeType = 1
            CASE "2", "M"
                FileSizeType = 2
            CASE "3", "G"
                FileSizeType = 3
        END SELECT
    END IF

    ' check for quiet variable.
    IF ENVIRON$("QUIET") <> Nul THEN
        X = INT(VAL(ENVIRON$("QUIET")))
        SELECT CASE X
            CASE -1, 0, 1, 2, 3, 4, 5, 6
                QuietSwitch = X
        END SELECT
    END IF

    ' init alternate characters.
    IF ENVIRON$("HEXCHARS") <> Nul THEN
        Hline = 45
        Vline = 124
        ULcorner = 43
        URcorner = 43
        LLcorner = 43
        LRcorner = 43
    END IF

    ' define screen offsets for file menu box.
    ' allows menu repositioning.
    Xcoor = 5
    Ycoor = 20

    ' check config variable.
    IF ENVIRON$("HEXCONFIG") <> Nul THEN
        EXIT SUB
    END IF

    REM Read Hexedit?.cfg file,
    REM   search current path, environment path, then path statement.

    ' search current path.
    File$ = _CWD$
    IF RIGHT$(File$, 1) <> "\" THEN
        File$ = File$ + "\"
    END IF
    Config.Filename$ = File$ + ConfigFile
    IF _FILEEXISTS(Config.Filename$) THEN
        GOSUB ReadFile2
        IF ValidFile THEN
            EXIT SUB
        END IF
    END IF

    ' search environment path.
    File$ = ENVIRON$("HEXEDIT")
    IF LEN(File$) THEN
        File$ = RTRIM$(File$)
        File$ = LTRIM$(File$)
        IF LEFT$(File$, 1) = Quote THEN
            File$ = MID$(File$, 2)
        END IF
        IF RIGHT$(File$, 1) = Quote THEN
            File$ = LEFT$(File$, LEN(File$) - 1)
        END IF
        IF RIGHT$(File$, 1) <> "\" THEN
            File$ = File$ + "\"
        END IF
        ASCIIZ = File$ + ConfigFile + CHR$(0)
        CALL GetShortFilename(Config.Filename$)
        IF LEN(Config.Filename$) THEN
            IF _FILEEXISTS(Config.Filename$) THEN
                GOSUB ReadFile2
                IF ValidFile THEN
                    EXIT SUB
                END IF
            END IF
        END IF
    END IF

    ' search path statement.
    Path$ = ENVIRON$("PATH")
    IF LEN(Path$) THEN
        DO
            ' parse path.
            Parse = INSTR(Path$, ";")
            IF Parse THEN
                File$ = LEFT$(Path$, Parse - 1)
                Path$ = MID$(Path$, Parse + 1)
            ELSE
                File$ = Path$
                Path$ = Nul
            END IF

            ' store filename.
            File$ = RTRIM$(File$)
            File$ = LTRIM$(File$)
            IF LEN(File$) THEN
                IF LEFT$(File$, 1) = Quote THEN
                    File$ = MID$(File$, 2)
                END IF
                IF RIGHT$(File$, 1) = Quote THEN
                    File$ = LEFT$(File$, LEN(File$) - 1)
                END IF
                IF RIGHT$(File$, 1) <> "\" THEN
                    File$ = File$ + "\"
                END IF
                ASCIIZ = File$ + ConfigFile + CHR$(0)
                CALL GetShortFilename(Config.Filename$)
                IF LEN(Config.Filename$) THEN
                    IF _FILEEXISTS(Config.Filename$) THEN
                        GOSUB ReadFile2
                        IF ValidFile THEN
                            EXIT SUB
                        END IF
                    END IF
                END IF
            END IF
            IF Path$ = Nul THEN
                EXIT DO
            END IF
        LOOP
    END IF
    EXIT SUB

    ' read in the data file.
    ReadFile2:
    ' open filename.
    ErrorTrap = False
    ValidFile = False
    x2 = FREEFILE
    OPEN Config.Filename$ FOR INPUT SHARED AS #x2
    IF ErrorTrap THEN
        RETURN
    END IF
    ValidFile = True

    ' read input lines.
    DO WHILE NOT EOF(x2)
        LINE INPUT #x2, FileLine$

        ' remove appended comment.
        Var = INSTR(FileLine$, "'")
        IF Var THEN
            IF Var = 1 THEN
                FileLine$ = Nul
            ELSE
                FileLine$ = LEFT$(FileLine$, Var - 1)
            END IF
        END IF

        ' store config line.
        FileLine2$ = FileLine$

        ' trim config line.
        GOSUB Remove.Spaces

        ' check for prepended comment.
        IF LEFT$(FileLine$, 1) = ";" THEN
            FileLine$ = Nul
        END IF

        ' check assignment value.
        Parse = INSTR(FileLine$, "=")

        ' parse off left/right sides.
        IF Parse THEN

            ' get left/right side values.
            Char$ = LEFT$(FileLine$, Parse - 1)
            Setting$ = MID$(FileLine$, Parse + 1)

            ' get right side value for filenames
            ' enclosed in quotes containing spaces.
            Parse = INSTR(FileLine2$, "=")
            Setting2$ = MID$(FileLine2$, Parse + 1)
            Setting2$ = RTRIM$(Setting2$)
            Setting2$ = LTRIM$(Setting2$)

            ' check length of values.
            IF LEN(Char$) > 0 AND LEN(Setting$) > 0 THEN
                ' compare values.
                SELECT CASE UCASE$(Char$)
                    ' check debug switches.
                    CASE "DEBUG"
                        SELECT CASE UCASE$(Setting$)
                            CASE "OFF", "0", "FALSE"
                                Debug = False
                            CASE "ON", "-1", "TRUE"
                                Debug = True
                        END SELECT
                    CASE "DEBUG2"
                        SELECT CASE UCASE$(Setting$)
                            CASE "OFF", "0", "FALSE"
                                Debug2 = False
                            CASE "ON", "-1", "TRUE"
                                Debug2 = True
                        END SELECT
                    CASE "DEBUG3"
                        SELECT CASE UCASE$(Setting$)
                            CASE "OFF", "0", "FALSE"
                                Debug3 = False
                            CASE "ON", "-1", "TRUE"
                                Debug3 = True
                        END SELECT
                    CASE "REVERSEWHEEL"
                        SELECT CASE UCASE$(Setting$)
                            CASE "OFF", "0", "FALSE"
                                WheelReverse = False
                            CASE "ON", "-1", "TRUE"
                                WheelReverse = True
                        END SELECT
                    CASE "CHARPRINT"
                        SELECT CASE UCASE$(Setting$)
                            CASE "OFF", "0", "FALSE"
                                CharPrint = False
                            CASE "ON", "-1", "TRUE"
                                CharPrint = True
                        END SELECT
                    CASE "FASTEXIT"
                        SELECT CASE UCASE$(Setting$)
                            CASE "OFF", "0", "FALSE"
                                FastExit = False
                            CASE "ON", "-1", "TRUE"
                                FastExit = True
                        END SELECT
                        ' check file sort maximum
                    CASE "SORTMAX"
                        Var! = 0!
                        GOSUB Remove.Commas
                        SELECT CASE UCASE$(RIGHT$(Var3$, 1))
                            CASE "K"
                                Var3$ = LEFT$(Var3$, LEN(Var3$) - 1)
                                Var3! = INT(VAL(Var3$))
                                IF Var3! >= 1! AND Var3! <= MaxPrecision1 THEN
                                    Var! = Var3! * 1024!
                                END IF
                            CASE "M"
                                Var3$ = LEFT$(Var3$, LEN(Var3$) - 1)
                                Var3! = INT(VAL(Var3$))
                                IF Var3! <= MaxPrecision2 THEN
                                    Var! = Var3! * 1048576!
                                END IF
                            CASE ELSE
                                Var! = INT(VAL(Var3$))
                        END SELECT
                        Var! = INT(Var!)
                        IF Var! = -1! THEN ' disable
                            SortMax = -1!
                        END IF
                        IF Var! > MaxPrecision THEN
                            Var! = MaxPrecision
                        END IF
                        IF Var! >= 1024! AND Var! <= MaxPrecision THEN
                            SortMax = Var!
                        END IF
                        ' check dir sort maximum
                    CASE "SORTMAX2"
                        Var! = 0!
                        GOSUB Remove.Commas
                        SELECT CASE UCASE$(RIGHT$(Var3$, 1))
                            CASE "K"
                                Var3$ = LEFT$(Var3$, LEN(Var3$) - 1)
                                Var3! = INT(VAL(Var3$))
                                IF Var3! >= 1! AND Var3! <= MaxPrecision1 THEN
                                    Var! = Var3! * 1024!
                                END IF
                            CASE "M"
                                Var3$ = LEFT$(Var3$, LEN(Var3$) - 1)
                                Var3! = INT(VAL(Var3$))
                                IF Var3! <= MaxPrecision2 THEN
                                    Var! = Var3! * 1048576!
                                END IF
                            CASE ELSE
                                Var! = INT(VAL(Var3$))
                        END SELECT
                        Var! = INT(Var!)
                        IF Var! = -1! THEN ' disable
                            SortMax2 = -1!
                        END IF
                        IF Var! > MaxPrecision THEN
                            Var! = MaxPrecision
                        END IF
                        IF Var! >= 1024! AND Var! <= MaxPrecision THEN
                            SortMax2 = Var!
                        END IF
                        ' check dump filename.
                    CASE "DUMPFILE"
                        DumpFile = Setting$
                        ' check exclude filename.
                    CASE "EXCLUDEFILE"
                        ExcludeFile = Setting$
                        ' check and concatenate loaded filenames.
                    CASE "EDITFILE"
                        IF Var$ = Nul THEN
                            Var$ = Setting2$
                        ELSE
                            Var$ = Var$ + CHR$(13) + Setting2$
                        END IF
                        ' check environment replacement variables.
                    CASE "HEXDISPLAY" ' 64-byte display.
                        SELECT CASE UCASE$(Setting$)
                            CASE "OFF", "0", "FALSE"
                                FileDisplayX = True
                            CASE "ON", "-1", "TRUE"
                                FileDisplayX = False
                        END SELECT
                    CASE "HEXSCREEN" ' help key list.
                        SELECT CASE UCASE$(Setting$)
                            CASE "OFF", "0", "FALSE"
                                ScreenRowX = True
                            CASE "ON", "-1", "TRUE"
                                ScreenRowX = False
                        END SELECT
                    CASE "HEXSORT" ' file\dir sort.
                        SELECT CASE UCASE$(Setting$)
                            CASE "OFF", "0", "FALSE"
                                HeapSortOff = True
                            CASE "ON", "-1", "TRUE"
                                HeapSortOff = False
                        END SELECT
                    CASE "AMBIGUATE" ' file menu box ambiguation.
                        SELECT CASE UCASE$(Setting$)
                            CASE "OFF", "0", "FALSE"
                                AmbiguateSwitch = False
                            CASE "ON", "-1", "TRUE"
                                AmbiguateSwitch = True
                        END SELECT
                    CASE "QUIET" ' file menu box display.
                        SELECT CASE UCASE$(Setting$)
                            CASE "OFF", "0", "FALSE"
                                QuietSwitch = False
                            CASE "ON", "-1", "TRUE"
                                QuietSwitch = True
                            CASE ELSE
                                SELECT CASE INT(VAL(Setting$))
                                    CASE 1 TO 6
                                        QuietSwitch = INT(VAL(Setting$))
                                END SELECT
                        END SELECT
                    CASE "FILESWITCH" ' file menu box date\time display.
                        SELECT CASE INT(VAL(Setting$))
                            CASE 0, 1, 2
                                FileSwitch = INT(VAL(Setting$))
                        END SELECT
                    CASE "FILESIZE" ' file menu box filesize display.
                        SELECT CASE UCASE$(Setting$)
                            CASE "0", "B"
                                FileSizeType = 0
                            CASE "1", "K"
                                FileSizeType = 1
                            CASE "2", "M"
                                FileSizeType = 2
                            CASE "3", "G"
                                FileSizeType = 3
                        END SELECT
                    CASE "MOUSEDRAGSCROLL" ' mouse drag scroll timer.
                        MouseTime = CSNG(VAL(Setting$))
                    CASE "PORT" ' default printer port.
                        NewValue = INT(VAL(Setting$))
                        IF NewValue >= 1 AND NewValue <= 3 THEN
                            PrinterPort = NewValue
                        END IF
                    CASE "SEARCH" ' default search variable.
                        SELECT CASE UCASE$(Setting$)
                            CASE "OFF", "0", "FALSE"
                                StoreSearchMulti = False
                            CASE "ON", "-1", "TRUE"
                                StoreSearchMulti = True
                        END SELECT
                    CASE "LASTDRIVE" ' override last drive.
                        SELECT CASE UCASE$(Setting$)
                            CASE "C" TO "Z"
                                Last.Drive = ASC(UCASE$(Setting$)) - 64
                        END SELECT
                    CASE "XCOOR" ' file menu box location.
                        NewValue = INT(VAL(Setting$))
                        IF NewValue >= 2 THEN
                            IF NewValue <= 8 THEN
                                Xcoor = NewValue
                            END IF
                        END IF
                    CASE "YCOOR" ' file menu box location.
                        NewValue = INT(VAL(Setting$))
                        IF NewValue >= 1 THEN
                            IF NewValue <= 39 THEN
                                Ycoor = NewValue
                            END IF
                        END IF
                    CASE ELSE
                        ' custom color overrides.
                        NewValue = INT(VAL(Setting$))
                        IF NewValue >= 0 AND NewValue <= 7 THEN
                            ' menu box ansi color override.
                            SELECT CASE UCASE$(Char$)
                                CASE "BACKGROUND"
                                    BackGround = NewValue
                                CASE "BACKGROUND2"
                                    BackGround2 = NewValue
                            END SELECT
                        END IF
                        IF NewValue >= 0 AND NewValue <= 15 THEN
                            ' menu box ansi color overrides.
                            SELECT CASE UCASE$(Char$)
                                CASE "BLACK"
                                    Black = NewValue
                                CASE "BLUE"
                                    Blue = NewValue
                                CASE "CYAN"
                                    Cyan = NewValue
                                CASE "GREEN"
                                    Green = NewValue
                                CASE "MAGENTA"
                                    Magenta = NewValue
                                CASE "PLAIN"
                                    Plain = NewValue
                                CASE "RED"
                                    Red = NewValue
                                CASE "WHITE"
                                    White = NewValue
                                CASE "YELLOW"
                                    Yellow = NewValue
                            END SELECT
                        END IF
                        ' check ascii value.
                        IF NewValue >= 0 AND NewValue <= 255 THEN
                            ' menu box ansi character overrides.
                            SELECT CASE UCASE$(Char$)
                                CASE "HLINE"
                                    Hline = NewValue
                                CASE "VLINE"
                                    Vline = NewValue
                                CASE "ULCORNER"
                                    ULcorner = NewValue
                                CASE "URCORNER"
                                    URcorner = NewValue
                                CASE "LLCORNER"
                                    LLcorner = NewValue
                                CASE "LRCORNER"
                                    LRcorner = NewValue
                            END SELECT
                        END IF
                END SELECT
            END IF
        END IF
    LOOP
    CLOSE #x2
    RETURN

    ' remove spaces.
    Remove.Spaces:
    Var1$ = FileLine$
    DO
        Parse = INSTR(Var1$, " ")
        IF Parse THEN
            Var1$ = LEFT$(Var1$, Parse - 1) + MID$(Var1$, Parse + 1)
        ELSE
            EXIT DO
        END IF
    LOOP
    FileLine$ = Var1$
    RETURN

    ' removes commas
    Remove.Commas:
    Var3$ = Setting$
    DO
        Var = INSTR(Var3$, ",")
        IF Var THEN
            Var3$ = LEFT$(Var3$, Var - 1) + MID$(Var3$, Var + 1)
        ELSE
            EXIT DO
        END IF
    LOOP
    RETURN
END SUB

REM Drop down menu subroutine:

REM Returns: variable CurrentMenu equals 1 to 7, or 0 if exit,
REM  variable CurrentMenuSelection is menu selection in CurrentMenu.

SUB DropDownMenu
    GOSUB StoreArea
    GOSUB DrawMenu
    GOSUB DrawCurrentMenuSelection

    ' keyboard/mouse input loop.
    DO
        _LIMIT 100
        CharInput$ = Nul

        ' call mouse subroutine.
        Z = MouseDriver

        ' check left mouse button.
        IF MouseButton1 THEN
            GOSUB MouseButton1X
        ELSE
            ' check right mouse button.
            IF MouseButton2 THEN
                GOSUB RestoreArea
                CurrentMenu = False
                EXIT SUB
            ELSE
                ' check mouse position.
                IF MouseX OR MouseY THEN
                    GOSUB MoveMouse
                END IF
            END IF
        END IF

        ' check mouse wheel.
        I$ = Nul
        IF MouseWheel = -1 THEN
            IF WheelReverse THEN
                I$ = CHR$(0) + CHR$(80) ' down
            ELSE
                I$ = CHR$(0) + CHR$(72) ' up
            END IF
            MouseWheel = 0
        END IF
        IF MouseWheel = 1 THEN
            IF WheelReverse THEN
                I$ = CHR$(0) + CHR$(72) ' up
            ELSE
                I$ = CHR$(0) + CHR$(80) ' down
            END IF
            MouseWheel = 0
        END IF

        ' store keyboard buffer.
        IF I$ <> Nul THEN
            CharInput$ = I$
        ELSE
            CharInput$ = INKEY$
        END IF
        IF LEN(CharInput$) THEN
            SELECT CASE LEN(CharInput$)
                CASE 1
                    CharInput$ = UCASE$(CharInput$)
                    SELECT CASE ASC(CharInput$)
                        CASE 65 TO 90 ' A - Z
                            SELECT CASE CurrentMenu
                                CASE 1
                                    VarZ = INSTR("OCAVTX", CharInput$)
                                    IF VarZ THEN
                                        GOSUB RestoreArea
                                        CurrentMenuSelection = VarZ
                                        EXIT SUB
                                    END IF
                                CASE 2
                                    VarZ = INSTR("AH", CharInput$)
                                    IF VarZ THEN
                                        GOSUB RestoreArea
                                        CurrentMenuSelection = VarZ
                                        EXIT SUB
                                    END IF
                                CASE 3
                                    VarZ = INSTR("SF", CharInput$)
                                    IF VarZ THEN
                                        GOSUB RestoreArea
                                        CurrentMenuSelection = VarZ
                                        EXIT SUB
                                    END IF
                                CASE 4
                                    VarZ = INSTR("ASRUB", CharInput$)
                                    IF VarZ THEN
                                        GOSUB RestoreArea
                                        CurrentMenuSelection = VarZ
                                        EXIT SUB
                                    END IF
                                CASE 5
                                    VarZ = INSTR("BP", CharInput$)
                                    IF VarZ THEN
                                        GOSUB RestoreArea
                                        CurrentMenuSelection = VarZ
                                        EXIT SUB
                                    END IF
                                CASE 6
                                    VarZ = INSTR("SF", CharInput$)
                                    IF VarZ THEN
                                        GOSUB RestoreArea
                                        CurrentMenuSelection = VarZ
                                        EXIT SUB
                                    END IF
                                CASE 7
                                    VarZ = INSTR("SB", CharInput$)
                                    IF VarZ THEN
                                        GOSUB RestoreArea
                                        CurrentMenuSelection = VarZ
                                        EXIT SUB
                                    END IF
                            END SELECT
                        CASE 9 ' Tab
                            GOSUB MenuRight
                        CASE 13 ' Enter
                            GOSUB RestoreArea
                            EXIT SUB
                        CASE 27 ' Escape
                            GOSUB RestoreArea
                            CurrentMenu = False
                            EXIT SUB
                    END SELECT
                CASE 2
                    SELECT CASE ASC(RIGHT$(CharInput$, 1))
                        CASE 72, 141, 152 ' Up/Ctrl-Up/Alt-Up
                            GOSUB MenuUp
                        CASE 80, 145, 160 ' Down/Ctrl-Down/Alt-Down
                            GOSUB MenuDown
                        CASE 75, 15, 115, 155 ' Left/Shift-Tab/Ctrl-Left/Alt-Left
                            GOSUB MenuLeft
                        CASE 142, 74 ' Ctrl-Keypad-/Alt-Keypad-
                            GOSUB MenuLeft
                        CASE 77, 116, 157 ' Right/Ctrl-Right/Alt-Right
                            GOSUB MenuRight
                        CASE 144, 78 ' Ctrl-Keypad+/Alt-Keypad+
                            GOSUB MenuRight
                        CASE 71, 73, 119, 132 ' Home/PageUp/Ctrl-Home/Ctrl-PageUp
                            GOSUB MenuFirst
                        CASE 79, 81, 117, 118 ' End/PageDown/Ctrl-End/Ctrl-PageDown
                            GOSUB MenuLast
                    END SELECT
            END SELECT
        END IF
    LOOP
    EXIT SUB

    ' moves to menu first left
    MenuFirst:
    IF CurrentMenu <> 1 THEN
        GOSUB RestoreArea
        CurrentMenu = 1
        GOSUB StoreArea
        GOSUB DrawMenu
        GOSUB DrawCurrentMenuSelection
    END IF
    RETURN

    ' moves to menu last right
    MenuLast:
    IF CurrentMenu <> 7 THEN
        GOSUB RestoreArea
        CurrentMenu = 7
        GOSUB StoreArea
        GOSUB DrawMenu
        GOSUB DrawCurrentMenuSelection
    END IF
    RETURN

    ' moves one menu left, wrapping.
    MenuLeft:
    GOSUB RestoreArea
    IF CurrentMenu = 1 THEN
        CurrentMenu = 7
    ELSE
        CurrentMenu = CurrentMenu - 1
    END IF
    GOSUB StoreArea
    GOSUB DrawMenu
    GOSUB DrawCurrentMenuSelection
    RETURN

    ' moves one menu right, wrapping.
    MenuRight:
    GOSUB RestoreArea
    IF CurrentMenu = 7 THEN
        CurrentMenu = 1
    ELSE
        CurrentMenu = CurrentMenu + 1
    END IF
    GOSUB StoreArea
    GOSUB DrawMenu
    GOSUB DrawCurrentMenuSelection
    RETURN

    ' moves menu up, wrapping.
    ' selects CurrentMenuSelection variable.
    MenuUp:
    SELECT CASE CurrentMenu
        CASE 1
            GOSUB EraseCurrentMenuSelection
            IF CurrentMenuSelection = 1 THEN
                CurrentMenuSelection = 6
            ELSE
                CurrentMenuSelection = CurrentMenuSelection - 1
            END IF
            GOSUB DrawCurrentMenuSelection
        CASE 2
            GOSUB EraseCurrentMenuSelection
            IF CurrentMenuSelection = 1 THEN
                CurrentMenuSelection = 2
            ELSE
                CurrentMenuSelection = CurrentMenuSelection - 1
            END IF
            GOSUB DrawCurrentMenuSelection
        CASE 3
            GOSUB EraseCurrentMenuSelection
            IF CurrentMenuSelection = 1 THEN
                CurrentMenuSelection = 2
            ELSE
                CurrentMenuSelection = CurrentMenuSelection - 1
            END IF
            GOSUB DrawCurrentMenuSelection
        CASE 4
            GOSUB EraseCurrentMenuSelection
            IF CurrentMenuSelection = 1 THEN
                CurrentMenuSelection = 5
            ELSE
                CurrentMenuSelection = CurrentMenuSelection - 1
            END IF
            GOSUB DrawCurrentMenuSelection
        CASE 5
            GOSUB EraseCurrentMenuSelection
            IF CurrentMenuSelection = 1 THEN
                CurrentMenuSelection = 2
            ELSE
                CurrentMenuSelection = CurrentMenuSelection - 1
            END IF
            GOSUB DrawCurrentMenuSelection
        CASE 6
            GOSUB EraseCurrentMenuSelection
            IF CurrentMenuSelection = 1 THEN
                CurrentMenuSelection = 2
            ELSE
                CurrentMenuSelection = CurrentMenuSelection - 1
            END IF
            GOSUB DrawCurrentMenuSelection
        CASE 7
            GOSUB EraseCurrentMenuSelection
            IF CurrentMenuSelection = 1 THEN
                CurrentMenuSelection = 2
            ELSE
                CurrentMenuSelection = CurrentMenuSelection - 1
            END IF
            GOSUB DrawCurrentMenuSelection
    END SELECT
    RETURN

    ' moves menu down, wrapping.
    ' selects CurrentMenuSelection variable.
    MenuDown:
    SELECT CASE CurrentMenu
        CASE 1
            GOSUB EraseCurrentMenuSelection
            IF CurrentMenuSelection = 6 THEN
                CurrentMenuSelection = 1
            ELSE
                CurrentMenuSelection = CurrentMenuSelection + 1
            END IF
            GOSUB DrawCurrentMenuSelection
        CASE 2
            GOSUB EraseCurrentMenuSelection
            IF CurrentMenuSelection = 2 THEN
                CurrentMenuSelection = 1
            ELSE
                CurrentMenuSelection = CurrentMenuSelection + 1
            END IF
            GOSUB DrawCurrentMenuSelection
        CASE 3
            GOSUB EraseCurrentMenuSelection
            IF CurrentMenuSelection = 2 THEN
                CurrentMenuSelection = 1
            ELSE
                CurrentMenuSelection = CurrentMenuSelection + 1
            END IF
            GOSUB DrawCurrentMenuSelection
        CASE 4
            GOSUB EraseCurrentMenuSelection
            IF CurrentMenuSelection = 5 THEN
                CurrentMenuSelection = 1
            ELSE
                CurrentMenuSelection = CurrentMenuSelection + 1
            END IF
            GOSUB DrawCurrentMenuSelection
        CASE 5
            GOSUB EraseCurrentMenuSelection
            IF CurrentMenuSelection = 2 THEN
                CurrentMenuSelection = 1
            ELSE
                CurrentMenuSelection = CurrentMenuSelection + 1
            END IF
            GOSUB DrawCurrentMenuSelection
        CASE 6
            GOSUB EraseCurrentMenuSelection
            IF CurrentMenuSelection = 2 THEN
                CurrentMenuSelection = 1
            ELSE
                CurrentMenuSelection = CurrentMenuSelection + 1
            END IF
            GOSUB DrawCurrentMenuSelection
        CASE 7
            GOSUB EraseCurrentMenuSelection
            IF CurrentMenuSelection = 2 THEN
                CurrentMenuSelection = 1
            ELSE
                CurrentMenuSelection = CurrentMenuSelection + 1
            END IF
            GOSUB DrawCurrentMenuSelection
    END SELECT
    RETURN

    ' removes hilight from current menu selection.
    EraseCurrentMenuSelection:
    Colorf2 White, 0
    SelectColor = 0
    GOSUB DisplayCurrentMenuSelection
    Colorf2 White, 0
    RETURN

    ' adds hilight to current menu selection.
    DrawCurrentMenuSelection:
    Colorf2 White, 1
    SelectColor = 1
    GOSUB DisplayCurrentMenuSelection
    Colorf2 White, 0
    RETURN

    ' draws current menu selection.
    DisplayCurrentMenuSelection:
    SELECT CASE CurrentMenu
        CASE 1
            SELECT CASE CurrentMenuSelection
                CASE 1
                    Locatef 3, 7, 0
                    Printf "Open New File  "
                    Colorf2 Magenta, SelectColor
                    Locatef 3, 7, 0
                    Printf "O"
                CASE 2
                    Locatef 4, 7, 0
                    Printf "Close File     "
                    Colorf2 Magenta, SelectColor
                    Locatef 4, 7, 0
                    Printf "C"
                CASE 3
                    Locatef 5, 7, 0
                    Printf "Close All Files"
                    Colorf2 Magenta, SelectColor
                    Locatef 5, 13, 0
                    Printf "A"
                CASE 4
                    Locatef 6, 7, 0
                    Printf "View Files     "
                    Colorf2 Magenta, SelectColor
                    Locatef 6, 7, 0
                    Printf "V"
                CASE 5
                    Locatef 7, 7, 0
                    Printf "Toggle Window  "
                    Colorf2 Magenta, SelectColor
                    Locatef 7, 7, 0
                    Printf "T"
                CASE 6
                    Locatef 8, 7, 0
                    Printf "Exit Program   "
                    Colorf2 Magenta, SelectColor
                    Locatef 8, 8, 0
                    Printf "x"
            END SELECT
        CASE 2
            SELECT CASE CurrentMenuSelection
                CASE 1
                    Locatef 3, 17, 0
                    Printf "ANSI Chart"
                    Colorf2 Magenta, SelectColor
                    Locatef 3, 17, 0
                    Printf "A"
                CASE 2
                    Locatef 4, 17, 0
                    Printf "HEX Chart "
                    Colorf2 Magenta, SelectColor
                    Locatef 4, 17, 0
                    Printf "H"
            END SELECT
        CASE 3
            SELECT CASE CurrentMenuSelection
                CASE 1
                    Locatef 3, 27, 0
                    Printf "HEX Screen Dump"
                    Colorf2 Magenta, SelectColor
                    Locatef 3, 31, 0
                    Printf "S"
                CASE 2
                    Locatef 4, 27, 0
                    Printf "HEX File Dump  "
                    Colorf2 Magenta, SelectColor
                    Locatef 4, 31, 0
                    Printf "F"
            END SELECT
        CASE 4
            SELECT CASE CurrentMenuSelection
                CASE 1
                    Locatef 3, 37, 0
                    Printf "Append Bytes       "
                    Colorf2 Magenta, SelectColor
                    Locatef 3, 37, 0
                    Printf "A"
                CASE 2
                    Locatef 4, 37, 0
                    Printf "Append ASCII String"
                    Colorf2 Magenta, SelectColor
                    Locatef 4, 50, 0
                    Printf "S"
                CASE 3
                    Locatef 5, 37, 0
                    Printf "Redraw Screen      "
                    Colorf2 Magenta, SelectColor
                    Locatef 5, 37, 0
                    Printf "R"
                CASE 4
                    Locatef 6, 37, 0
                    Printf "Undo Last Byte     "
                    Colorf2 Magenta, SelectColor
                    Locatef 6, 37, 0
                    Printf "U"
                CASE 5
                    Locatef 7, 37, 0
                    Printf "Undo All Bytes     "
                    Colorf2 Magenta, SelectColor
                    Locatef 7, 46, 0
                    Printf "B"
            END SELECT
        CASE 5
            SELECT CASE CurrentMenuSelection
                CASE 1
                    Locatef 3, 47, 0
                    Printf "Jump To Byte"
                    Colorf2 Magenta, SelectColor
                    Locatef 3, 55, 0
                    Printf "B"
                CASE 2
                    Locatef 4, 47, 0
                    Printf "Jump To Page"
                    Colorf2 Magenta, SelectColor
                    Locatef 4, 55, 0
                    Printf "P"
            END SELECT
        CASE 6
            SELECT CASE CurrentMenuSelection
                CASE 1
                    Locatef 3, 57, 0
                    Printf "HEX Screen Print"
                    Colorf2 Magenta, SelectColor
                    Locatef 3, 61, 0
                    Printf "S"
                CASE 2
                    Locatef 4, 57, 0
                    Printf "HEX File Print  "
                    Colorf2 Magenta, SelectColor
                    Locatef 4, 61, 0
                    Printf "F"
            END SELECT
        CASE 7
            SELECT CASE CurrentMenuSelection
                CASE 1
                    Locatef 3, 65, 0
                    Printf "Search String"
                    Colorf2 Magenta, SelectColor
                    Locatef 3, 72, 0
                    Printf "S"
                CASE 2
                    Locatef 4, 65, 0
                    Printf "Search Bytes "
                    Colorf2 Magenta, SelectColor
                    Locatef 4, 72, 0
                    Printf "B"
            END SELECT
    END SELECT
    RETURN

    ' draws menu.
    DrawMenu:
    CurrentMenuSelection = 1
    GOSUB BoxBorder
    BoxDrawX1 = Xstore1
    BoxDrawX2 = Xstore2
    BoxDrawY1 = Ystore1
    BoxDrawY2 = Ystore2
    SELECT CASE CurrentMenu
        CASE 1
            BoxDrawLength = 17
            GOSUB DrawBox
            Colorf White
            Locatef 3, 7, 0
            Printf "Open New File  "
            Locatef 4, 7, 0
            Printf "Close File     "
            Locatef 5, 7, 0
            Printf "Close All Files"
            Locatef 6, 7, 0
            Printf "View Files     "
            Locatef 7, 7, 0
            Printf "Toggle Window  "
            Locatef 8, 7, 0
            Printf "Exit Program   "
            Colorf Magenta
            Locatef 3, 7, 0
            Printf "O"
            Locatef 4, 7, 0
            Printf "C"
            Locatef 5, 13, 0
            Printf "A"
            Locatef 6, 7, 0
            Printf "V"
            Locatef 7, 7, 0
            Printf "T"
            Locatef 8, 8, 0
            Printf "x"
        CASE 2
            BoxDrawLength = 12
            GOSUB DrawBox
            Colorf White
            Locatef 3, 17, 0
            Printf "ANSI Chart"
            Locatef 4, 17, 0
            Printf "HEX Chart "
            Colorf Magenta
            Locatef 3, 17, 0
            Printf "A"
            Locatef 4, 17, 0
            Printf "H"
        CASE 3
            BoxDrawLength = 17
            GOSUB DrawBox
            Colorf White
            Locatef 3, 27, 0
            Printf "HEX Screen Dump"
            Locatef 4, 27, 0
            Printf "HEX File Dump  "
            Colorf Magenta
            Locatef 3, 31, 0
            Printf "S"
            Locatef 4, 31, 0
            Printf "F"
        CASE 4
            BoxDrawLength = 21
            GOSUB DrawBox
            Colorf White
            Locatef 3, 37, 0
            Printf "Append Bytes       "
            Locatef 4, 37, 0
            Printf "Append ASCII String"
            Locatef 5, 37, 0
            Printf "Redraw Screen      "
            Locatef 6, 37, 0
            Printf "Undo Last Byte     "
            Locatef 7, 37, 0
            Printf "Undo All Bytes     "
            Colorf Magenta
            Locatef 3, 37, 0
            Printf "A"
            Locatef 4, 50, 0
            Printf "S"
            Locatef 5, 37, 0
            Printf "R"
            Locatef 6, 37, 0
            Printf "U"
            Locatef 7, 46, 0
            Printf "B"
        CASE 5
            BoxDrawLength = 14
            GOSUB DrawBox
            Colorf White
            Locatef 3, 47, 0
            Printf "Jump To Byte"
            Locatef 4, 47, 0
            Printf "Jump To Page"
            Colorf Magenta
            Locatef 3, 55, 0
            Printf "B"
            Locatef 4, 55, 0
            Printf "P"
        CASE 6
            BoxDrawLength = 18
            GOSUB DrawBox
            Colorf White
            Locatef 3, 57, 0
            Printf "HEX Screen Print"
            Locatef 4, 57, 0
            Printf "HEX File Print  "
            Colorf Magenta
            Locatef 3, 61, 0
            Printf "S"
            Locatef 4, 61, 0
            Printf "F"
        CASE 7
            BoxDrawLength = 15
            GOSUB DrawBox
            Colorf White
            Locatef 3, 65, 0
            Printf "Search String"
            Locatef 4, 65, 0
            Printf "Search Bytes "
            Colorf Magenta
            Locatef 3, 72, 0
            Printf "S"
            Locatef 4, 72, 0
            Printf "B"
    END SELECT
    RETURN

    ' stores area under menu.
    StoreArea:
    IF CurrentMenu = False THEN
        RETURN
    END IF
    GOSUB BoxBorder
    RowX1 = 0
    ColumnY1 = 0
    FOR RowX2 = Xstore1 TO Xstore2
        RowX1 = RowX1 + 1
        ColumnY1 = 0
        FOR ColumnY2 = Ystore1 TO Ystore2
            ColumnY1 = ColumnY1 + 1
            ' store ascii character.
            Area1(RowX1, ColumnY1) = SCREEN(RowX2, ColumnY2)
            ' store color. (undocumented: also stores background color).
            Area2(RowX1, ColumnY1) = SCREEN(RowX2, ColumnY2, 1)
        NEXT
    NEXT
    ' hilight menu tab.
    Colorf2 White, 1
    CALL DisplayTab(CurrentMenu)
    RETURN

    ' restores area under menu.
    RestoreArea:
    IF CurrentMenu = False THEN
        RETURN
    END IF
    GOSUB BoxBorder
    RowX1 = 0
    ColumnY1 = 0
    FOR RowX2 = Xstore1 TO Xstore2
        RowX1 = RowX1 + 1
        ColumnY1 = 0
        FOR ColumnY2 = Ystore1 TO Ystore2
            ColumnY1 = ColumnY1 + 1
            Locatef RowX2, ColumnY2, 1
            ' restore color.
            TempZ = Area2(RowX1, ColumnY1)
            ' undocumented: also stores background color.
            VarB = INT(TempZ / 16)
            VarF = TempZ MOD 16
            Colorf2 VarF, VarB
            ' restore ascii character.
            Printf CHR$(Area1(RowX1, ColumnY1))
        NEXT
    NEXT
    ' remove hilight menu tab.
    Colorf2 White, 0
    CALL DisplayTab(CurrentMenu)
    RETURN

    ' returns borders of box.
    BoxBorder:
    SELECT CASE CurrentMenu
        CASE 1
            Xstore1 = 2
            Xstore2 = 9
            Ystore1 = 6
            Ystore2 = 22
        CASE 2
            Xstore1 = 2
            Xstore2 = 5
            Ystore1 = 16
            Ystore2 = 27
        CASE 3
            Xstore1 = 2
            Xstore2 = 5
            Ystore1 = 26
            Ystore2 = 42
        CASE 4
            Xstore1 = 2
            Xstore2 = 8
            Ystore1 = 36
            Ystore2 = 56
        CASE 5
            Xstore1 = 2
            Xstore2 = 5
            Ystore1 = 46
            Ystore2 = 59
        CASE 6
            Xstore1 = 2
            Xstore2 = 5
            Ystore1 = 56
            Ystore2 = 73
        CASE 7
            Xstore1 = 2
            Xstore2 = 5
            Ystore1 = 64
            Ystore2 = 78
    END SELECT
    RETURN

    ' draws box from (BoxDrawX1,BoxDrawY1) To (BoxDrawX2,BoxDrawY2),
    '  length of box from left to right being BoxDrawLength.
    DrawBox:
    Colorf Yellow
    Locatef BoxDrawX1, BoxDrawY1, 0
    Printf CHR$(ULcorner) + STRING$(BoxDrawLength - 2, Hline) + CHR$(URcorner)
    FOR RowX1 = BoxDrawX1 + 1 TO BoxDrawX2 - 1
        Locatef RowX1, BoxDrawY1, 0
        Printf CHR$(Vline)
        Locatef RowX1, BoxDrawY2, 0
        Printf CHR$(Vline)
    NEXT
    Locatef BoxDrawX2, BoxDrawY1, 0
    Printf CHR$(LLcorner) + STRING$(BoxDrawLength - 2, Hline) + CHR$(LRcorner)
    RETURN

    ' process mouse move.
    MoveMouse:
    ' select drop down menu.
    IF MouseX = 1 THEN
        NewMenuSelection = False
        SELECT CASE MouseY
            CASE 6 TO 9 ' File
                NewMenuSelection = 1
            CASE 16 TO 21 ' Charts
                NewMenuSelection = 2
            CASE 26 TO 29 ' Dump
                NewMenuSelection = 3
            CASE 36 TO 39 ' Edit
                NewMenuSelection = 4
            CASE 46 TO 49 ' Jump
                NewMenuSelection = 5
            CASE 56 TO 60 ' Print
                NewMenuSelection = 6
            CASE 64 TO 69 ' Search
                NewMenuSelection = 7
        END SELECT
        IF NewMenuSelection > False THEN
            IF NewMenuSelection <> CurrentMenu THEN
                IF CurrentMenu > False THEN
                    GOSUB RestoreArea
                END IF
                CurrentMenu = NewMenuSelection
                CurrentMenuSelection = 1
                GOSUB StoreArea
                GOSUB DrawMenu
                GOSUB DrawCurrentMenuSelection
            END IF
        END IF
        IF CurrentMenu > False THEN
            Colorf2 White, 1
            CALL DisplayTab(CurrentMenu)
        END IF
        RETURN
    END IF
    ' check mouse selection boundaries.
    SELECT CASE CurrentMenu
        CASE 1
            IF MouseX >= 3 AND MouseX <= 8 THEN
                IF MouseY >= 7 AND MouseY <= 21 THEN
                    IF MouseX - 2 <> CurrentMenuSelection THEN
                        GOSUB EraseCurrentMenuSelection
                        CurrentMenuSelection = MouseX - 2
                    END IF
                    GOSUB DrawCurrentMenuSelection
                END IF
            END IF
        CASE 2
            IF MouseX >= 3 AND MouseX <= 4 THEN
                IF MouseY >= 17 AND MouseY <= 26 THEN
                    IF MouseX - 2 <> CurrentMenuSelection THEN
                        GOSUB EraseCurrentMenuSelection
                        CurrentMenuSelection = MouseX - 2
                    END IF
                    GOSUB DrawCurrentMenuSelection
                END IF
            END IF
        CASE 3
            IF MouseX >= 3 AND MouseX <= 4 THEN
                IF MouseY >= 27 AND MouseY <= 41 THEN
                    IF MouseX - 2 <> CurrentMenuSelection THEN
                        GOSUB EraseCurrentMenuSelection
                        CurrentMenuSelection = MouseX - 2
                    END IF
                    GOSUB DrawCurrentMenuSelection
                END IF
            END IF
        CASE 4
            IF MouseX >= 3 AND MouseX <= 7 THEN
                IF MouseY >= 37 AND MouseY <= 55 THEN
                    IF MouseX - 2 <> CurrentMenuSelection THEN
                        GOSUB EraseCurrentMenuSelection
                        CurrentMenuSelection = MouseX - 2
                    END IF
                    GOSUB DrawCurrentMenuSelection
                END IF
            END IF
        CASE 5
            IF MouseX >= 3 AND MouseX <= 5 THEN
                IF MouseY >= 47 AND MouseY <= 58 THEN
                    IF MouseX - 2 <> CurrentMenuSelection THEN
                        GOSUB EraseCurrentMenuSelection
                        CurrentMenuSelection = MouseX - 2
                    END IF
                    GOSUB DrawCurrentMenuSelection
                END IF
            END IF
        CASE 6
            IF MouseX >= 3 AND MouseX <= 5 THEN
                IF MouseY >= 57 AND MouseY <= 72 THEN
                    IF MouseX - 2 <> CurrentMenuSelection THEN
                        GOSUB EraseCurrentMenuSelection
                        CurrentMenuSelection = MouseX - 2
                    END IF
                    GOSUB DrawCurrentMenuSelection
                END IF
            END IF
        CASE 7
            IF MouseX >= 3 AND MouseX <= 5 THEN
                IF MouseY >= 65 AND MouseY <= 77 THEN
                    IF MouseX - 2 <> CurrentMenuSelection THEN
                        GOSUB EraseCurrentMenuSelection
                        CurrentMenuSelection = MouseX - 2
                    END IF
                    GOSUB DrawCurrentMenuSelection
                END IF
            END IF
    END SELECT
    RETURN

    ' process left mouse button.
    MouseButton1X:

    ' test mouse click above menu and clear.
    IF MouseX = 1 THEN
        GOSUB RestoreArea
        CurrentMenu = False
        EXIT SUB
    END IF

    ' test mouse click below menu and clear.
    SELECT CASE CurrentMenu
        CASE 1
            IF MouseX > 9 THEN
                GOSUB RestoreArea
                CurrentMenu = False
                EXIT SUB
            END IF
        CASE 2
            IF MouseX > 5 THEN
                GOSUB RestoreArea
                CurrentMenu = False
                EXIT SUB
            END IF
        CASE 3
            IF MouseX > 5 THEN
                GOSUB RestoreArea
                CurrentMenu = False
                EXIT SUB
            END IF
        CASE 4
            IF MouseX > 8 THEN
                GOSUB RestoreArea
                CurrentMenu = False
                EXIT SUB
            END IF
        CASE 5
            IF MouseX > 6 THEN
                GOSUB RestoreArea
                CurrentMenu = False
                EXIT SUB
            END IF
        CASE 6
            IF MouseX > 6 THEN
                GOSUB RestoreArea
                CurrentMenu = False
                EXIT SUB
            END IF
        CASE 7
            IF MouseX > 6 THEN
                GOSUB RestoreArea
                CurrentMenu = False
                EXIT SUB
            END IF
    END SELECT

    ' test mouse click outside edges of menu.
    IF MouseX > 1 THEN
        SELECT CASE CurrentMenu
            CASE 1
                IF MouseY < 6 OR MouseY > 22 THEN
                    GOSUB RestoreArea
                    CurrentMenu = False
                    EXIT SUB
                END IF
            CASE 2
                IF MouseY < 16 OR MouseY > 27 THEN
                    GOSUB RestoreArea
                    CurrentMenu = False
                    EXIT SUB
                END IF
            CASE 3
                IF MouseY < 26 OR MouseY > 42 THEN
                    GOSUB RestoreArea
                    CurrentMenu = False
                    EXIT SUB
                END IF
            CASE 4
                IF MouseY < 36 OR MouseY > 56 THEN
                    GOSUB RestoreArea
                    CurrentMenu = False
                    EXIT SUB
                END IF
            CASE 5
                IF MouseY < 46 OR MouseY > 59 THEN
                    GOSUB RestoreArea
                    CurrentMenu = False
                    EXIT SUB
                END IF
            CASE 6
                IF MouseY < 56 OR MouseY > 73 THEN
                    GOSUB RestoreArea
                    CurrentMenu = False
                    EXIT SUB
                END IF
            CASE 7
                IF MouseY < 66 OR MouseY > 78 THEN
                    GOSUB RestoreArea
                    CurrentMenu = False
                    EXIT SUB
                END IF
        END SELECT
    END IF

    ' test mouse click withhin menu.
    IF MouseX - 2 = CurrentMenuSelection THEN
        SELECT CASE CurrentMenu
            CASE 1
                IF MouseY >= 7 AND MouseY <= 21 THEN
                    GOSUB RestoreArea
                    EXIT SUB
                END IF
            CASE 2
                IF MouseY >= 17 AND MouseY <= 26 THEN
                    GOSUB RestoreArea
                    EXIT SUB
                END IF
            CASE 3
                IF MouseY >= 27 AND MouseY <= 41 THEN
                    GOSUB RestoreArea
                    EXIT SUB
                END IF
            CASE 4
                IF MouseY >= 37 AND MouseY <= 55 THEN
                    GOSUB RestoreArea
                    EXIT SUB
                END IF
            CASE 5
                IF MouseY >= 47 AND MouseY <= 58 THEN
                    GOSUB RestoreArea
                    EXIT SUB
                END IF
            CASE 6
                IF MouseY >= 57 AND MouseY <= 72 THEN
                    GOSUB RestoreArea
                    EXIT SUB
                END IF
            CASE 7
                IF MouseY >= 65 AND MouseY <= 77 THEN
                    GOSUB RestoreArea
                    EXIT SUB
                END IF
        END SELECT
    END IF
    RETURN
END SUB

' inits mouse.
SUB ClearMouse
    WHILE _MOUSEINPUT: WEND ' empty buffer
END SUB

REM Deconcatenates a filename to a specified length
REM  with imbedded \..\ character strings.
REM
REM Input:
REM   Y$ - Netpath (full path)
REM   Z$ - DosPath (ambiguated)
REM   Z% - Length (32-64)
REM
REM Returns:
REM   Z$ - Concatenated path
REM     C:\path\..\path\
REM   or,
REM     For remote or default server:
REM       \\server name\share name\path\..\path\

SUB Deconcatenate (Y$, Z$, Z%)
    Y$ = UCASE$(Y$)
    Z$ = UCASE$(Z$)
    ' check netpath.
    IF LEN(Y$) THEN
        ' store net path.
        Y1$ = UCASE$(Y$)
        IF RIGHT$(Y1$, 1) <> "\" THEN
            Y1$ = Y1$ + "\"
        END IF

        ' check default net path.
        IF RTRIM$(DefaultNetPath) <> Nul THEN

            ' store default netpath.
            Z1$ = "\\" + UCASE$(RTRIM$(DefaultNetPath)) + "\"

            ' check netpath is in default path.
            IF LEFT$(Y1$, LEN(Z1$)) = Z1$ THEN

                ' ambiguate netpath.
                ASCIIZ3 = ASCIIZ
                ASCIIZ = Y1$ + CHR$(0)
                CALL GetShortFilename(Short.Filename$)
                ASCIIZ = ASCIIZ3

                ' store ambiguated netpath.
                N1$ = Short.Filename$
            END IF
        END IF
        IF N1$ = Nul THEN
            N1$ = Y1$
        END IF
        N1$ = UCASE$(N1$)

        ' truncate drive letter.
        IF MID$(N1$, 2, 1) = ":" THEN
            N1$ = MID$(N1$, 3)
        END IF

        ' truncate netpath from dospath.
        IF LEFT$(Z$, LEN(N1$)) = N1$ THEN
            Z$ = MID$(Z$, LEN(N1$) + 1)
        END IF

        ' get ending position of server name.
        Y2 = INSTR(3, Y1$, "\")

        ' get ending position of share name.
        Y3 = INSTR(Y2 + 1, Y1$, "\")

        ' get server\share name.
        Y1$ = LEFT$(Y1$, Y3)
    END IF

    ' check path
    IF INSTR(Z$, "\") = False THEN
        IF LEN(Y$) THEN
            Z$ = Y1$ + Z$
        END IF
        IF LEN(Z$) > Z% THEN
            Z$ = LEFT$(Z$, Z% - 3) + "..."
        END IF
        EXIT SUB
    END IF

    ' decrement length of netpath
    Z1% = Z%
    IF LEN(Y1$) THEN
        Z1% = Z1% - LEN(Y1$)
        IF Z1% <= 0 THEN
            Z$ = LEFT$(Y1$, Z% - 3) + "..."
            EXIT SUB
        END IF
        Z1% = Z1% + 1
    END IF

    ' deconcatenate path
    IF Y$ <> Nul THEN
        IF LEFT$(Z$, 1) <> "\" THEN
            Z$ = "\" + Z$
        END IF
    END IF
    DO
        IF LEN(Z$) > Z1% THEN
            V1 = INSTR(Z$, "\")
            IF V1 > 0 THEN
                DO
                    IF MID$(Z$, V1, 4) = "\..\" THEN
                        V1 = INSTR(V1 + 1, Z$, "\")
                    ELSE
                        EXIT DO
                    END IF
                LOOP
                V2 = INSTR(V1 + 1, Z$, "\")
                IF V2 > 0 THEN
                    Z$ = LEFT$(Z$, V1) + ".." + MID$(Z$, V2)
                ELSE
                    EXIT DO
                END IF
            END IF
        ELSE
            EXIT DO
        END IF
        ' remove redundant paths
        DO
            V = INSTR(Z$, "\..\..\")
            IF V > 0 THEN
                Z$ = LEFT$(Z$, V - 1) + "\..\" + MID$(Z$, V + 7)
            ELSE
                EXIT DO
            END IF
        LOOP
    LOOP

    ' remove redundant paths
    DO
        V = INSTR(Z$, "\..\..\")
        IF V > 0 THEN
            Z$ = LEFT$(Z$, V - 1) + "\..\" + MID$(Z$, V + 7)
        ELSE
            EXIT DO
        END IF
    LOOP

    ' prepend net path
    IF LEN(Y1$) THEN
        IF Z$ = "\" THEN
            Z$ = Y1$
        ELSE
            IF LEFT$(Z$, 2) = "\\" THEN
                N1$ = Z$
            ELSE
                IF LEFT$(Z$, 1) = "\" THEN
                    Z$ = Y1$ + MID$(Z$, 2)
                ELSE
                    Z$ = Y1$ + Z$
                END IF
            END IF
        END IF
    END IF

    ' truncate to length
    IF LEN(Z$) > Z% THEN
        Z$ = LEFT$(Z$, Z% - 3) + "..."
    END IF
END SUB

' initialize directory/filename record.
SUB OpenDataFiles1
    V1$ = DRX + "HEXEDIT1.DA" + MID$(STR$(Process.Number), 2)
    V2$ = DRX + "HEXEDIT2.DA" + MID$(STR$(Process.Number), 2)
    MultiFilename1(4) = Nul
    MultiFilename1(5) = Nul
    CLOSE #2, #3
    ' open filename random record structure for windows.
    OPEN V1$ FOR RANDOM AS #2 LEN = LEN(WinFileStruc)
    ' open directory random record structure for windows.
    OPEN V2$ FOR RANDOM AS #3 LEN = LEN(WinFileStruc)
    MultiFilename1(4) = V1$
    MultiFilename1(5) = V2$
END SUB

' redraws menu tab.
SUB DisplayTab (Var)
    SELECT CASE Var
        CASE 1 ' File
            Locatef 1, 6, 0
            Printf "File"
        CASE 2 ' Charts
            Locatef 1, 16, 0
            Printf "Charts"
        CASE 3 ' Dump
            Locatef 1, 26, 0
            Printf "Dump"
        CASE 4 ' Edit
            Locatef 1, 36, 0
            Printf "Edit"
        CASE 5 ' Jump
            Locatef 1, 46, 0
            Printf "Jump"
        CASE 6 ' Print
            Locatef 1, 56, 0
            Printf "Print"
        CASE 7 ' Search
            Locatef 1, 64, 0
            Printf "Search"
    END SELECT
    Colorf2 White, 0
END SUB

' display error trap message.
SUB DisplayCriticalError (Var)
    SELECT CASE Var
        CASE 5
            ' Ctrl-E TestError w/ debug will display
            '   syntax error for debug purposes.

            Printf "Syntax error"
        CASE 6
            Printf "Overflow"
        CASE 9
            Printf "Subscript out of range"
        CASE 14
            Printf "Out of string space"
        CASE 24
            Printf "Device timeout"
        CASE 25
            Printf "Device fault"
        CASE 27
            Printf "Out of paper"
        CASE 52
            Printf "Bad file name or number"
        CASE 53
            Printf "File not found"
        CASE 54
            Printf "Bad file mode"
        CASE 55
            Printf "File already open"
        CASE 57
            Printf "Device I/O error"
        CASE 58
            Printf "File already exists"
        CASE 59
            Printf "Bad record length"
        CASE 61
            Printf "Disk full"
        CASE 62
            Printf "Input past eof"
        CASE 63
            Printf "Bad record length"
        CASE 64
            Printf "Bad file name"
        CASE 67
            Printf "Not enough file handles"
        CASE 68
            Printf "Device unavailable"
        CASE 70
            Printf "Permission denied"
        CASE 71
            Printf "Disk not ready"
        CASE 72
            Printf "Disk-media error"
        CASE 75
            Printf "Path/File access error"
        CASE 76
            Printf "Pathname not found"
        CASE 81
            Printf "Invalid name"
        CASE 90
            Printf "Too many processes"
        CASE ELSE
            Printf "Untrapped error" + STR$(Var)
    END SELECT
END SUB

' construct file/dir exclusion list.
SUB ExcludeList (V1, Y$)
    IF V1 = 1 THEN
        Locatef Xcoor + 1, Ycoor + 2, 1
        Printf SPACE$(38)
        Locatef Xcoor + 1, Ycoor + 2, 1
        Colorf2 White, 0
        Printf "Enter file spec: "
        Y$ = LineInput$(Xcoor + 1, Ycoor + 19, 21)
    ELSE
        Locatef Xcoor + 1, Ycoor + 2, 1
        Printf SPACE$(38)
        Locatef Xcoor + 1, Ycoor + 2, 1
        Colorf2 White, 0
        Printf "Enter dir spec: "
        Y$ = LineInput$(Xcoor + 1, Ycoor + 18, 22)
    END IF
    IF LEN(Y$) THEN
        ' process filelist filename.
        Filename2$ = FILELISTEXISTS(Y$)
        IF LEN(Filename2$) THEN
            Y$ = Nul

            ' open filelist filename.
            Check.Disk = True
            Disk.Ready = False
            x2 = FREEFILE
            OPEN Filename2$ FOR INPUT AS #x2
            Check.Disk = False
            IF Disk.Ready THEN
                Locatef Xcoor + 1, Ycoor + 2, 1
                Printf SPACE$(38)
                Locatef Xcoor + 1, Ycoor + 2, 1
                Colorf2 White, 0
                Printf "Filelist not found. Press <esc>:"
                CALL PromptInkey
                EXIT SUB
            END IF
            DO UNTIL EOF(x2)
                LINE INPUT #x2, Y1$
                Y1$ = LTRIM$(Y1$)
                Y1$ = RTRIM$(Y1$)
                Y1$ = UCASE$(Y1$)
                IF LEN(Y1$) THEN
                    IF LEFT$(Y1$, 1) = Quote THEN
                        Y1$ = MID$(Y1$, 2)
                        IF RIGHT$(Y1$, 1) = Quote THEN
                            Y1$ = LEFT$(Y1$, LEN(Y1$) - 1)
                        END IF
                    END IF
                    IF LEN(Y1$) THEN
                        IF INSTR(Y1$, " ") = False THEN
                            ' add excluded filename.
                            Y$ = Y$ + Y1$ + " "
                            IF LEN(Y$) > 4096 THEN
                                Y$ = Nul
                                EXIT DO
                            END IF
                        END IF
                    END IF
                END IF
            LOOP
            CLOSE #x2
            Locatef Xcoor + 1, Ycoor + 2, 1
            Printf SPACE$(38)
            Locatef Xcoor + 1, Ycoor + 2, 1
            Colorf2 White, 0
            IF LEN(Y$) THEN
                Printf "Filelist loaded. Press <esc>:"
            ELSE
                Printf "Filelist not loaded. Press <esc>:"
            END IF
            CALL PromptInkey
        END IF
    END IF
    Y$ = LTRIM$(Y$)
    Y$ = RTRIM$(Y$)
END SUB

' display screen border.
SUB DisplayScreen2
    CLS
    Colorf Magenta
    Printf CHR$(ULcorner) + STRING$(76, Hline) + CHR$(URcorner)
    FOR Var2 = 2 TO 23
        Locatef Var2, 1, 0
        Printf CHR$(Vline)
        Locatef Var2, 78, 0
        Printf CHR$(Vline)
    NEXT
    Locatef 24, 1, 0
    Printf CHR$(LLcorner) + STRING$(76, Hline) + CHR$(LRcorner)
    Colorf Plain
END SUB

' display boot usage.
SUB DisplayBootUsage
    CLS
    Colorf White
    Locatef 1, 1, 0
    Printf "Hex Editor " + Version + " " + Release + "."
    Colorf Green
    Locatef 2, 1, 0
    Printf "Command Usage:"
    Colorf Yellow
    Locatef 3, 1, 0
    Printf "   Hexedit [@]<filename.ext>, [@]<filename.ext>, ..."
    Colorf Green
    Locatef 4, 1, 0
    Printf "Where:"
    Colorf Yellow
    Locatef 5, 1, 0
    Printf "   <filename.ext> is the file to edit. May include drive/pathname. Also"
    Locatef 6, 1, 0
    Printf "   supports long filenames in quotes. Filename may be omitted. Multiple"
    Locatef 7, 1, 0
    Printf "   files allowed with * and ? characters. Maximum of 9 files available."
    Locatef 8, 1, 0
    Printf "   Filename prepended with @ loads filelist from contents of text file."
    Locatef 9, 1, 0
    Printf "   May also contain server and share name if prepended as \\server\share\"
    Colorf Green
    Locatef 10, 1, 0
    Printf "Example:"
    Colorf Yellow
    Locatef 11, 1, 0
    Printf "   Hexedit \dos\page.com"
    Locatef 12, 1, 0
    Printf "   Or use the file menu box by starting Hexedit without a filename."
    Colorf Green
    Locatef 13, 1, 0
    Printf "File Menu Box Usage:"
    Colorf Yellow
    Locatef 14, 1, 0
    Printf "   Navigate using cursors, selecting with <enter>, and switch windows"
    Locatef 15, 1, 0
    Printf "   with <tab> and Shift-<tab>. Exits to editor or DOS with <escape>."
    Colorf Green
    Locatef 16, 1, 0
    Printf "File Editor Usage:"
    Colorf Yellow
    Locatef 17, 1, 0
    Printf "   Enter editing functions or cursor movement through the hex values,"
    Locatef 18, 1, 0
    Printf "   while changing them with <enter>, <delete> or <insert> as you edit."
    Colorf Green
    Locatef 19, 1, 0
    Printf "Author status:"
    Colorf Yellow
    Locatef 20, 1, 0
    Printf "   Written by: " + Author$
    Locatef 21, 1, 0
    Printf "   Email: " + Email
    Locatef 22, 1, 0
    Printf "   Urls: " + Urls
    Locatef 23, 1, 0
    Printf ""
END SUB

' display main program editing screen.
SUB DisplayScreen
    CLS
    Colorf Magenta
    Locatef 1, 1, 0
    Printf " " + CHR$(ULcorner)
    Printf STRING$(3, Hline)
    Colorf White
    Printf "File"
    Colorf Magenta
    Printf STRING$(6, Hline)
    Colorf White
    Printf "Charts"
    Colorf Magenta
    Printf STRING$(4, Hline)
    Colorf White
    Printf "Dump"
    Colorf Magenta
    Printf STRING$(6, Hline)
    Colorf White
    Printf "Edit"
    Colorf Magenta
    Printf STRING$(6, Hline)
    Colorf White
    Printf "Jump"
    Colorf Magenta
    Printf STRING$(6, Hline)
    Colorf White
    Printf "Print"
    Colorf Magenta
    Printf STRING$(3, Hline)
    Colorf White
    Printf "Search"
    Colorf Magenta
    Printf CHR$(Hline) + CHR$(Hline)
    Colorf Yellow
    Printf Version
    Colorf Magenta
    Printf STRING$(1, Hline)
    Printf CHR$(URcorner)
    Locatef 2, 1, 0
    Printf " " + CHR$(Vline) + STRING$(75, 32) + CHR$(Vline)
    Locatef 3, 1, 0
    Printf " " + CHR$(Vline) + " "
    Colorf Green
    Printf CHR$(ULcorner) + STRING$(46, Hline) + CHR$(URcorner) + " "
    Printf CHR$(ULcorner) + STRING$(22, Hline) + CHR$(URcorner)
    Colorf White
    Printf "x"
    Colorf Magenta
    Printf CHR$(Vline)
    Locatef 4, 1, 0
    Printf " " + CHR$(Vline)
    Colorf White
    Printf "0"
    Colorf Green
    Printf CHR$(Vline) + STRING$(46, 32) + CHR$(Vline)
    Colorf White
    Printf "<"
    Colorf Green
    Printf CHR$(Vline) + STRING$(22, 32) + CHR$(Vline)
    Colorf White
    Printf "?"
    Colorf Magenta
    Printf CHR$(Vline)
    Locatef 5, 1, 0
    Printf " " + CHR$(Vline)
    Colorf White
    Printf "1"
    Colorf Green
    Printf CHR$(Vline) + STRING$(46, 32) + CHR$(Vline)
    Colorf White
    Printf "|"
    Colorf Green
    Printf CHR$(Vline) + STRING$(22, 32) + CHR$(Vline) + " "
    Colorf Magenta
    Printf CHR$(Vline)
    Locatef 6, 1, 0
    Printf " " + CHR$(Vline)
    Colorf White
    Printf "2"
    Colorf Green
    Printf CHR$(Vline) + STRING$(46, 32) + CHR$(Vline) + " " + CHR$(Vline) + STRING$(22, 32) + CHR$(Vline) + " "
    Colorf Magenta
    Printf CHR$(Vline)
    Locatef 7, 1, 0
    Printf " " + CHR$(Vline)
    Colorf White
    Printf "3"
    Colorf Green
    Printf CHR$(Vline) + STRING$(46, 32) + CHR$(Vline) + " " + CHR$(Vline) + STRING$(22, 32) + CHR$(Vline) + " "
    Colorf Magenta
    Printf CHR$(Vline)
    Locatef 8, 1, 0
    Printf " " + CHR$(Vline)
    Colorf White
    Printf "4"
    Colorf Green
    Printf CHR$(Vline) + STRING$(46, 32) + CHR$(Vline) + " " + CHR$(Vline) + STRING$(22, 32) + CHR$(Vline) + " "
    Colorf Magenta
    Printf CHR$(Vline)
    Locatef 9, 1, 0
    Printf " " + CHR$(Vline)
    Colorf White
    Printf "5"
    Colorf Green
    Printf CHR$(Vline) + STRING$(46, 32) + CHR$(Vline) + " " + CHR$(Vline) + STRING$(22, 32) + CHR$(Vline) + " "
    Colorf Magenta
    Printf CHR$(Vline)
    Locatef 10, 1, 0
    Printf " " + CHR$(Vline)
    Colorf White
    Printf "6"
    Colorf Green
    Printf CHR$(Vline) + STRING$(46, 32) + CHR$(Vline) + " " + CHR$(Vline) + STRING$(22, 32) + CHR$(Vline) + " "
    Colorf Magenta
    Printf CHR$(Vline)
    Locatef 11, 1, 0
    Printf " " + CHR$(Vline)
    Colorf White
    Printf "7"
    Colorf Green
    Printf CHR$(Vline) + STRING$(46, 32) + CHR$(Vline) + " " + CHR$(Vline) + STRING$(22, 32) + CHR$(Vline) + " "
    Colorf Magenta
    Printf CHR$(Vline)
    Locatef 12, 1, 0
    Printf " " + CHR$(Vline)
    Colorf White
    Printf "8"
    Colorf Green
    Printf CHR$(Vline) + STRING$(46, 32) + CHR$(Vline) + " " + CHR$(Vline) + STRING$(22, 32) + CHR$(Vline) + " "
    Colorf Magenta
    Printf CHR$(Vline)
    Locatef 13, 1, 0
    Printf " " + CHR$(Vline)
    Colorf White
    Printf "9"
    Colorf Green
    Printf CHR$(Vline) + STRING$(46, 32) + CHR$(Vline) + " " + CHR$(Vline) + STRING$(22, 32) + CHR$(Vline) + " "
    Colorf Magenta
    Printf CHR$(Vline)
    Locatef 14, 1, 0
    Printf " " + CHR$(Vline)
    Colorf White
    Printf "A"
    Colorf Green
    Printf CHR$(Vline) + STRING$(46, 32) + CHR$(Vline) + " " + CHR$(Vline) + STRING$(22, 32) + CHR$(Vline) + " "
    Colorf Magenta
    Printf CHR$(Vline)
    Locatef 15, 1, 0
    Printf " " + CHR$(Vline)
    Colorf White
    Printf "B"
    Colorf Green
    Printf CHR$(Vline) + STRING$(46, 32) + CHR$(Vline) + " " + CHR$(Vline) + STRING$(22, 32) + CHR$(Vline) + " "
    Colorf Magenta
    Printf CHR$(Vline)
    Locatef 16, 1, 0
    Printf " " + CHR$(Vline)
    Colorf White
    Printf "C"
    Colorf Green
    Printf CHR$(Vline) + STRING$(46, 32) + CHR$(Vline) + " " + CHR$(Vline) + STRING$(22, 32) + CHR$(Vline) + " "
    Colorf Magenta
    Printf CHR$(Vline)
    Locatef 17, 1, 0
    Printf " " + CHR$(Vline)
    Colorf White
    Printf "D"
    Colorf Green
    Printf CHR$(Vline) + STRING$(46, 32) + CHR$(Vline) + " " + CHR$(Vline) + STRING$(22, 32) + CHR$(Vline) + " "
    Colorf Magenta
    Printf CHR$(Vline)
    Locatef 18, 1, 0
    Printf " " + CHR$(Vline)
    Colorf White
    Printf "E"
    Colorf Green
    Printf CHR$(Vline) + STRING$(46, 32) + CHR$(Vline) + " " + CHR$(Vline) + STRING$(22, 32) + CHR$(Vline) + " "
    Colorf Magenta
    Printf CHR$(Vline)
    Locatef 19, 1, 0
    Printf " " + CHR$(Vline)
    Colorf White
    Printf "F"
    Colorf Green
    Printf CHR$(Vline) + STRING$(46, 32) + CHR$(Vline)
    Colorf White
    Printf "|"
    Colorf Green
    Printf CHR$(Vline) + STRING$(22, 32) + CHR$(Vline) + " "
    Colorf Magenta
    Printf CHR$(Vline)
    Locatef 20, 1, 0
    Printf " " + CHR$(Vline) + " "
    Colorf Green
    Printf CHR$(LLcorner) + STRING$(46, Hline) + CHR$(LRcorner)
    Colorf White
    Printf ">"
    Colorf Green
    Printf CHR$(LLcorner) + STRING$(22, Hline) + CHR$(LRcorner) + " "
    Colorf Magenta
    Printf CHR$(Vline)
    ' check to skip info line area.
    IF ScreenRow THEN
        Colorf Magenta
        Locatef 21, 1, 0
        Printf " " + CHR$(LLcorner) + STRING$(75, Hline) + CHR$(LRcorner)
        Colorf Plain
        EXIT SUB
    END IF
    Locatef 21, 1, 0
    Printf " " + CHR$(Vline)
    Colorf Yellow
    Printf " Alt-A Append bytes, Alt-M Append string, Alt-C ANSI Chart, Alt-N New File "
    Colorf Magenta
    Printf CHR$(Vline)
    Locatef 22, 1, 0
    Printf " " + CHR$(Vline)
    Colorf Yellow
    Printf " Alt-H HEX Chart, Alt-R Redraw, Alt-S Search bytes, Alt-U Undo, Alt-X Exit "
    Colorf Magenta
    Printf CHR$(Vline)
    Locatef 23, 1, 0
    Printf " " + CHR$(Vline)
    Colorf Yellow
    Printf " Alt-J Jump, Alt-K Search string, Alt-D Dump, Alt-P Print, Alt-Z Undo All. "
    Colorf Magenta
    Printf CHR$(Vline)
    Colorf Magenta
    Locatef 24, 1, 0
    Printf " " + CHR$(LLcorner) + STRING$(75, Hline) + CHR$(LRcorner)
    Colorf Plain
END SUB

REM Help/main screens for main menu and file menu.
REM Ansi/Hex Charts and Print subroutines.
REM Screen/File Dump and Print subroutines.
REM Clipboard and ViewFile subroutines.

REM File/directory sort subroutines.
REM GetInfo subroutine for Attribute, Date/Time, FileSize.
REM GetDriveInfo subroutine.
REM DriveExists function.
REM NetPathExists function.
REM SearchFile subroutine.

REM File box main menu.

SUB FileMainMenu
    Colorf2 White, BackGround
    CLS
    Locatef Xcoor, Ycoor, 0
    Colorf2 White, 0
    Colorf Yellow
    Printf CHR$(ULcorner) + STRING$(10, Hline)
    Colorf Green
    Printf "(<esc>=Quit,F9=Help)"
    Colorf Yellow
    Printf STRING$(9, Hline) + CHR$(URcorner)
    Locatef Xcoor + 1, Ycoor, 0
    Printf CHR$(Vline) + " "
    Colorf White
    Printf "Filename:"
    Colorf Yellow
    Printf SPACE$(29) + CHR$(Vline)
    Locatef Xcoor + 2, Ycoor, 0
    Printf CHR$(Vline) + SPACE$(39) + CHR$(Vline)
    Locatef Xcoor + 3, Ycoor, 0
    Printf CHR$(Vline) + " "
    Colorf White
    Printf "Files:          Dirs:          Drives:"
    Colorf Yellow
    Printf CHR$(Vline)
    Locatef Xcoor + 4, Ycoor, 0
    Printf CHR$(Vline)
    Colorf Magenta
    Printf " " + CHR$(ULcorner) + STRING$(12, Hline) + CHR$(URcorner) + "  "
    Printf CHR$(ULcorner) + STRING$(12, Hline) + CHR$(URcorner) + "  "
    Printf CHR$(ULcorner) + STRING$(3, Hline) + CHR$(URcorner) + " "
    Colorf Yellow
    Printf CHR$(Vline)
    Colorf Yellow
    Locatef Xcoor + 5, Ycoor, 0
    Printf CHR$(Vline)
    Colorf Magenta
    Printf " " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "  "
    Printf CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "  "
    Printf CHR$(Vline) + SPACE$(3) + CHR$(Vline) + " "
    Colorf Yellow
    Printf CHR$(Vline)
    Colorf Yellow
    Locatef Xcoor + 6, Ycoor, 0
    Printf CHR$(Vline)
    Colorf Magenta
    Printf " " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "  "
    Printf CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "  "
    Printf CHR$(Vline) + SPACE$(3) + CHR$(Vline) + " "
    Colorf Yellow
    Printf CHR$(Vline)
    Colorf Yellow
    Locatef Xcoor + 7, Ycoor, 0
    Printf CHR$(Vline)
    Colorf Magenta
    Printf " " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "  "
    Printf CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "  "
    Printf CHR$(Vline) + SPACE$(3) + CHR$(Vline) + " "
    Colorf Yellow
    Printf CHR$(Vline)
    Colorf Yellow
    Locatef Xcoor + 8, Ycoor, 0
    Printf CHR$(Vline)
    Colorf Magenta
    Printf " " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "  "
    Printf CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "  "
    Printf CHR$(Vline) + SPACE$(3) + CHR$(Vline) + " "
    Colorf Yellow
    Printf CHR$(Vline)
    Colorf Yellow
    Locatef Xcoor + 9, Ycoor, 0
    Printf CHR$(Vline)
    Colorf Magenta
    Printf " " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "  "
    Printf CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "  "
    Printf CHR$(Vline) + SPACE$(3) + CHR$(Vline) + " "
    Colorf Yellow
    Printf CHR$(Vline)
    Colorf Yellow
    Locatef Xcoor + 10, Ycoor, 0
    Printf CHR$(Vline)
    Colorf Magenta
    Printf " " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "  "
    Printf CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "  "
    Printf CHR$(Vline) + SPACE$(3) + CHR$(Vline) + " "
    Colorf Yellow
    Printf CHR$(Vline)
    Colorf Yellow
    Locatef Xcoor + 11, Ycoor, 0
    Printf CHR$(Vline)
    Colorf Magenta
    Printf " " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "  "
    Printf CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "  "
    Printf CHR$(Vline) + SPACE$(3) + CHR$(Vline) + " "
    Colorf Yellow
    Printf CHR$(Vline)
    Colorf Yellow
    Locatef Xcoor + 12, Ycoor, 0
    Printf CHR$(Vline)
    Colorf Magenta
    Printf " " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "  "
    Printf CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "  "
    Printf CHR$(Vline) + SPACE$(3) + CHR$(Vline) + " "
    Colorf Yellow
    Printf CHR$(Vline)
    Colorf Yellow
    Locatef Xcoor + 13, Ycoor, 0
    Printf CHR$(Vline)
    Colorf Magenta
    Printf " " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "  "
    Printf CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "  "
    Printf CHR$(Vline) + SPACE$(3) + CHR$(Vline) + " "
    Colorf Yellow
    Printf CHR$(Vline)
    Colorf Yellow
    Locatef Xcoor + 14, Ycoor, 0
    Printf CHR$(Vline)
    Colorf Magenta
    Printf " " + CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "  "
    Printf CHR$(Vline) + SPACE$(12) + CHR$(Vline) + "  "
    Printf CHR$(Vline) + SPACE$(3) + CHR$(Vline) + " "
    Colorf Yellow
    Printf CHR$(Vline)
    Colorf Yellow
    Locatef Xcoor + 15, Ycoor, 0
    Printf CHR$(Vline)
    Colorf Magenta
    Printf " " + CHR$(LLcorner) + STRING$(12, Hline) + CHR$(LRcorner) + "  "
    Printf CHR$(LLcorner) + STRING$(12, Hline) + CHR$(LRcorner) + "  "
    Printf CHR$(LLcorner) + STRING$(3, Hline) + CHR$(LRcorner) + " "
    Colorf Yellow
    Printf CHR$(Vline)
    Locatef Xcoor + 16, Ycoor, 0
    Printf CHR$(LLcorner) + STRING$(39, Hline) + CHR$(LRcorner)
    Colorf White
    ' make file input box mouse symbols.
    Locatef Xcoor + 4, Ycoor + 16, 0
    Printf "<"
    Locatef Xcoor + 5, Ycoor + 16, 0
    Printf "|"
    Locatef Xcoor + 14, Ycoor + 16, 0
    Printf "|"
    Locatef Xcoor + 15, Ycoor + 16, 0
    Printf ">"
    ' make directory input box mouse symbols.
    Locatef Xcoor + 4, Ycoor + 32, 0
    Printf "<"
    Locatef Xcoor + 5, Ycoor + 32, 0
    Printf "|"
    Locatef Xcoor + 14, Ycoor + 32, 0
    Printf "|"
    Locatef Xcoor + 15, Ycoor + 32, 0
    Printf ">"
    ' make drive input box mouse symbols.
    Locatef Xcoor + 5, Ycoor + 39, 0
    Printf "|"
    Locatef Xcoor + 14, Ycoor + 39, 0
    Printf "|"
    ' make file menu box question symbol.
    Locatef Xcoor, Ycoor + 39, 0
    Printf "?"
    ' make file menu box exit symbol.
    Locatef Xcoor, Ycoor + 40, 0
    Printf "x"
    ' make remaining menu box areas.
    IF Xcoor - 1 > 0 THEN
        Colorf2 Green, BackGround
        Locatef Xcoor - 1, Ycoor, 0
        Printf "Hexedit " + Version + " For QB64 Windows PD 2017."
    END IF
    CALL BottomRow
END SUB

REM File box bottom row menu.

SUB BottomRow
    IF Xcoor + 17 <= 24 THEN
        Colorf2 Green, BackGround
        Locatef Xcoor + 17, Ycoor, 0
        Printf "Path:"
    END IF
    IF Xcoor + 18 <= 24 THEN
        Colorf2 Green, BackGround
        Locatef Xcoor + 18, Ycoor, 0
        Printf "File:"
    END IF
    IF Xcoor + 19 <= 24 THEN
        Colorf2 Green, BackGround
        Locatef Xcoor + 19, Ycoor, 0
        Printf "Size:"
    END IF
    Colorf2 Plain, 0
END SUB

REM display filename border area.

SUB DisplayScreen3X
    Locatef 3, 2, 0
    Colorf Magenta
    Printf CHR$(Vline) + " "
    Colorf Green
    Printf CHR$(ULcorner) + STRING$(46, Hline) + CHR$(URcorner) + " "
    Printf CHR$(ULcorner) + STRING$(22, Hline) + CHR$(URcorner)
    Colorf White
    Printf "x"
    Colorf Magenta
    Printf CHR$(Vline)
END SUB

REM Help screen subroutines:

' display help for file menu input box.
SUB DisplayHelp
    Xcoor2 = 5
    Ycoor2 = 3
    GOSUB RedrawHelpScreen
    I$ = Nul
    DO
        I$ = Nul
        DO
            _LIMIT 100
            I$ = INKEY$
            IF I$ <> Nul THEN
                EXIT DO
            END IF
            Z = MouseDriver ' get mouse
            IF MouseButton1 THEN
                MouseButton1 = False
                CALL ClearMouse
                IF Xcoor2 - 1 >= 1 THEN
                    Xcoor2 = Xcoor2 - 1
                    GOSUB RedrawHelpScreen
                    Var = False
                END IF
            END IF
            IF MouseButton2 THEN
                MouseButton2 = False
                CALL ClearMouse
                IF Xcoor2 + 1 <= 13 THEN
                    Xcoor2 = Xcoor2 + 1
                    GOSUB RedrawHelpScreen
                    Var = False
                END IF
            END IF
            IF MouseButton3 THEN
                I$ = CHR$(0) + CHR$(76) ' center box
                EXIT DO
            END IF
            IF MouseWheel = -1 THEN
                IF WheelReverse THEN
                    I$ = CHR$(0) + CHR$(80) ' down
                ELSE
                    I$ = CHR$(0) + CHR$(72) ' up
                END IF
                MouseWheel = 0
                EXIT DO
            END IF
            IF MouseWheel = 1 THEN
                IF WheelReverse THEN
                    I$ = CHR$(0) + CHR$(72) ' up
                ELSE
                    I$ = CHR$(0) + CHR$(80) ' down
                END IF
                MouseWheel = 0
                EXIT DO
            END IF
        LOOP
        Var = False
        SELECT CASE LEN(I$)
            CASE 1
                SELECT CASE I$
                    CASE CHR$(27) ' ExitBox
                        EXIT DO
                    CASE "|" ' SelectBox
                        IF Xcoor2 <> 1 THEN
                            Xcoor2 = 1
                            Var = True
                        END IF
                    CASE "#" ' SelectBox
                        IF Xcoor2 <> 13 THEN
                            Xcoor2 = 13
                            Var = True
                        END IF
                    CASE "1" TO "9" ' SelectBox
                        IF INT(VAL(I$)) <> Xcoor2 THEN
                            Xcoor2 = INT(VAL(I$))
                            Var = True
                        END IF
                    CASE "0" ' SelectBox
                        IF Xcoor2 <> 10 THEN
                            Xcoor2 = 10
                            Var = True
                        END IF
                    CASE "-" ' SelectBox
                        IF Xcoor2 <> 11 THEN
                            Xcoor2 = 11
                            Var = True
                        END IF
                    CASE "=" ' SelectBox
                        IF Xcoor2 <> 12 THEN
                            Xcoor2 = 12
                            Var = True
                        END IF
                    CASE "+" ' SelectBox
                        IF Xcoor2 <> 13 THEN
                            Xcoor2 = 13
                            Var = True
                        END IF
                END SELECT
            CASE 2
                VarQ = ASC(RIGHT$(I$, 1))
                SELECT CASE VarQ
                    ' Up/Ctrl-Up/Alt-Up/Ctrl--,Alt-- = MoveUp
                    CASE 72, 141, 152, 142, 74, 130
                        IF Xcoor2 - 1 >= 1 THEN
                            Xcoor2 = Xcoor2 - 1
                            Var = True
                        END IF
                        ' Down/Ctrl-Down/Alt-Down/Ctrl-+/Alt-+ = MoveDown
                    CASE 80, 145, 160, 144, 78, 131
                        IF Xcoor2 + 1 <= 13 THEN
                            Xcoor2 = Xcoor2 + 1
                            Var = True
                        END IF
                    CASE 76, 143 ' Keypad-5/Ctrl-Keypad-5 = CenterBox
                        IF Xcoor2 <> 5 THEN
                            Xcoor2 = 5
                            Var = True
                        END IF
                        ' Home/PageUp/Ctrl-Home/Ctrl-PageUp = MoveTop
                    CASE 71, 73, 119, 132
                        IF Xcoor2 <> 1 THEN
                            Xcoor2 = 1
                            Var = True
                        END IF
                        ' End/PageDown/Ctrl-End/Ctrl-PageDown = MoveBottom
                    CASE 79, 81, 117, 118
                        IF Xcoor2 <> 13 THEN
                            Xcoor2 = 13
                            Var = True
                        END IF
                END SELECT
        END SELECT
        IF Var THEN
            Var = False
            GOSUB RedrawHelpScreen
        END IF
    LOOP
    EXIT SUB

    RedrawHelpScreen:
    Colorf2 White, BackGround2
    CLS
    Locatef Xcoor2, Ycoor2, 0
    Printf "            File Menu Box Function Keys Help Screen " + Version + " " + Release
    Locatef Xcoor2 + 1, Ycoor2, 0
    Colorf2 White, 0
    Colorf Yellow
    Printf CHR$(ULcorner) + STRING$(74, Hline) + CHR$(URcorner)
    Locatef Xcoor2 + 2, Ycoor2, 0
    Printf CHR$(Vline) + " "
    Colorf White
    Printf "                  Press <escape> To Return To Menu:                      "
    Colorf Yellow
    Printf CHR$(Vline)
    Locatef Xcoor2 + 3, Ycoor2, 0
    Printf CHR$(Vline) + " "
    Colorf White
    Printf "F1 - Change Drive  F8 - Attribute Specs Alt-F3 Dir Exclude List          "
    Colorf Yellow
    Printf CHR$(Vline)
    Locatef Xcoor2 + 4, Ycoor2, 0
    Printf CHR$(Vline) + " "
    Colorf White
    Printf "F2 - Toggle Sort   F9 - Display Help    Alt-F4 Toggle File Sort Direction"
    Colorf Yellow
    Printf CHR$(Vline)
    Locatef Xcoor2 + 5, Ycoor2, 0
    Colorf Yellow
    Printf CHR$(Vline) + " "
    Colorf White
    Printf "F3 - Move Menu     F10 - Exit Editor    Alt-F5 Toggle Dir Sort Direction "
    Colorf Yellow
    Printf CHR$(Vline)
    Locatef Xcoor2 + 6, Ycoor2, 0
    Printf CHR$(Vline) + " "
    Colorf White
    Printf "F4 - Back Drive    F11 - Shell To DOS   Alt-F6 Toggle File Date/Time Info"
    Colorf Yellow
    Printf CHR$(Vline)
    Locatef Xcoor2 + 7, Ycoor2, 0
    Printf CHR$(Vline) + " "
    Colorf White
    Printf "F5 - Forward Drive F12 - Load FileSpec  Alt-F7 Toggle File Size Info     "
    Colorf Yellow
    Printf CHR$(Vline)
    Locatef Xcoor2 + 8, Ycoor2, 0
    Printf CHR$(Vline) + " "
    Colorf White
    Printf "F6 - Toggle Ambiguate  Alt-F1 Toggle Quiet   Alt-F8 Load Network Path    "
    Colorf Yellow
    Printf CHR$(Vline)
    Locatef Xcoor2 + 9, Ycoor2, 0
    Printf CHR$(Vline) + " "
    Colorf White
    Printf "F7 - Redraw Menu Box   Alt-F2 Exclude List   Alt-F9 Load Default Net Path"
    Colorf Yellow
    Printf CHR$(Vline)
    Locatef Xcoor2 + 10, Ycoor2, 0
    Printf CHR$(Vline) + " "
    Colorf White
    Printf "Alt-A to Alt-Z  Select Drive Letter   Alt-F10 Load Default Net Path Drive"
    Colorf Yellow
    Printf CHR$(Vline)
    Locatef Xcoor2 + 11, Ycoor2, 0
    Printf CHR$(LLcorner) + STRING$(74, Hline) + CHR$(LRcorner)
    Colorf White
    RETURN
END SUB

' display help screens.
SUB HelpScreen
    GOSUB DisplayHelpScreen1
    GOSUB DisplayHelpScreen2
    GOSUB DisplayHelpScreen3
    GOSUB DisplayHelpScreen4
    GOSUB DisplayHelpScreen5
    EXIT SUB

    ' help screen header.
    HelpHeader:
    CALL DisplayScreen2
    Locatef 2, 2, 0
    Colorf White
    Printf "Help screen: Hex Editor " + Version + " " + Release + " functions:"
    RETURN

    ' help screen 1.
    DisplayHelpScreen1:
    GOSUB HelpHeader
    Colorf Red
    Locatef 3, 2, 0
    Printf "Function keys:"
    Colorf Yellow
    Locatef 4, 2, 0
    Printf "Alt-A  Append multiple bytes to file.   Alt-T  HEX File Print."
    Locatef 5, 2, 0
    Printf "Alt-B  Append multiple null bytes.      Alt-U  Undo last byte change."
    Locatef 6, 2, 0
    Printf "Alt-C  ANSI Chart.                      Alt-V  View files."
    Locatef 7, 2, 0
    Printf "Alt-D  HEX Screen Dump.                 Alt-W  Close file."
    Locatef 8, 2, 0
    Printf "Alt-E  HEX File Dump.                   Alt-X  Exit program."
    Locatef 9, 2, 0
    Printf "Alt-F  Start input menu.                Alt-Y  Toggle right window."
    Locatef 10, 2, 0
    Printf "Alt-G  Append multiple specified bytes. Alt-Z  Undo all bytes changes."
    Locatef 11, 2, 0
    Printf "Alt-H  HEX Chart.                       "
    Colorf Red
    Printf "Editing keys:"
    Colorf Yellow
    Locatef 12, 2, 0
    Printf "Alt-I  DOS shell.                       Tab    -- Switch windows."
    Locatef 13, 2, 0
    Printf "Alt-J  Jump to byte position.           Enter  -- Change byte value."
    Locatef 14, 2, 0
    Printf "Alt-K  Search for ASCII string.         Insert -- Change string value."
    Locatef 15, 2, 0
    Printf "Alt-L  Jump to page position.           Delete -- Change hex string."
    Locatef 16, 2, 0
    Printf "Alt-M  Append ASCII string to file.     Escape -- Input Menu."
    Locatef 17, 2, 0
    Printf "Alt-N  Open new file.                   (hex value numeral preceded)."
    Locatef 18, 2, 0
    Printf "Alt-O  Print help.                      (right window unprintable chars"
    Locatef 19, 2, 0
    Printf "Alt-P  HEX Screen Print.                are represented with a dot)."
    Locatef 20, 2, 0
    Printf "Alt-Q  Help screen.                     (ascii values preceded with H"
    Locatef 21, 2, 0
    Printf "Alt-R  Redraw screen.                   are treated as hexidecimal)."
    Locatef 22, 2, 0
    Printf "Alt-S  Search for multiple bytes.       (<escape> key exits search)."
    Locatef 23, 2, 0
    CALL PressKey
    RETURN

    ' help screen 2.
    DisplayHelpScreen2:
    GOSUB HelpHeader
    Colorf Red
    Locatef 3, 2, 0
    Printf "Marker keys:"
    Colorf Yellow
    Locatef 4, 2, 0
    Printf "1   add marker."
    Locatef 5, 2, 0
    Printf "2   add specific marker value."
    Locatef 6, 2, 0
    Printf "3   delete marker."
    Locatef 7, 2, 0
    Printf "4   delete specific marker."
    Locatef 8, 2, 0
    Printf "5   jump previous marker."
    Locatef 9, 2, 0
    Printf "6   jump current marker."
    Locatef 10, 2, 0
    Printf "7   jump next marker."
    Locatef 11, 2, 0
    Printf "8   jump specific marker."
    Locatef 12, 2, 0
    Printf "9   list all markers."
    Locatef 13, 2, 0
    Printf "0   list specific marker."
    Locatef 14, 2, 0
    Printf "-   list markers of value."
    Locatef 15, 2, 0
    Printf "+   list range of markers."
    Locatef 16, 2, 0
    Printf "=   delete a range."
    Locatef 17, 2, 0
    Printf "[   delete all markers."
    Locatef 18, 2, 0
    Printf "]   delete markers of value."
    Locatef 19, 2, 0
    CALL PressKey
    RETURN

    ' help screen 3.
    DisplayHelpScreen3:
    GOSUB HelpHeader
    Colorf Red
    Locatef 3, 2, 0
    Printf "Information keys:"
    Colorf Yellow
    Locatef 4, 2, 0
    Printf "? key displays file length, and undos remaining."
    Locatef 5, 2, 0
    Printf "! key displays current page, row, and column."
    Locatef 6, 2, 0
    Printf "~ key displays last page and markers used."
    Locatef 7, 2, 0
    Printf Quote + " key displays current path of file being edited."
    Locatef 8, 2, 0
    Printf "; key displays the range of the current hilighted area."
    Locatef 9, 2, 0
    Printf "{ key displays number of pasted entries stored in the undo file."
    Colorf Red
    Locatef 10, 2, 0
    Printf "Display keys:"
    Colorf Yellow
    Locatef 11, 2, 0
    Printf "F1 key toggles 64-byte filename display."
    Locatef 12, 2, 0
    Printf "F2 key toggles lower screen help key list."
    Colorf Red
    Locatef 13, 2, 0
    Printf "DOS function keys:"
    Colorf Yellow
    Locatef 14, 2, 0
    Printf "F11 key opens DOS shell in editor or file menu box."
    Locatef 15, 2, 0
    Printf "F12 key prompts for DOS command in editor."
    Locatef 16, 2, 0
    Printf "Control-S Start screen saver.  Control-T Toggle search string."
    Locatef 17, 2, 0
    Colorf Red
    Printf "Hilight keys: "
    Colorf Yellow
    Printf "Shift-<key> hilights area, where <key> is:"
    Locatef 18, 2, 0
    Printf "<left>/<right>/<up>/<down>/<page up>/<page down>/<home>/<end>"
    Locatef 19, 2, 0
    Colorf Red
    Printf "Clipboard controls: "
    Colorf Yellow
    Printf "Control-C (copy) Control-V (paste)"
    Locatef 20, 2, 0
    Printf "Control-X (undo current paste)  Control-Z (undo all pastes)"
    Colorf Red
    Locatef 21, 2, 0
    Printf "Calculator key:"
    Colorf Yellow
    Printf "  Keypad-5/Alt-F10  "
    Colorf Red
    Printf "Repeat last search:"
    Colorf Yellow
    Printf "  Control-F3"
    Locatef 22, 2, 0
    Printf "Alt-- Date/Time Display  Alt-= Files Display"
    Locatef 23, 2, 0
    CALL PressKey
    RETURN

    ' help screen 4.
    DisplayHelpScreen4:
    GOSUB HelpHeader
    Colorf Red
    Locatef 3, 2, 0
    Printf "Multiple file keys:"
    Colorf Yellow
    Locatef 4, 2, 0
    Printf "F6 - Next File.      F8 - Load New File.   F10 - View Files."
    Locatef 5, 2, 0
    Printf "F7 - Previous File.  F9 - Close File.      Alt-0  Close All Files."
    Locatef 6, 2, 0
    Printf "Alt-1 To Alt-9  -  Select Specific File."
    Locatef 7, 2, 0
    Printf "Control-Keypad-5  -  Search All Currently Loaded Filenames."
    Locatef 8, 2, 0
    Printf "Key < Previous file, Key > Next file."
    Locatef 9, 2, 0
    Printf "Key | First file, Key # Last file."
    Colorf Red
    Locatef 10, 2, 0
    Printf "File menu box keys:"
    Colorf Yellow
    Locatef 11, 2, 0
    Printf "F1 - drive change.            F7 - redraw file menu box."
    Locatef 12, 2, 0
    Printf "F2 - toggle file sort.        F8 - attribute override."
    Locatef 13, 2, 0
    Printf "F3 - move file menu box.      F9 - display help."
    Locatef 14, 2, 0
    Printf "F4 - back 1 drive letter.     F10 - exit editor."
    Locatef 15, 2, 0
    Printf "F5 - forward 1 drive letter.  F11 - shell to DOS."
    Locatef 16, 2, 0
    Printf "F6 - toggle 8.3 ambiguation.  F12 - load filespec into Editor."
    Locatef 17, 2, 0
    Printf "Alt-A to Alt-Z - select drive letter, Alt-F1 Toggle Quiet."
    Locatef 18, 2, 0
    Printf "Alt-F2 File Exclude List.     Alt-F3 Dir Exclude List."
    Locatef 19, 2, 0
    Printf "Alt-F4 Toggle File Sort.      Alt-F5 Toggle Dir Sort."
    Locatef 20, 2, 0
    Printf "Alt-F6 Toggle File Date/Time. Alt-F7 Toggle File Size Info."
    Locatef 21, 2, 0
    Printf "Alt-F8 Load Network Path.     Alt-F9 Load Default Network Path."
    Locatef 22, 2, 0
    Printf "Alt-F10 Load Default Network Path Drive."
    Colorf Yellow
    Locatef 23, 2, 0
    CALL PressKey
    RETURN

    ' help screen 5.
    DisplayHelpScreen5:
    CALL DisplayScreen2
    Colorf White
    Locatef 2, 2, 0
    Var$ = "Hexedit information: "
    ' process number 0-9
    Var$ = Var$ + "[process #" + MID$(STR$(Process.Number + 1), 2)
    ' machine name
    IF LEN(RTRIM$(DefaultNetPath)) THEN
        Var$ = Var$ + ":" + RTRIM$(DefaultNetPath)
    END IF
    IF LEN(Var$) > 77 THEN
        Var$ = LEFT$(Var$, 75) + ".."
    END IF
    Var$ = Var$ + "]"
    Printf Var$

    ' display program info
    Colorf Yellow
    Locatef 3, 2, 0
    Printf "Program: " + Program + " " + Version + " " + Release + "."
    Locatef 4, 2, 0
    Printf "Author: " + Author$
    Locatef 5, 2, 0
    Printf "Release: " + Publish
    Locatef 6, 2, 0
    Printf "Status: " + Status
    Locatef 7, 2, 0
    Printf "Email: " + Email
    Locatef 8, 2, 0
    Printf "Urls: " + Urls
    Locatef 9, 2, 0
    CALL PressKey
    RETURN
END SUB

' routine to print screen/file/help.
' input variable:
'   Var1 = 1  PrintScreen
'   Var1 = 2  PrintFile
'   Var1 = 3  PrintHelp
SUB PrintSub (Var1)
    SELECT CASE Var1
        CASE 1
            Column = False
            ColumnSpace = False
            HexLine$ = Nul
            HexLine2$ = Nul
            FirstByte = (FilePage - 1) * 320 + 1
            LastByte = (FilePage - 1) * 320 + 320
            DumpLine$ = DumpLineRange$
            LPRINT ""
            LPRINT DumpLine$
            Temp# = FirstByte
            FOR NextByte = FirstByte TO LastByte
                IF NextByte <= FileLength THEN
                    SeekPosition = NextByte
                    CALL LseekFile
                    CALL ReadFile
                    FileByte = Buffer
                    ByteValue = ASC(FileByte)
                    IF ByteValue < 32 THEN
                        HexLine2$ = HexLine2$ + "."
                    ELSE
                        HexLine2$ = HexLine2$ + FileByte
                    END IF
                    HexLine$ = HexLine$ + RIGHT$("00" + HEX$(ASC(FileByte)), 2)
                ELSE
                    HexLine$ = HexLine$ + "  "
                    HexLine2$ = HexLine2$ + " "
                END IF
                ColumnSpace = ColumnSpace + 1
                IF ColumnSpace = 4 THEN
                    HexLine$ = HexLine$ + " "
                    Column = Column + 1
                    ColumnSpace = False
                END IF
                Column = Column + 2
                IF Column > 44 THEN
                    HexFile$ = HexLine$ + " " + HexLine2$
                    HexFile$ = RTRIM$(HexFile$)
                    IF LEN(HexFile$) THEN
                        HexFile$ = HexFile$ + SPACE$(67 - LEN(HexFile$))
                        HexFile$ = HexFile$ + "x" + RIGHT$("00000000" + HEX$(Temp# - 1#), 8)
                        LPRINT HexFile$
                    END IF
                    HexLine$ = Nul
                    HexLine2$ = Nul
                    Temp# = NextByte + 1#
                    Column = False
                END IF
            NEXT
            LPRINT CHR$(12);
        CASE 2
            Column = False
            ColumnSpace = False
            HexLine$ = Nul
            HexLine2$ = Nul

            ' calculate last page
            FirstByte = 1
            LastPage = INT((FileLength - 1) / 320) + 1
            LastByte = (LastPage - 1) * 320 + 320

            ' write to printer
            FileDumped = True
            ' display message about dumping.
            Colorf Yellow
            Locatef 2, 4, 0
            Printf SPACE$(74)
            Locatef 2, 4, 0
            Printf "Printing file: (Press <esc> to quit):"
            DumpLine$ = DumpLineRange$
            LPRINT ""
            LPRINT DumpLine$
            Temp# = FirstByte
            PercentDisplayed! = SFalse
            Locatef 2, 41, 0
            Printf " 0%"
            FOR NextByte = FirstByte TO LastByte
                IF NextByte <= FileLength THEN
                    SeekPosition = NextByte
                    CALL LseekFile
                    CALL ReadFile
                    FileByte = Buffer
                    ByteValue = ASC(FileByte)
                    ' skip unprintable characters
                    IF ByteValue < 32 THEN
                        HexLine2$ = HexLine2$ + "."
                    ELSE
                        HexLine2$ = HexLine2$ + FileByte
                    END IF
                    HexLine$ = HexLine$ + RIGHT$("00" + HEX$(ASC(FileByte)), 2)
                ELSE
                    HexLine$ = HexLine$ + "  "
                    HexLine2$ = HexLine2$ + " "
                END IF
                ColumnSpace = ColumnSpace + 1
                IF ColumnSpace = 4 THEN
                    HexLine$ = HexLine$ + " "
                    Column = Column + 1
                    ColumnSpace = False
                END IF
                Column = Column + 2
                IF Column > 44 THEN
                    IF INKEY$ = CHR$(27) THEN
                        FileDumped = False
                        EXIT FOR
                    END IF
                    HexFile$ = HexLine$ + " " + HexLine2$
                    HexFile$ = RTRIM$(HexFile$)
                    IF LEN(HexFile$) THEN
                        HexFile$ = HexFile$ + SPACE$(67 - LEN(HexFile$))
                        HexFile$ = HexFile$ + "x" + RIGHT$("00000000" + HEX$(Temp# - 1#), 8)
                        LPRINT HexFile$
                        PercentCopied! = INT(CSNG(NextByte / LastByte) * 100!)
                        IF PercentCopied! > PercentDisplayed! THEN
                            Locatef 2, 41, 0
                            Printf STR$(PercentCopied!) + "%"
                            PercentDisplayed! = PercentCopied!
                        END IF
                    END IF
                    HexLine$ = Nul
                    HexLine2$ = Nul
                    Temp# = NextByte + 1#
                    Column = False
                END IF
            NEXT
            LPRINT CHR$(12);
        CASE 3
            LPRINT "Help screen: Hex Editor " + Version + " " + Release + " functions:"
            LPRINT "Function keys:"
            LPRINT " Alt-A  Append multiple bytes to file.   Alt-T  HEX File Print."
            LPRINT " Alt-B  Append multiple null bytes.      Alt-U  Undo last byte change."
            LPRINT " Alt-C  ANSI Chart.                      Alt-V  View files."
            LPRINT " Alt-D  HEX Screen Dump.                 Alt-W  Close file."
            LPRINT " Alt-E  HEX File Dump.                   Alt-X  Exit program."
            LPRINT " Alt-F  Start input menu.                Alt-Y  Toggle right window."
            LPRINT " Alt-G  Append multiple specified bytes. Alt-Z  Undo all byte changes."
            LPRINT " Alt-H  HEX Chart.                       Editing keys:"
            LPRINT " Alt-I  DOS shell.                       Tab    -- Switch windows."
            LPRINT " Alt-J  Jump to byte position.           Enter  -- Change byte value."
            LPRINT " Alt-K  Search for ASCII string.         Insert -- Change string value."
            LPRINT " Alt-L  Jump to page position.           Delete -- Change hex string."
            LPRINT " Alt-M  Append ASCII string to file.     Escape -- Input Menu."
            LPRINT " Alt-N  Open new file.                   (hex value numeral preceded)."
            LPRINT " Alt-O  Print help.                      (ascii values preceded with H"
            LPRINT " Alt-P  HEX Screen Print.                treated as hexidecimal.)"
            LPRINT " Alt-Q  Help screen.                     (right window unprintable chars"
            LPRINT " Alt-R  Redraw screen.                   are represented with a dot)."
            LPRINT " Alt-S  Search for multiple bytes.       (<escape> key exits search)."
            LPRINT "Marker keys:"
            LPRINT " 1  -  add marker              2  -  add specific marker value"
            LPRINT " 3  -  delete marker           4  -  delete specific marker"
            LPRINT " 5  -  jump previous marker    6  -  jump current marker"
            LPRINT " 7  -  jump next marker        8  -  jump specific marker"
            LPRINT " 9  -  list all markers        0  -  list specific marker"
            LPRINT " -  -  list markers of value   +  -  list range of markers"
            LPRINT " =  -  delete a range          [  -  delete all markers"
            LPRINT " ]  -  delete markers of value"
            LPRINT "Information keys:"
            LPRINT " ? key displays file length, and undos remaining."
            LPRINT " ! key displays current page, row, and column."
            LPRINT " ~ key displays last page and markers used."
            LPRINT " " + Quote + " key displays current path of file being edited."
            LPRINT " ; key displays the range of the current hilighted area."
            LPRINT " { key displays number of pasted entries stored in the undo file."
            LPRINT "Calculator key:  Keypad-5/Alt-F10"
            LPRINT "Repeat last search:  Control-F3"
            LPRINT " Alt-- Date/Time Display  Alt-= Files Display"
            LPRINT CHR$(12);
            LPRINT "Help screen: Hex Editor " + Version + " " + Release + " functions:"
            LPRINT "Display keys:"
            LPRINT " F1 key toggles 64-byte filename display."
            LPRINT " F2 key toggles lower screen help key list."
            LPRINT "DOS function keys:"
            LPRINT " F11 key opens DOS shell in editor or file menu box."
            LPRINT " F12 key prompts for DOS command in editor."
            LPRINT " Control-S Start screen saver.  Control-T Toggle search string."
            LPRINT "Hilight keys:"
            LPRINT " Shift-<key> hilights area, where <key> is:"
            LPRINT " <left>/<right>/<up>/<down>/<page up>/<page down>/<home>/<end>"
            LPRINT "Clipboard controls:"
            LPRINT " Control-C (copy)                 Control-V (paste)"
            LPRINT " Control-X (undo current paste)  Control-Z (undo all pastes)"
            LPRINT "Multiple file keys:"
            LPRINT " F6 - Next file.  F7 - Previous file  F8 - Load new file."
            LPRINT " F9 - Close file. F10 - View files.   Alt-0 - Close all files."
            LPRINT " Alt-1 to Alt-9  -  select specific file."
            LPRINT " Control-Keypad-5  -  Search All Currently Loaded Filenames."
            LPRINT " Key > Next file, Key < Previous file."
            LPRINT "File menu box keys:"
            LPRINT " F1 - Change Drive          F2 - Toggle Sort"
            LPRINT " F3 - Move File Box         F4 - Back Drive"
            LPRINT " F5 - Forward Drive         F6 - Toggle Ambiguate"
            LPRINT " F7 - Redraw File Menu Box  F8 - Attribute Override"
            LPRINT " F9 - Display Help          F10 - Exit Editor"
            LPRINT " F11 - Shell To DOS         F12 - Load FileSpec into Editor"
            LPRINT " Alt-A To Alt-Z - Select Drive Letter"
            LPRINT " Alt-F1 Toggle Quiet Mode   Alt-F2 File Exclude List"
            LPRINT " Alt-F3 Dir Exclude List    Alt-F4 Toggle File Sort"
            LPRINT " Alt-F5 Toggle Dir Sort     Alt-F6 Toggle File date/time"
            LPRINT " Alt-F7 Toggle File Size"
            LPRINT "File Menu Box Network keys:"
            LPRINT " Alt-F8  Load Network Path  Alt-F9  Load Default Network Path"
            LPRINT " Alt-F10 Load Default Network Path Drive"
            LPRINT CHR$(12);
    END SELECT
END SUB

' subroutine to dump screen/file contents to file.
' input variable:
'   Var1 = 1  DumpScreen
'   Var1 = 2  DumpFile
SUB DumpSub (Var1, x2)
    SELECT CASE Var1
        CASE 1
            FirstByte = (FilePage - 1) * 320 + 1
            LastByte = (FilePage - 1) * 320 + 320
            DumpLine$ = DumpLineRange$
            PRINT #x2, ""
            PRINT #x2, DumpLine$
            Temp# = FirstByte
            FOR NextByte = FirstByte TO LastByte
                IF NextByte <= FileLength THEN
                    SeekPosition = NextByte
                    CALL LseekFile
                    CALL ReadFile
                    FileByte = Buffer
                    ByteValue = ASC(FileByte)
                    ' skip unprintable characters
                    IF ByteValue < 32 THEN
                        HexLine2$ = HexLine2$ + "."
                    ELSE
                        HexLine2$ = HexLine2$ + FileByte
                    END IF
                    HexLine$ = HexLine$ + RIGHT$("00" + HEX$(ASC(FileByte)), 2)
                ELSE
                    HexLine$ = HexLine$ + "  "
                    HexLine2$ = HexLine2$ + " "
                END IF
                ColumnSpace = ColumnSpace + 1
                IF ColumnSpace = 4 THEN
                    HexLine$ = HexLine$ + " "
                    Column = Column + 1
                    ColumnSpace = False
                END IF
                Column = Column + 2
                IF Column > 44 THEN
                    HexFile$ = HexLine$ + " " + HexLine2$
                    HexFile$ = RTRIM$(HexFile$)
                    IF LEN(HexFile$) THEN
                        HexFile$ = HexFile$ + SPACE$(67 - LEN(HexFile$))
                        HexFile$ = HexFile$ + "x" + RIGHT$("00000000" + HEX$(Temp# - 1#), 8)
                        PRINT #x2, HexFile$
                    END IF
                    HexLine$ = Nul
                    HexLine2$ = Nul
                    Temp# = NextByte + 1#
                    Column = False
                END IF
            NEXT
        CASE 2
            ' calculate last page
            FirstByte = 1
            LastPage = INT((FileLength - 1) / 320) + 1
            LastByte = (LastPage - 1) * 320 + 320

            ' write to file
            FileDumped = True
            Colorf Yellow
            Locatef 2, 4, 0
            Printf SPACE$(74)
            Locatef 2, 4, 0
            Printf "Writing file: (Press <esc> to quit):"
            DumpLine$ = DumpLineRange$
            PRINT #x2, ""
            PRINT #x2, DumpLine$
            Temp# = FirstByte
            PercentDisplayed! = SFalse
            Locatef 2, 40, 0
            Printf " 0%"
            FOR NextByte = FirstByte TO LastByte
                IF NextByte <= FileLength THEN
                    SeekPosition = NextByte
                    CALL LseekFile
                    CALL ReadFile
                    FileByte = Buffer
                    ByteValue = ASC(FileByte)
                    ' skip unprintable characters
                    IF ByteValue < 32 THEN
                        HexLine2$ = HexLine2$ + "."
                    ELSE
                        HexLine2$ = HexLine2$ + FileByte
                    END IF
                    HexLine$ = HexLine$ + RIGHT$("00" + HEX$(ASC(FileByte)), 2)
                ELSE
                    HexLine$ = HexLine$ + "  "
                    HexLine2$ = HexLine2$ + " "
                END IF
                ColumnSpace = ColumnSpace + 1
                IF ColumnSpace = 4 THEN
                    HexLine$ = HexLine$ + " "
                    Column = Column + 1
                    ColumnSpace = False
                END IF
                Column = Column + 2
                IF Column > 44 THEN
                    IF INKEY$ = CHR$(27) THEN
                        FileDumped = False
                        EXIT FOR
                    END IF
                    HexFile$ = HexLine$ + " " + HexLine2$
                    HexFile$ = RTRIM$(HexFile$)
                    IF LEN(HexFile$) THEN
                        HexFile$ = HexFile$ + SPACE$(67 - LEN(HexFile$))
                        HexFile$ = HexFile$ + "x" + RIGHT$("00000000" + HEX$(Temp# - 1#), 8)
                        PRINT #x2, HexFile$
                        PercentCopied! = INT(CSNG(NextByte / LastByte) * 100!)
                        IF PercentCopied! > PercentDisplayed! THEN
                            Locatef 2, 40, 0
                            Printf STR$(PercentCopied!) + "%"
                            PercentDisplayed! = PercentCopied!
                        END IF
                    END IF
                    HexLine$ = Nul
                    HexLine2$ = Nul
                    Temp# = NextByte + 1#
                    Column = False
                END IF
            NEXT
    END SELECT
END SUB

' routine to display Ansi/Hex chart.
' input variable:
'   Var1 = 1  ANSI Chart
'   Var1 = 2  HEX Chart
SUB DisplayChart (Var1)
    SELECT CASE Var1
        CASE 1
            CALL DisplayScreen2
            Colorf White
            Locatef 2, 2, 0
            Printf "ASCII Chart for characters 1 to 127:"
            Var2 = 3
            Locatef 3, 2, 0
            FOR Char = 1 TO 127
                SELECT CASE Char
                    ' skip unprintable characters
                    CASE 0, 7, 9 TO 13, 28 TO 32
                        DisplayChar$ = " "
                        ' store character
                    CASE ELSE
                        DisplayChar$ = CHR$(Char)
                END SELECT
                Var$ = MID$(STR$(Char), 2)
                Var1$ = RIGHT$("00" + Var$, 3) + " "
                Colorf Green
                Printf Var1$
                Colorf Yellow

                _CONTROLCHR OFF
                Printf CHR$(Char) + " "
                _CONTROLCHR ON
                'Printf DisplayChar$ + " "

                ' check full screen line
                IF (Char MOD 10) = False THEN
                    Var2 = Var2 + 1
                    Locatef Var2, 2, 0
                END IF
            NEXT
            Locatef 16, 2, 0
            CALL PressKey
            CALL DisplayScreen2
            Colorf White
            Locatef 2, 2, 0
            Printf "ASCII Chart for characters 128 to 255:"
            Var2 = 3
            Locatef 3, 2, 0
            FOR Char = 128 TO 255
                DisplayChar$ = CHR$(Char)
                Var$ = MID$(STR$(Char), 2)
                Var1$ = RIGHT$("00" + Var$, 3) + " "
                Colorf Green
                Printf Var1$
                Colorf Yellow
                Printf DisplayChar$ + " "
                ' check full screen line
                IF ((Char - 7) MOD 10) = False THEN
                    Var2 = Var2 + 1
                    Locatef Var2, 2, 0
                END IF
            NEXT
            Locatef 16, 2, 0
            CALL PressKey
        CASE 2
            CALL DisplayScreen2
            Colorf White
            Locatef 2, 2, 0
            Printf "HEX Chart for characters 1 to 127:"
            Var2 = 3
            Locatef 3, 2, 0
            FOR Char = 1 TO 127
                SELECT CASE Char
                    ' skip unprintable characters
                    CASE 0, 7, 9 TO 13, 28 TO 32
                        DisplayChar$ = " "
                        ' store character
                    CASE ELSE
                        DisplayChar$ = CHR$(Char)
                END SELECT
                Var$ = HEX$(Char)
                Var1$ = RIGHT$("0" + Var$, 2) + " "
                Colorf Green
                Printf Var1$
                Colorf Yellow

                _CONTROLCHR OFF
                Printf CHR$(Char) + " "
                _CONTROLCHR ON
                'Printf DisplayChar$ + " "

                ' check full screen line
                IF (Char MOD 10) = False THEN
                    Var2 = Var2 + 1
                    Locatef Var2, 2, 0
                END IF
            NEXT
            Locatef 16, 2, 0
            CALL PressKey
            Colorf Plain
            CALL DisplayScreen2
            Colorf White
            Locatef 2, 2, 0
            Printf "HEX Chart for characters 128 to 255:"
            Var2 = 3
            Locatef 3, 2, 0
            FOR Char = 128 TO 255
                DisplayChar$ = CHR$(Char)
                Var$ = HEX$(Char)
                Var1$ = RIGHT$("0" + Var$, 2) + " "
                Colorf Green
                Printf Var1$
                Colorf Yellow
                Printf DisplayChar$ + " "
                ' check full screen line
                IF ((Char - 7) MOD 10) = False THEN
                    Var2 = Var2 + 1
                    Locatef Var2, 2, 0
                END IF
            NEXT
            Locatef 16, 2, 0
            CALL PressKey
    END SELECT
END SUB

REM Clipboard routines:

SUB Clipboard2 (Var)
    ' select clipboard routine.
    IF Var = 1 THEN GOTO CopyToClipboard
    IF Var = 2 THEN GOTO PasteFromClipboard
    ' Uses:
    '  StoreUndoPaste: store area to be over-written into paste undo file.

    IF Var = 3 THEN GOTO ClipboardUndo
    IF Var = 4 THEN GOTO ClipboardUndoAll
    ' Uses:
    '  UndoClipboard: restore last paste undo entry.

    EXIT SUB

    ' copy hilighted area to clipboard file.
    CopyToClipboard:
    IF CopyPositionStart = DFalse THEN
        CALL DisplayX
        Colorf White
        Printf "Total 0 bytes copied to clipboard."
        CALL LocateCursor2
        EXIT SUB
    END IF
    ' store clipboard length.
    ByteLength# = CopyPositionEnd - CopyPositionStart + 1#
    IF ByteLength# + 4# > 2147483647# THEN
        StatusMessage = "Copy extends beyond clipboard file length."
        CALL DisplayStatus2
        EXIT SUB
    END IF
    CALL DisplayX
    Colorf White
    Printf "Copying bytes to clipboard."
    CALL LocateCursor2
    Bytes$ = RIGHT$("00000000" + HEX$(ByteLength#), 8)
    CopyByte = CHR$(VAL("&H" + MID$(Bytes$, 1, 2)))
    PUT #4, 1, CopyByte
    CopyByte = CHR$(VAL("&H" + MID$(Bytes$, 3, 2)))
    PUT #4, 2, CopyByte
    CopyByte = CHR$(VAL("&H" + MID$(Bytes$, 5, 2)))
    PUT #4, 3, CopyByte
    CopyByte = CHR$(VAL("&H" + MID$(Bytes$, 7, 2)))
    PUT #4, 4, CopyByte
    ' write clipboard.
    Temp# = FilePosition
    Temp2# = 4#
    FOR NextByte = CopyPositionStart TO CopyPositionEnd
        SeekPosition = NextByte
        CALL LseekFile
        CALL ReadFile
        FileByte = Buffer
        Temp2# = Temp2# + 1#
        PUT #4, Temp2#, FileByte
    NEXT
    FilePosition = Temp#
    CALL DisplayX
    Colorf White
    UndoToggle = NOT UndoToggle
    IF UndoToggle THEN
        Printf "(+)"
    ELSE
        Printf "(X)"
    END IF
    Printf " " + FormatX$(ByteLength#, 1) + " bytes copied to clipboard."
    CALL LocateCursor2
    EXIT SUB

    ' paste clipboard to current file position.
    PasteFromClipboard:
    ' read clipboard length.
    IF LOF(4) = 0 THEN
        CALL DisplayX
        Colorf White
        Printf "Total 0 bytes pasted from clipboard."
        CALL LocateCursor2
        EXIT SUB
    END IF
    ' get clipboard length.
    ByteLength# = DFalse
    GET #4, 1, CopyByte
    ByteLength# = ByteLength# + ASC(CopyByte) * 16 ^ 6
    GET #4, 2, CopyByte
    ByteLength# = ByteLength# + ASC(CopyByte) * 16 ^ 4
    GET #4, 3, CopyByte
    ByteLength# = ByteLength# + ASC(CopyByte) * 16 ^ 2
    GET #4, 4, CopyByte
    ByteLength# = ByteLength# + ASC(CopyByte)
    ' check end of file.
    IF FilePosition + ByteLength# - 1# > FileLength THEN
        StatusMessage = "Paste extends beyond file length."
        CALL DisplayStatus2
        EXIT SUB
    END IF
    ' clear hilight area.
    IF CopyPositionStart > 0# THEN
        CALL ResetHilightBytes
    END IF
    ' store paste area to undo clipboard file.
    GOSUB StoreUndoPaste
    IF ValidPaste = False THEN
        EXIT SUB
    END IF
    ' write paste bytes.
    Temp# = FilePosition
    LastPage = FilePage
    FOR NextByte = 1# TO ByteLength#
        GET #4, NextByte + 4#, FileByte
        SeekPosition = FilePosition
        CALL LseekFile
        CALL WriteFile
        CALL CalculatePosition1
        IF LastPage = FilePage THEN
            CALL ClearPageByte
        END IF
        IF NextByte < ByteLength# THEN
            FilePosition = FilePosition + 1
        END IF
    NEXT
    FilePosition = Temp#
    CALL CalculatePosition1
    CALL DisplayPageByte
    CALL DisplayX
    Colorf White
    Printf "Entry #" + FormatX$(CDBL(ByteEntries), 1) + " pasted."
    CALL LocateCursor2
    EXIT SUB

    ' store area to be over-written into paste undo file.
    '   see also: Struc.txt describes file format.
    StoreUndoPaste:
    IF LOF(5) = 0 THEN
        CopyByte = CHR$(0)
        PUT #5, 1, CopyByte
        PUT #5, 2, CopyByte
    END IF
    ValidPaste = True
    ' get maximum entries.
    ByteEntries = 0
    GET #5, 1, CopyByte
    ByteEntries = ByteEntries + ASC(CopyByte) * 16 ^ 2
    GET #5, 2, CopyByte
    ByteEntries = ByteEntries + ASC(CopyByte)
    IF ByteEntries >= 32767 THEN
        ValidPaste = False
        StatusMessage = "Paste undo entries extend beyond file length."
        CALL DisplayStatus2
        RETURN
    END IF
    ' scan to last entry position in paste undo file.
    Temp2# = 3#
    Temp3 = 1
    DO
        ' check last entry.
        IF Temp3 > ByteEntries THEN
            EXIT DO
        END IF
        ' skip file start position.
        Temp2# = Temp2# + 4#
        LengthOfRecord# = DFalse
        GET #5, Temp2#, CopyByte
        LengthOfRecord# = LengthOfRecord# + ASC(CopyByte) * 16 ^ 6
        Temp2# = Temp2# + 1#
        GET #5, Temp2#, CopyByte
        LengthOfRecord# = LengthOfRecord# + ASC(CopyByte) * 16 ^ 4
        Temp2# = Temp2# + 1#
        GET #5, Temp2#, CopyByte
        LengthOfRecord# = LengthOfRecord# + ASC(CopyByte) * 16 ^ 2
        Temp2# = Temp2# + 1#
        GET #5, Temp2#, CopyByte
        LengthOfRecord# = LengthOfRecord# + ASC(CopyByte)
        Temp2# = Temp2# + LengthOfRecord# + 1#
        Temp3 = Temp3 + 1
    LOOP
    ' get maximum entries.
    TotalBytes# = Temp2# + ByteLength# + 8#
    IF TotalBytes# >= 2147483647# THEN
        ValidPaste = False
        StatusMessage = "Paste undo extends beyond file length."
        CALL DisplayStatus2
        RETURN
    END IF
    CALL DisplayX
    Colorf White
    Printf "Pasting bytes from clipboard."
    CALL LocateCursor2
    ' store new entry.
    ByteEntries = ByteEntries + 1
    Bytes$ = RIGHT$("0000" + HEX$(ByteEntries), 4)
    CopyByte = CHR$(VAL("&H" + MID$(Bytes$, 1, 2)))
    PUT #5, 1, CopyByte
    CopyByte = CHR$(VAL("&H" + MID$(Bytes$, 3, 2)))
    PUT #5, 2, CopyByte
    ' store file position of undo paste area.
    Bytes$ = RIGHT$("00000000" + HEX$(FilePosition), 8)
    CopyByte = CHR$(VAL("&H" + MID$(Bytes$, 1, 2)))
    PUT #5, Temp2#, CopyByte
    CopyByte = CHR$(VAL("&H" + MID$(Bytes$, 3, 2)))
    Temp2# = Temp2# + 1#
    PUT #5, Temp2#, CopyByte
    CopyByte = CHR$(VAL("&H" + MID$(Bytes$, 5, 2)))
    Temp2# = Temp2# + 1#
    PUT #5, Temp2#, CopyByte
    CopyByte = CHR$(VAL("&H" + MID$(Bytes$, 7, 2)))
    Temp2# = Temp2# + 1#
    PUT #5, Temp2#, CopyByte
    ' store length of undo paste area.
    Bytes$ = RIGHT$("00000000" + HEX$(ByteLength#), 8)
    CopyByte = CHR$(VAL("&H" + MID$(Bytes$, 1, 2)))
    Temp2# = Temp2# + 1#
    PUT #5, Temp2#, CopyByte
    CopyByte = CHR$(VAL("&H" + MID$(Bytes$, 3, 2)))
    Temp2# = Temp2# + 1#
    PUT #5, Temp2#, CopyByte
    CopyByte = CHR$(VAL("&H" + MID$(Bytes$, 5, 2)))
    Temp2# = Temp2# + 1#
    PUT #5, Temp2#, CopyByte
    CopyByte = CHR$(VAL("&H" + MID$(Bytes$, 7, 2)))
    Temp2# = Temp2# + 1#
    PUT #5, Temp2#, CopyByte
    ' write undo clipboard.
    Temp# = FilePosition
    FOR NextByte = Temp# TO Temp# + ByteLength# - 1#
        SeekPosition = NextByte
        CALL LseekFile
        CALL ReadFile
        FileByte = Buffer
        Temp2# = Temp2# + 1#
        PUT #5, Temp2#, FileByte
    NEXT
    FilePosition = Temp#
    RETURN

    ' undo last paste from clipboard.
    ClipboardUndo:
    IF LOF(5) = 0 THEN
        CopyByte = CHR$(0)
        PUT #5, 1, CopyByte
        PUT #5, 2, CopyByte
        ValidPaste = False
    ELSE
        GOSUB UndoClipboard
    END IF
    CALL DisplayX
    Colorf White
    IF ValidPaste = False THEN
        Printf "Total 0 bytes paste undo."
    ELSE
        Printf "Entry #" + FormatX$(CDBL(ByteEntries + 1), 1) + " paste undo."
    END IF
    CALL LocateCursor2
    EXIT SUB

    ' undo all pastes from clipboard.
    ClipboardUndoAll:
    TotalEntries = 0
    IF LOF(5) = 0 THEN
        CopyByte = CHR$(0)
        PUT #5, 1, CopyByte
        PUT #5, 2, CopyByte
    ELSE
        ByteEntries = 0
        GET #5, 1, CopyByte
        ByteEntries = ByteEntries + ASC(CopyByte) * 16 ^ 2
        GET #5, 2, CopyByte
        ByteEntries = ByteEntries + ASC(CopyByte)
        IF ByteEntries > 0 THEN
            TotalEntries = ByteEntries
            DO
                GOSUB UndoClipboard
                IF ValidPaste = False THEN
                    EXIT DO
                END IF
            LOOP
        END IF
    END IF
    CALL DisplayX
    Colorf White
    Printf "Total " + FormatX$(CDBL(TotalEntries), 1) + " entries in paste undos."
    CALL LocateCursor2
    EXIT SUB

    ' restore last paste undo entry.
    UndoClipboard:
    ' get last entry.
    ByteEntries = 0
    GET #5, 1, CopyByte
    ByteEntries = ByteEntries + ASC(CopyByte) * 16 ^ 2
    GET #5, 2, CopyByte
    ByteEntries = ByteEntries + ASC(CopyByte)
    ValidPaste = True
    IF ByteEntries = 0 THEN
        ValidPaste = False
        RETURN
    END IF
    ' scan to last entry position in paste undo file.
    Temp# = FilePosition
    Temp2# = 3#
    Temp3 = 1
    DO
        ' check last entry.
        IF Temp3 = ByteEntries THEN
            EXIT DO
        END IF
        ' skip file start position.
        Temp2# = Temp2# + 4#
        LengthOfRecord# = DFalse
        GET #5, Temp2#, CopyByte
        LengthOfRecord# = LengthOfRecord# + ASC(CopyByte) * 16 ^ 6
        Temp2# = Temp2# + 1#
        GET #5, Temp2#, CopyByte
        LengthOfRecord# = LengthOfRecord# + ASC(CopyByte) * 16 ^ 4
        Temp2# = Temp2# + 1#
        GET #5, Temp2#, CopyByte
        LengthOfRecord# = LengthOfRecord# + ASC(CopyByte) * 16 ^ 2
        Temp2# = Temp2# + 1#
        GET #5, Temp2#, CopyByte
        LengthOfRecord# = LengthOfRecord# + ASC(CopyByte)
        Temp2# = Temp2# + LengthOfRecord# + 1#
        Temp3 = Temp3 + 1
    LOOP
    ' restore last entry.
    ByteEntries = ByteEntries - 1
    Bytes$ = RIGHT$("0000" + HEX$(ByteEntries), 4)
    CopyByte = CHR$(VAL("&H" + MID$(Bytes$, 1, 2)))
    PUT #5, 1, CopyByte
    CopyByte = CHR$(VAL("&H" + MID$(Bytes$, 3, 2)))
    PUT #5, 2, CopyByte
    ' restore file position of undo paste area.
    NextByte = DFalse
    GET #5, Temp2#, CopyByte
    NextByte = NextByte + ASC(CopyByte) * 16 ^ 6
    Temp2# = Temp2# + 1#
    GET #5, Temp2#, CopyByte
    NextByte = NextByte + ASC(CopyByte) * 16 ^ 4
    Temp2# = Temp2# + 1#
    GET #5, Temp2#, CopyByte
    NextByte = NextByte + ASC(CopyByte) * 16 ^ 2
    Temp2# = Temp2# + 1#
    GET #5, Temp2#, CopyByte
    NextByte = NextByte + ASC(CopyByte)
    ' restore length of undo paste area.
    ByteLength# = DFalse
    Temp2# = Temp2# + 1#
    GET #5, Temp2#, CopyByte
    ByteLength# = ByteLength# + ASC(CopyByte) * 16 ^ 6
    Temp2# = Temp2# + 1#
    GET #5, Temp2#, CopyByte
    ByteLength# = ByteLength# + ASC(CopyByte) * 16 ^ 4
    Temp2# = Temp2# + 1#
    GET #5, Temp2#, CopyByte
    ByteLength# = ByteLength# + ASC(CopyByte) * 16 ^ 2
    Temp2# = Temp2# + 1#
    GET #5, Temp2#, CopyByte
    ByteLength# = ByteLength# + ASC(CopyByte)
    ' undo paste area.
    Temp# = FilePosition
    Temp3# = NextByte
    LastPage = FilePage
    FOR FilePosition = Temp3# TO Temp3# + ByteLength# - 1#
        Temp2# = Temp2# + 1#
        GET #5, Temp2#, FileByte
        SeekPosition = FilePosition
        CALL LseekFile
        CALL WriteFile
        CALL CalculatePosition1
        IF LastPage = FilePage THEN
            CALL ClearPageByte
        END IF
    NEXT
    FilePosition = Temp#
    CALL CalculatePosition1
    CALL DisplayPageByte
    CALL DisplayX
    Colorf White
    Printf "Undoing entry from paste file."
    CALL LocateCursor2
    RETURN
END SUB

REM Viewfile routine:

' returns Var=1 to MaxFiles of file number.
SUB Viewfiles (Var)
    GOSUB StoreArea
    GOSUB DrawMenu
    MenuSelect = 1
    GOSUB DrawCurrentMenuSelection

    ' keyboard/mouse input loop.
    DO
        _LIMIT 100
        CharInput$ = Nul

        ' call mouse subroutine.
        Z = MouseDriver

        ' check left mouse button.
        IF MouseButton1 THEN
            GOSUB MouseButton1Y
        ELSE
            ' check right mouse button.
            IF MouseButton2 THEN
                GOSUB RestoreArea
                Var = False
                EXIT SUB
            ELSE
                ' check mouse position.
                IF MouseX OR MouseY THEN
                    GOSUB MoveMouse
                END IF
            END IF
        END IF

        ' check mouse wheel.
        I$ = Nul
        IF MouseWheel = -1 THEN
            IF WheelReverse THEN
                I$ = CHR$(0) + CHR$(80) ' down
            ELSE
                I$ = CHR$(0) + CHR$(72) ' up
            END IF
            MouseWheel = 0
        END IF
        IF MouseWheel = 1 THEN
            IF WheelReverse THEN
                I$ = CHR$(0) + CHR$(72) ' up
            ELSE
                I$ = CHR$(0) + CHR$(80) ' down
            END IF
            MouseWheel = 0
        END IF

        ' store keyboard buffer.
        IF I$ <> Nul THEN
            CharInput$ = I$
        ELSE
            CharInput$ = INKEY$
        END IF
        IF LEN(CharInput$) THEN
            SELECT CASE LEN(CharInput$)
                CASE 1
                    SELECT CASE ASC(CharInput$)
                        CASE 13 ' Enter
                            GOSUB RestoreArea
                            IF MenuSelect > NumberFiles THEN
                                Var = False
                            ELSE
                                Var = MenuSelect
                            END IF
                            EXIT DO
                        CASE 27 ' Escape
                            GOSUB RestoreArea
                            Var = False
                            EXIT DO
                        CASE 49 TO 48 + MaxFiles ' 1 to MaxFiles
                            GOSUB EraseCurrentMenuSelection
                            MenuSelect = ASC(CharInput$) - 48
                            GOSUB DrawCurrentMenuSelection
                        CASE 65 TO 90, 97 TO 122 ' A - Z, a - z
                            GOSUB Search.File2
                    END SELECT
                CASE 2
                    VarX = ASC(RIGHT$(CharInput$, 1))
                    SELECT CASE VarX
                        CASE 72, 141, 152 ' Up/Ctrl-Up/Alt-Up
                            GOSUB MenuUp
                        CASE 80, 145, 160 ' Down/Ctrl-Down/Alt-Down
                            GOSUB MenuDown
                        CASE 71, 73, 119, 132 ' Home/PageUp/Ctrl-Home/Ctrl-PageUp
                            GOSUB MenuFirst
                        CASE 79, 81, 117, 118 ' End/PageDown/Ctrl-End/Ctrl-PageDown
                            GOSUB MenuLast
                        CASE 59 TO 67 ' F1 - F9
                            GOSUB EraseCurrentMenuSelection
                            MenuSelect = VarX - 58
                            GOSUB DrawCurrentMenuSelection
                        CASE 94 TO 102 ' Ctrl-F1 to Ctrl-F9
                            GOSUB EraseCurrentMenuSelection
                            MenuSelect = VarX - 93
                            GOSUB DrawCurrentMenuSelection
                        CASE 104 TO 112 ' Alt-F1 to Alt-F9
                            GOSUB EraseCurrentMenuSelection
                            MenuSelect = VarX - 103
                            GOSUB DrawCurrentMenuSelection
                        CASE 120 TO 128 ' Alt-1 to Alt-9
                            GOSUB EraseCurrentMenuSelection
                            MenuSelect = VarX - 119
                            GOSUB DrawCurrentMenuSelection
                    END SELECT
            END SELECT
        END IF
    LOOP
    EXIT SUB

    ' search filename.
    Search.File2:
    FOR VarX = MenuSelect + 1 TO NumberFiles
        VarX$ = RTRIM$(File(VarX).Filename)
        IF LEFT$(VarX$, 1) = UCASE$(CharInput$) THEN
            GOSUB EraseCurrentMenuSelection
            MenuSelect = VarX
            GOSUB DrawCurrentMenuSelection
            RETURN
        END IF
    NEXT
    FOR VarX = 1 TO MenuSelect
        VarX$ = RTRIM$(File(VarX).Filename)
        IF LEFT$(VarX$, 1) = UCASE$(CharInput$) THEN
            GOSUB EraseCurrentMenuSelection
            MenuSelect = VarX
            GOSUB DrawCurrentMenuSelection
            RETURN
        END IF
    NEXT
    RETURN

    ' draws menu.
    DrawMenu:
    BoxDrawX1 = 4
    BoxDrawX2 = 14
    BoxDrawY1 = 6
    BoxDrawY2 = 21
    BoxDrawLength = 16
    GOSUB DrawBox
    Colorf2 White, 0
    FOR Var2 = 1 TO MaxFiles
        Locatef 4 + Var2, 7, 0
        Printf MID$(STR$(Var2), 2) + " "
        IF Var2 > NumberFiles THEN
            Printf "<none>      "
        ELSE
            Printf File(Var2).Filename
        END IF
    NEXT
    RETURN

    ' draws box from (BoxDrawX1,BoxDrawY1) To (BoxDrawX2,BoxDrawY2),
    '  length of box from left to right being BoxDrawLength.
    DrawBox:
    Colorf Yellow
    Locatef BoxDrawX1, BoxDrawY1, 0
    Printf CHR$(ULcorner) + STRING$(BoxDrawLength - 2, Hline) + CHR$(URcorner)
    FOR RowX1 = BoxDrawX1 + 1 TO BoxDrawX2 - 1
        Locatef RowX1, BoxDrawY1, 0
        Printf CHR$(Vline)
        Locatef RowX1, BoxDrawY2, 0
        Printf CHR$(Vline)
    NEXT
    Locatef BoxDrawX2, BoxDrawY1, 0
    Printf CHR$(LLcorner) + STRING$(BoxDrawLength - 2, Hline) + CHR$(LRcorner)
    Colorf2 0, 7
    Locatef 4, 9, 0
    Printf "View Files"
    Colorf Yellow
    RETURN

    ' stores area under menu.
    StoreArea:
    RowX1 = False
    ColumnY1 = False
    FOR RowX2 = 4 TO 14
        RowX1 = RowX1 + 1
        ColumnY1 = False
        FOR ColumnY2 = 6 TO 21
            ColumnY1 = ColumnY1 + 1
            ' store ascii character.
            Area1(RowX1, ColumnY1) = SCREEN(RowX2, ColumnY2)
            ' store color. (undocumented: also stores background color).
            Area2(RowX1, ColumnY1) = SCREEN(RowX2, ColumnY2, 1)
        NEXT
    NEXT
    RETURN

    ' restores area under menu.
    RestoreArea:
    RowX1 = False
    ColumnY1 = False
    FOR RowX2 = 4 TO 14
        RowX1 = RowX1 + 1
        ColumnY1 = False
        FOR ColumnY2 = 6 TO 21
            ColumnY1 = ColumnY1 + 1
            Locatef RowX2, ColumnY2, 1
            ' restore color.
            TempZ = Area2(RowX1, ColumnY1)
            ' undocumented: also stores background color.
            VarB = INT(TempZ / 16)
            VarF = TempZ MOD 16
            Colorf2 VarF, VarB
            ' restore ascii character.
            Printf CHR$(Area1(RowX1, ColumnY1))
        NEXT
    NEXT
    RETURN

    ' moves menu up, wrapping.
    MenuUp:
    GOSUB EraseCurrentMenuSelection
    IF MenuSelect = 1 THEN
        MenuSelect = MaxFiles
    ELSE
        MenuSelect = MenuSelect - 1
    END IF
    GOSUB DrawCurrentMenuSelection
    RETURN

    ' moves menu down, wrapping.
    MenuDown:
    GOSUB EraseCurrentMenuSelection
    IF MenuSelect = MaxFiles THEN
        MenuSelect = 1
    ELSE
        MenuSelect = MenuSelect + 1
    END IF
    GOSUB DrawCurrentMenuSelection
    RETURN

    ' moves menu to top
    MenuFirst:
    GOSUB EraseCurrentMenuSelection
    IF MenuSelect <> 1 THEN
        MenuSelect = 1
    END IF
    GOSUB DrawCurrentMenuSelection
    RETURN

    ' moves menu to bottom
    MenuLast:
    GOSUB EraseCurrentMenuSelection
    IF MenuSelect <> MaxFiles THEN
        MenuSelect = MaxFiles
    END IF
    GOSUB DrawCurrentMenuSelection
    RETURN

    ' removes hilight from current menu selection.
    EraseCurrentMenuSelection:
    Colorf2 White, 0
    GOSUB DisplayCurrentMenuSelection
    Colorf2 White, 0
    RETURN

    ' adds hilight to current menu selection.
    DrawCurrentMenuSelection:
    Colorf2 White, 1
    GOSUB DisplayCurrentMenuSelection
    Colorf2 White, 0
    RETURN

    ' draws current menu selection.
    DisplayCurrentMenuSelection:
    Locatef 4 + MenuSelect, 7, 0
    Printf MID$(STR$(MenuSelect), 2) + " "
    IF MenuSelect > NumberFiles THEN
        Printf "<none>      "
        CALL ClearStatus
        Printf "View file" + STR$(MenuSelect) + ": <none>"
    ELSE
        Printf File(MenuSelect).Filename
        GOSUB DisplayPath
    END IF
    RETURN

    ' display path of file being edited.
    DisplayPath:
    CALL ClearStatus
    N$ = RTRIM$(File(MenuSelect).Netpath)
    Z$ = RTRIM$(File(MenuSelect).ShortFilename)
    IF N$ <> Nul THEN
        IF MID$(Z$, 2, 1) = ":" THEN
            Z$ = MID$(Z$, 3)
        END IF
    END IF
    CALL Deconcatenate(N$, Z$, 64)
    Var = LEN(Z$)
    DO
        Var = Var - 1
        IF Var = False THEN
            Z$ = Nul
            EXIT DO
        END IF
        IF MID$(Z$, Var, 1) = "\" THEN
            Z$ = LEFT$(Z$, Var)
            EXIT DO
        END IF
    LOOP
    IF Z$ = Nul THEN
        Z$ = "\"
    END IF
    Printf "Viewing path: " + Z$ + " "
    FileDisplay2 = True
    RETURN

    ' process left mouse button.
    MouseButton1Y:
    IF MouseX = 0 THEN
        RETURN
    END IF

    ' test mouse click outside of box,
    IF MouseX < 4 OR MouseX > 14 THEN
        GOSUB RestoreArea
        Var = False
        EXIT SUB
    END IF
    IF MouseY < 6 OR MouseY > 21 THEN
        GOSUB RestoreArea
        Var = False
        EXIT SUB
    END IF

    ' test mouse click inside of box.
    IF MouseX >= 5 AND MouseX <= 13 THEN
        IF MouseY >= 7 AND MouseY <= 20 THEN
            Var = MouseX - 4
            GOSUB RestoreArea
            EXIT SUB
        END IF
    END IF
    RETURN

    ' process mouse move.
    MoveMouse:
    ' check mouse selection boundaries.
    IF MouseX >= 5 AND MouseX <= 13 THEN
        IF MouseY >= 7 AND MouseY <= 20 THEN
            IF MouseX - 4 <> MenuSelect THEN
                GOSUB EraseCurrentMenuSelection
                MenuSelect = MouseX - 4
            END IF
            GOSUB DrawCurrentMenuSelection
        END IF
    END IF
    RETURN
END SUB

' sorts Windows directories/filenames in
'   hexedit1.da?, hexedit2.da? files.
SUB SortFiles (Var1)
    DIM I1 AS STRING, I2 AS STRING
    ' sort windows filenames.
    IF Var1 = 1 THEN
        Num! = Num.Files
        ' perform heap sort.
        IF FileSort THEN
            ' descending.
            FOR I! = 2! TO Num!
                J! = I!
                DO UNTIL J! = 1!
                    P! = J! \ 2!
                    I1 = RTRIM$(Filenames(J!))
                    I2 = RTRIM$(Filenames(P!))
                    IF I1 < I2 THEN
                        WinFileStruc.Name = I2
                        PUT #2, J!, WinFileStruc
                        WinFileStruc.Name = I1
                        PUT #2, P!, WinFileStruc
                        J! = P!
                    ELSE
                        EXIT DO
                    END IF
                LOOP
            NEXT
            FOR I! = Num! TO 2! STEP -1!
                I1 = RTRIM$(Filenames(1!))
                I2 = RTRIM$(Filenames(I!))
                WinFileStruc.Name = I2
                PUT #2, 1!, WinFileStruc
                WinFileStruc.Name = I1
                PUT #2, I!, WinFileStruc
                J! = 1!
                DO
                    IF 2! * J! > I! - 1! THEN
                        EXIT DO
                    END IF
                    C! = 2! * J!
                    IF C! + 1! <= I! - 1! THEN
                        IF Filenames(C! + 1!) < Filenames(C!) THEN
                            C! = C! + 1!
                        END IF
                    END IF
                    I1 = RTRIM$(Filenames(J!))
                    I2 = RTRIM$(Filenames(C!))
                    IF I1 >= I2 THEN
                        WinFileStruc.Name = I2
                        PUT #2, J!, WinFileStruc
                        WinFileStruc.Name = I1
                        PUT #2, C!, WinFileStruc
                        J! = C!
                    ELSE
                        EXIT DO
                    END IF
                LOOP
            NEXT
        ELSE
            ' ascending.
            FOR I! = 2! TO Num!
                J! = I!
                DO UNTIL J! = 1!
                    P! = J! \ 2!
                    I1 = RTRIM$(Filenames(J!))
                    I2 = RTRIM$(Filenames(P!))
                    IF I1 > I2 THEN
                        WinFileStruc.Name = I2
                        PUT #2, J!, WinFileStruc
                        WinFileStruc.Name = I1
                        PUT #2, P!, WinFileStruc
                        J! = P!
                    ELSE
                        EXIT DO
                    END IF
                LOOP
            NEXT
            FOR I! = Num! TO 2! STEP -1!
                I1 = RTRIM$(Filenames(1!))
                I2 = RTRIM$(Filenames(I!))
                WinFileStruc.Name = I2
                PUT #2, 1!, WinFileStruc
                WinFileStruc.Name = I1
                PUT #2, I!, WinFileStruc
                J! = 1!
                DO
                    IF 2! * J! > I! - 1! THEN
                        EXIT DO
                    END IF
                    C! = 2! * J!
                    IF C! + 1! <= I! - 1! THEN
                        IF Filenames(C! + 1!) > Filenames(C!) THEN
                            C! = C! + 1!
                        END IF
                    END IF
                    I1 = RTRIM$(Filenames(J!))
                    I2 = RTRIM$(Filenames(C!))
                    IF I1 < I2 THEN
                        WinFileStruc.Name = I2
                        PUT #2, J!, WinFileStruc
                        WinFileStruc.Name = I1
                        PUT #2, C!, WinFileStruc
                        J! = C!
                    ELSE
                        EXIT DO
                    END IF
                LOOP
            NEXT
        END IF
        ' sort windows directories.
    ELSE
        Num! = Num.Dirs
        Start! = 0!
        IF RTRIM$(Directories(1)) = ".." THEN
            Start! = 1!
        END IF
        IF Start! >= Num! THEN
            EXIT SUB
        END IF
        ' perform insertion sort.
        FOR R! = 2! + Start! TO Num!
            I1 = RTRIM$(Directories(R!))
            FOR J! = R! TO 2! + Start! STEP -1!
                I2 = RTRIM$(Directories(J! - 1!))
                ' descending.
                IF DirSort THEN
                    IF I2 < I1 THEN
                        WinFileStruc.Name = I2
                        PUT #3, J!, WinFileStruc
                    ELSE
                        EXIT FOR
                    END IF
                ELSE
                    ' ascending.
                    IF I2 > I1 THEN
                        WinFileStruc.Name = I2
                        PUT #3, J!, WinFileStruc
                    ELSE
                        EXIT FOR
                    END IF
                END IF
            NEXT
            WinFileStruc.Name = I1
            PUT #3, J!, WinFileStruc
        NEXT
    END IF
END SUB

SUB GetInfo (VarZ, VarZ$)
    IF VarZ = 0 THEN
        X$ = Nul
        IF (FileAttribute AND 1) = 1 THEN
            X$ = X$ + "o"
        END IF
        IF (FileAttribute AND 2) = 2 THEN
            X$ = X$ + "h"
        END IF
        IF (FileAttribute AND 4) = 4 THEN
            X$ = X$ + "s"
        END IF
        IF (FileAttribute AND 32) = 32 THEN
            X$ = X$ + "a"
        END IF
        IF X$ <> Nul THEN
            X$ = " (" + X$ + ")"
        END IF
        VarZ$ = X$
        EXIT SUB
    END IF
 
    ' construct file date and time for display.
    FileDateTime = Nul
    FileSize = False
    hfind = FindFirstFileA(_OFFSET(ASCIIZ), _OFFSET(finddata))
    IF hfind <> INVALID_HANDLE_VALUE THEN
        FileAttribute = finddata.dwFileAttributes
        FileSize = finddata.nFileSizeHigh * &H100000000~&& OR finddata.nFileSizeLow
        SELECT CASE FileSwitch
            CASE 0 ' last modified /TW
                x& = FileTimeToSystemTime&(finddata.ftLastWriteTime, SysTime)
            CASE 1 ' creation /TC
                x& = FileTimeToSystemTime&(finddata.ftCreationTime, SysTime)
            CASE 2 ' last accessed /TA
                x& = FileTimeToSystemTime&(finddata.ftLastAccessTime, SysTime)
            CASE ELSE ' /TW
                x& = FileTimeToSystemTime&(finddata.ftLastWriteTime, SysTime)
        END SELECT
        FileDateTime = "[" + GetDateTime$(z) + "]"
        x = FindClose(hfind)
        EXIT SUB
    END IF

    ' get file attribute.
    FileAttribute = GetFileAttr(ASCIIZ)
END SUB

' returns MM-DD-YYYY HH:MM:SS
FUNCTION GetDateTime$ (z)
    GetDateTime$ = RIGHT$("00" + LTRIM$(STR$(SysTime.wMonth)), 2) + "-"
    GetDateTime$ = GetDateTime$ + RIGHT$("00" + LTRIM$(STR$(SysTime.wDay)), 2) + "-"
    GetDateTime$ = GetDateTime$ + LTRIM$(STR$(SysTime.wYear)) + " "

    GetDateTime$ = GetDateTime$ + RIGHT$("00" + LTRIM$(STR$(SysTime.wHour)), 2) + ":"
    GetDateTime$ = GetDateTime$ + RIGHT$("00" + LTRIM$(STR$(SysTime.wMinute)), 2) + ":"
    GetDateTime$ = GetDateTime$ + RIGHT$("00" + LTRIM$(STR$(SysTime.wSecond)), 2)
END FUNCTION

' search file subroutine.
'   input:
'     Var = 0 search with ascii string input.
'     Var = 1 search with hex string input.
'     Var = 2 continue search from previous input.
'   output:
'     FoundString = 1 invalid search string input.
'     FoundString = 0 search string not found.
'     FoundString = -1 search string found.
'     SearchBytePosition = location of start of search string in file.
SUB SearchFile (Var, FoundString)
    FoundString = False
    ' check to continue search.
    IF Var = 2 THEN
        ByteString$ = RTRIM$(StoreSearchString)
        NumBytes = StoreNumBytes
        GOTO StartSearch
    END IF
    ' search multiple bytes of an ASCII string in file and locate there.
    IF Var = 0 THEN
        CALL ClearStatus
        Printf "Enter ASCII string?"
        ByteString$ = LineInput$(2, 24, 54)
        IF LEN(ByteString$) = False THEN
            StatusMessage = "Invalid search string."
            CALL DisplayStatus2
            FoundString = 1
            EXIT SUB
        END IF
        NumBytes = LEN(ByteString$)
        CALL AsciiToHex2(ByteString$)
    ELSE
        ' search multiple bytes in file and locate there.
        '   left window specifies space-separated hex byte pairs,
        '   right window specifies space-separated 3-byte ascii pairs.
        CALL ClearStatus
        IF CurrentWindow = False THEN
            Printf "Enter hex byte(s)?"
            ByteString$ = LineInput$(2, 23, 55)
            IF LEFT$(ByteString$, 1) = "+" THEN
                ByteString$ = MID$(ByteString$, 2)
                CALL CheckAsciiBytes(ByteString$)
            ELSE
                AllowWildCard = True
                CALL CheckHexBytes(ByteString$)
            END IF
        ELSE
            Printf "Enter ascii byte(s)?"
            ByteString$ = LineInput$(2, 25, 53)
            IF UCASE$(LEFT$(ByteString$, 1)) = "H" THEN
                ByteString$ = MID$(ByteString$, 2)
                AllowWildCard = True
                CALL CheckHexBytes(ByteString$)
            ELSE
                CALL CheckAsciiBytes(ByteString$)
            END IF
        END IF
        IF ValidByteString = False THEN
            StatusMessage = "Invalid search string."
            CALL DisplayStatus2
            FoundString = 1
            EXIT SUB
        END IF
    END IF
    StartSearch:
    ' display searching message.
    CALL ClearStatus
    DisplayLength = LEN(ByteString$)
    IF DisplayLength > 28 THEN
        Var$ = "Searching for " + LEFT$(ByteString$, 28) + "..."
    ELSE
        Var$ = "Searching for " + ByteString$ + ":"
    END IF
    Var$ = Var$ + " (Press <esc> to quit)"
    CursorLocation = LEN(Var$) + 4
    Printf Var$

    ' store search variables.
    FoundString = False
    CALL ClearPageByte
    LastPage = FilePage
    OriginalString$ = ByteString$
    StoreSearchString = ByteString$
    StoreNumBytes = NumBytes
    ByteSearch1 = INSTR(ByteString$, "?")
    StoreSearchPosition = FilePosition
    TotalByte$ = Nul

    ' check continue search.
    IF Var = 2 THEN
        ' check continue from last position.
        IF StoreSearchPosition = FilePosition THEN
            IF FilePosition + 1 > FileLength THEN
                EXIT SUB
            END IF
            ' reset search type.
            Var = 3
            ' increment from previous search position.
            FilePosition = FilePosition + 1
        END IF
    END IF

    ' store initial byte string.
    SearchBytePosition = FilePosition
    FOR FileBytePosition = FilePosition TO FilePosition + NumBytes - 1
        IF FileBytePosition > FileLength THEN
            IF Var = 3 THEN
                FilePosition = FilePosition - 1
            END IF
            FoundString = False
            EXIT SUB
        END IF
        SeekPosition = FileBytePosition
        CALL LseekFile
        CALL ReadFile
        FileByte = Buffer
        Byte$ = HEX$(ASC(FileByte))
        Byte$ = RIGHT$("00" + Byte$, 2)
        TotalByte$ = TotalByte$ + Byte$
    NEXT

    ' reset search variables.
    Byte1# = 1#
    RemainingBytes# = FileLength - FilePosition + 1
    FileBytePosition = FilePosition + NumBytes - 1
    PercentDisplayed! = SFalse
    Locatef 2, CursorLocation, 0
    Printf " 0%"

    ' continue search.
    DO
        ' fill in ? character
        IF ByteSearch1 THEN
            ByteString$ = OriginalString$
            FOR TotalBytes = 1 TO NumBytes * 2
                Byte1$ = MID$(ByteString$, TotalBytes, 1)
                Byte2$ = MID$(TotalByte$, TotalBytes, 1)
                IF Byte1$ = "?" THEN
                    MID$(ByteString$, TotalBytes, 1) = Byte2$
                END IF
            NEXT
        END IF

        ' compare byte strings
        IF ByteString$ = TotalByte$ THEN
            StoreSearchPosition = SearchBytePosition
            FoundString = True
            EXIT DO
        END IF

        ' get next byte
        FileBytePosition = FileBytePosition + 1
        IF FileBytePosition > FileLength THEN
            IF Var = 3 THEN
                FilePosition = FilePosition - 1
            END IF
            FoundString = False
            EXIT DO
        END IF

        ' increment byte search variables.
        Byte1# = Byte1# + 1#
        SearchBytePosition = SearchBytePosition + 1#
        SeekPosition = FileBytePosition
        CALL LseekFile
        CALL ReadFile
        FileByte = Buffer
        Byte$ = HEX$(ASC(FileByte))
        Byte$ = RIGHT$("00" + Byte$, 2)
        TotalByte$ = MID$(TotalByte$, 3) + Byte$

        ' display percent remaining
        PercentCopied! = INT(CSNG(Byte1# / RemainingBytes#) * 100!)
        IF PercentCopied! > PercentDisplayed! THEN
            Locatef 2, CursorLocation, 0
            Printf STR$(PercentCopied!) + "%"
            PercentDisplayed! = PercentCopied!
        END IF

        ' check to exit search
        IF INKEY$ = CHR$(27) THEN
            EXIT DO
        END IF
    LOOP
END SUB

REM constructs and checks filelist filename exists.
REM   returns ambiguated filename.
FUNCTION FILELISTEXISTS$ (Var$)
    ' construct filelist filename.
    VarX$ = Var$
    V = INSTR(VarX$, "@")
    IF V = 0 THEN
        FILELISTEXISTS$ = Nul
        EXIT FUNCTION
    END IF
    FOR V = LEN(VarX$) TO 1 STEP -1
        IF MID$(VarX$, V, 1) = "@" THEN
            EXIT FOR
        END IF
    NEXT
    IF V = 1 THEN ' @filelist.txt
        VarX$ = MID$(VarX$, V + 1)
    ELSE
        IF V > 1 THEN
            IF MID$(VarX$, V - 1, 1) = "\" THEN ' \dos\@filelist.txt
                VarX$ = LEFT$(VarX$, V - 1) + MID$(VarX$, V + 1)
            ELSE
                IF MID$(VarX$, V - 1, 1) = ":" THEN ' c:@filelist.txt
                    VarX$ = LEFT$(VarX$, V - 1) + MID$(VarX$, V + 1)
                END IF
            END IF
        END IF
    END IF
    ' check filelist filename exists.
    IF INSTR(V, VarX$, "\") THEN ' c:\@path\filename.ext
        FILELISTEXISTS$ = Nul
    ELSE
        IF _FILEEXISTS(VarX$) = 0 THEN
            FILELISTEXISTS$ = Nul
        ELSE
            FILELISTEXISTS$ = VarX$
        END IF
    END IF
END FUNCTION

' test volume media inserted.
FUNCTION MEDIAEXISTS (V)
    ' check drive exists.
    IF DRIVEEXISTS(V) THEN
        MEDIAEXISTS = False
        EXIT FUNCTION
    END IF

    ' check cdrom exists
    IF DriveType = "[CDROM]" THEN
        MEDIAEXISTS = True
        EXIT FUNCTION
    END IF

    ' get drive info.
    VarX$ = CHR$(V + 64) + ":\" + CHR$(0)
    Vname$ = SPACE$(MAX_PATH)
    Fname$ = SPACE$(MAX_PATH)
    R = GetVolumeInformationA(VarX$, Vname$, MAX_PATH, serial~&, empty1~&, empty2~&, Fname$, MAX_PATH)
    IF R THEN
        MEDIAEXISTS = True
    ELSE
        MEDIAEXISTS = False
    END IF
END FUNCTION

' get drive information.
SUB GetDriveInfo (DriveAttribute$)
    ' reset drive info.
    DriveAttribute$ = Nul

    ' check drive exists.
    IF DRIVEEXISTS(Current.Drive) THEN
        EXIT SUB
    END IF

    ' get drive info.
    VarX$ = CHR$(Current.Drive + 64) + ":\" + CHR$(0)
    Vname$ = SPACE$(MAX_PATH)
    Fname$ = SPACE$(MAX_PATH)
    R = GetVolumeInformationA(VarX$, Vname$, MAX_PATH, serial~&, empty1~&, empty2~&, Fname$, MAX_PATH)
    IF R THEN
        ' get volume label.
        tmp1$ = RTRIM$(Vname$)
        v = INSTR(tmp1$, CHR$(0))
        IF v THEN tmp1$ = LEFT$(tmp1$, v - 1)
        DriveAttribute$ = tmp1$

        ' check quiet switch.
        SELECT CASE QuietSwitch
            CASE -1, 4, 5, 6
                EXIT SUB
        END SELECT

        ' serial number.
        Sname$ = LEFT$(HEX$(serial~&), 4) + "-" + RIGHT$(HEX$(serial~&), 4)
        DriveAttribute$ = DriveAttribute$ + " (" + Sname$ + ")"

        ' file system type.
        tmp1$ = RTRIM$(Fname$)
        v = INSTR(tmp1$, CHR$(0))
        IF v THEN tmp1$ = LEFT$(tmp1$, v - 1)
        DriveAttribute$ = DriveAttribute$ + " [" + tmp1$ + "]"
        EXIT SUB
    END IF
    DriveAttribute$ = DriveType
END SUB

' check drive exists.
'  returns -1 if drive not detected.
FUNCTION DRIVEEXISTS (V)
    VarX$ = CHR$(V + 64) + ":\" + CHR$(0)
    VarX = GetDriveType(VarX$)
    DriveType = Nul
    SELECT CASE VarX
        CASE 0
            DriveType = "[UNKNOWN]"
        CASE 1
            DriveType = "[BADROOT]"
        CASE 2
            DriveType = "[REMOVABLE]"
        CASE 3
            DriveType = "[FIXED]"
        CASE 4
            DriveType = "[REMOTE]"
        CASE 5
            DriveType = "[CDROM]"
        CASE 6
            DriveType = "[RAMDISK]"
    END SELECT
    IF VarX > 1 THEN
        DRIVEEXISTS = 0
    ELSE
        DRIVEEXISTS = -1
    END IF
END FUNCTION

' check netpath exists.
'  returns -1 if netpath not detected.
FUNCTION NETPATHEXISTS (Z$)
    VarX$ = Z$ + CHR$(0)
    VarX = GetDriveType(VarX$)
    IF VarX > 1 THEN
        NETPATHEXISTS = 0
    ELSE
        NETPATHEXISTS = -1
    END IF
END FUNCTION

' delete process filenames.
SUB Delete.Process
    ' close all files.
    CLOSE

    ' set error trap flag
    InErrorFlag = -1

    ' special debug purposes.
    IF Debug2 THEN
        EXIT SUB
    END IF

    ' DOS shell temp file.
    Var$ = "DOSEXIT" + MID$(STR$(Process.Number), 2) + ".BAT"
    GOSUB Remove.File

    ' multiple temp files. where ? is processnumber.
    REM MultiFilename1(1) = d:\path\UNDOBYTE.DA? ' byte undo file.
    REM MultiFilename1(2) = d:\path\MARKERS1.DA? ' marker file.
    REM MultiFilename1(3) = d:\path\COPYFILE.DA? ' paste file.
    REM MultiFilename1(4) = d:\path\HEXEDIT1.DA? ' filenames.
    REM MultiFilename1(5) = d:\path\HEXEDIT2.DA? ' directories.

    FOR Var = 1 TO 5
        Var$ = MultiFilename1(Var)
        GOSUB Remove.File
    NEXT

    ' multiple paste undo files. where ? is processnumber, * is filenumber.
    REM MultiFilenames(1 To 9) = d:\path\UNDOFIL?.DA*

    FOR Var = 1 TO MaxFiles
        Var$ = MultiFilenames(Var)
        GOSUB Remove.File
    NEXT
    EXIT SUB

    ' remove temporary datafile.
    Remove.File:
    Var$ = RTRIM$(Var$)
    IF LEN(Var$) THEN
        IF _FILEEXISTS(Var$) THEN
            G$ = Var$ + CHR$(0)
            x = DeleteFileA(G$)
            IF Debug THEN
                Locatef CSRLIN + 1, 1, 1
                Printf "Killed: " + Var$
            END IF
        END IF
    END IF
    RETURN
END SUB

REM Marker and Hilighting subroutines.
REM Hex/Dec calculator subroutine.
REM Formatting subroutine.
REM File menu box move subroutine.
REM File menu box file/dir override subroutine.
REM File exclusion subourtine.
REM Path override subroutines.
REM Specialized LINE INPUT subroutine.
REM LoadDirSpec menu subroutine.
REM LoadFileSpec menu subroutine.

REM Marker routines:

SUB Marker (Var)
    IF Var = 1 THEN GOTO ListMarkerRange
    IF Var = 2 THEN GOTO AddMarker
    IF Var = 3 THEN GOTO AddSpecificMarker
    IF Var = 4 THEN GOTO DeleteMarker
    IF Var = 5 THEN GOTO DeleteSpecificMarker
    IF Var = 6 THEN GOTO JumpPreviousMarker
    IF Var = 7 THEN GOTO JumpCurrentMarker
    IF Var = 8 THEN GOTO JumpNextMarker
    IF Var = 9 THEN GOTO JumpSpecificMarker
    IF Var = 10 THEN GOTO ListAllMarkers
    IF Var = 11 THEN GOTO ListSpecificMarker
    IF Var = 12 THEN GOTO ListMarkersOfValue
    IF Var = 13 THEN GOTO DeleteMarkerRange
    IF Var = 14 THEN GOTO DeleteAllMarkers
    IF Var = 15 THEN GOTO DeleteMarkersOfValue
    EXIT SUB

    AddMarker:
    TempPosition3 = FilePosition
    GOSUB AddMarkerValue
    EXIT SUB

    AddMarkerValue:
    IF MarkerCount = 1048576! THEN
        StatusMessage = "Maximum markers are at 1,048,576."
        CALL DisplayStatus2
        RETURN
    END IF
    IF MarkerCount < 1048576! THEN
        MarkerCount = MarkerCount + 1!
        GET #7, MarkerCount, MarkerFile
        MID$(MarkerFile.Markers1, (CurrentFile - 1) * 8 + 1, 8) = MKD$(TempPosition3)
        PUT #7, MarkerCount, MarkerFile
        CurrentMarker = MarkerCount
    END IF
    RETURN

    AddSpecificMarker:
    CALL ClearStatus
    Printf "Enter file position?"
    ByteString$ = LineInput$(2, 25, 10)
    IF UCASE$(LEFT$(ByteString$, 1)) = "H" THEN
        CALL CheckHexValue(ByteString$)
        IF ValidHexValue = False THEN
            EXIT SUB
        END IF
        TempPosition3 = HexValue
    ELSE
        CALL CheckASCIIValue(ByteString$)
        IF ValidASCIIValue = False THEN
            EXIT SUB
        END IF
        TempPosition3 = ASCIIValue3
    END IF
    IF TempPosition3 >= 1 AND TempPosition3 <= FileLength THEN
        GOSUB AddMarkerValue
        CALL LocateCursor2
        CALL DisplayFilename
        EXIT SUB
    END IF
    StatusMessage = "Invalid file position."
    CALL DisplayStatus2
    EXIT SUB

    DeleteMarker:
    IF CurrentMarker >= 1! AND CurrentMarker <= MarkerCount THEN
        GET #7, CurrentMarker, MarkerFile
        MID$(MarkerFile.Markers1, (CurrentFile - 1) * 8 + 1, 8) = MKD$(0#)
        PUT #7, CurrentMarker, MarkerFile
    END IF
    EXIT SUB

    DeleteSpecificMarker:
    CALL ClearStatus
    Printf "Enter marker number?"
    ByteString$ = LineInput$(2, 25, 10)
    IF LEN(ByteString$) THEN
        IF UCASE$(LEFT$(ByteString$, 1)) = "H" THEN
            ByteString$ = "&" + ByteString$
        END IF
        MarkerPosition = INT(VAL(ByteString$))
        IF MarkerPosition >= 1! AND MarkerPosition <= MarkerCount THEN
            GET #7, MarkerPosition, MarkerFile
            MID$(MarkerFile.Markers1, (CurrentFile - 1) * 8 + 1, 8) = MKD$(0#)
            PUT #7, MarkerPosition, MarkerFile
            CALL LocateCursor2
            CALL DisplayFilename
            EXIT SUB
        END IF
    END IF
    StatusMessage = "Invalid marker number."
    CALL DisplayStatus2
    EXIT SUB

    JumpPreviousMarker:
    NewMarker = CurrentMarker
    DO
        IF NewMarker <= 1! THEN
            EXIT SUB
        END IF
        NewMarker = NewMarker - 1!
        IF Markers#(NewMarker) > 0# THEN
            CurrentMarker = NewMarker
            EXIT DO
        END IF
    LOOP
    GOTO JumpCurrentMarker

    JumpNextMarker:
    NewMarker = CurrentMarker
    DO
        IF NewMarker >= MarkerCount THEN
            EXIT SUB
        END IF
        NewMarker = NewMarker + 1!
        IF Markers#(NewMarker) > 0# THEN
            CurrentMarker = NewMarker
            EXIT DO
        END IF
    LOOP
    GOTO JumpCurrentMarker

    JumpSpecificMarker:
    CALL ClearStatus
    Printf "Enter marker number?"
    ByteString$ = LineInput$(2, 25, 10)
    IF LEN(ByteString$) THEN
        IF UCASE$(LEFT$(ByteString$, 1)) = "H" THEN
            ByteString$ = "&" + ByteString$
        END IF
        MarkerPosition = INT(VAL(ByteString$))
        IF MarkerPosition >= 1! AND MarkerPosition <= MarkerCount THEN
            IF Markers#(MarkerPosition) > 0# THEN
                CurrentMarker = MarkerPosition
                GOTO JumpCurrentMarker
            END IF
        END IF
    END IF
    StatusMessage = "Invalid marker number."
    CALL DisplayStatus2
    EXIT SUB

    JumpCurrentMarker:
    IF CurrentMarker >= 1! AND CurrentMarker <= MarkerCount THEN
        TempPosition = Markers#(CurrentMarker)
        IF TempPosition >= 1 AND TempPosition <= FileLength THEN
            IF TempPosition <> FilePosition THEN
                CALL ClearPageByte
                LastPage = FilePage
                FilePosition = TempPosition
                CALL CalculatePosition1
                IF LastPage <> FilePage THEN
                    CALL DisplayHexPage
                END IF
                CALL DisplayPageByte
            END IF
        END IF
    END IF
    CALL DisplayFilename
    EXIT SUB

    ListAllMarkers:
    CALL DisplayScreen2
    Colorf White
    Locatef 2, 2, 0
    Printf "Marker list:"
    PageCount = False
    CountFlag = False
    Var2 = 2
    FOR MarkerPosition = 1! TO MarkerCount
        IF Markers#(MarkerPosition) > 0# THEN
            PageCount = PageCount + 1
            CountFlag = True
            Colorf Yellow
            Var2 = Var2 + 1
            Locatef Var2, 2, 0
            CALL FormatPosition2(2)
            IF PageCount >= 20 THEN
                PageCount = False
                Locatef 23, 2, 0
                CALL PressKey
                CALL DisplayScreen2
                Colorf White
                Locatef 2, 2, 0
                Printf "Marker list:"
                Var2 = 2
            END IF
        END IF
    NEXT
    IF CountFlag = False THEN
        Colorf Yellow
        Locatef 3, 2, 0
        Printf "No markers stored."
        Locatef 23, 2, 0
        CALL PressKey
    END IF
    IF PageCount > False THEN
        Locatef 23, 2, 0
        CALL PressKey
    END IF
    EXIT SUB

    ListSpecificMarker:
    CALL ClearStatus
    Printf "Enter marker number?"
    ByteString$ = LineInput$(2, 25, 10)
    IF LEN(ByteString$) THEN
        IF UCASE$(LEFT$(ByteString$, 1)) = "H" THEN
            ByteString$ = "&" + ByteString$
        END IF
        MarkerPosition = INT(VAL(ByteString$))
        IF MarkerPosition >= 1! AND MarkerPosition <= MarkerCount THEN
            CALL ClearStatus
            CALL FormatPosition2(1)
            CALL LocateCursor2
            CALL PromptKey
            CALL DisplayFilename
            EXIT SUB
        END IF
    END IF
    StatusMessage = "Invalid marker number."
    CALL DisplayStatus2
    EXIT SUB

    ListMarkersOfValue:
    CALL ClearStatus
    Printf "Enter marker value?"
    ByteString$ = LineInput$(2, 24, 10)
    IF UCASE$(LEFT$(ByteString$, 1)) = "H" THEN
        CALL CheckHexValue(ByteString$)
        IF ValidHexValue = False THEN
            EXIT SUB
        END IF
        TempPosition1 = HexValue
    ELSE
        CALL CheckASCIIValue(ByteString$)
        IF ValidASCIIValue = False THEN
            EXIT SUB
        END IF
        TempPosition1 = ASCIIValue3
    END IF
    CALL DisplayScreen2
    Colorf White
    Locatef 2, 2, 0
    Printf "Marker list:"
    PageCount = False
    CountFlag = False
    Var2 = 2
    FOR MarkerPosition = 1! TO MarkerCount
        IF Markers#(MarkerPosition) = TempPosition1 THEN
            PageCount = PageCount + 1
            CountFlag = True
            Colorf Yellow
            Var2 = Var2 + 1
            Locatef Var2, 2, 0
            CALL FormatPosition2(2)
            IF PageCount >= 20 THEN
                PageCount = False
                Locatef 23, 2, 0
                CALL PressKey
                CALL DisplayScreen2
                Colorf White
                Locatef 2, 2, 0
                Printf "Marker list:"
                Var2 = 2
            END IF
        END IF
    NEXT
    IF CountFlag = False THEN
        Colorf Yellow
        Locatef 3, 2, 0
        Printf "No markers of value stored."
        Locatef 23, 2, 0
        CALL PressKey
    END IF
    IF PageCount > False THEN
        Locatef 23, 2, 0
        CALL PressKey
    END IF
    EXIT SUB

    ListMarkerRange:
    CALL ClearStatus
    Printf "Enter beginning marker number?"
    ByteString$ = LineInput$(2, 35, 10)
    IF LEN(ByteString$) THEN
        IF UCASE$(LEFT$(ByteString$, 1)) = "H" THEN
            ByteString$ = "&" + ByteString$
        END IF
        MarkerPosition1 = INT(VAL(ByteString$))
        IF MarkerPosition1 >= 1! AND MarkerPosition1 <= MarkerCount THEN
            CALL ClearStatus
            Printf "Enter ending marker number?"
            ByteString$ = LineInput$(2, 32, 10)
            IF LEN(ByteString$) THEN
                IF UCASE$(LEFT$(ByteString$, 1)) = "H" THEN
                    ByteString$ = "&" + ByteString$
                END IF
                MarkerPosition2 = INT(VAL(ByteString$))
                IF MarkerPosition2 >= 1! AND MarkerPosition2 <= MarkerCount THEN
                    CALL DisplayScreen2
                    Colorf White
                    Locatef 2, 2, 0
                    Printf "Marker list:"
                    PageCount = False
                    CountFlag = False
                    Var2 = 2
                    FOR MarkerPosition = MarkerPosition1 TO MarkerPosition2
                        IF Markers#(MarkerPosition) > 0# THEN
                            PageCount = PageCount + 1
                            CountFlag = True
                            Colorf Yellow
                            Var2 = Var2 + 1
                            Locatef Var2, 2, 0
                            CALL FormatPosition2(2)
                            IF PageCount >= 20 THEN
                                PageCount = False
                                Locatef 23, 2, 0
                                CALL PressKey
                                CALL DisplayScreen2
                                Colorf White
                                Locatef 2, 2, 0
                                Printf "Marker list:"
                                Var2 = 2
                            END IF
                        END IF
                    NEXT
                    IF CountFlag = False THEN
                        Colorf Yellow
                        Locatef 3, 2, 0
                        Printf "No markers stored."
                        Locatef 23, 2, 0
                        CALL PressKey
                    END IF
                    IF PageCount > False THEN
                        Locatef 23, 2, 0
                        CALL PressKey
                    END IF
                    ValidFunction = True
                    EXIT SUB
                END IF
            END IF
        END IF
    END IF
    ValidFunction = False
    StatusMessage = "Invalid marker range."
    CALL DisplayStatus2
    EXIT SUB

    DeleteMarkerRange:
    CALL ClearStatus
    Printf "Enter beginning marker number?"
    ByteString$ = LineInput$(2, 35, 10)
    IF LEN(ByteString$) THEN
        IF UCASE$(LEFT$(ByteString$, 1)) = "H" THEN
            ByteString$ = "&" + ByteString$
        END IF
        MarkerPosition1 = INT(VAL(ByteString$))
        IF MarkerPosition1 >= 1! AND MarkerPosition1 <= MarkerCount THEN
            CALL ClearStatus
            Printf "Enter ending marker number?"
            ByteString$ = LineInput$(2, 32, 10)
            IF LEN(ByteString$) THEN
                IF UCASE$(LEFT$(ByteString$, 1)) = "H" THEN
                    ByteString$ = "&" + ByteString$
                END IF
                MarkerPosition2 = INT(VAL(ByteString$))
                IF MarkerPosition2 >= 1! AND MarkerPosition2 <= MarkerCount THEN
                    FOR MarkerPosition = MarkerPosition1 TO MarkerPosition2
                        GET #7, MarkerPosition, MarkerFile
                        MID$(MarkerFile.Markers1, (CurrentFile - 1) * 8 + 1, 8) = MKD$(0#)
                        PUT #7, MarkerPosition, MarkerFile
                    NEXT
                    StatusMessage = "Range of markers deleted."
                    CALL DisplayStatus2
                    EXIT SUB
                END IF
            END IF
        END IF
    END IF
    StatusMessage = "Invalid marker range."
    CALL DisplayStatus2
    EXIT SUB

    DeleteAllMarkers:
    CurrentMarker = False
    MarkerCount = False
    StatusMessage = "All markers deleted."
    CALL DisplayStatus2
    EXIT SUB

    DeleteMarkersOfValue:
    CALL ClearStatus
    Printf "Enter marker value?"
    ByteString$ = LineInput$(2, 24, 10)
    IF LEN(ByteString$) THEN
        IF UCASE$(LEFT$(ByteString$, 1)) = "H" THEN
            CALL CheckHexValue(ByteString$)
            IF ValidHexValue = False THEN
                EXIT SUB
            END IF
            TempPosition1 = HexValue
        ELSE
            CALL CheckASCIIValue(ByteString$)
            IF ValidASCIIValue = False THEN
                EXIT SUB
            END IF
            TempPosition1 = ASCIIValue3
        END IF
        FOR MarkerPosition = 1! TO MarkerCount
            IF Markers#(MarkerPosition) = TempPosition1 THEN
                GET #7, MarkerPosition, MarkerFile
                MID$(MarkerFile.Markers1, (CurrentFile - 1) * 8 + 1, 8) = MKD$(0#)
                PUT #7, MarkerPosition, MarkerFile
            END IF
        NEXT
    END IF
    StatusMessage = "All markers of value deleted."
    CALL DisplayStatus2
    EXIT SUB
END SUB

REM Hilighting key routines:

REM process left mouse button drag.
REM   also includes shift-<key> hilighting.

SUB MouseButton1Drag (Var)
    IF Var = 0 THEN GOTO DragMouse
    IF Var = 1 THEN GOTO ShiftLeftKey
    IF Var = 2 THEN GOTO ShiftRightKey
    IF Var = 3 THEN GOTO ShiftUpKey
    IF Var = 4 THEN GOTO ShiftDownKey
    IF Var = 5 THEN GOTO ShiftPageUpKey
    IF Var = 6 THEN GOTO ShiftPageDownKey
    IF Var = 7 THEN GOTO ShiftEndKey
    IF Var = 8 THEN GOTO ShiftHomeKey
    IF Var = 9 THEN GOTO DragMousePageUp
    IF Var = 10 THEN GOTO DragMousePageDown
    EXIT SUB

    ' move hilight area left.
    ShiftLeftKey:
    IF FilePosition = 1 THEN
        GOSUB StoreHilight
    ELSE
        IF PageColumn - 1 >= 1 THEN
            GOSUB StoreHilight
            IF CopyPositionEnd - 1 >= CopyPositionPivot THEN
                CALL ClearHilightByte
                PageColumn = PageColumn - 1
                FilePosition = FilePosition - 1
                CopyPositionEnd = CopyPositionEnd - 1
            ELSE
                IF CopyPositionStart - 1 <= CopyPositionPivot THEN
                    PageColumn = PageColumn - 1
                    FilePosition = FilePosition - 1
                    CopyPositionStart = CopyPositionStart - 1
                ELSE
                    EXIT SUB
                END IF
            END IF
        END IF
    END IF
    CALL DisplayHilightByte
    CALL LocateHilightCursor
    EXIT SUB

    ' move hilight area right.
    ShiftRightKey:
    IF FilePosition = FileLength THEN
        GOSUB StoreHilight
    ELSE
        IF PageColumn = 20 THEN
            GOSUB StoreHilight
        ELSE
            IF PageColumn + 1 <= 20 THEN
                IF FilePosition + 1 <= FileLength THEN
                    IF CopyPositionStart = DFalse THEN
                        GOSUB StoreHilight
                    ELSE
                        IF CopyPositionStart + 1 <= CopyPositionPivot THEN
                            CALL ClearHilightByte
                            PageColumn = PageColumn + 1
                            FilePosition = FilePosition + 1
                            CopyPositionStart = CopyPositionStart + 1
                        ELSE
                            IF CopyPositionEnd + 1 >= CopyPositionPivot THEN
                                PageColumn = PageColumn + 1
                                FilePosition = FilePosition + 1
                                CopyPositionEnd = CopyPositionEnd + 1
                            ELSE
                                EXIT SUB
                            END IF
                        END IF
                    END IF
                END IF
            END IF
        END IF
    END IF
    CALL DisplayHilightByte
    CALL LocateHilightCursor
    EXIT SUB

    ' move hilight area up.
    ShiftUpKey:
    IF PageRow - 1 >= 1 THEN
        GOSUB StoreHilight
        IF CopyPositionEnd > CopyPositionPivot THEN
            IF CopyPositionEnd - 20 >= CopyPositionPivot THEN
                Temp# = FilePosition
                Temp2# = PageRow
                FOR FilePosition = CopyPositionEnd TO CopyPositionEnd - 20 STEP -1
                    CALL CalculatePosition1
                    CALL ClearHilightByte
                NEXT
                PageRow = Temp2# - 1
                FilePosition = Temp# - 20
                CopyPositionEnd = CopyPositionEnd - 20
                CALL CalculatePosition1
                CALL DisplayHilightByte
                CALL LocateHilightCursor
            ELSE
                IF CopyPositionEnd - 20 < CopyPositionPivot THEN
                    Temp# = FilePosition
                    Temp2# = PageRow
                    FOR FilePosition = CopyPositionPivot TO CopyPositionEnd
                        CALL CalculatePosition1
                        CALL ClearHilightByte
                    NEXT
                    CopyPositionStart = CopyPositionEnd - 20
                    CopyPositionEnd = CopyPositionPivot
                    FOR FilePosition = CopyPositionStart TO CopyPositionPivot
                        CALL CalculatePosition1
                        CALL DisplayHilightByte
                    NEXT
                    PageRow = Temp2# - 1
                    FilePosition = Temp# - 20
                    CALL CalculatePosition1
                    CALL DisplayHilightByte
                    CALL LocateHilightCursor
                END IF
            END IF
        ELSE
            Temp# = FilePosition
            Temp2# = PageRow
            FOR FilePosition = CopyPositionStart - 20 TO CopyPositionStart
                CALL CalculatePosition1
                CALL DisplayHilightByte
            NEXT
            CopyPositionStart = CopyPositionStart - 20
            PageRow = Temp2# - 1
            FilePosition = Temp# - 20
            CALL CalculatePosition1
            CALL DisplayHilightByte
            CALL LocateHilightCursor
        END IF
    END IF
    EXIT SUB

    ' move hilight area down.
    ShiftDownKey:
    IF PageRow + 1 <= 16 THEN
        IF FilePosition + 20 <= FileLength THEN
            GOSUB StoreHilight
            IF CopyPositionStart < CopyPositionPivot THEN
                Temp# = FilePosition
                Temp2# = PageRow
                IF CopyPositionStart + 20 < CopyPositionPivot THEN
                    FOR FilePosition = CopyPositionStart TO CopyPositionStart + 20
                        CALL CalculatePosition1
                        CALL ClearHilightByte
                    NEXT
                    PageRow = Temp2# + 1
                    FilePosition = Temp# + 20
                    CopyPositionStart = CopyPositionStart + 20
                    CALL DisplayHilightByte
                    CALL LocateHilightCursor
                ELSE
                    FOR FilePosition = CopyPositionStart TO CopyPositionPivot
                        CALL CalculatePosition1
                        CALL ClearHilightByte
                    NEXT
                    CopyPositionStart = CopyPositionPivot
                    CopyPositionEnd = Temp# + 20
                    FOR FilePosition = CopyPositionPivot TO CopyPositionEnd
                        CALL CalculatePosition1
                        CALL DisplayHilightByte
                    NEXT
                    PageRow = Temp2# + 1
                    FilePosition = CopyPositionEnd
                    CALL DisplayHilightByte
                    CALL LocateHilightCursor
                END IF
            ELSE
                IF CopyPositionEnd >= CopyPositionPivot THEN
                    Temp# = FilePosition
                    Temp2# = PageRow
                    FOR FilePosition = CopyPositionEnd TO CopyPositionEnd + 20
                        CALL CalculatePosition1
                        CALL DisplayHilightByte
                    NEXT
                    PageRow = Temp2# + 1
                    FilePosition = Temp# + 20
                    CopyPositionEnd = CopyPositionEnd + 20
                    CALL DisplayHilightByte
                    CALL LocateHilightCursor
                END IF
            END IF
        END IF
    END IF
    EXIT SUB

    ' move hilight area up one page.
    ShiftPageUpKey:
    ' check there is a page to move up.
    IF FilePosition - 320 >= 1 THEN
        GOSUB StoreHilight
        ' move copypositionstart up one page.
        IF CopyPositionEnd = CopyPositionPivot THEN
            FilePage = FilePage - 1
            FilePosition = FilePosition - 320
            CopyPositionStart = CopyPositionStart - 320
        ELSE
            IF CopyPositionEnd > CopyPositionPivot THEN
                ' move copypositionend up one page before pivot.
                IF CopyPositionEnd - 320 < CopyPositionPivot THEN
                    FilePage = FilePage - 1
                    FilePosition = FilePosition - 320
                    CopyPositionStart = FilePosition
                    CopyPositionEnd = CopyPositionPivot
                ELSE
                    ' move copypositionend up one page.
                    IF CopyPositionEnd - 320 >= CopyPositionPivot THEN
                        FilePage = FilePage - 1
                        FilePosition = FilePosition - 320
                        CopyPositionEnd = CopyPositionEnd - 320
                    END IF
                END IF
            END IF
        END IF
    ELSE
        ' check there is a first position on the first page to move up to.
        IF FilePosition > 1 THEN
            GOSUB StoreHilight
            PageRow = 1
            PageColumn = 1
            FilePosition = 1
            CopyPositionStart = 1
            CopyPositionEnd = CopyPositionPivot
        ELSE
            EXIT SUB
        END IF
    END IF
    CALL CalculatePosition1
    CALL DisplayHexPage
    Reset1 = False
    CALL ResetByte
    CALL DisplayHilightByte
    CALL LocateHilightCursor
    EXIT SUB

    ' move hilight area down one page.
    ShiftPageDownKey:
    ' check there is a page to move down.
    IF FilePosition + 320 <= FileLength THEN
        GOSUB StoreHilight
        ' move copypositionend down one page.
        IF CopyPositionStart = CopyPositionPivot THEN
            FilePage = FilePage + 1
            FilePosition = FilePosition + 320
            CopyPositionEnd = CopyPositionEnd + 320
        ELSE
            IF CopyPositionStart < CopyPositionPivot THEN
                ' move copypositionstart down one page after pivot.
                IF CopyPositionStart + 320 <= CopyPositionPivot THEN
                    FilePage = FilePage + 1
                    FilePosition = FilePosition + 320
                    CopyPositionStart = FilePosition
                    CopyPositionEnd = CopyPositionPivot
                ELSE
                    ' move copypositionstart down one page.
                    IF CopyPositionStart + 320 > CopyPositionPivot THEN
                        FilePage = FilePage + 1
                        FilePosition = FilePosition + 320
                        CopyPositionStart = CopyPositionPivot
                        CopyPositionEnd = FilePosition
                    END IF
                END IF
            END IF
        END IF
    ELSE
        ' check there is a last position on the last page to move down to.
        IF FilePosition < FileLength THEN
            GOSUB StoreHilight
            FilePosition = FileLength
            CopyPositionStart = CopyPositionPivot
            CopyPositionEnd = FileLength
        ELSE
            EXIT SUB
        END IF
    END IF
    CALL CalculatePosition1
    CALL DisplayHexPage
    Reset1 = False
    CALL ResetByte
    CALL DisplayHilightByte
    CALL LocateHilightCursor
    EXIT SUB

    ' move hilight area to end of line.
    ShiftEndKey:
    ' set to column 20
    IF PageColumn < 20 THEN
        ' check column 20 is positioned before end of file
        GOSUB StoreHilight
        IF FilePosition - PageColumn + 20 <= FileLength THEN
            Temp# = FilePosition
            Temp2# = PageColumn
            TempPosition3 = CopyPositionPivot
            CALL CalculatePosition2
            IF PageRow = PageRow2 THEN
                IF Temp# - Temp2# + 20 >= CopyPositionPivot THEN
                    FOR FilePosition = Temp# - Temp2# + 1 TO CopyPositionPivot
                        CALL CalculatePosition1
                        CALL ClearHilightByte
                    NEXT
                    FOR FilePosition = CopyPositionPivot TO Temp# - Temp2# + 20
                        CALL CalculatePosition1
                        CALL DisplayHilightByte
                    NEXT
                END IF
                CopyPositionEnd = Temp# - Temp2# + 20
                CopyPositionStart = CopyPositionPivot
            ELSE
                IF Temp# - Temp2# + 20 >= CopyPositionPivot THEN
                    FOR FilePosition = Temp# TO Temp# - Temp2# + 20
                        CALL CalculatePosition1
                        CALL DisplayHilightByte
                    NEXT
                    CopyPositionEnd = Temp# - Temp2# + 20
                    CopyPositionStart = CopyPositionPivot
                ELSE
                    FOR FilePosition = Temp# TO Temp# - Temp2# + 20
                        CALL CalculatePosition1
                        CALL ClearHilightByte
                    NEXT
                    CopyPositionStart = Temp# - Temp2# + 1
                    CopyPositionEnd = CopyPositionPivot
                END IF
            END IF
            FilePosition = Temp# - Temp2# + 20
            PageColumn = 20
            CALL DisplayHilightByte
            CALL LocateHilightCursor
        ELSE
            ' last position is end of file.
            Temp# = FilePosition
            Temp2# = PageColumn
            TempPosition3 = CopyPositionPivot
            CALL CalculatePosition2
            IF PageRow = PageRow2 THEN
                IF FileLength >= CopyPositionPivot THEN
                    FOR FilePosition = Temp# - Temp2# + 1 TO CopyPositionPivot
                        CALL CalculatePosition1
                        CALL ClearHilightByte
                    NEXT
                    FOR FilePosition = CopyPositionPivot TO FileLength
                        CALL CalculatePosition1
                        CALL DisplayHilightByte
                    NEXT
                END IF
            END IF
            FilePosition = FileLength
            CopyPositionEnd = FileLength
            CopyPositionStart = CopyPositionPivot
            CALL CalculatePosition1
            CALL DisplayHilightByte
            CALL LocateHilightCursor
        END IF
    END IF
    EXIT SUB

    ' move hilight area to start of line.
    ShiftHomeKey:
    ' set to column 1
    IF PageColumn > 1 THEN
        GOSUB StoreHilight
        Temp# = FilePosition
        Temp2# = PageColumn
        TempPosition3 = CopyPositionPivot
        CALL CalculatePosition2
        IF PageRow = PageRow2 THEN
            IF Temp# - Temp2# + 1 <= CopyPositionPivot THEN
                FOR FilePosition = CopyPositionPivot TO Temp#
                    CALL CalculatePosition1
                    CALL ClearHilightByte
                NEXT
                FOR FilePosition = Temp# - Temp2# + 1 TO CopyPositionPivot
                    CALL CalculatePosition1
                    CALL DisplayHilightByte
                NEXT
            END IF
            CopyPositionStart = Temp# - Temp2# + 1
            CopyPositionEnd = CopyPositionPivot
        ELSE
            IF Temp# - Temp2# + 1 <= CopyPositionPivot THEN
                FOR FilePosition = Temp# - Temp2# + 1 TO Temp#
                    CALL CalculatePosition1
                    CALL DisplayHilightByte
                NEXT
                CopyPositionStart = Temp# - Temp2# + 1
                CopyPositionEnd = CopyPositionPivot
            ELSE
                FOR FilePosition = Temp# - Temp2# + 1 TO Temp#
                    CALL CalculatePosition1
                    CALL ClearHilightByte
                NEXT
                CopyPositionEnd = Temp# - Temp2# + 1
                CopyPositionStart = CopyPositionPivot
            END IF
        END IF
        FilePosition = Temp# - Temp2# + 1
        PageColumn = 1
        CALL DisplayHilightByte
        CALL LocateHilightCursor
    END IF
    EXIT SUB

    ' store inital hilight start
    StoreHilight:
    IF CopyPositionStart = DFalse THEN
        CopyPositionStart = FilePosition
        CopyPositionPivot = FilePosition
        CopyPositionEnd = FilePosition
    END IF
    RETURN

    REM Mouse hilighting routines:

    DragMouse:
    ' check mouse position in screen editing area.
    IF MouseX > 3 AND MouseX < 20 THEN
        IF MouseY >= 6 AND MouseY <= 49 THEN
            ' check initial click is inside editing area.
            IF CopyStart = DFalse THEN
                EXIT SUB
            END IF
            ' check screen character.
            VarX = SCREEN(MouseX, MouseY)
            ' check space.
            IF VarX = 32 THEN
                EXIT SUB
            END IF
            ' check new position.
            IF VarX <> 32 THEN
                ' calculate new position.
                NewPosition = CalculatePosition3
                ' initialize copy area.
                IF CopyPositionStart = DFalse THEN
                    CopyPositionStart = CopyStart
                    CopyPositionPivot = CopyStart
                    CopyPositionEnd = CopyStart
                END IF
                ' check initial click area.
                IF NewPosition = CopyPositionPivot THEN
                    FOR TempPosition3 = CopyPositionStart TO CopyPositionEnd
                        CALL CalculatePosition2
                        IF FilePage2 = FilePage THEN
                            FilePosition = TempPosition3
                            CALL CalculatePosition1
                            Colorf White
                            CALL BytePrint
                        END IF
                    NEXT
                    CopyPositionStart = NewPosition
                    CopyPositionEnd = NewPosition
                    FilePosition = CopyPositionPivot
                    CALL CalculatePosition1
                    Colorf2 0, 7
                    CALL BytePrint
                    Colorf2 7, 0
                END IF
                ' check backwards wrap.
                IF NewPosition < CopyPositionPivot THEN
                    IF CopyPositionEnd > CopyPositionPivot THEN
                        FOR TempPosition3 = CopyPositionPivot TO CopyPositionEnd
                            CALL CalculatePosition2
                            IF FilePage2 = FilePage THEN
                                FilePosition = TempPosition3
                                CALL CalculatePosition1
                                Colorf White
                                CALL BytePrint
                            END IF
                        NEXT
                    END IF
                    IF NewPosition > CopyPositionStart THEN
                        FOR TempPosition3 = CopyPositionStart TO NewPosition
                            CALL CalculatePosition2
                            IF FilePage2 = FilePage THEN
                                FilePosition = TempPosition3
                                CALL CalculatePosition1
                                Colorf White
                                CALL BytePrint
                            END IF
                        NEXT
                    END IF
                    CopyPositionStart = NewPosition
                    CopyPositionEnd = CopyPositionPivot
                    FOR TempPosition3 = CopyPositionStart TO CopyPositionPivot
                        CALL CalculatePosition2
                        IF FilePage2 = FilePage THEN
                            FilePosition = TempPosition3
                            CALL CalculatePosition1
                            Colorf2 0, 7
                            CALL BytePrint
                        END IF
                    NEXT
                    Colorf2 7, 0
                END IF
                ' check forwards wrap.
                IF NewPosition > CopyPositionPivot THEN
                    IF CopyPositionStart < CopyPositionPivot THEN
                        FOR TempPosition3 = CopyPositionStart TO CopyPositionPivot
                            CALL CalculatePosition2
                            IF FilePage2 = FilePage THEN
                                FilePosition = TempPosition3
                                CALL CalculatePosition1
                                Colorf White
                                CALL BytePrint
                            END IF
                        NEXT
                    END IF
                    IF NewPosition < CopyPositionEnd THEN
                        FOR TempPosition3 = NewPosition TO CopyPositionEnd
                            CALL CalculatePosition2
                            IF FilePage2 = FilePage THEN
                                FilePosition = TempPosition3
                                CALL CalculatePosition1
                                Colorf White
                                CALL BytePrint
                            END IF
                        NEXT
                    END IF
                    CopyPositionStart = CopyPositionPivot
                    CopyPositionEnd = NewPosition
                    FOR TempPosition3 = CopyPositionPivot TO CopyPositionEnd
                        CALL CalculatePosition2
                        IF FilePage2 = FilePage THEN
                            FilePosition = TempPosition3
                            CALL CalculatePosition1
                            Colorf2 0, 7
                            CALL BytePrint
                        END IF
                    NEXT
                    Colorf2 7, 0
                END IF
                ' get new position and locate there.
                FilePosition = NewPosition
                CALL CalculatePosition1
                Colorf2 0, 7
                CALL BytePrint
                Colorf2 7, 0
                CALL DisplayPosition
                CALL LocateCursor
            END IF
        END IF
    END IF
    EXIT SUB

    ' move hilight area up one page.
    DragMousePageUp:
    ' check initial click is inside editing area.
    IF CopyStart = DFalse THEN
        EXIT SUB
    END IF
    ' check scrolling interval.
    IF Time1 = SFalse THEN
        Time1 = TIMER
    END IF
    GOSUB TimeElapsed
    IF VarT = SFalse THEN
        EXIT SUB
    END IF
    Time1 = TIMER
    ' check drag variables.
    IF CopyPositionEnd = DFalse THEN
        CopyPositionEnd = CopyStart
    END IF
    IF CopyPositionPivot = DFalse THEN
        CopyPositionPivot = CopyPositionEnd
    END IF
    IF CopyPositionStart = DFalse THEN
        CopyPositionStart = (FilePage - 1) * 320 + 1
    END IF
    ' check there is a page to move up.
    IF FilePage - 1 >= 1 THEN
        ' move copypositionstart up one page.
        FilePage = FilePage - 1
        FilePosition = (FilePage - 1) * 320 + 1
        CopyPositionStart = FilePosition
        CALL CalculatePosition1
        CALL DisplayHexPage
        Reset1 = False
        CALL ResetByte
        CALL DisplayHilightByte
        CALL LocateHilightCursor
    END IF
    EXIT SUB

    ' move hilight area down one page.
    DragMousePageDown:
    ' check initial click is inside editing area.
    IF CopyStart = DFalse THEN
        EXIT SUB
    END IF
    ' check scrolling interval.
    IF Time1 = SFalse THEN
        Time1 = TIMER
    END IF
    GOSUB TimeElapsed
    IF VarT = SFalse THEN
        EXIT SUB
    END IF
    Time1 = TIMER
    ' check drag variables.
    IF CopyPositionStart = DFalse THEN
        CopyPositionStart = CopyStart
    END IF
    IF CopyPositionPivot = DFalse THEN
        CopyPositionPivot = CopyPositionStart
    END IF
    IF CopyPositionEnd = DFalse THEN
        CopyPositionEnd = (FilePage - 1) * 320 + 320
    END IF
    ' check there is a page to move down.
    FilePage2 = INT((FileLength - 1) / 320) + 1
    IF FilePage + 1 <= FilePage2 THEN
        ' move copypositionend down one page.
        FilePage = FilePage + 1
        FilePosition = (FilePage - 1) * 320 + 320
        IF FilePosition > FileLength THEN
            FilePosition = FileLength
        END IF
        CopyPositionEnd = FilePosition
        CALL CalculatePosition1
        CALL DisplayHexPage
        Reset1 = False
        CALL ResetByte
        CALL DisplayHilightByte
        CALL LocateHilightCursor
    END IF
    EXIT SUB

    ' calculate elapsed time.
    TimeElapsed:
    Elapsed.Time! = TIMER - Time1
    IF Elapsed.Time! < SFalse THEN
        Elapsed.Time! = Elapsed.Time! + 86400!
    END IF
    IF Elapsed.Time! > MouseTime THEN
        VarT = True
    ELSE
        VarT = False
    END IF
    RETURN
END SUB

' realtime hex/dec calculator.
SUB HexCalc
    GOSUB MakeBox ' create edit box.
    Ins = -1 ' reset insert flag.
    CalcBox = 1 ' reset to left box.
    Box$ = "0" ' current box
    Box1$ = "0" ' left box string
    Box2$ = "0" ' right box string
    GOSUB SelectBox2 ' display box 2.
    GOSUB SelectBox1 ' display box 1.
    DO ' calculator loop
        DO ' keystroke loop
            _LIMIT 100
            Z = MouseDriver ' get mouse
            IF MouseButton1 THEN
                Colorf2 7, 0
                EXIT SUB
            END IF
            IF MouseButton2 THEN
                Colorf2 7, 0
                EXIT SUB
            END IF
            Var$ = INKEY$ ' get keystroke
            IF LEN(Var$) THEN ' check keystroke
                EXIT DO
            END IF
        LOOP
        SELECT CASE LEN(Var$)
            CASE 1 ' single ascii key
                SELECT CASE ASC(Var$)
                    CASE 8 ' backspace
                        IF Ycoor1 - Column3 > False THEN
                            IF Ins THEN
                                Box$ = LEFT$(Box$, Ycoor1 - Column3 - 1) + MID$(Box$, Ycoor1 - Column3 + 1)
                                Ycoor1 = Ycoor1 - 1
                                Locatef Xcoor1, Ycoor1, 1
                                Var$ = MID$(Box$, Ycoor1 - Column3 + 1) + " "
                                Colorf2 15, 0
                                Printf Var$
                                Locatef Xcoor1, Ycoor1, 1
                                GOSUB PrintBoxes
                            ELSE ' move left
                                Ycoor1 = Ycoor1 - 1
                                LOCATE Xcoor1, Ycoor1, 1
                            END IF
                        END IF
                    CASE 9 ' tab
                        IF CalcBox = 1 THEN
                            CalcBox = 2
                            GOSUB SelectBox2
                            GOSUB PrintBoxes
                        END IF
                    CASE 27 ' escape
                        Colorf2 7, 0
                        EXIT SUB
                    CASE ELSE ' keystroke
                        VarX = False
                        TempX$ = UCASE$(Var$)
                        SELECT CASE TempX$
                            CASE "0" TO "9"
                                VarX = True
                            CASE "A" TO "F"
                                IF CalcBox = 1 THEN
                                    VarX = True
                                END IF
                        END SELECT
                        IF VarX THEN
                            IF Ycoor1 - Column3 + 1 <= LineLength THEN
                                ' insert digit
                                IF Ins THEN
                                    Box$ = LEFT$(Box$, Ycoor1 - Column3) + TempX$ + MID$(Box$, Ycoor1 - Column3 + 1)
                                    Box$ = LEFT$(Box$, LineLength)
                                    Locatef Xcoor1, Ycoor1, 1
                                    Var$ = MID$(Box$, Ycoor1 - Column3 + 1)
                                    Colorf2 15, 0
                                    Printf Var$
                                    Ycoor1 = Ycoor1 + 1
                                    Locatef Xcoor1, Ycoor1, 1
                                    GOSUB PrintBoxes
                                ELSE ' overstrike char
                                    IF Ycoor1 - Column3 + 1 > LEN(Box$) THEN
                                        Box$ = Box$ + TempX$ ' append box
                                    ELSE
                                        MID$(Box$, Ycoor1 - Column3 + 1, 1) = TempX$ ' replace
                                    END IF
                                    Locatef Xcoor1, Ycoor1, 1
                                    Colorf2 15, 0
                                    Printf TempX$
                                    Ycoor1 = Ycoor1 + 1
                                    Locatef Xcoor1, Ycoor1, 1
                                    GOSUB PrintBoxes
                                END IF
                            END IF
                        END IF
                END SELECT
            CASE 2 ' extended key
                SELECT CASE ASC(RIGHT$(Var$, 1))
                    CASE 15 ' shift-tab
                        IF CalcBox = 2 THEN
                            CalcBox = 1
                            GOSUB SelectBox1
                            GOSUB PrintBoxes
                        END IF
                    CASE 71 ' home
                        Ycoor1 = Column3
                    CASE 79 ' end
                        Ycoor1 = LEN(Box$) + Column3
                    CASE 77 ' right
                        IF Ycoor1 - Column3 + 1 <= LEN(Box$) THEN
                            Ycoor1 = Ycoor1 + 1
                        END IF
                    CASE 75 ' left
                        IF Ycoor1 - Column3 > False THEN
                            Ycoor1 = Ycoor1 - 1
                        END IF
                    CASE 82 ' insert
                        Ins = NOT Ins
                        Colorf2 14, 1
                        IF Ins THEN
                            Locatef 4, 30, 1
                            Printf "<ins>"
                        ELSE
                            Locatef 4, 30, 1
                            Printf STRING$(5, 205)
                        END IF
                        Colorf2 15, 0
                    CASE 83 ' delete
                        IF Ycoor1 - Column3 + 1 <= LEN(Box$) THEN
                            Box$ = LEFT$(Box$, Ycoor1 - Column3) + MID$(Box$, Ycoor1 - Column3 + 2)
                            Locatef Xcoor1, Ycoor1, 1
                            Var$ = MID$(Box$, Ycoor1 - Column3 + 1) + " "
                            Colorf2 15, 0
                            Printf Var$
                            Locatef Xcoor1, Ycoor1, 1
                            GOSUB PrintBoxes
                        END IF
                    CASE 119 ' control-home
                        Ycoor1 = Column3
                    CASE 117 ' control-end
                        Ycoor1 = LEN(Box$) + Column3
                END SELECT
                Locatef Xcoor1, Ycoor1, 1
        END SELECT
    LOOP
    EXIT SUB

    ' create edit box.
    MakeBox:
    Colorf2 14, 1
    Locatef 4, 6, 1
    Var$ = " " + CHR$(201) + STRING$(1, 205) + "<esc>=Quit" + STRING$(11, 205) + "<ins>" + CHR$(187) + " "
    Printf Var$
    Locatef 5, 6, 1
    Var$ = " " + CHR$(186) + SPACE$(9) + "Hex" + SPACE$(11) + "Dec " + CHR$(186) + " "
    Printf Var$
    Locatef 6, 6, 1
    Var$ = " " + CHR$(200) + STRING$(1, 205) + "<tab>/<shift-tab>=switch" + STRING$(2, 205) + CHR$(188) + " "
    Printf Var$
    RETURN

    ' move to box 1 (left box).
    SelectBox1:
    Box2$ = Box$ ' store right box.
    Box$ = Box1$ ' reset to left box.

    ' reset editing parameters.
    Xcoor1 = 5
    Ycoor1 = 9
    Column3 = 9
    LineLength = 8

    ' display left box.
    Colorf2 15, 0
    Locatef Xcoor1, Ycoor1, 1
    Printf SPACE$(8)
    Locatef Xcoor1, Ycoor1, 1
    Printf Box$
    Ycoor1 = Ycoor1 + LEN(Box$)
    Locatef Xcoor1, Ycoor1, 1
    RETURN

    ' move to box 2 (right box).
    SelectBox2:
    Box1$ = Box$ ' store left box.
    Box$ = Box2$ ' reset to right box.

    ' reset editing parameters.
    Xcoor1 = 5
    Ycoor1 = 21
    Column3 = 21
    LineLength = 10

    ' display right box.
    Colorf2 15, 0
    Locatef Xcoor1, Ycoor1, 1
    Printf SPACE$(10)
    Locatef Xcoor1, Ycoor1, 1
    Printf Box$
    Ycoor1 = Ycoor1 + LEN(Box$)
    Locatef Xcoor1, Ycoor1, 1
    RETURN

    ' calculates value of current box,
    ' displays result in calculated form
    ' in opposite box.
    PrintBoxes:
    IF CalcBox = 1 THEN ' is in hex box.
        ' strip leading zeroes for signed bit conversion.
        TempBox$ = Box$
        DO
            IF LEFT$(TempBox$, 1) = "0" THEN
                TempBox$ = MID$(TempBox$, 2)
            ELSE
                EXIT DO
            END IF
        LOOP
        Value# = VAL("&H" + TempBox$) ' retreive decimal value.
        IF Value# < 0# THEN ' check twos-complement from signed value.
            IF LEN(TempBox$) = 8 THEN ' 8000 0000 to FFFF FFFF
                Value# = Value# + 4294967296#
            ELSE
                IF LEN(TempBox$) = 4 THEN ' 8000 to FFFF
                    Value# = Value# + 65536
                END IF
            END IF
        END IF
        ' display decimal value.
        Box2$ = MID$(STR$(Value#), 2)
        Colorf2 15, 0
        Locatef 5, 21, 1
        Printf SPACE$(10)
        Locatef 5, 21, 1
        Printf Box2$
    END IF
    IF CalcBox = 2 THEN ' is in decimal box.
        Value# = VAL(Box$) ' retreive hex value.
        IF Value# >= 4294967296# THEN ' check overflow.
            Colorf2 15, 0
            Locatef 5, 9, 1
            Var$ = "overflow"
            Printf Var$
            Box1$ = "0"
        ELSE
            IF Value# > 2147483647# THEN ' force to twos-complement.
                Value# = Value# - 4294967296# ' 8000 0000 to FFFF FFFF
            END IF
            ' display hex value.
            Box1$ = HEX$(Value#)
            Colorf2 15, 0
            Locatef 5, 9, 1
            Printf SPACE$(8)
            Locatef 5, 9, 1
            Printf Box1$
        END IF
    END IF
    Locatef Xcoor1, Ycoor1, 1
    RETURN
END SUB

' formatting function.
'   Var#  input value.
'   Var3  format type:
'      1 = filelength in hexedit.
'      0 = file status area in file menu box.
'     -1 = filesize in file menu box.
FUNCTION FormatX$ (Var#, Var3)
    IF Var3 = -1 THEN
        SELECT CASE FileSizeType
            CASE 0 ' Byte
                FormatX$ = FormatString$(Var#, 0) + " B. "
            CASE 1 ' Kilobyte
                Var# = Var# / 1024#
                FormatX$ = FormatString$(Var#, 1) + " KB. "
            CASE 2 ' Megabyte
                Var# = Var# / 1048576#
                FormatX$ = FormatString$(Var#, 2) + " MB. "
            CASE 3 ' Gigabyte
                Var# = Var# / 1073741824#
                FormatX$ = FormatString$(Var#, 3) + " GB. "
        END SELECT
        IF LEFT$(FormatX$, 1) = "." THEN
            FormatX$ = "0" + FormatX$
        END IF
        EXIT FUNCTION
    END IF
    FormatX$ = FormatString$(Var#, 0)
END FUNCTION

' formats a double numeric string
FUNCTION FormatString$ (s#, x) ' x = 0 B, 1 K, 2 M, 3 G
    x$ = Nul
    s$ = STR$(s#)
    IF INSTR(s$, "D") THEN ' return string
        FormatString$ = s$
        EXIT FUNCTION
    END IF
    IF LEFT$(s$, 1) = "-" THEN ' store sign
        e$ = "-"
        s$ = MID$(s$, 2)
    END IF
    s$ = LTRIM$(s$) ' format string
    IF INSTR(s$, ".") THEN
        q$ = MID$(s$, INSTR(s$, "."))
        s$ = LEFT$(s$, INSTR(s$, ".") - 1)
    END IF
    FOR l = LEN(s$) TO 3 STEP -3
        x$ = MID$(s$, l - 2, 3) + "," + x$
    NEXT
    IF l > 0 THEN
        x$ = MID$(s$, 1, l) + "," + x$
    END IF
    IF LEN(s$) < 3 THEN
        x$ = s$
    END IF
    IF RIGHT$(x$, 1) = "," THEN
        x$ = LEFT$(x$, LEN(x$) - 1)
    END IF

    ' construct string
    SELECT CASE x
        CASE 0 ' B
            x$ = e$ + x$
        CASE 1 ' K .0
            IF LEN(q$) THEN
                q$ = LEFT$(q$, 2)
            END IF
            x$ = e$ + x$ + q$
        CASE 2 ' M .00
            IF LEN(q$) THEN
                q$ = LEFT$(q$, 3)
            END IF
            x$ = e$ + x$ + q$
        CASE 3 ' G .000
            IF LEN(q$) THEN
                q$ = LEFT$(q$, 4)
            END IF
            x$ = e$ + x$ + q$
    END SELECT
    FormatString$ = x$
END FUNCTION

' file menu box move subroutine.
SUB MoveMenu
    GOSUB StoreArea
    GOSUB RestoreArea
    I$ = Nul
    DO
        I$ = Nul
        DO
            _LIMIT 100
            I$ = INKEY$
            IF LEN(I$) THEN
                EXIT DO
            END IF
            Z = MouseDriver ' get mouse
            IF MouseButton1 THEN
                MouseButton1 = False
                CALL ClearMouse
                IF Xcoor - 1 >= 2 THEN
                    Xcoor = Xcoor - 1
                    GOSUB RestoreArea
                END IF
            END IF
            IF MouseButton2 THEN
                MouseButton2 = False
                CALL ClearMouse
                IF Xcoor + 1 <= 8 THEN
                    Xcoor = Xcoor + 1
                    GOSUB RestoreArea
                END IF
            END IF
            IF MouseButton3 THEN
                I$ = CHR$(0) + CHR$(76) ' center box
                EXIT DO
            END IF
            IF MouseWheel = -1 THEN
                IF WheelReverse THEN
                    I$ = CHR$(0) + CHR$(80) ' down
                ELSE
                    I$ = CHR$(0) + CHR$(72) ' up
                END IF
                MouseWheel = 0
                EXIT DO
            END IF
            IF MouseWheel = 1 THEN
                IF WheelReverse THEN
                    I$ = CHR$(0) + CHR$(72) ' up
                ELSE
                    I$ = CHR$(0) + CHR$(80) ' down
                END IF
                MouseWheel = 0
                EXIT DO
            END IF
        LOOP
        Var = False
        SELECT CASE LEN(I$)
            CASE 1
                SELECT CASE I$
                    CASE CHR$(27) ' exit
                        I$ = Nul
                        EXIT DO
                    CASE "|"
                        Xcoor = 2
                        Var = True
                    CASE "#"
                        Xcoor = 8
                        Var = True
                    CASE "<" ' Up
                        IF Xcoor - 1 >= 2 THEN
                            Xcoor = Xcoor - 1
                            Var = True
                        END IF
                    CASE ">" ' Down
                        IF Xcoor + 1 <= 8 THEN
                            Xcoor = Xcoor + 1
                            Var = True
                        END IF
                    CASE "1", "`", "~" ' left
                        IF Ycoor - 1 >= 1 THEN
                            Ycoor = Ycoor - 1
                            Var = True
                        END IF
                    CASE "2" TO "8" ' up/down
                        Xcoor = INT(VAL(I$))
                        Var = True
                    CASE "9", "0", "-", "=", "_", "+" ' right
                        IF Ycoor + 1 <= 39 THEN
                            Ycoor = Ycoor + 1
                            Var = True
                        END IF
                    CASE "!", "@", "#", "$", "%", "^", "&", "*", "(", ")" ' center box
                        Xcoor = 5
                        Ycoor = 20
                        Var = True
                END SELECT
            CASE 2
                VarQ = ASC(RIGHT$(I$, 1))
                SELECT CASE VarQ
                    CASE 59 ' F1
                        Xcoor = 2
                        Var = True
                    CASE 60 TO 66 ' F2 to F8
                        Xcoor = VarQ - 58
                        Var = True
                    CASE 67, 68 ' F9, F10
                        Xcoor = 8
                        Var = True
                    CASE 94 ' Ctrl-F1
                        Xcoor = 2
                        Var = True
                    CASE 95 TO 101 ' Ctrl-F2 to Ctrl-F8
                        Xcoor = VarQ - 93
                        Var = True
                    CASE 102, 103 ' Ctrl-F9, Ctrl-F10
                        Xcoor = 8
                        Var = True
                    CASE 104 ' Alt-F1
                        Xcoor = 2
                        Var = True
                    CASE 105 TO 111 ' Alt-F2 to Alt-F8
                        Xcoor = VarQ - 103
                        Var = True
                    CASE 112, 113 ' Alt-F9, Alt-F10
                        Xcoor = 8
                        Var = True
                    CASE 120 ' Alt-1
                        Xcoor = 2
                        Var = True
                    CASE 121 TO 127 ' Alt-2 to Alt-8
                        Xcoor = VarQ - 119
                        Var = True
                    CASE 128, 129 ' Alt-9, Alt-0
                        Xcoor = 8
                        Var = True
                    CASE 133, 134 ' F11, F12
                        Xcoor = 8
                        Var = True
                    CASE 137, 138 ' Ctrl-F11, Ctrl-F12
                        Xcoor = 8
                        Var = True
                    CASE 139, 140 ' Alt-F11, Alt-F12
                        Xcoor = 8
                        Var = True
                    CASE 152, 72, 142, 74, 130 ' Alt-Up/Up/Ctrl--/Alt--
                        IF Xcoor - 1 >= 2 THEN
                            Xcoor = Xcoor - 1
                            Var = True
                        END IF
                    CASE 160, 80, 144, 78, 131 ' Alt-Down/Down/Ctrl-+/Alt-+
                        IF Xcoor + 1 <= 8 THEN
                            Xcoor = Xcoor + 1
                            Var = True
                        END IF
                    CASE 75, 155 ' Left/Alt-Left
                        IF Ycoor - 1 >= 1 THEN
                            Ycoor = Ycoor - 1
                            Var = True
                        END IF
                    CASE 77, 157 ' Right/Alt-Right
                        IF Ycoor + 1 <= 39 THEN
                            Ycoor = Ycoor + 1
                            Var = True
                        END IF
                    CASE 71, 119, 132 ' Home/Ctrl-Home/Ctrl-PageUp = move to upper-left
                        Xcoor = 2
                        Ycoor = 1
                        Var = True
                    CASE 79, 117, 118 ' End/Ctrl-End/Ctrl-PageDown = move to lower-right
                        Xcoor = 8
                        Ycoor = 39
                        Var = True
                    CASE 73 ' PageUp = move to upper-right
                        Xcoor = 2
                        Ycoor = 39
                        Var = True
                    CASE 81 ' PageDown = move to lower-left
                        Xcoor = 8
                        Ycoor = 1
                        Var = True
                    CASE 115, 155 ' Ctrl-Left/Alt-Left = move to left-middle
                        Xcoor = 4
                        Ycoor = 1
                        Var = True
                    CASE 116, 157 ' Ctrl-Right/Alt-Right = move to right-middle
                        Xcoor = 4
                        Ycoor = 39
                        Var = True
                    CASE 141 ' Ctrl-Up = move to upper-middle
                        Xcoor = 2
                        Ycoor = 20
                        Var = True
                    CASE 145 ' Ctrl-Down = move to lower-middle
                        Xcoor = 8
                        Ycoor = 20
                        Var = True
                    CASE 76, 143 ' Keypad-5/Ctrl-Keypad-5 = center box
                        Xcoor = 5
                        Ycoor = 20
                        Var = True
                    CASE 74, 142 ' Alt-Keypad-/Ctrl-Keypad- = move to left-middle
                        Xcoor = 4
                        Ycoor = 1
                        Var = True
                    CASE 78, 144 ' Alt-Keypad+/Ctrl-Keypad+ = move to right-middle
                        Xcoor = 4
                        Ycoor = 39
                        Var = True
                END SELECT
        END SELECT
        IF Var THEN
            GOSUB RestoreArea
        END IF
    LOOP
    EXIT SUB

    ' store area.
    StoreArea:
    RowX1 = False
    ColumnY1 = False
    FOR RowX2 = Xcoor - 1 TO Xcoor + 16
        RowX1 = RowX1 + 1
        ColumnY1 = False
        FOR ColumnY2 = Ycoor TO Ycoor + 41
            ColumnY1 = ColumnY1 + 1
            ' store ascii character.
            Area1(RowX1, ColumnY1) = SCREEN(RowX2, ColumnY2)
            ' store color. (undocumented: also stores background color).
            Area2(RowX1, ColumnY1) = SCREEN(RowX2, ColumnY2, 1)
        NEXT
    NEXT
    RETURN

    ' restore area.
    RestoreArea:
    Colorf2 White, BackGround
    CLS
    RowX1 = False
    ColumnY1 = False
    FOR RowX2 = Xcoor - 1 TO Xcoor + 16
        RowX1 = RowX1 + 1
        ColumnY1 = False
        FOR ColumnY2 = Ycoor TO Ycoor + 41
            ColumnY1 = ColumnY1 + 1
            Locatef RowX2, ColumnY2, 1
            ' restore color.
            TempZ = Area2(RowX1, ColumnY1)
            ' undocumented: also stores background color.
            VarB = INT(TempZ / 16)
            VarF = TempZ MOD 16
            Colorf2 VarF, VarB
            ' restore ascii character.
            Printf CHR$(Area1(RowX1, ColumnY1))
        NEXT
    NEXT
    RETURN
END SUB

SUB OverridePrompt
    Locatef Xcoor + 1, Ycoor + 2, 1
    Printf SPACE$(38)
    Locatef Xcoor + 1, Ycoor + 2, 1
    Colorf2 White, 0
    Printf "Require readonly bit. Press <y/n>:"
    DO
        M$ = Nul
        WHILE M$ = Nul
            _LIMIT 100
            M$ = INKEY$
        WEND
        M$ = UCASE$(M$)
        IF M$ = "Y" THEN
            RequireReadOnly = True
            EXIT DO
        END IF
        IF M$ = "N" THEN
            RequireReadOnly = False
            EXIT DO
        END IF
    LOOP
    Locatef Xcoor + 1, Ycoor + 2, 1
    Printf SPACE$(38)
    Locatef Xcoor + 1, Ycoor + 2, 1
    Colorf2 White, 0
    Printf "Require hidden bit. Press <y/n>:"
    DO
        M$ = Nul
        WHILE M$ = Nul
            _LIMIT 100
            M$ = INKEY$
        WEND
        M$ = UCASE$(M$)
        IF M$ = "Y" THEN
            RequireHidden = True
            EXIT DO
        END IF
        IF M$ = "N" THEN
            RequireHidden = False
            EXIT DO
        END IF
    LOOP
    Locatef Xcoor + 1, Ycoor + 2, 1
    Printf SPACE$(38)
    Locatef Xcoor + 1, Ycoor + 2, 1
    Colorf2 White, 0
    Printf "Require system bit. Press <y/n>:"
    DO
        M$ = Nul
        WHILE M$ = Nul
            _LIMIT 100
            M$ = INKEY$
        WEND
        M$ = UCASE$(M$)
        IF M$ = "Y" THEN
            RequireSystem = True
            EXIT DO
        END IF
        IF M$ = "N" THEN
            RequireSystem = False
            EXIT DO
        END IF
    LOOP
    Locatef Xcoor + 1, Ycoor + 2, 1
    Printf SPACE$(38)
    Locatef Xcoor + 1, Ycoor + 2, 1
    Colorf2 White, 0
    Printf "Require archive bit. Press <y/n>:"
    DO
        M$ = Nul
        WHILE M$ = Nul
            _LIMIT 100
            M$ = INKEY$
        WEND
        M$ = UCASE$(M$)
        IF M$ = "Y" THEN
            RequireArchive = True
            EXIT DO
        END IF
        IF M$ = "N" THEN
            RequireArchive = False
            EXIT DO
        END IF
    LOOP
    Locatef Xcoor + 1, Ycoor + 2, 1
    Printf SPACE$(38)
    Locatef Xcoor + 1, Ycoor + 2, 1
    Colorf2 White, 0
    Printf "Require dir readonly bit. Press <y/n>:"
    DO
        M$ = Nul
        WHILE M$ = Nul
            _LIMIT 100
            M$ = INKEY$
        WEND
        M$ = UCASE$(M$)
        IF M$ = "Y" THEN
            RequireDirReadOnly = True
            EXIT DO
        END IF
        IF M$ = "N" THEN
            RequireDirReadOnly = False
            EXIT DO
        END IF
    LOOP
    Locatef Xcoor + 1, Ycoor + 2, 1
    Printf SPACE$(38)
    Locatef Xcoor + 1, Ycoor + 2, 1
    Colorf2 White, 0
    Printf "Require dir hidden bit. Press <y/n>:"
    DO
        M$ = Nul
        WHILE M$ = Nul
            _LIMIT 100
            M$ = INKEY$
        WEND
        M$ = UCASE$(M$)
        IF M$ = "Y" THEN
            RequireDirHidden = True
            EXIT DO
        END IF
        IF M$ = "N" THEN
            RequireDirHidden = False
            EXIT DO
        END IF
    LOOP
    Locatef Xcoor + 1, Ycoor + 2, 1
    Printf SPACE$(38)
    Locatef Xcoor + 1, Ycoor + 2, 1
    Colorf2 White, 0
    Printf "Require dir system bit. Press <y/n>:"
    DO
        M$ = Nul
        WHILE M$ = Nul
            _LIMIT 100
            M$ = INKEY$
        WEND
        M$ = UCASE$(M$)
        IF M$ = "Y" THEN
            RequireDirSystem = True
            EXIT DO
        END IF
        IF M$ = "N" THEN
            RequireDirSystem = False
            EXIT DO
        END IF
    LOOP
    Locatef Xcoor + 1, Ycoor + 2, 1
    Printf SPACE$(38)
    Locatef Xcoor + 1, Ycoor + 2, 1
    Colorf2 White, 0
    Printf "Require dir archive bit. Press <y/n>:"
    DO
        M$ = Nul
        WHILE M$ = Nul
            _LIMIT 100
            M$ = INKEY$
        WEND
        M$ = UCASE$(M$)
        IF M$ = "Y" THEN
            RequireDirArchive = True
            EXIT DO
        END IF
        IF M$ = "N" THEN
            RequireDirArchive = False
            EXIT DO
        END IF
    LOOP
END SUB

' routine compares occurrence of filename1$ in filename2$.
'  allows imbedded ? and * characters,
'  also compares ^ character exclusion.
SUB CheckExcluded (Filename1$, Filename2$, Match)
    Match = True ' assume mask matches filename2
    Length1 = 1
    Length2 = 1
    DO
        ' global replacement
        IF MID$(Filename1$, Length1, 1) = "*" THEN
            DO
                Length1 = Length1 + 1
                IF Length1 > LEN(Filename1$) THEN
                    EXIT SUB
                END IF
                ' global replacement followed by exclusion character
                ' searches remaining string until exclusion character found or not.
                IF MID$(Filename1$, Length1, 1) = "^" THEN
                    Length1 = Length1 + 1
                    Not.Include$ = MID$(Filename1$, Length1, 1)
                    DO
                        IF Not.Include$ <> MID$(Filename2$, Length2, 1) THEN
                            Length2 = Length2 + 1
                        ELSE
                            Match = False
                            EXIT SUB
                        END IF
                        IF Length2 > LEN(Filename2$) THEN
                            EXIT SUB
                        END IF
                    LOOP
                END IF
                ' global replacement followed by ? or another *
                ' skips to next character.
                IF MID$(Filename1$, Length1, 1) <> "*" THEN
                    IF MID$(Filename1$, Length1, 1) <> "?" THEN
                        EXIT DO
                    END IF
                END IF
            LOOP
            ' global replacement
            ' searches for next matching character
            DO
                IF MID$(Filename1$, Length1, 1) = MID$(Filename2$, Length2, 1) THEN
                    EXIT DO
                ELSE
                    Length2 = Length2 + 1
                END IF
                IF Length2 > LEN(Filename2$) THEN
                    EXIT DO
                END IF
            LOOP
        ELSE
            ' character replacement
            ' matches any next character
            IF MID$(Filename1$, Length1, 1) = "?" THEN
                Length1 = Length1 + 1
                Length2 = Length2 + 1
            ELSE
                ' exclusion character
                ' checks next character unmatched
                IF MID$(Filename1$, Length1, 1) = "^" THEN
                    Length1 = Length1 + 1
                    Not.Include$ = MID$(Filename1$, Length1, 1)
                    IF Not.Include$ <> MID$(Filename2$, Length2, 1) THEN
                        Length1 = Length1 + 1
                        Length2 = Length2 + 1
                    ELSE
                        Match = False
                        EXIT DO
                    END IF
                ELSE
                    ' matches next character
                    IF MID$(Filename1$, Length1, 1) = MID$(Filename2$, Length2, 1) THEN
                        Length1 = Length1 + 1
                        Length2 = Length2 + 1
                    ELSE
                        Match = False
                        EXIT DO
                    END IF
                    ' check string lengths
                    IF Length1 > LEN(Filename1$) THEN
                        IF Length2 <= LEN(Filename2$) THEN
                            Match = False
                        END IF
                        EXIT DO
                    END IF
                END IF
            END IF
        END IF
    LOOP
    EXIT SUB
END SUB

SUB Parse.Path (D$, X$)
    ' parse out imbedded \.\ path.
    GOSUB PathOverride1
    ' parse out trailing \.. path with multiple dots.
    GOSUB PathOverride2
    ' parse out leading ..\ path with multiple dots.
    GOSUB PathOverride3
    ' parse out leading \..\ path with multiple dots.
    GOSUB PathOverride4
    ' parse out imbedded \..\ path with multiple dots.
    GOSUB PathOverride5
    ' parse out imbedded \\ from path.
    GOSUB PathOverride6
    EXIT SUB

    ' parse out imbedded \.\ path.
    PathOverride1:
    IF LEN(X$) THEN
        DO
            V = INSTR(X$, "\.\")
            IF V THEN
                X$ = LEFT$(X$, V) + MID$(X$, V + 3)
            ELSE
                EXIT DO
            END IF
        LOOP
    END IF
    RETURN

    ' parse out trailing \.. path with multiple dots.
    PathOverride2:
    Z$ = Nul
    IF LEN(X$) THEN
        ' search for trailing path.
        DO
            Z = False
            L = False
            IF RIGHT$(X$, 1) = "." THEN
                FOR V = LEN(X$) TO 1 STEP -1
                    IF MID$(X$, V, 1) = "." THEN
                        L = L + 1
                    ELSE
                        IF MID$(X$, V, 1) = "\" THEN
                            Z = True
                            EXIT FOR
                        ELSE
                            EXIT FOR
                        END IF
                    END IF
                NEXT
            END IF
            IF Z = False THEN
                EXIT DO
            END IF
            Z$ = MID$(X$, V) + Z$
            X$ = LEFT$(X$, V - 1)
        LOOP
        IF Z$ = Nul THEN
            ' strip trailing dots.
            IF INSTR(X$, "\") THEN
                DO
                    IF RIGHT$(X$, 1) = "." THEN
                        X$ = LEFT$(X$, LEN(X$) - 1)
                    ELSE
                        EXIT DO
                    END IF
                LOOP
            END IF
            RETURN
        END IF
        DO
            ' search leading dots.
            L = False
            FOR V = 2 TO LEN(Z$)
                IF MID$(Z$, V, 1) = "." THEN
                    L = L + 1
                    IF V = LEN(Z$) THEN
                        Z$ = Nul
                        EXIT FOR
                    END IF
                ELSE
                    IF MID$(Z$, V, 1) = "\" THEN
                        Z$ = MID$(Z$, V)
                        EXIT FOR
                    END IF
                END IF
            NEXT
            ' strip trailing path.
            DO
                L2 = 1
                Z = False
                FOR V = LEN(X$) TO 1 STEP -1
                    IF MID$(X$, V, 1) = "\" THEN
                        L2 = L2 + 1
                        IF L = L2 THEN
                            Z = True
                            EXIT DO
                        END IF
                    END IF
                NEXT
                IF Z = False THEN
                    EXIT DO
                END IF
            LOOP
            IF Z = False THEN
                X$ = Nul
                EXIT DO
            END IF
            IF V = 1 THEN
                IF LEFT$(X$, 1) = "\" THEN
                    X$ = "\"
                    EXIT DO
                END IF
            END IF
            X$ = LEFT$(X$, V - 1)
            IF Z$ = Nul THEN
                EXIT DO
            END IF
        LOOP
    END IF
    ' strip trailing dots.
    IF INSTR(X$, "\") THEN
        DO
            IF RIGHT$(X$, 1) = "." THEN
                X$ = LEFT$(X$, LEN(X$) - 1)
            ELSE
                EXIT DO
            END IF
        LOOP
    END IF
    RETURN

    ' parse out leading ..\ path with multiple dots.
    PathOverride3:
    Z$ = D$
    DO
        ' search for leading dots.
        Z = False
        L = False
        IF LEFT$(X$, 1) = "." THEN
            FOR V = 1 TO LEN(X$)
                IF MID$(X$, V, 1) = "." THEN
                    L = L + 1
                ELSE
                    IF MID$(X$, V, 1) = "\" THEN
                        Z = True
                        EXIT FOR
                    ELSE
                        EXIT FOR
                    END IF
                END IF
            NEXT
        END IF
        IF Z = False THEN
            EXIT DO
        END IF
        X$ = MID$(X$, V + 1)
        ' parse off trailing path.
        IF L > 1 THEN
            L2 = 1
            DO
                Z = False
                FOR V = LEN(Z$) TO 1 STEP -1
                    IF MID$(Z$, V, 1) = "\" THEN
                        Z$ = LEFT$(Z$, V - 1)
                        L2 = L2 + 1
                        Z = True
                        EXIT FOR
                    END IF
                NEXT
                IF Z = False THEN
                    Z$ = Nul
                    EXIT DO
                END IF
                IF L2 = L THEN
                    EXIT DO
                END IF
            LOOP
        END IF
    LOOP
    D$ = Z$
    RETURN

    ' parse out leading \..\ path with multiple dots.
    PathOverride4:
    DO
        IF LEFT$(X$, 1) = "\" THEN
            IF LEN(X$) = 1 THEN
                EXIT DO
            END IF
            L = False
            FOR V = 2 TO LEN(X$)
                IF MID$(X$, V, 1) = "." THEN
                    L = L + 1
                ELSE
                    IF MID$(X$, V, 1) = "\" THEN
                        IF L > 0 THEN
                            X$ = MID$(X$, V)
                            EXIT FOR
                        END IF
                    END IF
                    EXIT DO
                END IF
            NEXT
        ELSE
            EXIT DO
        END IF
    LOOP
    RETURN

    ' parse out imbedded \..\ path with multiple dots.
    PathOverride5:
    IF LEN(X$) THEN
        DO
            ' search for \.\
            Z = False
            FOR V = 1 TO LEN(X$)
                IF MID$(X$, V, 1) = "\" THEN
                    L = False
                    FOR V2 = V + 1 TO LEN(X$)
                        IF MID$(X$, V2, 1) = "." THEN
                            L = L + 1
                        ELSE
                            IF MID$(X$, V2, 1) = "\" THEN
                                IF L > 0 THEN
                                    Z = True
                                END IF
                                EXIT FOR
                            ELSE
                                EXIT FOR
                            END IF
                        END IF
                    NEXT
                END IF
                IF Z = True THEN
                    EXIT FOR
                END IF
            NEXT
            IF Z = False THEN
                EXIT DO
            END IF
            Z$ = "\" + STRING$(L, ".") + "\"
            V4 = INSTR(X$, Z$)
            A$ = MID$(X$, V4 + L + 2)
            L2 = 1
            DO
                V4 = V4 - 1
                IF V4 = False THEN
                    EXIT DO
                END IF
                IF MID$(X$, V4, 1) = "\" THEN
                    L2 = L2 + 1
                    IF L2 = L THEN
                        EXIT DO
                    END IF
                END IF
            LOOP
            IF V4 = False THEN
                X$ = A$
            ELSE
                X$ = LEFT$(X$, V4) + A$
            END IF
        LOOP
    END IF

    ' search for imbedded ..\
    DO
        V = INSTR(X$, ".\")
        IF V THEN
            L = False
            FOR V2 = V TO 1 STEP -1
                IF MID$(X$, V2, 1) = "." THEN
                    L = L + 1
                ELSE
                    X$ = LEFT$(X$, V2) + MID$(X$, V + 1)
                    EXIT FOR
                END IF
            NEXT
        ELSE
            EXIT DO
        END IF
    LOOP
    RETURN

    ' strip imbedded \\ from path.
    PathOverride6:
    DO
        V = INSTR(X$, "\\")
        IF V THEN
            X$ = LEFT$(X$, V - 1) + MID$(X$, V + 1)
        ELSE
            EXIT DO
        END IF
    LOOP
    RETURN
END SUB

' strip multiple dots from path.
SUB Parse.Path2 (D$, X$)
    DO
        IF LEFT$(X$, 2) = ".." THEN
            Z = False
            FOR Var = LEN(D$) TO 1 STEP -1
                IF MID$(D$, Var, 1) = "\" THEN
                    D$ = LEFT$(D$, Var - 1)
                    X$ = MID$(X$, 2)
                    Z = True
                    EXIT FOR
                END IF
            NEXT
            IF Z = False THEN
                D$ = Nul
                X$ = Nul
                EXIT DO
            END IF
        ELSE
            X$ = Nul
            EXIT DO
        END IF
    LOOP
END SUB

' Custom line input function.
' Input:
'    XC = X-coordinate
'    YC = Y-coordinate
'    LC = Edit area length
FUNCTION LineInput$ (XC, YC, LC)
    ' init entry area position.
    Xposition1 = 1
    Xposition2 = 0

    ' display edit entry area.
    Insert = -1
    GOSUB DisplayFileLine

    ' main input loop.
    DO
        ' get keypress.
        _LIMIT 100
        I$ = INKEY$

        ' check key.
        IF LEN(I$) = 1 THEN

            ' enter key.
            IF I$ = CHR$(13) THEN
                LineInput$ = X$
                EXIT DO
            END IF

            ' escape key.
            IF I$ = CHR$(27) THEN
                LineInput$ = Nul
                EXIT DO
            END IF

            ' backspace.
            IF I$ = CHR$(8) THEN
                IF LEN(X$) THEN
                    IF Xposition2 > 0 THEN
                        IF Insert THEN ' destructive backspace
                            X$ = LEFT$(X$, Xposition2 - 1) + MID$(X$, Xposition2 + 1)
                        END IF
                        Xposition2 = Xposition2 - 1
                        IF Xposition2 - LC <= Xposition1 THEN
                            Xposition1 = Xposition1 - 1
                            IF Xposition1 < 1 THEN
                                Xposition1 = 1
                            END IF
                        END IF
                        GOSUB DisplayFileLine
                    END IF
                END IF
            ELSE
                ' append/insert character into edit area.
                OK = -1
                IF ASC(I$) >= 0 AND ASC(I$) <= 31 THEN
                    OK = 0 ' disallow control charcters
                END IF
                IF OK THEN
                    IF Insert THEN
                        X$ = LEFT$(X$, Xposition2) + I$ + MID$(X$, Xposition2 + 1)
                        Xposition2 = Xposition2 + 1
                        IF Xposition2 > LC THEN
                            Xposition1 = Xposition1 + 1
                        END IF
                    ELSE
                        IF Xposition2 + 1 > LEN(X$) THEN
                            X$ = X$ + I$ ' append
                            Xposition2 = Xposition2 + 1
                            IF Xposition2 > LC THEN
                                Xposition1 = Xposition1 + 1
                            END IF
                        ELSE ' insert
                            MID$(X$, Xposition2 + 1, 1) = I$
                            Xposition2 = Xposition2 + 1
                        END IF
                    END IF
                    GOSUB DisplayFileLine
                END IF
            END IF
        END IF

        ' check extended key
        IF LEN(I$) = 2 THEN
            SELECT CASE ASC(RIGHT$(I$, 1))
                CASE 82 ' Insert
                    Insert = NOT Insert
                    IF Insert THEN
                        LOCATE , , 1, 8, 8 ' block cursor
                    ELSE
                        LOCATE , , 1, 0, 8 ' line cursor
                    END IF
                CASE 83 ' Delete
                    IF LEN(X$) > 0 THEN
                        X$ = LEFT$(X$, Xposition2) + MID$(X$, Xposition2 + 2)
                        GOSUB DisplayFileLine
                    END IF
                CASE 71, 73, 119 ' Home/PageUp/Ctrl-Home
                    IF Xposition2 > 0 THEN
                        Xposition1 = 1
                        Xposition2 = 0
                        GOSUB DisplayFileLine
                    END IF
                CASE 79, 81, 117 ' End/PageDown/Ctrl-End
                    IF Xposition2 < LEN(X$) THEN
                        Xposition2 = LEN(X$)
                        Xposition1 = Xposition2 - LC + 1
                        IF Xposition1 < 1 THEN
                            Xposition1 = 1
                        END IF
                        GOSUB DisplayFileLine
                    END IF
                CASE 75, 115, 155 ' Left/Ctrl-Left/Alt-Left
                    IF LEN(X$) THEN
                        IF Xposition2 > 0 THEN
                            Xposition2 = Xposition2 - 1
                            IF Xposition2 - LC <= Xposition1 THEN
                                Xposition1 = Xposition1 - 1
                                IF Xposition1 < 1 THEN
                                    Xposition1 = 1
                                END IF
                                GOSUB DisplayFileLine
                            END IF
                        END IF
                    END IF
                CASE 77, 116, 157 ' Right/Ctrl-Right/Alt-Right
                    IF LEN(X$) THEN
                        IF Xposition2 < LEN(X$) THEN
                            Xposition2 = Xposition2 + 1
                            IF Xposition2 > Xposition1 + LC - 1 THEN
                                Xposition1 = Xposition1 + 1
                            END IF
                            GOSUB DisplayFileLine
                        END IF
                    END IF
            END SELECT
        END IF
    LOOP
    LOCATE , , 1, 8, 8
    EXIT FUNCTION

    ' display current entry area.
    DisplayFileLine:
    Locatef XC, YC, 1
    Printf SPACE$(LC)
    ' display edit line and position cursor.
    Locatef XC, YC, 1
    IF LEN(X$) THEN
        Colorf White
        Printf MID$(X$, Xposition1, LC)
    END IF
    Locatef XC, YC + Xposition2 - Xposition1 + 1, 1
    Colorf2 Plain, 0
    RETURN
END FUNCTION

' load current directories.
SUB LoadDirSpec (DirY$, N$, C$, D$)
    IF RequireDirReadOnly OR RequireDirHidden OR RequireDirSystem OR RequireDirArchive THEN
        Required = True
    ELSE
        Required = False
    END IF
    Colorf White
    Locatef Xcoor + 1, Ycoor + 12, 1
    Printf SPACE$(26)
    Locatef Xcoor + 1, Ycoor + 12, 1
    Printf DirLoadMessage
    Colorf Plain

    ' reset directory counter.
    IF D$ = "" OR D$ = "\" THEN
        Num.Dirs = 0
    ELSE
        Num.Dirs = 1
        WinFileStruc.Name = ".."
        PUT #3, 1, WinFileStruc
    END IF

    ' find directories.
    F$ = MakeFilename3$(N$, C$, D$)
    F$ = F$ + CHR$(0)
    hfind = FindFirstFileA(_OFFSET(F$), _OFFSET(finddata))
    IF hfind <> INVALID_HANDLE_VALUE THEN
        DO
            X$ = finddata.cFileName
            VarX = INSTR(X$, CHR$(0))
            IF VarX THEN
                X$ = LEFT$(X$, VarX - 1)
            END IF

            IF INSTR(X$, "?") THEN ' unicode
                X$ = finddata.cAlternateFileName
                VarX = INSTR(X$, CHR$(0))
                IF VarX THEN
                    X$ = LEFT$(X$, VarX - 1)
                END IF
            END IF

            IF LEN(X$) THEN
                Attr = finddata.dwFileAttributes
                IF (Attr AND &H10) = &H10 THEN
                    IF X$ = "." OR X$ = ".." THEN
                        Eat$ = Nul
                    ELSE
                        ' check file counter.
                        IF Num.Dirs >= MaxPrecision THEN
                            EXIT DO
                        END IF

                        ' reset file flag.
                        Flag = True
                        IF Required THEN
                            GOSUB Check.Required1
                        END IF

                        ' check flag.
                        IF Flag THEN
                            ' check excluded list.
                            IF LEN(DirY$) THEN
                                GOSUB Check.List1
                            END IF
                            IF Flag THEN
                                ' store directory.
                                Num.Dirs = Num.Dirs + 1!
                                WinFileStruc.Name = X$
                                PUT #3, Num.Dirs, WinFileStruc
                            END IF
                        END IF
                    END IF
                END IF
            END IF
        LOOP WHILE FindNextFileA(hfind, _OFFSET(finddata))
        x = FindClose(hfind)
    END IF

    ' display number of directories.
    Locatef Xcoor + 3, Ycoor + 24, 0
    Printf SPACE$(8)
    Locatef Xcoor + 3, Ycoor + 24, 0
    Colorf White

    ' format display
    Var# = CDBL(Num.Dirs)
    IF Var# > 32767# THEN
        Var# = INT(Var# / 1024#)
    END IF
    Value$ = FormatX$(Var#, 0)
    IF Num.Dirs > 32767! THEN
        Value$ = Value$ + "K"
    END IF
    Printf Value$
    Colorf Plain

    ' sort directories.
    IF HeapSortOff THEN
        EXIT SUB
    END IF
    IF Num.Dirs < 2 THEN
        EXIT SUB
    END IF
    IF SortMax2 > 0! THEN
        IF Num.Dirs >= SortMax2 THEN
            Locatef Xcoor + 1, Ycoor + 2, 1
            Printf SPACE$(38)
            Locatef Xcoor + 1, Ycoor + 2, 1
            Colorf2 White, 0
            Var! = INT(SortMax2 / 1024!)
            Printf "Dirs exceed" + STR$(Var!) + "K. Sort anyway<y/n>:"
            DO
                M$ = Nul
                WHILE M$ = Nul
                    _LIMIT 100
                    M$ = INKEY$
                WEND
                IF M$ = CHR$(27) THEN
                    GOSUB FileDisplay
                    EXIT SUB
                END IF
                M$ = UCASE$(M$)
                IF M$ = "Y" THEN
                    GOSUB FileDisplay
                    EXIT DO
                END IF
                IF M$ = "N" THEN
                    GOSUB FileDisplay
                    EXIT SUB
                END IF
            LOOP
        END IF
    END IF
    Colorf White
    Locatef Xcoor + 1, Ycoor + 12, 1
    Printf SPACE$(26)
    Locatef Xcoor + 1, Ycoor + 12, 1
    Printf "Sorting dirs.."
    Colorf Plain
    CALL SortFiles(2)
    EXIT SUB

    ' display filename
    FileDisplay:
    Locatef Xcoor + 1, Ycoor + 2, 1
    Printf "Filename: "
    RETURN

    ' check dir exclusion list.
    Check.List1:
    Y2$ = UCASE$(DirY$)
    L1$ = UCASE$(X$)
    DO
        ' parse list.
        Y1 = INSTR(Y2$, " ")
        IF Y1 THEN
            Y1$ = LEFT$(Y2$, Y1 - 1)
            Y2$ = MID$(Y2$, Y1 + 1)
        ELSE
            Y1$ = Y2$
            Y2$ = Nul
        END IF
        Y1$ = LTRIM$(Y1$)
        Y1$ = RTRIM$(Y1$)
        Y2$ = LTRIM$(Y2$)
        Y2$ = RTRIM$(Y2$)
        ' check excluded file in filename.
        IF LEN(Y1$) THEN
            CALL CheckExcluded(Y1$, L1$, Exclude.File%)
            IF Exclude.File% THEN
                Flag = False
                EXIT DO
            END IF
        END IF
        IF Y2$ = Nul THEN
            EXIT DO
        END IF
    LOOP
    RETURN

    ' check requirements.
    Check.Required1:
    IF RequireDirReadOnly THEN
        IF (Attr AND 1) = 0 THEN
            Flag = False
        END IF
    END IF
    IF RequireDirHidden THEN
        IF (Attr AND 2) = 0 THEN
            Flag = False
        END IF
    END IF
    IF RequireDirSystem THEN
        IF (Attr AND 4) = 0 THEN
            Flag = False
        END IF
    END IF
    IF RequireDirArchive THEN
        IF (Attr AND 32) = 0 THEN
            Flag = False
        END IF
    END IF
    RETURN
END SUB

' load specified files.
SUB LoadFileSpec (FileY$, F$)
    IF RequireReadOnly OR RequireHidden OR RequireSystem OR RequireArchive THEN
        Required = True
    ELSE
        Required = False
    END IF
    Colorf White
    Locatef Xcoor + 1, Ycoor + 12, 1
    Printf SPACE$(26)
    Locatef Xcoor + 1, Ycoor + 12, 1
    Printf FileLoadMessage
    Colorf Plain
    Num.Files = False

    ' find files.
    IF RIGHT$(F$, 1) = "\" THEN
        F$ = F$ + "*.*"
    END IF
    F$ = F$ + CHR$(0)
    hfind = FindFirstFileA(_OFFSET(F$), _OFFSET(finddata))
    IF hfind <> INVALID_HANDLE_VALUE THEN
        DO
            X$ = finddata.cFileName
            VarX = INSTR(X$, CHR$(0))
            IF VarX THEN
                X$ = LEFT$(X$, VarX - 1)
            END IF

            IF INSTR(X$, "?") THEN ' unicode
                X$ = finddata.cAlternateFileName
                VarX = INSTR(X$, CHR$(0))
                IF VarX THEN
                    X$ = LEFT$(X$, VarX - 1)
                END IF
            END IF

            IF LEN(X$) THEN
                Attr = finddata.dwFileAttributes
                IF (Attr AND &H10) = &H0 THEN
                    ' check file counter.
                    IF Num.Files >= MaxPrecision THEN
                        EXIT DO
                    END IF

                    ' reset file flag.
                    Flag = True
                    IF Required THEN
                        GOSUB Check.Required2
                    END IF

                    ' check flag.
                    IF Flag THEN
                        ' check excluded list.
                        IF LEN(FileY$) THEN
                            GOSUB Check.List2
                        END IF

                        ' check flag.
                        IF Flag THEN
                            ' store filename.
                            Num.Files = Num.Files + 1!
                            WinFileStruc.Name = X$
                            PUT #2, Num.Files, WinFileStruc
                        END IF
                    END IF
                END IF
            END IF
        LOOP WHILE FindNextFileA(hfind, _OFFSET(finddata))
        x = FindClose(hfind)
    END IF

    ' display number of files.
    Locatef Xcoor + 3, Ycoor + 9, 0
    Printf SPACE$(9)
    Locatef Xcoor + 3, Ycoor + 9, 0
    Colorf White

    ' format display
    Var# = CDBL(Num.Files)
    IF Var# > 32767# THEN
        Var# = INT(Var# / 1024#)
    END IF
    Value$ = FormatX$(Var#, 0)
    IF Num.Files > 32767! THEN
        Value$ = Value$ + "K"
    END IF
    Printf Value$
    Colorf Plain

    ' sort files.
    IF HeapSortOff THEN
        EXIT SUB
    END IF
    IF Num.Files < 2 THEN
        EXIT SUB
    END IF
    IF SortMax > 0! THEN
        IF Num.Files >= SortMax THEN
            Locatef Xcoor + 1, Ycoor + 2, 1
            Printf SPACE$(38)
            Locatef Xcoor + 1, Ycoor + 2, 1
            Colorf2 White, 0
            Var! = INT(SortMax / 1024!)
            Printf "Files exceed" + STR$(Var!) + "K. Sort anyway<y/n>:"
            DO
                M$ = Nul
                WHILE M$ = Nul
                    _LIMIT 100
                    M$ = INKEY$
                WEND
                IF M$ = CHR$(27) THEN
                    GOSUB FileDisplay2
                    EXIT SUB
                END IF
                M$ = UCASE$(M$)
                IF M$ = "Y" THEN
                    GOSUB FileDisplay2
                    EXIT DO
                END IF
                IF M$ = "N" THEN
                    GOSUB FileDisplay2
                    EXIT SUB
                END IF
            LOOP
        END IF
    END IF
    Colorf White
    Locatef Xcoor + 1, Ycoor + 12, 1
    Printf SPACE$(26)
    Locatef Xcoor + 1, Ycoor + 12, 1
    Printf "Sorting files.."
    Colorf Plain
    CALL SortFiles(1)
    EXIT SUB

    ' display filename
    FileDisplay2:
    Locatef Xcoor + 1, Ycoor + 2, 1
    Printf "Filename: "
    RETURN

    ' check file exclusion list.
    Check.List2:
    Y2$ = UCASE$(FileY$)
    L1$ = UCASE$(X$)
    DO
        ' parse list.
        Y1 = INSTR(Y2$, " ")
        IF Y1 THEN
            Y1$ = LEFT$(Y2$, Y1 - 1)
            Y2$ = MID$(Y2$, Y1 + 1)
        ELSE
            Y1$ = Y2$
            Y2$ = Nul
        END IF
        Y1$ = LTRIM$(Y1$)
        Y1$ = RTRIM$(Y1$)
        Y2$ = LTRIM$(Y2$)
        Y2$ = RTRIM$(Y2$)
        ' check excluded file in filename.
        IF LEN(Y1$) THEN
            CALL CheckExcluded(Y1$, L1$, Exclude.File%)
            IF Exclude.File% THEN
                Flag = False
                EXIT DO
            END IF
        END IF
        IF Y2$ = Nul THEN
            EXIT DO
        END IF
    LOOP
    RETURN

    ' check requirements.
    Check.Required2:
    IF RequireReadOnly THEN
        IF (Attr AND 1) = 0 THEN
            Flag = False
        END IF
    END IF
    IF RequireHidden THEN
        IF (Attr AND 2) = 0 THEN
            Flag = False
        END IF
    END IF
    IF RequireSystem THEN
        IF (Attr AND 4) = 0 THEN
            Flag = False
        END IF
    END IF
    IF RequireArchive THEN
        IF (Attr AND 32) = 0 THEN
            Flag = False
        END IF
    END IF
    RETURN
END SUB

' subroutine to access subdirectories
SUB Silentdel_Directories (Directory.Search$)
    ' declare subroutine variables
    DIM Attribute AS INTEGER
    DIM TempASCIIZ AS STRING * 260
    DIM finddata2 AS WIN32_FIND_DATA
    DIM Wfile.Handle AS _UNSIGNED _OFFSET

    ' make directory filename
    TempASCIIZ = Directory.Search$ + "*.*" + CHR$(0)

    ' start directory search
    Wfile.Handle = FindFirstFileA(_OFFSET(TempASCIIZ), _OFFSET(finddata2))
    IF Wfile.Handle <> INVALID_HANDLE_VALUE THEN

        ' delete filenames
        CALL Silentdel_DeleteFiles(Directory.Search$)

        ' recurse subdirectories
        DO
            ' check directory attribute
            Attribute = finddata2.dwFileAttributes

            ' check directory
            IF (Attribute AND &H10) = &H10 THEN

                ' store directory name
                Directory$ = finddata2.cFileName
                Directory$ = LEFT$(Directory$, INSTR(Directory$, CHR$(0)) - 1)

                ' check directory name
                IF Directory$ <> "." AND Directory$ <> ".." THEN

                    ' store short filename
                    IF INSTR(Directory$, "?") THEN
                        Directory$ = finddata2.cAlternateFileName
                        V = INSTR(Directory$, CHR$(0))
                        IF V THEN Directory$ = LEFT$(Directory$, V - 1)
                    END IF

                    ' make next search directory
                    IF LEN(Directory$) THEN
                        ' make next search directory
                        Next.Directory$ = Directory.Search$ + Directory$ + "\"

                        ' recursively search subdirectories
                        CALL Silentdel_Directories(Next.Directory$)
                    END IF
                END IF
            END IF
        LOOP WHILE FindNextFileA(Wfile.Handle, _OFFSET(finddata2))
        x = FindClose(Wfile.Handle)
    END IF

    ' delete directory
    CALL Silentdel_DeleteDirectory(Directory.Search$)
END SUB

' subroutine to delete an empty directory
SUB Silentdel_DeleteDirectory (Directory$)
    ' declare subroutine variables
    DIM TempASCIIZ AS STRING * 260

    ' store directory filename
    TempASCIIZ = Directory$ + CHR$(0)

    ' change directory attribute
    AttrX = GetFileAttributes(TempASCIIZ)
    AttrX = AttrX AND NOT &H1 ' remove read-only bit
    x = SetFileAttributes&(TempASCIIZ, AttrX)

    ' delete directory
    x = RemoveDirectoryA(TempASCIIZ)
END SUB

' subroutine to delete files in a directory
SUB Silentdel_DeleteFiles (Directory$)
    ' declare subroutine variables
    DIM Attribute AS INTEGER
    DIM TempASCIIZ AS STRING * 260
    DIM TempASCIIZ2 AS STRING * 260
    DIM finddata2 AS WIN32_FIND_DATA
    DIM Wfile.Handle AS _UNSIGNED _OFFSET

    ' make filename
    TempASCIIZ = Directory$ + "*.*" + CHR$(0)

    Wfile.Handle = FindFirstFileA(_OFFSET(TempASCIIZ), _OFFSET(finddata2))
    IF Wfile.Handle <> INVALID_HANDLE_VALUE THEN

        ' filename loop
        DO
            ' store filename
            Filename$ = finddata2.cFileName
            Filename$ = LEFT$(Filename$, INSTR(Filename$, CHR$(0)) - 1)

            ' check filename
            IF Filename$ <> "." AND Filename$ <> ".." THEN
                ' store filename
                TempASCIIZ2 = Directory$ + Filename$ + CHR$(0)

                ' change filename attribute
                AttrX = GetFileAttributes(TempASCIIZ2)
                AttrX = AttrX AND NOT &H1 ' remove read-only bit
                x = SetFileAttributes&(TempASCIIZ2, AttrX)

                ' delete long filename
                x = DeleteFileA(TempASCIIZ2)

                ' check error and delete 8.3 filename
                IF x = 0 THEN
                    Short.Filename$ = finddata2.cAlternateFileName
                    V = INSTR(Short.Filename$, CHR$(0))
                    IF V THEN Short.Filename$ = LEFT$(Short.Filename$, V - 1)
                    TempASCIIZ2 = Directory$ + Short.Filename$ + CHR$(0)

                    ' change filename attribute
                    AttrX = GetFileAttributes(TempASCIIZ2)
                    AttrX = AttrX AND NOT &H1
                    x = SetFileAttributes&(TempASCIIZ2, AttrX)

                    ' delete short filename
                    x = DeleteFileA(TempASCIIZ2)
                END IF
            END IF
        LOOP WHILE FindNextFileA(Wfile.Handle, _OFFSET(finddata2))
        x = FindClose(Wfile.Handle)
    END IF
END SUB

REM File menu box routine:

SUB Menu (N$, C$, D$, X$, E$)

    REM Call to Menu() Returns:
    REM   N$  -  Network path
    REM       \\server\share
    REM       Without trailing slash
    REM         Or Nul for no net
    REM   C$  -  Drive letter
    REM       Normally C without : or \
    REM   D$  -  Directory
    REM       Without leading or trailing \ (can be null)
    REM       Can be long pathname. No trailing spaces.
    REM   X$  -  Filespec
    REM       Normally *.*
    REM   E$  -  Filename.ext
    REM       Can be long filename. No trailing spaces.
    REM
    REM Concatenate upon return:
    REM   IF N$ = Nul THEN
    REM      IF D$ = Nul THEN
    REM         Filename = C$ + ":\" + E$
    REM      ELSE
    REM         Filename = C$ + ":\" + D$ + "\" + E$
    REM      END IF
    REM   ELSE
    REM      IF D$ = Nul THEN
    REM         Filename = N$ + "\" + E$
    REM      ELSE
    REM         Filename = N$ + "\" + D$ + "\" + E$
    REM      END IF
    REM   END IF
    REM
    REM Although netpath may be specified as c:\\server\share\dir1\filename.ext
    REM this box does not fully support mixed drive letter and netpath.
    REM
    REM During editing,
    REM   I$  -  Current keystroke.
    REM   F$  -  Fully qualified pathname with filename and drive letter.
    REM   Q$  -  Current subdirectory.
    REM   D1$ -  Temporary directory storage.
    REM   X1$ -  Temporary file entry area path/file.
    REM   X2$ -  Temporary filename storage.
    REM   G$  -  Pathname constructed for KILL, MKDIR, RMDIR.
    REM
    REM Mouse variables,
    REM   IsMenu =
    REM     1  -  Click in file box.
    REM     2  -  Click in dir box.
    REM     3  -  Click in drive box.
    REM     4  -  Click in entry area.
    REM     5  -  Click on 'x' to exit.
    _TITLE "HEXEDIT"

    ' reset flags.
    Ambiguate = AmbiguateSwitch
    FileSort = False
    DirSort = False

    ' open structure files.
    CALL OpenDataFiles1

    ' display menu screen.
    CALL FileMainMenu

    ' initialize drives.
    Current.Drive = False
    GOSUB InitDrive

    ' get current filespec.
    GOSUB InitFileSpec

    ' get current directory spec.
    GOSUB InitDirSpec

    ' read all filenames.
    GOSUB ClearFileBox
    FileLoadMessage = "Initing files.."
    CALL LoadFileSpec(FileY$, F$)
    GOSUB DisplayFileSpec
    GOSUB DisplayCurrentPath

    ' read all subdirectories.
    GOSUB ClearDirBox
    DirLoadMessage = "Initing dirs.."
    CALL LoadDirSpec(DirY$, N$, C$, D$)
    GOSUB DisplayDirSpec
    GOSUB DisplayCurrentDir
    GOSUB DisplayCurrentPath

    ' display first directory.
    Current.Dir! = 1!
    Dir.Box.Line = 1
    GOSUB DisplayInitDir

    ' display all drives.
    GOSUB InitDrives

    ' display first file.
    GOSUB ClearLongName2
    IF Num.Files > 0 THEN
        Current.File! = 1!
        Box.Line = 1
        GOSUB InitFiles
    END IF

    ' reset filename attribute overrides.
    RequireReadOnly = False
    RequireHidden = False
    RequireSystem = False
    RequireArchive = False
    RequireDirReadOnly = False
    RequireDirHidden = False
    RequireDirSystem = False
    RequireDirArchive = False

    REM File entry area variables:
    REM   ProcessEditLine - processes X$ edit line when set to True.
    REM   Xstart     - hilights file entry area for overstrike when set to True.
    REM   Xposition1 - left position in file entry area editing string.
    REM   Xposition2 - position of character in file entry area editing string.
    REM

    REM main input loop..

    Xstart = True
    Xposition1 = 1
    DO
        ' reset filespec.
        IF X$ = Nul THEN
            X$ = "*.*"
            Xposition1 = 1
            Xposition2 = 3
        END IF

        ' display file entry area.
        GOSUB DisplayFileLine

        ' start input loop.
        DO
            ' reset input.
            I$ = Nul

            ' reset edit line.
            ProcessEditLine = False

            ' process input.
            DO
                ' get keypress.
                _LIMIT 100
                I$ = INKEY$

                ' process keypress.
                IF LEN(I$) THEN
                    IsMenu = False
                    EXIT DO
                END IF

                ' call mouse subroutine.
                Z = MouseDriver

                ' check exit symbol.
                IF IsMenu = 5 THEN
                    I$ = CHR$(27)
                    EXIT DO
                END IF

                ' check mouse wheel down
                IF MouseWheel = -1 THEN
                    MouseWheel = 0
                    IF WheelReverse THEN
                        I$ = CHR$(9) ' down
                        GOTO TabFile
                    END IF
                END IF
                IF MouseWheel = 1 THEN
                    MouseWheel = 0
                    IF WheelReverse = 0 THEN
                        I$ = CHR$(9) ' down
                        GOTO TabFile
                    END IF
                END IF

                ' check left mouse button.
                IF MouseButton1 THEN
                    GOSUB MouseButton1Z
                    SELECT CASE IsMenu
                        CASE 1 ' file box.
                            IF I$ = CHR$(13) THEN
                                E$ = RTRIM$(Filenames(Current.File!))
                                GOTO EndLoop2
                            ELSE
                                GOSUB FileBoxKey
                            END IF
                        CASE 2 ' dir box.
                            IF I$ = CHR$(13) THEN
                                GOSUB GetNewPath
                                EXIT DO
                            ELSE
                                GOSUB DirBoxKey
                            END IF
                        CASE 3 ' drive box.
                            IF I$ = CHR$(13) THEN
                                X$ = CHR$(Current.Drive + 64) + ":\*.*"
                                ProcessEditLine = True
                                EXIT DO
                            ELSE
                                GOSUB DriveBoxKey
                            END IF
                    END SELECT
                ELSE
                    ' check mouse position.
                    IF MouseX OR MouseY THEN
                        GOSUB MouseOverX1
                        GOSUB DisplayFileLine
                    END IF
                END IF
            LOOP

            ' ignore slash
            IF I$ = "/" THEN
                I$ = Nul
            END IF

            StartLoop0:

            ' check alt-<key>
            IF LEN(I$) = 2 THEN
                GOSUB GetAltKey
                IF VarZ THEN
                    ' specify drive letter.
                    X$ = CHR$(Var2 + 64) + ":\*.*"
                    I$ = Nul
                    ProcessEditLine = True
                    EXIT DO
                END IF
            END IF

            StartLoop1:

            ' check extended key
            IF LEN(I$) = 2 THEN
                SELECT CASE ASC(RIGHT$(I$, 1))
                    CASE 71, 119 ' Home/Ctrl-Home
                        IF Xposition2 > 0 THEN
                            Xstart = False
                            Xposition1 = 1
                            Xposition2 = 0
                            GOSUB DisplayFileLine
                        END IF
                    CASE 80, 145, 160 ' Down/Ctrl-Down/Alt-Down
                        I$ = CHR$(9)
                        GOTO TabFile
                    CASE 79, 117 ' End/Ctrl-End
                        IF Xposition2 < LEN(X$) THEN
                            Xstart = False
                            Xposition2 = LEN(X$)
                            Xposition1 = Xposition2 - 25
                            IF Xposition1 < 1 THEN
                                Xposition1 = 1
                            END IF
                            GOSUB DisplayFileLine
                        END IF
                    CASE 83 ' Delete
                        IF LEN(X$) > 0 THEN
                            Xstart = False
                            X$ = LEFT$(X$, Xposition2) + MID$(X$, Xposition2 + 2)
                            GOSUB DisplayFileLine
                        END IF
                    CASE 75, 115, 155 ' Left/Ctrl-Left/Alt-Left
                        IF LEN(X$) THEN
                            IF Xposition2 > 0 THEN
                                Xposition2 = Xposition2 - 1
                                IF Xposition2 - 25 <= Xposition1 THEN
                                    Xposition1 = Xposition1 - 1
                                    IF Xposition1 < 1 THEN
                                        Xposition1 = 1
                                    END IF
                                    GOSUB DisplayFileLine
                                END IF
                            END IF
                        END IF
                    CASE 77, 116, 157 ' Right/Ctrl-Right/Alt-Right
                        IF LEN(X$) THEN
                            IF Xposition2 < LEN(X$) THEN
                                Xposition2 = Xposition2 + 1
                                IF Xposition2 > Xposition1 + 25 THEN
                                    Xposition1 = Xposition1 + 1
                                END IF
                                GOSUB DisplayFileLine
                            END IF
                        END IF
                    CASE 59 ' F1  - change drive letter.
                        I$ = Nul
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Printf SPACE$(38)
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Colorf2 Yellow, 0
                        Printf "Drive letter: "
                        DO
                            _LIMIT 100
                            Z$ = INKEY$
                            IF LEN(Z$) = 1 THEN
                                Z$ = UCASE$(Z$)
                                IF Z$ >= "A" AND Z$ <= "Z" THEN
                                    EXIT DO
                                END IF
                            END IF
                        LOOP
                        GOSUB DisplayFilename6
                        I$ = Nul
                        X$ = Z$ + ":\*.*"
                        ProcessEditLine = True
                        EXIT DO
                    CASE 60 ' F2  - toggle heap sorting.
                        I$ = Nul
                        HeapSortOff = NOT HeapSortOff
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Printf SPACE$(38)
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Colorf2 White, 0
                        IF HeapSortOff THEN
                            Printf "Sorting Off. Press <esc>:"
                        ELSE
                            Printf "Sorting On. Press <esc>:"
                        END IF
                        CALL PromptInkey
                        GOSUB UpdateDisplay
                        EXIT DO
                    CASE 61 ' F3 - move file menu box.
                        I$ = Nul
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Printf SPACE$(38)
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Colorf2 White, 0
                        Printf "Use cursor keys. Press <esc> to quit."
                        CALL MoveMenu
                        CALL BottomRow
                        GOSUB DisplayCurrentPath
                        IF Num.Files > 0 THEN
                            GOSUB DisplayLongName2
                        END IF
                        GOSUB DisplayFilename6
                        GOSUB DisplayFileLine
                    CASE 62 ' F4 - backward 1 drive letter.
                        I$ = Nul
                        GOSUB MoveDriveUp
                        X$ = CHR$(Current.Drive + 64) + ":\*.*"
                        ProcessEditLine = True
                        EXIT DO
                    CASE 63 ' F5 - forward 1 drive letter.
                        I$ = Nul
                        GOSUB MoveDriveDown
                        X$ = CHR$(Current.Drive + 64) + ":\*.*"
                        ProcessEditLine = True
                        EXIT DO
                    CASE 64 ' F6 - toggle ambiguate.
                        I$ = Nul
                        Ambiguate = NOT Ambiguate
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Printf SPACE$(38)
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Colorf2 White, 0
                        IF Ambiguate = False THEN
                            Printf "Ambiguation Off. Press <esc>:"
                        ELSE
                            Printf "Ambiguation On. Press <esc>:"
                        END IF
                        CALL PromptInkey
                        GOSUB UpdateDisplay
                        EXIT DO
                    CASE 65 ' F7 - redraw screen
                        GOSUB RedrawScreen
                        EXIT DO
                    CASE 66 ' F8 - attribute override
                        I$ = Nul
                        CALL OverridePrompt
                        GOSUB UpdateDisplay
                        EXIT DO
                    CASE 67 ' F9 - help screen
                        I$ = Nul
                        CALL DisplayHelp
                        GOSUB RedrawScreen
                    CASE 68 ' F10 - exit program
                        I$ = CHR$(27)
                        EXIT DO
                    CASE 133 ' F11 - drop to DOS
                        Colorf Plain
                        CLS
                        Printf "Type 'Exit' to return to editor.."
                        Locatef 2, 1, 1
                        SHELL
                        GOSUB RedrawScreen
                        EXIT DO
                    CASE 134 ' F12 - enter filespec
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Printf SPACE$(38)
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Colorf2 White, 0
                        Printf "Enter file spec?"
                        X$ = LineInput$(Xcoor + 1, Ycoor + 19, 21)
                        I$ = Nul
                        IF LEN(X$) THEN
                            E$ = X$
                            IF MID$(E$, 2, 1) = ":" THEN
                                C$ = LEFT$(E$, 1)
                                E$ = MID$(E$, 3)
                                N$ = Nul
                            END IF
                            FOR VarQ = LEN(E$) TO 1 STEP -1
                                IF MID$(E$, VarQ, 1) = "\" THEN
                                    D$ = LEFT$(E$, VarQ)
                                    E$ = MID$(E$, VarQ + 1)
                                    EXIT FOR
                                END IF
                            NEXT
                            IF RIGHT$(D$, 1) = "\" THEN
                                D$ = LEFT$(D$, LEN(D$) - 1)
                            END IF
                            IF LEFT$(D$, 1) = "\" THEN
                                D$ = MID$(D$, 2)
                            END IF
                            X$ = "*.*"
                            I$ = CHR$(13)
                            EXIT DO
                        END IF
                        GOSUB DisplayFilename6
                        GOSUB DisplayFileLine
                        EXIT DO
                    CASE 104 ' Alt-F1 - toggle quiet mode.
                        I$ = Nul
                        SELECT CASE QuietSwitch
                            CASE -1
                                QuietSwitch = 0
                            CASE 0
                                QuietSwitch = 1
                            CASE 1
                                QuietSwitch = 2
                            CASE 2
                                QuietSwitch = 3
                            CASE 3
                                QuietSwitch = 4
                            CASE 4
                                QuietSwitch = 5
                            CASE 5
                                QuietSwitch = 6
                            CASE 6
                                QuietSwitch = -1
                        END SELECT
                        SELECT CASE QuietSwitch
                            CASE 0
                                P$ = "Quiet switch off."
                            CASE -1
                                P$ = "Quiet switch on."
                            CASE ELSE
                                P$ = "Quiet switch level" + STR$(QuietSwitch) + "."
                        END SELECT
                        P$ = P$ + " Press <esc>."
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Printf SPACE$(38)
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Colorf2 White, 0
                        Printf P$
                        CALL PromptInkey
                        GOSUB UpdateDisplay
                        EXIT DO
                    CASE 105 ' Alt-F2 - file exclusion entry.
                        I$ = Nul
                        CALL ExcludeList(1, Y$)
                        FileY$ = Y$
                        GOSUB RedrawScreen
                        EXIT DO
                    CASE 106 ' Alt-F3 - dir exclusion entry.
                        I$ = Nul
                        CALL ExcludeList(2, Y$)
                        DirY$ = Y$
                        GOSUB RedrawScreen
                        EXIT DO
                    CASE 107 ' Alt-F4 - toggle file sort ascending/descending.
                        I$ = Nul
                        FileSort = NOT FileSort
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Printf SPACE$(38)
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Colorf2 White, 0
                        IF FileSort THEN
                            Printf "File sort descending. Press <esc>:"
                        ELSE
                            Printf "File sort ascending. Press <esc>:"
                        END IF
                        CALL PromptInkey
                        GOSUB UpdateDisplay
                        EXIT DO
                    CASE 108 ' Alt-F5 - toggle dir sort ascending/descending.
                        I$ = Nul
                        DirSort = NOT DirSort
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Printf SPACE$(38)
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Colorf2 White, 0
                        IF DirSort THEN
                            Printf "Dir sort descending. Press <esc>:"
                        ELSE
                            Printf "Dir sort ascending. Press <esc>:"
                        END IF
                        CALL PromptInkey
                        GOSUB UpdateDisplay
                        EXIT DO
                    CASE 109 ' Alt-F6 - toggle file date/time switch.
                        I$ = Nul
                        SELECT CASE FileSwitch
                            CASE 0
                                FileSwitch = 1
                            CASE 1
                                FileSwitch = 2
                            CASE 2
                                FileSwitch = 0
                        END SELECT
                        P$ = "File switch level" + STR$(FileSwitch) + "."
                        P$ = P$ + " Press <esc>."
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Printf SPACE$(38)
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Colorf2 White, 0
                        Printf P$
                        CALL PromptInkey
                        GOSUB UpdateDisplay
                        EXIT DO
                    CASE 110 ' Alt-F7 - toggle file size switch.
                        I$ = Nul
                        SELECT CASE FileSizeType
                            CASE 0
                                FileSizeType = 1
                                Var$ = "KB."
                            CASE 1
                                FileSizeType = 2
                                Var$ = "MB."
                            CASE 2
                                FileSizeType = 3
                                Var$ = "GB."
                            CASE 3
                                FileSizeType = 0
                                Var$ = "B."
                        END SELECT
                        P$ = "File size switch: " + Var$
                        P$ = P$ + " Press <esc>."
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Printf SPACE$(38)
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Colorf2 White, 0
                        Printf P$
                        CALL PromptInkey
                        GOSUB UpdateDisplay
                        EXIT DO
                    CASE 111 ' Alt-F8 - network path.
                        I$ = Nul
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Printf SPACE$(38)
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Colorf2 White, 0
                        Printf "Net path?"
                        Z$ = LineInput$(Xcoor + 1, Ycoor + 12, 28)
                        X$ = Nul
                        IF LEN(Z$) THEN
                            IF LEFT$(Z$, 2) = "\\" THEN
                                X$ = Z$
                            END IF
                        END IF
                        GOSUB DisplayFilename6
                        GOSUB DisplayFileLine
                        ProcessEditLine = True
                        EXIT DO
                    CASE 112 ' Alt-F9 - default network path.
                        I$ = Nul
                        X$ = Nul
                        ' store default server name
                        IF RTRIM$(DefaultNetPath) <> Nul THEN
                            X$ = "\\" + RTRIM$(DefaultNetPath) + "\C\"
                            GOSUB DisplayFilename6
                            GOSUB DisplayFileLine
                            ProcessEditLine = True
                            EXIT DO
                        END IF
                    CASE 113 ' Alt-F10 - load default net w/ drive letter
                        I$ = Nul
                        X$ = Nul
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Printf SPACE$(38)
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Colorf2 White, 0
                        Printf "Drive letter: "
                        DO
                            _LIMIT 100
                            Z$ = INKEY$
                            IF LEN(Z$) = 1 THEN
                                Z$ = UCASE$(Z$)
                                IF Z$ >= "A" AND Z$ <= "Z" THEN
                                    EXIT DO
                                END IF
                            END IF
                        LOOP
                        Printf Z$
                        ' store default server name
                        IF RTRIM$(DefaultNetPath) <> Nul THEN
                            X$ = "\\" + RTRIM$(DefaultNetPath) + "\" + UCASE$(Z$) + "\"
                            GOSUB DisplayFilename6
                            GOSUB DisplayFileLine
                            ProcessEditLine = True
                            EXIT DO
                        END IF
                    CASE ELSE
                        I$ = Nul ' nul activity
                END SELECT
                I$ = Nul ' nul keystroke
            END IF

            REM tab key label.
            TabFile:

            ' Tab moves to file loop, or
            '   directory loop if there are no files.
            IF I$ = CHR$(9) THEN
                IF Num.Files > 0 THEN
                    GOSUB FileInputLoop

                    ' check function key.
                    IF LEN(I$) = 2 THEN
                        VarQ = ASC(RIGHT$(I$, 1))
                        SELECT CASE VarQ
                            CASE 59 TO 68, 104 TO 113, 133, 134
                                GOTO StartLoop1
                        END SELECT
                        GOSUB GetAltKey
                        IF VarZ THEN
                            GOTO StartLoop0
                        END IF
                    END IF

                    ' tab from drive input loop.
                    IF I$ = CHR$(9) THEN
                        I$ = Nul
                        EXIT DO
                    END IF

                    ' shift-tab from dir input loop.
                    IF I$ = CHR$(0) + CHR$(15) THEN
                        I$ = Nul
                        EXIT DO
                    END IF

                    ' click on file entry area.
                    IF IsMenu = 4 THEN
                        GOSUB DisplayCurrentPath
                        IF Num.Files > 0 THEN
                            GOSUB DisplayLongName2
                        END IF
                        EXIT DO
                    END IF
                    IF I$ = CHR$(13) THEN
                        SELECT CASE IsMenu
                            CASE 1 ' file box.
                                E$ = RTRIM$(Filenames(Current.File!))
                                GOTO EndLoop2
                            CASE 2 ' dir box.
                                GOSUB GetNewPath
                            CASE 3 ' drive box.
                                X$ = CHR$(Current.Drive + 64) + ":\*.*"
                                I$ = Nul
                                ProcessEditLine = True
                                EXIT DO
                            CASE 4 ' entry area.
                                GOSUB DisplayCurrentPath
                                IF Num.Files > 0 THEN
                                    GOSUB DisplayLongName2
                                END IF
                                EXIT DO
                            CASE 5
                                I$ = CHR$(27)
                                EXIT DO
                            CASE ELSE
                                E$ = RTRIM$(Filenames(Current.File!))
                                GOTO EndLoop2
                        END SELECT
                    END IF
                ELSE
                    GOSUB DirInputLoop
                    ' check function key.
                    IF LEN(I$) = 2 THEN
                        VarQ = ASC(RIGHT$(I$, 1))
                        SELECT CASE VarQ
                            CASE 59 TO 68, 104 TO 113, 133, 134
                                GOTO StartLoop1
                        END SELECT
                        GOSUB GetAltKey
                        IF VarZ THEN
                            GOTO StartLoop0
                        END IF
                    END IF
                    ' tab from drive input loop.
                    IF I$ = CHR$(9) THEN
                        I$ = Nul
                        EXIT DO
                    END IF
                    ' shift-tab from drive input loop.
                    IF I$ = CHR$(0) + CHR$(15) THEN
                        I$ = Nul
                        EXIT DO
                    END IF
                    IF IsMenu = 4 THEN
                        GOSUB DisplayCurrentPath
                        IF Num.Files > 0 THEN
                            GOSUB DisplayLongName2
                        END IF
                        EXIT DO
                    END IF
                    IF I$ = CHR$(13) THEN
                        SELECT CASE IsMenu
                            CASE 1 ' file box.
                                E$ = RTRIM$(Filenames(Current.File!))
                                GOTO EndLoop2
                            CASE 2 ' dir box.
                                GOSUB GetNewPath
                            CASE 3 ' drive box.
                                X$ = CHR$(Current.Drive + 64) + ":\*.*"
                                I$ = Nul
                                ProcessEditLine = True
                                EXIT DO
                            CASE 4 ' entry area.
                                GOSUB DisplayCurrentPath
                                IF Num.Files > 0 THEN
                                    GOSUB DisplayLongName2
                                END IF
                                EXIT DO
                            CASE 5
                                I$ = CHR$(27)
                                EXIT DO
                            CASE ELSE
                                GOSUB GetNewPath
                        END SELECT
                    END IF
                END IF
            END IF

            ' test break key.
            IF I$ = CHR$(3) THEN ' Ctrl-C
                _DELAY 1.2 ' delay for break
            END IF

            ' test error key.
            IF I$ = CHR$(5) THEN ' Ctrl-E
                IF Debug THEN
                    I$ = Nul
                    V = SQR(-1) ' test syntax error
                END IF
            END IF

            ' enter key.
            IF I$ = CHR$(13) THEN
                I$ = Nul
                ProcessEditLine = True
                EXIT DO
            END IF

            ' escape key.
            IF I$ = CHR$(27) THEN
                EXIT DO ' exit box.
            END IF

            ' backspace.
            IF I$ = CHR$(8) THEN
                IF LEN(X$) THEN
                    IF Xstart = True AND Xposition2 = 0 THEN
                        X$ = Nul
                        Xstart = False
                        Xposition1 = 1
                        Xposition2 = 0
                        GOSUB DisplayFileLine
                    ELSE
                        IF Xposition2 > 0 THEN
                            Xstart = False
                            X$ = LEFT$(X$, Xposition2 - 1) + MID$(X$, Xposition2 + 1)
                            Xposition2 = Xposition2 - 1
                            IF Xposition2 - 25 <= Xposition1 THEN
                                Xposition1 = Xposition1 - 1
                                IF Xposition1 < 1 THEN
                                    Xposition1 = 1
                                END IF
                            END IF
                            GOSUB DisplayFileLine
                        END IF
                    END IF
                END IF
            ELSE
                ' append/insert character into filename area.
                IF LEN(I$) THEN
                    ' check input length.
                    IF LEN(X$) >= 259 THEN ' asciiz
                        X$ = Nul
                        Xstart = False
                        Xposition1 = 1
                        Xposition2 = 0
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Printf SPACE$(38)
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Colorf2 White, 0
                        Printf "Edit line error. Press <esc>:"
                        CALL PromptInkey
                    ELSE
                        IF Xstart THEN
                            X$ = Nul
                            Xstart = False
                            Xposition1 = 1
                            Xposition2 = 0
                            GOSUB DisplayFileLine
                        END IF
                        X$ = LEFT$(X$, Xposition2) + I$ + MID$(X$, Xposition2 + 1)
                        Xposition2 = Xposition2 + 1
                        IF Xposition2 > 26 THEN
                            Xposition1 = Xposition1 + 1
                        END IF
                        GOSUB DisplayFileLine
                    END IF
                END IF
            END IF
        LOOP

        ' exit menu box w/o filename.
        IF I$ = CHR$(27) THEN
            E$ = Nul
            EXIT DO
        END IF

        ' exit menu box with filename.
        IF I$ = CHR$(13) THEN
            EXIT DO
        END IF

        REM Process edit line in X$
        REM
        REM Parses
        REM   c:\path\filename.ext
        REM     or
        REM   \\netpath\share\path
        REM
        REM With partial pathname override,
        REM filename ambiguation detection, and
        REM multi-dot imbedded path retracting.

        ' check process flag.
        IF ProcessEditLine THEN

            ' store values.
            D1$ = D$
            X2$ = F$

            ' change netpath.
            IF LEFT$(X$, 2) = "\\" THEN
                IF RIGHT$(X$, 1) <> "\" THEN
                    X$ = X$ + "\"
                END IF
                N$ = X$

                ' display message.
                Colorf White
                Locatef Xcoor + 1, Ycoor + 12, 1
                Printf SPACE$(26)
                Locatef Xcoor + 1, Ycoor + 12, 1
                Printf "Checking path.."
                Colorf Plain

                ' check netpath not available.
                Disk.Ready = NETPATHEXISTS(N$)
                IF Disk.Ready THEN
                    N$ = Nul
                    GOSUB PromptNet
                    GOSUB InitFileSpec
                    Xstart = True
                    GOTO EndLoop1
                END IF

                ' store new netpath.
                N$ = LEFT$(N$, LEN(N$) - 1)
                D$ = Nul ' root.
                X$ = "*.*"

                ' parse dospath from netpath
                VX = INSTR(3, N$, "\") + 1
                VX = INSTR(VX + 1, N$, "\")
                IF VX THEN
                    D$ = MID$(N$, VX)
                    N$ = LEFT$(N$, VX - 1)
                END IF
                New.Net = True
            END IF

            ' change drive.
            IF MID$(X$, 2, 1) = ":" THEN

                ' display message.
                Colorf White
                Locatef Xcoor + 1, Ycoor + 12, 1
                Printf SPACE$(26)
                Locatef Xcoor + 1, Ycoor + 12, 1
                Printf "Loading drive.."
                Colorf Plain

                ' check drive.
                Z$ = UCASE$(LEFT$(X$, 1))
                X$ = MID$(X$, 3)

                ' check last drive.
                V = ASC(Z$) - 64
                IF V > Last.Drive THEN
                    GOSUB PromptDisk
                    GOSUB InitFileSpec
                    Xstart = True
                    GOTO EndLoop1
                END IF

                ' check disk available.
                Disk.Ready = DRIVEEXISTS(V)

                ' check disk ready.
                IF Disk.Ready THEN
                    GOSUB PromptDisk
                    GOSUB InitFileSpec
                    Xstart = True
                    GOTO EndLoop1
                END IF

                ' check media exists.
                IF Disk.Ready = False THEN
                    IF MEDIAEXISTS(V) = False THEN
                        Disk.Ready = True
                    END IF
                END IF

                ' check disk ready.
                IF Disk.Ready THEN
                    GOSUB PromptMedia
                    GOSUB InitFileSpec
                    Xstart = True
                    GOTO EndLoop1
                END IF

                ' store new drive.
                IF C$ <> Z$ OR N$ <> Nul THEN
                    N$ = Nul
                    C$ = Z$
                    New.Drive = V
                    IF X$ = Nul THEN
                        X$ = "\"
                    END IF
                    IF RIGHT$(X$, 1) = "\" THEN
                        X$ = X$ + "*.*"
                    END IF
                END IF
            END IF

            ' parse out path.
            CALL Parse.Path(D$, X$)

            ' parse off directory.
            IF INSTR(X$, "\") THEN
                FOR Var = LEN(X$) TO 1 STEP -1
                    IF MID$(X$, Var, 1) = "\" THEN
                        EXIT FOR
                    END IF
                NEXT

                ' parse filename.
                SELECT CASE Var
                    CASE 1 ' check root.
                        D$ = Nul
                        X$ = MID$(X$, Var + 1)
                    CASE LEN(X$) ' check nul filename.
                        D$ = LEFT$(X$, Var - 1)
                        X$ = Nul
                        ' parse directory/filename.
                    CASE ELSE
                        IF LEFT$(X$, 1) = "\" THEN
                            D$ = LEFT$(X$, Var - 1)
                        ELSE
                            D$ = D$ + "\" + LEFT$(X$, Var - 1)
                        END IF
                        X$ = MID$(X$, Var + 1)
                END SELECT
            END IF

            ' process directory.
            IF LEFT$(D$, 1) = "\" THEN
                D$ = MID$(D$, 2)
            END IF
            IF RIGHT$(D$, 1) = "\" THEN
                D$ = LEFT$(D$, LEN(D$) - 1)
            END IF
            IF LEFT$(D$, 1) = "\" THEN
                D$ = Nul
            END IF
            IF RIGHT$(D$, 1) = "\" THEN
                D$ = Nul
            END IF
            IF D$ = "\" THEN
                D$ = Nul
            END IF

            ' check directory.
            GOSUB CheckPath
            IF ValidPath = False THEN
                D$ = D1$
                X$ = X1$
                Xposition1 = 1
                Xposition2 = 0
                GOTO EndLoop1
            END IF

            ' store directory.
            D3$ = D$
            X3$ = X$

            ' prevent directory from loading twice.
            LoadedDir = False

            ' check filename.
            IF X$ = STRING$(LEN(X$), ".") THEN
                ' strip multiple dots from path.
                CALL Parse.Path2(D$, X$)
            END IF

            ' construct partial path.
            IF D$ = Nul THEN
                D$ = X$
            ELSE
                IF X$ <> Nul THEN
                    D$ = D$ + "\" + X$
                END IF
            END IF

            ' check path.
            GOSUB CheckPath

            ' check valid path.
            IF ValidPath = False THEN
                D$ = D3$
                X$ = X3$
            END IF

            ' check valid path.
            IF ValidPath THEN
                ' check directory already loaded.
                IF D$ <> D1$ OR New.Drive > 0 OR New.Net THEN
                    ' load current directory.
                    DirLoadMessage = "Loading dirs.."
                    CALL LoadDirSpec(DirY$, N$, C$, D$)
                    New.Drive = True
                    New.Net = False
                END IF
                ' reset filename.
                X$ = Nul
                ' set loaded flag.
                LoadedDir = True
                GOSUB DisplayCurrentDir
            END IF

            ' check filename.
            IF X$ = Nul THEN
                GOSUB InitFileSpec
            END IF

            ' check loaded dir.
            IF LoadedDir = False THEN
                ' check filename characters.
                IF INSTR(X$, "?") = False THEN
                    IF INSTR(X$, "*") = False THEN
                        ' search for directory spec override.
                        FOR Var! = 1! TO Num.Dirs
                            S$ = UCASE$(RTRIM$(Directories(Var!)))
                            ' check X$ is directory in current one.
                            IF D$ = Nul THEN
                                ASCIIZ = "\" + S$ + CHR$(0)
                            ELSE
                                ASCIIZ = "\" + D$ + "\" + S$ + CHR$(0)
                            END IF
                            Flag = False
                            ' get conanicalized directory name.
                            V4 = False
                            GOSUB ShortFilenameX
                            ' check directory name.
                            IF UCASE$(X$) = Short.Filename$ THEN
                                Flag = True
                            END IF
                            ' check directory name.
                            IF Flag = False THEN
                                IF UCASE$(X$) = S$ THEN
                                    Flag = True
                                END IF
                            END IF
                            IF Flag THEN
                                ' store directory.
                                S$ = RTRIM$(Directories(Var!))
                                IF D$ = Nul THEN
                                    D$ = S$
                                ELSE
                                    D$ = D$ + "\" + S$
                                END IF
                                ' restore filename override.
                                GOSUB InitFileSpec
                                EXIT FOR
                            END IF
                        NEXT
                    END IF
                END IF
            END IF

            ' store current filespec.
            IF X$ = "." THEN
                X$ = Nul
            END IF

            ' store and load directories.
            IF LoadedDir = False THEN
                ' check directory already loaded.
                IF D$ <> D1$ OR New.Drive > 0 OR New.Net THEN
                    ' load directories.
                    GOSUB LoadNewDir
                    New.Drive = True
                    New.Net = False
                END IF
            ELSE
                ' init directories.
                GOSUB LoadNewDir2
                GOSUB DisplayCurrentDir
            END IF

            ' store filename.
            GOSUB InitDirSpec

            ' store filename.
            X1$ = X$
            Xposition1 = 1
            Xposition2 = 0

            ' compare filespecs.
            IF UCASE$(F$) <> UCASE$(X2$) THEN
                ' store filespec.
                X2$ = F$
                ' load file box.
                GOSUB LoadNewFiles
            END IF

            ' check filename characters.
            IF INSTR(X$, "?") = False THEN
                IF INSTR(X$, "*") = False THEN
                    ' search for filename spec override.
                    FOR Var! = 1! TO Num.Files
                        S$ = UCASE$(RTRIM$(Filenames(Var!)))
                        ' check X$ is filename in current directory.
                        IF D$ = Nul THEN
                            ASCIIZ = "\" + S$ + CHR$(0)
                        ELSE
                            ASCIIZ = "\" + D$ + "\" + S$ + CHR$(0)
                        END IF
                        Flag = False
                        ' get conanicalized filename.
                        V4 = False
                        GOSUB ShortFilenameX
                        ' check filename.
                        IF UCASE$(X$) = Short.Filename$ THEN
                            Flag = True
                        END IF
                        ' check filename.
                        IF Flag = False THEN
                            IF UCASE$(X$) = S$ THEN
                                Flag = True
                            END IF
                        END IF
                        IF Flag THEN
                            ' select file for editing.
                            E$ = RTRIM$(Filenames(Var!))
                            EXIT DO
                        END IF
                    NEXT
                END IF
            END IF

            ' construct dir/filename.
            V$ = MakeFilename$(N$, C$, D$, X$)

            ' check filename characters.
            IF INSTR(V$, "?") = False THEN
                IF INSTR(V$, "*") = False THEN
                    ' select file for editing.
                    E$ = X$
                    EXIT DO
                END IF
            END IF

            ' display all drives.
            IF New.Drive = True THEN
                Current.Drive = ASC(C$) - 64
                GOSUB InitDrives
                New.Drive = False
            END IF

            ' restart editing loop.
            Xstart = True
        END IF
        EndLoop1:
    LOOP

    ' exit editing loop.
    EndLoop2:

    ' exit file menu box.
    Colorf2 7, 0
    CLS

    ' return to editor.
    EXIT SUB

    ' reset file menu box.
    UpdateDisplay:
    GOSUB DisplayFilename6
    Colorf2 Plain, 0
    ' init dir box.
    GOSUB ClearDirBox
    DirLoadMessage = "Updating dirs.."
    CALL LoadDirSpec(DirY$, N$, C$, D$)
    GOSUB DisplayDirSpec
    Current.Dir! = 1!
    Dir.Box.Line = 1
    GOSUB DisplayCurrentDir
    ' init file box.
    GOSUB ClearFileBox
    FileLoadMessage = "Updating files.."
    CALL LoadFileSpec(FileY$, F$)
    GOSUB DisplayFileSpec
    GOSUB DisplayCurrentPath
    ' display first file.
    GOSUB ClearLongName2
    IF Num.Files > 0 THEN
        Current.File! = 1!
        Box.Line = 1
        GOSUB InitFiles
    END IF
    ' init drive box.
    GOSUB InitDrives
    RETURN

    ' init filespec.
    InitFileSpec:
    ' compare stored filename.
    IF X1$ = Nul THEN
        X$ = "*.*"
        Xposition1 = 1
        Xposition2 = 3
    ELSE
        ' restore filename spec.
        X$ = X1$
        Xposition1 = 1
        Xposition2 = 0
    END IF
    ' check filename.
    IF X$ = "." THEN
        X$ = Nul
    END IF
    RETURN

    ' init current directory.
    InitDirSpec:
    F$ = MakeFilename$(N$, C$, D$, X$)
    RETURN

    ' inits dir box with new dirspec.
    LoadNewDir:
    Current.Dir! = 1!
    Dir.Box.Line = 1
    GOSUB ClearDirBox
    GOSUB CheckPath
    IF ValidPath = False THEN
        D$ = D1$
        X$ = X1$
        Xposition1 = 1
        Xposition2 = 0
    END IF
    DirLoadMessage = "Reloading dirs.."
    CALL LoadDirSpec(DirY$, N$, C$, D$)
    GOSUB DisplayDirSpec
    GOSUB DisplayCurrentDir
    GOSUB DisplayCurrentPath
    GOSUB DisplayDirectory
    RETURN

    ' inits dir box without new dirspec.
    LoadNewDir2:
    Current.Dir! = 1!
    Dir.Box.Line = 1
    GOSUB ClearDirBox
    GOSUB CheckPath
    IF ValidPath = False THEN
        D$ = D1$
        X$ = X1$
        Xposition1 = 1
        Xposition2 = 0
    END IF
    GOSUB DisplayDirSpec
    GOSUB DisplayCurrentDir
    GOSUB DisplayCurrentPath2
    GOSUB DisplayDirectory
    RETURN

    ' inits file box.
    LoadNewFiles:
    GOSUB ClearFileBox
    FileLoadMessage = "Reloading files.."
    CALL LoadFileSpec(FileY$, F$)
    GOSUB DisplayFileSpec
    IF Num.Files > 0 THEN
        Current.File! = 1!
        Box.Line = 1
        GOSUB InitFiles
    ELSE
        GOSUB ClearLongName2
    END IF
    RETURN

    ' display current filename entry area.
    DisplayFileLine:
    Locatef Xcoor + 1, Ycoor + 12, 1
    Printf SPACE$(26)
    ' check hilighting.
    IF Xstart THEN
        Colorf2 Black, Plain
    END IF
    ' display edit line and position cursor.
    Locatef Xcoor + 1, Ycoor + 12, 1
    Printf MID$(X$, Xposition1, 26)
    Locatef Xcoor + 1, Ycoor + Xposition2 - Xposition1 + 13, 1
    Colorf2 Plain, 0
    RETURN

    ' display invalid disk message.
    PromptMedia:
    Z2$ = "Media not ready. Press <esc>:"
    GOTO NextPrompt
    PromptDisk:
    Z2$ = "Disk not ready. Press <esc>:"
    GOTO NextPrompt
    ' display invalid netpath message.
    PromptNet:
    Z2$ = "Net not ready. Press <esc>:"
    NextPrompt:
    Locatef Xcoor + 1, Ycoor + 2, 1
    Printf SPACE$(38)
    Locatef Xcoor + 1, Ycoor + 2, 1
    Colorf2 White, 0
    Printf Z2$
    CALL PromptInkey
    GOSUB DisplayFilename6
    Colorf2 Plain, 0
    RETURN

    ' init filename input loop.
    InitFiles:
    E$ = RTRIM$(Filenames(1!))
    Colorf2 Black, Plain
    Locatef Xcoor + 5, Ycoor + 3, 1
    Printf LEFT$(E$, 12)
    Colorf2 Plain, 0
    GOSUB DisplayLongName2
    RETURN

    ' filename input loop.
    FileInputLoop:
    I$ = Nul
    DO
        IF Current.File! > 0 THEN
            GOSUB DisplayLongName2
            GOSUB ClearFilename
            GOSUB DisplayFilename1
        END IF
        DO
            ' get keystroke.
            _LIMIT 100
            I$ = INKEY$
            IF LEN(I$) THEN
                IsMenu = False
                EXIT DO
            END IF

            ' call mouse subroutine.
            Z = MouseDriver

            ' check file entry area.
            IF IsMenu >= 4 THEN
                RETURN
            END IF

            ' check mouse wheel.
            IF MouseWheel = -1 THEN
                IF WheelReverse THEN
                    I$ = CHR$(0) + CHR$(80) ' down
                ELSE
                    I$ = CHR$(0) + CHR$(72) ' up
                END IF
                MouseWheel = 0
                EXIT DO
            END IF
            IF MouseWheel = 1 THEN
                IF WheelReverse THEN
                    I$ = CHR$(0) + CHR$(72) ' up
                ELSE
                    I$ = CHR$(0) + CHR$(80) ' down
                END IF
                MouseWheel = 0
                EXIT DO
            END IF

            ' check left mouse button.
            IF MouseButton1 THEN
                GOSUB MouseButton1Z
                SELECT CASE IsMenu
                    CASE 1 ' file box.
                        IF I$ = CHR$(13) THEN
                            EXIT DO
                        ELSE
                            GOSUB FileBoxKey
                        END IF
                    CASE 2 ' dir box.
                        IF I$ = CHR$(13) THEN
                            RETURN
                        ELSE
                            GOSUB DirBoxKey
                        END IF
                    CASE 3 ' drive box.
                        IF I$ = CHR$(13) THEN
                            RETURN
                        ELSE
                            GOSUB DriveBoxKey
                        END IF
                END SELECT
            ELSE
                ' check mouse position.
                IF MouseX OR MouseY THEN
                    GOSUB MouseOverX1
                END IF
            END IF
        LOOP

        ' check function key.
        IF LEN(I$) = 2 THEN
            VarQ = ASC(RIGHT$(I$, 1))
            SELECT CASE VarQ
                CASE 59 TO 68, 104 TO 113, 133, 134
                    RETURN
            END SELECT
            GOSUB GetAltKey
            IF VarZ THEN
                RETURN
            END IF
        END IF

        ' up returns shift-tab.
        IF LEN(I$) = 2 THEN
            IF ASC(RIGHT$(I$, 1)) = 72 THEN
                IF Current.File! = 1! THEN
                    IF Box.Line = 1 THEN
                        I$ = CHR$(0) + CHR$(15)
                    END IF
                END IF
            END IF
        END IF

        ' shift-tab returns to top.
        IF LEN(I$) = 2 THEN
            IF ASC(RIGHT$(I$, 1)) = 15 THEN
                RETURN
            END IF
        END IF

        ' right returns tab.
        IF LEN(I$) = 2 THEN
            IF ASC(RIGHT$(I$, 1)) = 77 THEN
                I$ = CHR$(9)
            END IF
        END IF

        ' Tab moves to directory loop.
        IF I$ = CHR$(9) THEN
            GOSUB DirInputLoop
            ' check function key.
            IF LEN(I$) = 2 THEN
                VarQ = ASC(RIGHT$(I$, 1))
                SELECT CASE VarQ
                    CASE 59 TO 68, 104 TO 113, 133, 134
                        RETURN
                END SELECT
                GOSUB GetAltKey
                IF VarZ THEN
                    RETURN
                END IF
            END IF
            IF IsMenu >= 4 THEN
                RETURN
            END IF
            IF I$ = CHR$(9) THEN
                GOSUB DisplayCurrentPath
                RETURN
            END IF
        END IF
        IF I$ = CHR$(13) THEN
            RETURN
        END IF
        IF I$ = CHR$(27) THEN
            RETURN
        END IF
        IF LEN(I$) = 1 THEN
            SELECT CASE I$
                CASE "A" TO "Z", "a" TO "z", "0" TO "9"
                    ' scan the first character of the filenames.
                    J$ = I$
                    DO
                        IF Current.File! + 1! <= Num.Files THEN
                            IF Box.Line < 10 THEN
                                GOSUB ClearFilename
                                Box.Line = Box.Line + 1
                                Current.File! = Current.File! + 1!
                                GOSUB DisplayFilename1
                                GOSUB DisplayLongName2
                            ELSE
                                Current.File! = Current.File! + 1!
                                GOSUB DisplayFilename2
                                GOSUB DisplayFileBox1
                                GOSUB DisplayFilename3
                                GOSUB DisplayLongName2
                            END IF
                            E$ = RTRIM$(Filenames(Current.File!))
                            IF LEFT$(E$, 1) = J$ THEN
                                EXIT DO
                            END IF
                            _LIMIT 100
                            I$ = INKEY$
                            IF I$ = CHR$(27) THEN
                                EXIT DO
                            END IF
                        ELSE
                            EXIT DO
                        END IF
                    LOOP
            END SELECT
            I$ = Nul
        END IF
        IF LEN(I$) = 2 THEN
            GOSUB FileBoxKey
            IF Num.Files = 0 THEN
                I$ = CHR$(0) + CHR$(15)
                RETURN
            END IF
        END IF
    LOOP
    RETURN

    ' process key in file box.
    FileBoxKey:
    V = ASC(RIGHT$(I$, 1))
    SELECT CASE V
        CASE 82 ' insert
            Locatef Xcoor + 1, Ycoor + 2, 1
            Printf SPACE$(38)
            Locatef Xcoor + 1, Ycoor + 2, 1
            Colorf2 White, 0

            ' get new file.
            Printf "Filename?"
            ZQ$ = LineInput$(Xcoor + 1, Ycoor + 12, 28)

            ' parse new file.
            IF LEN(ZQ$) THEN

                ' create filename.
                G$ = MakeFilename$(N$, C$, D$, ZQ$)
                G$ = G$ + CHR$(0)
                hfind = CreateFile(G$, &H180, 0, 0, 1, 0, 0)
                IF hfind <> INVALID_HANDLE_VALUE THEN
                    x = CloseHandle(hfind)
                    ' init file box.
                    GOSUB DisplayFilename6
                    GOSUB ClearFileBox
                    FileLoadMessage = "Updating files.."
                    CALL LoadFileSpec(FileY$, F$)
                    GOSUB DisplayFileSpec
                    GOSUB DisplayCurrentPath
                    ' display first file.
                    GOSUB ClearLongName2
                    IF Num.Files > 0 THEN
                        Current.File! = 1!
                        Box.Line = 1
                        GOSUB InitFiles
                    END IF
                ELSE
                    Locatef Xcoor + 1, Ycoor + 2, 1
                    Printf SPACE$(38)
                    Locatef Xcoor + 1, Ycoor + 2, 1
                    Colorf2 White, 0
                    IF GetLastError& = &H50 THEN ' check already exists
                        Printf "Filename already exists. Press <esc>:"
                    ELSE
                        Printf "Error 0x" + HEX$(GetLastError) + " Press <esc>:"
                    END IF
                    CALL PromptInkey
                END IF
            END IF
            GOSUB DisplayFilename6
            GOSUB DisplayFileLine
            GOSUB DisplayLongName2
        CASE 83 ' delete
            ' check file.
            IF Num.Files > 0 THEN
                E$ = RTRIM$(Filenames(Current.File!))
                Locatef Xcoor + 1, Ycoor + 2, 1
                Printf SPACE$(38)
                Locatef Xcoor + 1, Ycoor + 2, 1
                Colorf2 White, 0
                Printf "Delete current file(y/n)?"
                ErrorRespond$ = Nul
                DO
                    _LIMIT 100
                    ErrorRespond$ = INKEY$
                    IF LEN(ErrorRespond$) THEN
                        IF UCASE$(ErrorRespond$) = "Y" THEN
                            EXIT DO
                        END IF
                        IF UCASE$(ErrorRespond$) = "N" THEN
                            EXIT DO
                        END IF
                    END IF
                LOOP
                ' parse key.
                IF UCASE$(ErrorRespond$) = "Y" THEN

                    ' delete filename.
                    G$ = MakeFilename$(N$, C$, D$, E$)
                    G$ = G$ + CHR$(0)

                    ' change filename attribute
                    AttrX = GetFileAttributes(G$)
                    AttrX = AttrX AND NOT &H1 ' remove read-only bit
                    x = SetFileAttributes&(G$, AttrX)
                    x = DeleteFileA(G$)

                    ' check carry flag error
                    IF x = 0 THEN
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Printf SPACE$(38)
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Colorf2 White, 0
                        Printf "Error 0x" + HEX$(GetLastError) + " Press <esc>:"
                        CALL PromptInkey
                    ELSE
                        ' init file box.
                        GOSUB DisplayFilename6
                        GOSUB ClearFileBox
                        FileLoadMessage = "Updating files.."
                        CALL LoadFileSpec(FileY$, F$)
                        GOSUB DisplayFileSpec
                        GOSUB DisplayCurrentPath
                        ' display first file.
                        GOSUB ClearLongName2
                        IF Num.Files > 0 THEN
                            Current.File! = 1!
                            Box.Line = 1
                            GOSUB InitFiles
                        END IF
                    END IF
                END IF
                GOSUB DisplayFilename6
                GOSUB DisplayFileLine
                GOSUB DisplayLongName2
            END IF
        CASE 72, 141, 152 ' up/ctrl-up/alt-up
            IF Current.File! - 1 > 0 THEN
                IF Box.Line > 1 THEN
                    GOSUB ClearFilename
                    Box.Line = Box.Line - 1
                    Current.File! = Current.File! - 1!
                    GOSUB DisplayFilename1
                    GOSUB DisplayLongName2
                ELSE
                    Current.File! = Current.File! - 1!
                    GOSUB DisplayFilename2
                    GOSUB DisplayFileBox2
                    GOSUB DisplayFilename4
                    GOSUB DisplayLongName2
                END IF
            END IF
        CASE 80, 145, 160 ' down/ctrl-down/alt-down
            IF Current.File! + 1 <= Num.Files THEN
                IF Box.Line < 10 THEN
                    GOSUB ClearFilename
                    Box.Line = Box.Line + 1
                    Current.File! = Current.File! + 1!
                    GOSUB DisplayFilename1
                    GOSUB DisplayLongName2
                ELSE
                    Current.File! = Current.File! + 1!
                    GOSUB DisplayFilename2
                    GOSUB DisplayFileBox1
                    GOSUB DisplayFilename3
                    GOSUB DisplayLongName2
                END IF
            END IF
        CASE 73, 132 ' pageup/ctrl-pageup
            IF Current.File! - 10 > 0 THEN
                Box.Line = 1
                Current.File! = Current.File! - 10!
            ELSE
                Box.Line = 1
                Current.File! = 1!
            END IF
            GOSUB DisplayFilename2
            GOSUB DisplayFileBox2
            GOSUB DisplayFilename4
            GOSUB DisplayLongName2
        CASE 81, 118 ' pagedown/ctrl-pagedown
            IF Current.File! + 10 <= Num.Files THEN
                Box.Line = 10
                Current.File! = Current.File! + 10!
                GOSUB DisplayFilename2
                GOSUB DisplayFileBox1
                GOSUB DisplayFilename3
                GOSUB DisplayLongName2
            ELSE
                IF Current.File! + 1 <= Num.Files THEN
                    DO UNTIL Current.File! = Num.Files
                        IF Box.Line < 10 THEN
                            GOSUB ClearFilename
                            Box.Line = Box.Line + 1
                            Current.File! = Current.File! + 1!
                            GOSUB DisplayFilename1
                            GOSUB DisplayLongName2
                        ELSE
                            Current.File! = Current.File! + 1!
                            GOSUB DisplayFilename2
                            GOSUB DisplayFileBox1
                            GOSUB DisplayFilename3
                            GOSUB DisplayLongName2
                        END IF
                    LOOP
                END IF
            END IF
        CASE 71, 119 ' home/ctrl-home
            IF Current.File! > 1 THEN
                Box.Line = 1
                Current.File! = 1!
            END IF
            GOSUB DisplayFilename2
            GOSUB DisplayFileBox2
            GOSUB DisplayFilename4
            GOSUB DisplayLongName2
        CASE 79, 117 ' end/ctrl-end
            IF Current.File! + 1 <= Num.Files THEN
                DO UNTIL Current.File! = Num.Files
                    IF Box.Line < 10 THEN
                        GOSUB ClearFilename
                        Box.Line = Box.Line + 1
                        Current.File! = Current.File! + 1!
                        GOSUB DisplayFilename1
                        GOSUB DisplayLongName2
                    ELSE
                        Current.File! = Current.File! + 1!
                        GOSUB DisplayFilename2
                        GOSUB DisplayFileBox1
                        GOSUB DisplayFilename3
                        GOSUB DisplayLongName2
                    END IF
                    _LIMIT 100
                    I$ = INKEY$
                    IF I$ = CHR$(27) THEN
                        EXIT DO
                    END IF
                LOOP
            END IF
    END SELECT
    RETURN

    ' clear filename.
    ClearFilename:
    Colorf2 Plain, 0
    Locatef Box.Line + Xcoor + 4, Ycoor + 3, 1
    Printf LEFT$(RTRIM$(Filenames(Current.File!)), 12)
    RETURN

    ' display filename.
    DisplayFilename1:
    E$ = RTRIM$(Filenames(Current.File!))
    Colorf2 Plain, 0
    Locatef Xcoor + 1, Ycoor + 12, 1
    Printf SPACE$(26)
    Locatef Xcoor + 1, Ycoor + 12, 1
    GOSUB TruncateFilename
    Printf A$
    Colorf2 Black, Plain
    Locatef Box.Line + Xcoor + 4, Ycoor + 3, 1
    Printf LEFT$(E$, 12)
    V9 = LEN(RTRIM$(LEFT$(E$, 12)))
    Locatef Box.Line + Xcoor + 4, Ycoor + V9 + 3, 1
    Colorf2 Plain, 0
    RETURN

    ' display filename.
    DisplayFilename2:
    E$ = RTRIM$(Filenames(Current.File!))
    Colorf2 Plain, 0
    Locatef Xcoor + 1, Ycoor + 12, 1
    Printf SPACE$(26)
    Locatef Xcoor + 1, Ycoor + 12, 1
    GOSUB TruncateFilename
    Printf A$
    GOSUB ClearFileBox
    Colorf2 Plain, 0
    RETURN

    ' display filename.
    DisplayFilename3:
    E$ = RTRIM$(Filenames(Current.File!))
    Colorf2 Black, Plain
    Locatef Xcoor + 14, Ycoor + 3, 1
    Printf LEFT$(E$, 12)
    V9 = LEN(RTRIM$(LEFT$(E$, 12)))
    Locatef Xcoor + 14, Ycoor + V9 + 3, 1
    RETURN

    ' display filename.
    DisplayFilename4:
    E$ = RTRIM$(Filenames(Current.File!))
    Colorf2 Black, Plain
    Locatef Xcoor + 5, Ycoor + 3, 1
    Printf LEFT$(E$, 12)
    V9 = LEN(RTRIM$(LEFT$(E$, 12)))
    Locatef Xcoor + 5, Ycoor + V9 + 3, 1
    RETURN

    ' display filename.
    DisplayFilename5:
    E$ = RTRIM$(Filenames(Current.File!))
    Colorf2 Black, Plain
    Locatef Box.Line + Xcoor + 4, Ycoor + 3, 1
    Printf LEFT$(E$, 12)
    Colorf2 Plain, 0
    RETURN

    ' display filename line.
    DisplayFilename6:
    Locatef Xcoor + 1, Ycoor + 2, 1
    Printf SPACE$(38)
    Locatef Xcoor + 1, Ycoor + 2, 1
    Colorf2 White, 0
    Printf "Filename: "
    Colorf2 Plain, 0
    RETURN

    ' update filename box.
    DisplayFileBox1:
    FOR V = 1 TO 9
        Locatef Xcoor - V + 14, Ycoor + 3, 1
        Printf LEFT$(RTRIM$(Filenames(Current.File! - V)), 12)
    NEXT
    RETURN

    ' update filename box.
    DisplayFileBox2:
    FOR V = 1 TO 9
        IF Current.File! + V <= Num.Files THEN
            Locatef Xcoor + V + 5, Ycoor + 3, 1
            Printf LEFT$(RTRIM$(Filenames(Current.File! + V)), 12)
        END IF
    NEXT
    RETURN

    ' display init directory.
    DisplayInitDir:
    Q$ = RTRIM$(Directories(Current.Dir!))
    Locatef Dir.Box.Line + Xcoor + 4, Ycoor + 19, 1
    Colorf2 Black, Plain
    Printf LEFT$(Q$, 12)
    Colorf2 Plain, 0
    RETURN

    ' directory input loop.
    DirInputLoop:
    GOSUB DisplayInitDir
    GOSUB DisplayLongName0
    I$ = Nul
    DO
        DO
            ' get keystroke.
            _LIMIT 100
            I$ = INKEY$
            IF LEN(I$) THEN
                IsMenu = False
                EXIT DO
            END IF

            ' call mouse subroutine.
            Z = MouseDriver

            ' check file entry area.
            IF IsMenu >= 4 THEN
                RETURN
            END IF

            ' check mouse wheel.
            IF MouseWheel = -1 THEN
                IF WheelReverse THEN
                    I$ = CHR$(0) + CHR$(80) ' down
                ELSE
                    I$ = CHR$(0) + CHR$(72) ' up
                END IF
                MouseWheel = 0
                EXIT DO
            END IF
            IF MouseWheel = 1 THEN
                IF WheelReverse THEN
                    I$ = CHR$(0) + CHR$(72) ' up
                ELSE
                    I$ = CHR$(0) + CHR$(80) ' down
                END IF
                MouseWheel = 0
                EXIT DO
            END IF

            ' check left mouse button.
            IF MouseButton1 THEN
                GOSUB MouseButton1Z
                SELECT CASE IsMenu
                    CASE 1 ' file box.
                        IF I$ = CHR$(13) THEN
                            RETURN
                        ELSE
                            GOSUB FileBoxKey
                        END IF
                    CASE 2 ' dir box.
                        IF I$ = CHR$(13) THEN
                            RETURN
                        ELSE
                            GOSUB DirBoxKey
                        END IF
                    CASE 3 ' drive box.
                        IF I$ = CHR$(13) THEN
                            RETURN
                        ELSE
                            GOSUB DriveBoxKey
                        END IF
                END SELECT
            ELSE
                ' check mouse position.
                IF MouseX OR MouseY THEN
                    GOSUB MouseOverX1
                END IF
            END IF
        LOOP

        ' check function key.
        IF LEN(I$) = 2 THEN
            VarQ = ASC(RIGHT$(I$, 1))
            SELECT CASE VarQ
                CASE 59 TO 68, 104 TO 113, 133, 134
                    RETURN
            END SELECT
            GOSUB GetAltKey
            IF VarZ THEN
                RETURN
            END IF
        END IF

        ' up returns shift-tab.
        IF LEN(I$) = 2 THEN
            IF ASC(RIGHT$(I$, 1)) = 72 THEN
                IF Current.Dir! = 1! THEN
                    IF Dir.Box.Line = 1 THEN
                        I$ = CHR$(0) + CHR$(15)
                    END IF
                END IF
            END IF
        END IF

        ' left returns shift-tab.
        IF LEN(I$) = 2 THEN
            IF ASC(RIGHT$(I$, 1)) = 75 THEN
                I$ = CHR$(0) + CHR$(15)
            END IF
        END IF

        ' shift-tab returns to file loop.
        IF LEN(I$) = 2 THEN
            IF ASC(RIGHT$(I$, 1)) = 15 THEN
                ' display current filename.
                GOSUB ClearLongName2
                IF Num.Files > 0 THEN
                    GOSUB DisplayLongName2
                    GOSUB ClearFilename
                    GOSUB DisplayFilename1
                END IF
                ' display current directory.
                GOSUB ClearDirectory
                GOSUB DisplayCurrentPath
                RETURN
            END IF
        END IF

        ' right returns tab.
        IF LEN(I$) = 2 THEN
            IF ASC(RIGHT$(I$, 1)) = 77 THEN
                I$ = CHR$(9)
            END IF
        END IF

        ' Tab moves to drive input loop.
        IF I$ = CHR$(9) THEN
            GOSUB DriveInputLoop
            ' check function key.
            IF LEN(I$) = 2 THEN
                VarQ = ASC(RIGHT$(I$, 1))
                SELECT CASE VarQ
                    CASE 59 TO 68, 104 TO 113, 133, 134
                        RETURN
                END SELECT
                GOSUB GetAltKey
                IF VarZ THEN
                    RETURN
                END IF
            END IF
            IF IsMenu >= 3 THEN
                GOSUB DisplayCurrentPath
                IF Num.Files > 0 THEN
                    GOSUB DisplayLongName2
                END IF
                RETURN
            END IF
            IF I$ = CHR$(9) THEN
                GOSUB DisplayCurrentPath
                IF Num.Files > 0 THEN
                    GOSUB DisplayLongName2
                END IF
                RETURN
            END IF
            Q$ = RTRIM$(Directories(Current.Dir!))
            GOSUB DisplayLongName1
        END IF
        IF I$ = CHR$(13) THEN
            IsMenu = 2
            RETURN
        END IF
        IF I$ = CHR$(27) THEN
            RETURN
        END IF
        IF LEN(I$) = 1 THEN
            SELECT CASE I$
                CASE "A" TO "Z", "a" TO "z", "0" TO "9"
                    ' scan the first character of the directories.
                    J$ = I$
                    DO
                        IF Current.Dir! + 1! <= Num.Dirs THEN
                            IF Dir.Box.Line < 10 THEN
                                GOSUB ClearDirectory
                                Dir.Box.Line = Dir.Box.Line + 1
                                Current.Dir! = Current.Dir! + 1!
                                GOSUB DisplayDirectory
                            ELSE
                                GOSUB ClearDirBox
                                Current.Dir! = Current.Dir! + 1!
                                GOSUB DisplayDirBox1
                                GOSUB DisplayDirectory2
                            END IF
                            Q$ = RTRIM$(Directories(Current.Dir!))
                            GOSUB DisplayLongName1
                            IF LEFT$(Q$, 1) = J$ THEN
                                EXIT DO
                            END IF
                            _LIMIT 100
                            I$ = INKEY$
                            IF I$ = CHR$(27) THEN
                                EXIT DO
                            END IF
                        ELSE
                            EXIT DO
                        END IF
                    LOOP
            END SELECT
            I$ = Nul
        END IF
        IF LEN(I$) = 2 THEN
            GOSUB DirBoxKey
        END IF
    LOOP
    RETURN

    ' clear directory.
    ClearDirectory:
    Locatef Dir.Box.Line + Xcoor + 4, Ycoor + 19, 1
    Colorf2 Plain, 0
    Printf LEFT$(RTRIM$(Directories(Current.Dir!)), 12)
    RETURN

    ' display directory.
    DisplayDirectory:
    Locatef Dir.Box.Line + Xcoor + 4, Ycoor + 19, 1
    Colorf2 Black, Plain
    Printf LEFT$(RTRIM$(Directories(Current.Dir!)), 12)
    Colorf2 Plain, 0
    RETURN

    ' display directory.
    DisplayDirectory2:
    Colorf2 Black, Plain
    Locatef Xcoor + 14, Ycoor + 19, 1
    Printf LEFT$(RTRIM$(Directories(Current.Dir!)), 12)
    Colorf2 Plain, 0
    RETURN

    ' display directory.
    DisplayDirectory3:
    Colorf2 Black, Plain
    Locatef Xcoor + 5, Ycoor + 19, 1
    Printf LEFT$(RTRIM$(Directories(Current.Dir!)), 12)
    Colorf2 Plain, 0
    RETURN

    ' update dir box.
    DisplayDirBox1:
    Colorf2 Plain, 0
    FOR V = 1 TO 9
        Locatef Xcoor - V + 14, Ycoor + 19, 1
        Printf LEFT$(RTRIM$(Directories(Current.Dir! - V)), 12)
    NEXT
    RETURN

    ' update dir box.
    DisplayDirBox2:
    Colorf2 Plain, 0
    FOR V = 1 TO 9
        IF Current.Dir! + V <= Num.Dirs THEN
            Locatef Xcoor + V + 5, Ycoor + 19, 1
            Printf LEFT$(RTRIM$(Directories(Current.Dir! + V)), 12)
        END IF
    NEXT
    RETURN

    ' process dir box key.
    DirBoxKey:
    V = ASC(RIGHT$(I$, 1))
    SELECT CASE V
        CASE 82 ' insert
            Locatef Xcoor + 1, Ycoor + 2, 1
            Printf SPACE$(38)
            Locatef Xcoor + 1, Ycoor + 2, 1
            Colorf2 White, 0

            ' get new path.
            Printf "Dir path?"
            ZQ$ = LineInput$(Xcoor + 1, Ycoor + 12, 28)

            ' parse new path.
            IF LEN(ZQ$) THEN

                ' create directory.
                G$ = MakeFilename$(N$, C$, D$, ZQ$)
                G$ = G$ + CHR$(0)
                x = CreateDirectoryA(G$, 0)

                ' check carry flag error
                IF x = 0 THEN
                    Locatef Xcoor + 1, Ycoor + 2, 1
                    Printf SPACE$(38)
                    Locatef Xcoor + 1, Ycoor + 2, 1
                    Colorf2 White, 0
                    IF GetLastError& = &HB7 THEN
                        Printf "Directory already exists. Press <esc>:"
                    ELSE
                        Printf "Error 0x" + HEX$(GetLastError) + " Press <esc>:"
                    END IF
                    CALL PromptInkey
                ELSE
                    ' redisplay dir box.
                    GOSUB DisplayFilename6
                    GOSUB ClearDirBox
                    DirLoadMessage = "Loading dirs.."
                    CALL LoadDirSpec(DirY$, N$, C$, D$)
                    GOSUB DisplayDirSpec
                    GOSUB DisplayCurrentDir
                    GOSUB DisplayCurrentPath
                    ' display first directory.
                    Current.Dir! = 1!
                    Dir.Box.Line = 1
                    GOSUB DisplayInitDir
                END IF
            END IF
            GOSUB DisplayFilename6
            GOSUB DisplayFileLine
            GOSUB DisplayInitDir
            GOSUB DisplayLongName1
        CASE 83 ' delete
            ' check path.
            Q$ = RTRIM$(Directories(Current.Dir!))
            IF Q$ = "." OR Q$ = ".." THEN
                Locatef Xcoor + 1, Ycoor + 2, 1
                Printf SPACE$(38)
                Locatef Xcoor + 1, Ycoor + 2, 1
                Colorf2 White, 0
                Printf "Can't delete directory. Press <esc>:"
                CALL PromptInkey
            ELSE
                Locatef Xcoor + 1, Ycoor + 2, 1
                Printf SPACE$(38)
                Locatef Xcoor + 1, Ycoor + 2, 1
                Colorf2 White, 0
                Printf "Delete current path(y/n)?"
                ErrorRespond$ = Nul
                DO
                    _LIMIT 100
                    ErrorRespond$ = INKEY$
                    IF LEN(ErrorRespond$) THEN
                        IF UCASE$(ErrorRespond$) = "Y" THEN
                            EXIT DO
                        END IF
                        IF UCASE$(ErrorRespond$) = "N" THEN
                            EXIT DO
                        END IF
                    END IF
                LOOP
                IF UCASE$(ErrorRespond$) = "Y" THEN

                    ' delete directory.
                    G$ = MakeFilename$(N$, C$, D$, Q$) + "\"
                    CALL Silentdel_Directories(G$)

                    ' check carry flag error
                    IF _DIREXISTS(G$) THEN
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Printf SPACE$(38)
                        Locatef Xcoor + 1, Ycoor + 2, 1
                        Colorf2 White, 0
                        Printf "Error deleting directory. Press <esc>:"
                        CALL PromptInkey
                    ELSE
                        ' redisplay dir box.
                        GOSUB DisplayFilename6
                        GOSUB ClearDirBox
                        DirLoadMessage = "Loading dirs.."
                        CALL LoadDirSpec(DirY$, N$, C$, D$)
                        GOSUB DisplayDirSpec
                        GOSUB DisplayCurrentDir
                        GOSUB DisplayCurrentPath
                        ' display first directory.
                        Current.Dir! = 1!
                        Dir.Box.Line = 1
                        GOSUB DisplayInitDir
                    END IF
                END IF
            END IF
            GOSUB DisplayFilename6
            GOSUB DisplayFileLine
            GOSUB DisplayInitDir
            GOSUB DisplayLongName1
        CASE 72, 141, 152 ' up/ctrl-up/alt-up
            IF Current.Dir! - 1 > 0 THEN
                IF Dir.Box.Line > 1 THEN
                    GOSUB ClearDirectory
                    Dir.Box.Line = Dir.Box.Line - 1
                    Current.Dir! = Current.Dir! - 1!
                    GOSUB DisplayDirectory
                ELSE
                    GOSUB ClearDirBox
                    Current.Dir! = Current.Dir! - 1!
                    GOSUB DisplayDirBox2
                    GOSUB DisplayDirectory3
                END IF
                Q$ = RTRIM$(Directories(Current.Dir!))
                GOSUB DisplayLongName1
            END IF
        CASE 80, 145, 160 ' down/ctrl-down/alt-down
            IF Current.Dir! + 1 <= Num.Dirs THEN
                IF Dir.Box.Line < 10 THEN
                    GOSUB ClearDirectory
                    Dir.Box.Line = Dir.Box.Line + 1
                    Current.Dir! = Current.Dir! + 1!
                    GOSUB DisplayDirectory
                ELSE
                    GOSUB ClearDirBox
                    Current.Dir! = Current.Dir! + 1!
                    GOSUB DisplayDirBox1
                    GOSUB DisplayDirectory2
                END IF
                Q$ = RTRIM$(Directories(Current.Dir!))
                GOSUB DisplayLongName1
            END IF
        CASE 73, 132 ' pageup/ctrl-pageup
            IF Current.Dir! - 10 > 0 THEN
                Dir.Box.Line = 1
                Current.Dir! = Current.Dir! - 10!
            ELSE
                Dir.Box.Line = 1
                Current.Dir! = 1!
            END IF
            GOSUB ClearDirBox
            GOSUB DisplayDirBox2
            GOSUB DisplayDirectory3
            Q$ = RTRIM$(Directories(Current.Dir!))
            GOSUB DisplayLongName1
        CASE 81, 118 ' pagedown/ctrl-pagedown
            IF Current.Dir! + 10 <= Num.Dirs THEN
                GOSUB ClearDirBox
                Dir.Box.Line = 10
                Current.Dir! = Current.Dir! + 10!
                GOSUB DisplayDirBox1
                GOSUB DisplayDirectory2
                Q$ = RTRIM$(Directories(Current.Dir!))
                GOSUB DisplayLongName1
            ELSE
                IF Current.Dir! + 1 <= Num.Dirs THEN
                    DO UNTIL Current.Dir! = Num.Dirs
                        IF Dir.Box.Line < 10 THEN
                            GOSUB ClearDirectory
                            Dir.Box.Line = Dir.Box.Line + 1
                            Current.Dir! = Current.Dir! + 1!
                            GOSUB DisplayDirectory
                        ELSE
                            GOSUB ClearDirBox
                            Current.Dir! = Current.Dir! + 1!
                            GOSUB DisplayDirBox1
                            GOSUB DisplayDirectory2
                        END IF
                    LOOP
                    Q$ = RTRIM$(Directories(Current.Dir!))
                    GOSUB DisplayLongName1
                END IF
            END IF
        CASE 71, 119 ' home/ctrl-home
            IF Current.Dir! > 1 THEN
                Dir.Box.Line = 1
                Current.Dir! = 1!
            END IF
            GOSUB ClearDirBox
            GOSUB DisplayDirBox2
            GOSUB DisplayDirectory3
            Q$ = RTRIM$(Directories(Current.Dir!))
            GOSUB DisplayLongName1
        CASE 79, 117 ' end/ctrl-end
            IF Current.Dir! + 1 <= Num.Dirs THEN
                DO UNTIL Current.Dir! = Num.Dirs
                    IF Dir.Box.Line < 10 THEN
                        GOSUB ClearDirectory
                        Dir.Box.Line = Dir.Box.Line + 1
                        Current.Dir! = Current.Dir! + 1!
                        GOSUB DisplayDirectory
                    ELSE
                        GOSUB ClearDirBox
                        Current.Dir! = Current.Dir! + 1!
                        GOSUB DisplayDirBox1
                        GOSUB DisplayDirectory2
                    END IF
                    _LIMIT 100
                    I$ = INKEY$
                    IF I$ = CHR$(27) THEN
                        EXIT DO
                    END IF
                LOOP
                Q$ = RTRIM$(Directories(Current.Dir!))
                GOSUB DisplayLongName1
            END IF
    END SELECT
    RETURN

    ' drive input loop.
    DriveInputLoop:
    I$ = Nul
    DO
        GOSUB DisplayDrive
        DO
            ' get keystroke.
            _LIMIT 100
            I$ = INKEY$
            IF LEN(I$) THEN
                IsMenu = False
                EXIT DO
            END IF

            ' call mouse subroutine.
            Z = MouseDriver

            ' check file entry area.
            IF IsMenu >= 4 THEN
                RETURN
            END IF

            ' check mouse wheel.
            IF MouseWheel = -1 THEN
                IF WheelReverse THEN
                    I$ = CHR$(0) + CHR$(80) ' down
                ELSE
                    I$ = CHR$(0) + CHR$(72) ' up
                END IF
                MouseWheel = 0
                EXIT DO
            END IF
            IF MouseWheel = 1 THEN
                IF WheelReverse THEN
                    I$ = CHR$(0) + CHR$(72) ' up
                ELSE
                    I$ = CHR$(0) + CHR$(80) ' down
                END IF
                MouseWheel = 0
                EXIT DO
            END IF

            ' check left mouse button.
            IF MouseButton1 THEN
                GOSUB MouseButton1Z
                SELECT CASE IsMenu
                    CASE 1 ' file box.
                        IF I$ = CHR$(13) THEN
                            RETURN
                        ELSE
                            GOSUB FileBoxKey
                        END IF
                    CASE 2 ' dir box.
                        IF I$ = CHR$(13) THEN
                            RETURN
                        ELSE
                            GOSUB DirBoxKey
                        END IF
                    CASE 3 ' drive box.
                        IF I$ = CHR$(13) THEN
                            RETURN
                        ELSE
                            GOSUB DriveBoxKey
                        END IF
                END SELECT
            ELSE
                ' check mouse position.
                IF MouseX OR MouseY THEN
                    GOSUB MouseOverX1
                    GOSUB DisplayDrive
                END IF
            END IF
        LOOP

        ' check function key.
        IF LEN(I$) = 2 THEN
            VarQ = ASC(RIGHT$(I$, 1))
            SELECT CASE VarQ
                CASE 59 TO 68, 104 TO 113, 133, 134
                    RETURN
            END SELECT
            GOSUB GetAltKey
            IF VarZ THEN
                RETURN
            END IF
        END IF

        ' left returns shift-tab.
        IF LEN(I$) = 2 THEN
            IF ASC(RIGHT$(I$, 1)) = 75 THEN
                I$ = CHR$(0) + CHR$(15)
            END IF
        END IF

        ' shift-tab returns to directory loop.
        IF LEN(I$) = 2 THEN
            IF ASC(RIGHT$(I$, 1)) = 15 THEN
                I$ = Nul
                GOSUB DisplayDirectory
                RETURN
            END IF
        END IF

        ' up returns tab.
        IF LEN(I$) = 2 THEN
            IF ASC(RIGHT$(I$, 1)) = 72 THEN
                IF Current.Drive = 1 THEN
                    IF Drive.Box.Line = 1 THEN
                        I$ = CHR$(9)
                    END IF
                END IF
            END IF
        END IF

        ' right returns tab.
        IF LEN(I$) = 2 THEN
            IF ASC(RIGHT$(I$, 1)) = 77 THEN
                I$ = CHR$(9)
            END IF
        END IF

        ' Tab returns to top loop.
        IF I$ = CHR$(9) THEN
            RETURN
        END IF

        ' select a drive.
        IF I$ = CHR$(13) THEN
            IsMenu = 3
            RETURN
        END IF

        ' exit from drive box.
        IF I$ = CHR$(27) THEN
            RETURN
        END IF

        ' process drive box keystroke.
        IF LEN(I$) THEN
            GOSUB DriveBoxKey
        END IF
    LOOP
    RETURN

    ' process drive letter.
    GetAltKey:
    ' get alt keycode.
    Var = ASC(RIGHT$(I$, 1))
    VarZ = False
    ' compare all Alt-n keys.
    FOR Var2 = 1 TO 26 ' A - Z
        ' check key.
        IF Keys(Var2) = Var THEN
            IF Var2 <= Last.Drive THEN
                VarZ = True
            END IF
            RETURN
        END IF
    NEXT
    RETURN

    ' process drive box key.
    DriveBoxKey:
    SELECT CASE LEN(I$)
        CASE 1
            ' select a drive letter.
            SELECT CASE I$
                CASE "A" TO "Z"
                    V0 = ASC(I$) - 64
                    GOSUB MoveSelectDrive
                CASE "a" TO "z"
                    V0 = ASC(I$) - 96
                    GOSUB MoveSelectDrive
                CASE "<" ' up
                    GOSUB MoveDriveUp
                CASE ">" ' down
                    V6 = False
                    GOSUB MoveDriveDown
                CASE "|" ' drive A:
                    GOSUB MoveFirstDrive
                CASE "#" ' drive Z:
                    GOSUB MoveLastDrive
            END SELECT
        CASE 2
            V = ASC(RIGHT$(I$, 1))
            SELECT CASE V
                CASE 71, 119 ' home/ctrl-home
                    GOSUB MoveFirstDrive
                CASE 79, 117 ' end/ctrl-end
                    GOSUB MoveLastDrive
                CASE 72, 141, 152 ' up/ctrl-up/alt-up
                    GOSUB MoveDriveUp
                CASE 80, 145, 160 ' down/ctrl-down/alt-down
                    V6 = False
                    GOSUB MoveDriveDown
                CASE 73, 132 ' pageup/ctrl-pageup
                    FOR V7 = 1 TO 5 ' scroll up one-half page
                        GOSUB MoveDriveUp
                    NEXT
                CASE 81, 118 ' pagedown/ctrl-pagedown
                    FOR V7 = 1 TO 5 ' scroll down one-half page
                        V6 = False
                        GOSUB MoveDriveDown
                    NEXT
            END SELECT
    END SELECT
    RETURN

    ' move to selected drive.
    MoveSelectDrive:
    IF V0 > Last.Drive THEN
        V0 = Last.Drive
    END IF
    GOSUB MoveFirstDrive ' assume A:
    ' scroll down to drive letter.
    FOR V7 = 2 TO V0 ' B: to Z:
        V6 = False
        GOSUB MoveDriveDown
    NEXT
    RETURN

    ' move to drive A:
    MoveFirstDrive:
    DO
        IF Current.Drive > 1 THEN
            GOSUB MoveDriveUp
        ELSE
            EXIT DO
        END IF
    LOOP
    RETURN

    ' move to last drive.
    MoveLastDrive:
    DO
        IF Current.Drive + 1 <= Last.Drive THEN
            V6 = False
            GOSUB MoveDriveDown
        ELSE
            EXIT DO
        END IF
    LOOP
    RETURN

    ' move up one drive letter.
    MoveDriveUp:
    IF Current.Drive - 1 > 0 THEN
        IF Drive.Box.Line > 1 THEN
            GOSUB ClearDrive
            Drive.Box.Line = Drive.Box.Line - 1
            Current.Drive = Current.Drive - 1
            GOSUB DisplayDrive
        ELSE
            Current.Drive = Current.Drive - 1
            GOSUB ClearDriveBox
            Colorf2 Plain, 0
            FOR VX = 1 TO 9
                Locatef Xcoor + VX + 5, Ycoor + 35, 0
                Printf "[" + CHR$(Current.Drive + VX + 64) + "]"
            NEXT
            Drive.Box.Line = 1
            GOSUB DisplayDrive
        END IF
    END IF
    RETURN

    ' move down one drive letter with drive info.
    MoveDriveDown:
    IF Current.Drive + 1 <= Last.Drive THEN
        IF Drive.Box.Line < 10 THEN
            GOSUB ClearDrive
            Drive.Box.Line = Drive.Box.Line + 1
            Current.Drive = Current.Drive + 1
            IF V6 = False THEN
                GOSUB DisplayDrive
            ELSE
                GOSUB DisplayDrive2
            END IF
        ELSE
            Current.Drive = Current.Drive + 1
            GOSUB ClearDriveBox
            Colorf2 Plain, 0
            FOR VX = 1 TO 9
                Locatef Xcoor - VX + 14, Ycoor + 35, 1
                Printf "[" + CHR$(Current.Drive - VX + 64) + "]"
            NEXT
            Drive.Box.Line = 10
            IF V6 = False THEN
                GOSUB DisplayDrive
            ELSE
                GOSUB DisplayDrive2
            END IF
        END IF
    END IF
    RETURN

    ' display path with dir info.
    DisplayCurrentPath:
    GOSUB DisplayCurrentPath3
    GOSUB DisplayLongName0
    RETURN

    ' display path w/o dir info.
    DisplayCurrentPath2:
    GOSUB DisplayCurrentPath3
    GOSUB DisplayLongName3
    RETURN

    ' format pathname for display.
    DisplayCurrentPath3:
    Q$ = D$
    FOR Var = LEN(Q$) TO 1 STEP -1
        IF MID$(Q$, Var, 1) = "\" THEN
            Q$ = MID$(Q$, Var + 1)
            EXIT FOR
        END IF
    NEXT
    IF Q$ = Nul THEN
        Q$ = "\"
    END IF
    RETURN

    ' display long directory w/o dir info.
    DisplayLongName0:
    Colorf2 Green, BackGround
    IF Xcoor + 17 <= 24 THEN
        Length = 80 - Ycoor - 1
        Locatef Xcoor + 17, Ycoor, 0
        Printf SPACE$(Length)
        Locatef Xcoor + 17, Ycoor, 0
        IF Q$ = "." OR Q$ = ".." THEN
            G$ = Q$
        ELSE
            G$ = MakeFilename2$(N$, C$, D$)
            G$ = UnAmbiguateFile$(G$)
        END IF
        P$ = "Path: " + G$
        IF LEN(P$) > Length THEN
            P$ = LEFT$(P$, Length - 3) + "..."
        END IF
        Printf P$
    END IF
    Colorf2 Plain, 0
    RETURN

    ' display long directory with dir info.
    DisplayLongName1:
    Colorf2 Green, BackGround
    IF Xcoor + 17 <= 24 THEN
        Length = 80 - Ycoor - 1
        Locatef Xcoor + 17, Ycoor, 0
        Printf SPACE$(Length)
        Locatef Xcoor + 17, Ycoor, 0
        IF Q$ = "." OR Q$ = ".." THEN
            G$ = Q$
        ELSE
            G$ = MakeFilename$(N$, C$, D$, Q$)
            G$ = UnAmbiguateFile$(G$)
        END IF
        P$ = "Path: " + G$
        IF LEN(P$) > Length THEN
            P$ = LEFT$(P$, Length - 3) + "..."
        END IF
        Printf P$
    END IF
    Colorf2 Plain, 0
    GOSUB DisplayDirInfo
    V = LEN(RTRIM$(Directories(Current.Dir!)))
    IF V > 12 THEN
        V = 12
    END IF
    Locatef Dir.Box.Line + Xcoor + 4, Ycoor + V + 19, 1
    RETURN

    ' display long filename with file info.
    DisplayLongName2:
    Colorf2 Green, BackGround
    IF Xcoor + 18 <= 24 THEN
        Length = 80 - Ycoor - 1
        Locatef Xcoor + 18, Ycoor, 0
        Printf SPACE$(Length)
        Locatef Xcoor + 18, Ycoor, 0
        G$ = MakeFilename$(N$, C$, D$, E$)
        G$ = UnAmbiguateFile$(G$)
        P$ = "File: " + G$
        IF LEN(P$) > Length THEN
            P$ = LEFT$(P$, Length - 3) + "..."
        END IF
        Printf P$
    END IF
    Colorf2 Plain, 0
    GOSUB DisplayFileInfo
    V = LEN(RTRIM$(Filenames(Current.File!)))
    IF V > 12 THEN
        V = 12
    END IF
    Locatef Box.Line + Xcoor + 4, Ycoor + V + 3, 1
    RETURN

    ' display long directory w/o dir info.
    DisplayLongName3:
    Colorf2 Green, BackGround
    IF Xcoor + 17 <= 24 THEN
        Length = 80 - Ycoor - 1
        Locatef Xcoor + 17, Ycoor, 0
        Printf SPACE$(Length)
        Locatef Xcoor + 17, Ycoor, 0
        P$ = "Path: " + Q$
        IF LEN(P$) > Length THEN
            P$ = LEFT$(P$, Length - 3) + "..."
        END IF
        Printf P$
    END IF
    Colorf2 Plain, 0
    RETURN

    ' display filename information.
    DisplayFileInfo:
    Colorf2 Green, BackGround
    IF Xcoor + 19 <= 24 THEN
        GOSUB GetFileInfo
        Var# = FileSize
        P$ = "Info: " + FormatX$(Var#, -1)
        SELECT CASE QuietSwitch
            CASE -1, 1, 3, 5
                ' nul
            CASE ELSE
                IF LEN(FileDateTime) THEN
                    P$ = P$ + FileDateTime
                END IF
        END SELECT
        SELECT CASE QuietSwitch
            CASE -1, 2, 3, 6
                ' nul
            CASE ELSE
                GOSUB GetAttribute
        END SELECT
        GOSUB DisplayInfo
    END IF
    Colorf2 Plain, 0
    RETURN

    ' display directory information.
    DisplayDirInfo:
    Colorf2 Green, BackGround
    IF Xcoor + 19 <= 24 THEN
        GOSUB GetDirInfo
        P$ = "Info: <dir> "
        SELECT CASE QuietSwitch
            CASE -1, 1, 3, 5
                ' nul
            CASE ELSE
                IF LEN(FileDateTime) THEN
                    P$ = P$ + FileDateTime
                END IF
        END SELECT
        SELECT CASE QuietSwitch
            CASE -1, 2, 3, 6
                ' nul
            CASE ELSE
                GOSUB GetAttribute
        END SELECT
        GOSUB DisplayInfo
    END IF
    Colorf2 Plain, 0
    RETURN

    ' display drive attribute.
    DisplayDriveInfo:
    Colorf2 Green, BackGround
    IF Xcoor + 19 <= 24 THEN
        P$ = "Info: " + CHR$(Current.Drive + 64) + ":\"
        CALL GetDriveInfo(DriveAttribute$)
        P$ = P$ + DriveAttribute$
        GOSUB DisplayInfo
    END IF
    Colorf2 Plain, 0
    RETURN

    ' display file info.
    DisplayInfo:
    Length = 80 - Ycoor - 1
    Locatef Xcoor + 19, Ycoor, 0
    Printf SPACE$(Length)
    Locatef Xcoor + 19, Ycoor, 0
    IF Ycoor + LEN(P$) >= 80 THEN
        P$ = LEFT$(P$, 80 - Ycoor - 1)
    END IF
    Printf P$
    RETURN

    ' get filesize, date/time, and attribute.
    GetFileInfo:
    ' store long filename.
    ASCIIZ = MakeFilename$(N$, C$, D$, E$) + CHR$(0)
    ' get file info
    CALL GetInfo(-1, V$)
    RETURN

    ' get dir date/time, attribute.
    GetDirInfo:
    ' store long filename.
    ASCIIZ = MakeFilename$(N$, C$, D$, Q$) + CHR$(0)
    ' get file info
    CALL GetInfo(-1, V$)
    RETURN

    ' get file/dir attribute.
    GetAttribute:
    CALL GetInfo(0, A$)
    IF A$ <> Nul THEN
        IF Ycoor + LEN(P$) + LEN(A$) < 80 THEN
            P$ = P$ + A$
        END IF
    END IF
    RETURN

    ' clear long directory area.
    ClearLongName1:
    Colorf2 Green, BackGround
    IF Xcoor + 17 <= 24 THEN
        Length = 80 - Ycoor - 1
        Locatef Xcoor + 17, Ycoor, 0
        Printf SPACE$(Length)
        Locatef Xcoor + 17, Ycoor, 0
        Printf "Path: "
    END IF
    Colorf2 Plain, 0
    RETURN

    ' clear long filename area.
    ClearLongName2:
    Colorf2 Green, BackGround
    IF Xcoor + 18 <= 24 THEN
        Length = 80 - Ycoor - 1
        Locatef Xcoor + 18, Ycoor, 0
        Printf SPACE$(Length)
        Locatef Xcoor + 18, Ycoor, 0
        Printf "File: "
    END IF
    ' clear size area.
    IF Xcoor + 19 <= 24 THEN
        Length = 80 - Ycoor - 1
        Locatef Xcoor + 19, Ycoor, 0
        Printf SPACE$(Length)
        Locatef Xcoor + 19, Ycoor, 0
        Printf "Info: "
    END IF
    Colorf2 Plain, 0
    RETURN

    ' construct new path.
    GetNewPath:
    ' check filespec.
    IF INSTR(X$, "?") = False THEN
        IF INSTR(X$, "*") = False THEN
            X$ = "*.*"
            Xposition1 = 1
            Xposition2 = 3
        END IF
    END IF
    ' check file.
    IF X$ = Nul THEN
        X$ = "*.*"
        Xposition1 = 1
        Xposition2 = 3
    END IF
    ' store new path.
    Q$ = RTRIM$(Directories(Current.Dir!))
    ' store path to be parsed.
    X$ = Q$ + "\" + X$
    RETURN

    ' truncate filename for display.
    TruncateFilename:
    A$ = RTRIM$(E$)
    IF LEN(A$) > 26 THEN
        A$ = LEFT$(A$, 23) + "..."
    END IF
    RETURN

    ' return current drive.
    InitDrive:
    IF C$ = Nul THEN
        D1$ = _CWD$
        C$ = UCASE$(LEFT$(D1$, 1))
        Drive.Number = ASC(C$) - 65 ' 0=a, 1=b,..
        RETURN
    END IF
    Drive.Number = ASC(C$) - 65
    RETURN

    ' check path.
    CheckPath:
    ' reset flag.
    ValidPath = True

    ' check path.
    IF D$ = Nul THEN
        RETURN
    END IF
    IF D$ = "\" THEN
        RETURN
    END IF

    ' store directory.
    ASCIIZ = MakeFilename2$(N$, C$, D$) + CHR$(0)
    AttributeX = GetFileAttr(ASCIIZ)

    ' check filename is not path.
    IF (AttributeX AND &H10) <> &H10 THEN
        ValidPath = False
    END IF
    RETURN

    ' display directory box.
    DisplayDirSpec:
    VarX! = SFalse
    DO
        VarX! = VarX! + 1!
        IF VarX! > 10! THEN
            EXIT DO
        END IF
        IF VarX! > Num.Dirs THEN
            EXIT DO
        END IF
        Locatef CINT(VarX!) + Xcoor + 4, Ycoor + 19, 1
        Q$ = Directories(VarX!)
        Q$ = RTRIM$(Q$)
        Printf LEFT$(Q$, 12)
    LOOP
    RETURN

    ' clear directory box.
    ClearDirBox:
    FOR VarX = 1 TO 10
        Locatef VarX + Xcoor + 4, Ycoor + 19, 1
        Printf SPACE$(12)
    NEXT
    RETURN

    ' display directory.
    DisplayCurrentDir:

    ' ambiguate dospath.
    IF RIGHT$(D$, 2) = "\." THEN
        D$ = LEFT$(D$, LEN(D$) - 2)
    END IF
    ASCIIZ = MakeFilename4$(N$, C$, D$) + CHR$(0)
    V4 = True
    GOSUB ShortFilenameX
    IF Short.Filename$ = Nul THEN
        IF N$ = Nul THEN
            Short.Filename$ = C$ + ":\"
        ELSE
            Short.Filename$ = N$
        END IF
    END IF
    Z$ = Short.Filename$
    IF N$ = Nul THEN
        IF MID$(Z$, 2, 1) <> ":" THEN
            Z$ = C$ + ":" + Z$
        END IF
    ELSE
        IF MID$(Z$, 2, 1) = ":" THEN
            Z$ = MID$(Z$, 3)
        END IF
    END IF

    ' get deconcatenated filename.
    N1$ = N$
    CALL Deconcatenate(N$, Z$, 37)
    N$ = N1$

    ' display filename.
    Locatef Xcoor + 2, Ycoor + 2, 1
    Printf SPACE$(37)
    Locatef Xcoor + 2, Ycoor + 2, 1
    Printf UCASE$(Z$)
    RETURN

    ' display filename box.
    DisplayFileSpec:
    VarX! = SFalse
    DO
        VarX! = VarX! + 1!
        IF VarX! > 10! THEN
            EXIT DO
        END IF
        IF VarX! > Num.Files THEN
            EXIT DO
        END IF
        Locatef CINT(VarX!) + Xcoor + 4, Ycoor + 3, 1
        Q$ = Filenames(VarX!)
        Q$ = RTRIM$(Q$)
        Printf LEFT$(Q$, 12)
    LOOP
    RETURN

    ' clear filename box.
    ClearFileBox:
    FOR VarX = 1 TO 10
        Locatef VarX + Xcoor + 4, Ycoor + 3, 1
        Printf SPACE$(12)
    NEXT
    RETURN

    ' format filename for display and search purposes.
    ShortFilenameX:
    IF D$ = "\" THEN
        Short.Filename$ = "\"
        RETURN
    END IF
    IF D$ = Nul THEN
        Short.Filename$ = "\"
        RETURN
    END IF

    ' read ambiguated 8.3 filename.
    CALL GetShortFilename(Short.Filename$)
    IF Short.Filename$ = Nul THEN
        RETURN
    END IF

    ' check 8.3 flag.
    IF V4 THEN
        RETURN
    END IF

    ' store 8.3 filename.
    FOR V = LEN(Short.Filename$) TO 1 STEP -1
        IF MID$(Short.Filename$, V, 1) = "\" THEN
            Short.Filename$ = MID$(Short.Filename$, V + 1)
            EXIT FOR
        END IF
    NEXT
    RETURN

    ' clear current drive.
    ClearDrive:
    Colorf2 Plain, 0
    Locatef Xcoor + Drive.Box.Line + 4, Ycoor + 35, 0
    Printf "[" + CHR$(Current.Drive + 64) + "]"
    RETURN

    ' clear drive box.
    ClearDriveBox:
    FOR Var = 1 TO 10
        Locatef Xcoor + 4 + Var, Ycoor + 35, 1
        Printf "   "
    NEXT
    RETURN

    ' display current drive with info.
    DisplayDrive:
    GOSUB DisplayDriveInfo
    Colorf2 Black, Plain
    Locatef Xcoor + Drive.Box.Line + 4, Ycoor + 35, 1
    Printf "[" + CHR$(Current.Drive + 64) + "]"
    Locatef Xcoor + Drive.Box.Line + 4, Ycoor + 38, 1
    Colorf2 Plain, 0
    RETURN

    ' display current drive w/o info.
    DisplayDrive2:
    Colorf2 Black, Plain
    Locatef Xcoor + Drive.Box.Line + 4, Ycoor + 35, 1
    Printf "[" + CHR$(Current.Drive + 64) + "]"
    Locatef Xcoor + Drive.Box.Line + 4, Ycoor + 38, 1
    Colorf2 Plain, 0
    RETURN

    ' display available drives.
    DisplayDrives:
    FOR Var = 1 TO Last.Drive
        IF Var > 10 THEN
            EXIT FOR
        END IF
        Locatef Xcoor + 4 + Var, Ycoor + 35, 1
        Printf "[" + CHR$(Var + 64) + "]"
    NEXT
    RETURN

    ' display current drives.
    InitDrives:
    ' init drive letter.
    IF Current.Drive = False THEN
        Current.Drive = Drive.Number + 1
    END IF
    ' display drives.
    V3 = Current.Drive
    IF V3 > Last.Drive THEN
        V3 = Last.Drive
    END IF
    GOSUB ClearDriveBox
    Drive.Box.Line = 1
    Current.Drive = 1
    GOSUB DisplayDrives
    GOSUB DisplayDrive2
    ' scroll to drive.
    DO UNTIL Current.Drive >= V3
        V6 = True
        GOSUB MoveDriveDown
    LOOP
    GOSUB DisplayDriveInfo
    RETURN

    ' process left mouse button single-click.
    MouseButton1Z:
    ' store mouse variables.
    IsMenu = False
    ' file box pageup
    IF MouseX = Xcoor + 4 THEN
        IF MouseY = Ycoor + 16 THEN
            I$ = CHR$(0) + CHR$(73)
            IsMenu = 1
            RETURN
        END IF
    END IF
    ' file box up
    IF MouseX = Xcoor + 5 THEN
        IF MouseY = Ycoor + 16 THEN
            I$ = CHR$(0) + CHR$(72)
            IsMenu = 1
            RETURN
        END IF
    END IF
    ' file box down
    IF MouseX = Xcoor + 14 THEN
        IF MouseY = Ycoor + 16 THEN
            I$ = CHR$(0) + CHR$(80)
            IsMenu = 1
            RETURN
        END IF
    END IF
    ' file box pagedown
    IF MouseX = Xcoor + 15 THEN
        IF MouseY = Ycoor + 16 THEN
            I$ = CHR$(0) + CHR$(81)
            IsMenu = 1
            RETURN
        END IF
    END IF
    ' directory box pageup
    IF MouseX = Xcoor + 4 THEN
        IF MouseY = Ycoor + 32 THEN
            I$ = CHR$(0) + CHR$(73)
            IsMenu = 2
            RETURN
        END IF
    END IF
    ' directory box up
    IF MouseX = Xcoor + 5 THEN
        IF MouseY = Ycoor + 32 THEN
            I$ = CHR$(0) + CHR$(72)
            IsMenu = 2
            RETURN
        END IF
    END IF
    ' directory box down
    IF MouseX = Xcoor + 14 THEN
        IF MouseY = Ycoor + 32 THEN
            I$ = CHR$(0) + CHR$(80)
            IsMenu = 2
            RETURN
        END IF
    END IF
    ' directory box pagedown
    IF MouseX = Xcoor + 15 THEN
        IF MouseY = Ycoor + 32 THEN
            I$ = CHR$(0) + CHR$(81)
            IsMenu = 2
            RETURN
        END IF
    END IF
    ' drive box up
    IF MouseX = Xcoor + 5 THEN
        IF MouseY = Ycoor + 39 THEN
            I$ = CHR$(0) + CHR$(72)
            IsMenu = 3
            RETURN
        END IF
    END IF
    ' drive box down
    IF MouseX = Xcoor + 14 THEN
        IF MouseY = Ycoor + 39 THEN
            I$ = CHR$(0) + CHR$(80)
            IsMenu = 3
            RETURN
        END IF
    END IF
    ' check mouse selection boundaries for file box.
    IF MouseX >= Xcoor + 5 AND MouseX <= Xcoor + 14 THEN
        IF MouseY >= Ycoor + 3 AND MouseY <= Ycoor + 14 THEN
            IF Num.Files > 0 THEN
                I$ = Nul
                Valid = False
                V = MouseX - (Xcoor + 4)
                IF V = Box.Line THEN
                    Valid = True
                END IF
                IF V > Box.Line THEN
                    IF Current.File! + (V - Box.Line) <= Num.Files THEN
                        Current.File! = Current.File! + (V - Box.Line)
                        Valid = True
                    END IF
                END IF
                IF V < Box.Line THEN
                    IF Current.File! - (Box.Line - V) > 0 THEN
                        Current.File! = Current.File! - (Box.Line - V)
                        Valid = True
                    END IF
                END IF
                IF Valid THEN
                    I$ = CHR$(13)
                    IsMenu = 1
                END IF
            END IF
            RETURN
        END IF
    END IF
    ' check mouse selection boundaries for dir box.
    IF MouseX >= Xcoor + 5 AND MouseX <= Xcoor + 14 THEN
        IF MouseY >= Ycoor + 19 AND MouseY <= Ycoor + 31 THEN
            I$ = Nul
            Valid = False
            V = MouseX - (Xcoor + 4)
            IF V = Dir.Box.Line THEN
                Valid = True
            END IF
            IF V > Dir.Box.Line THEN
                IF Current.Dir! + (V - Dir.Box.Line) <= Num.Dirs THEN
                    Current.Dir! = Current.Dir! + (V - Dir.Box.Line)
                    Valid = True
                END IF
            END IF
            IF V < Dir.Box.Line THEN
                IF Current.Dir! - (Dir.Box.Line - V) > 0 THEN
                    Current.Dir! = Current.Dir! - (Dir.Box.Line - V)
                    Valid = True
                END IF
            END IF
            IF Valid THEN
                I$ = CHR$(13)
                IsMenu = 2
            END IF
            RETURN
        END IF
    END IF
    ' check mouse selection boundaries for drive box.
    IF MouseX >= Xcoor + 5 AND MouseX <= Xcoor + 14 THEN
        IF MouseY >= Ycoor + 35 AND MouseY <= Ycoor + 37 THEN
            I$ = Nul
            Valid = False
            V = MouseX - (Xcoor + 4)
            IF V = Drive.Box.Line THEN
                Valid = True
            END IF
            IF V > Drive.Box.Line THEN
                IF Current.Drive + (V - Drive.Box.Line) <= Last.Drive THEN
                    GOSUB ClearDrive
                    Current.Drive = Current.Drive + (V - Drive.Box.Line)
                    Drive.Box.Line = Drive.Box.Line + (V - Drive.Box.Line)
                    GOSUB DisplayDrive
                    Valid = True
                END IF
            END IF
            IF V < Drive.Box.Line THEN
                IF Current.Drive - (Drive.Box.Line - V) > 0 THEN
                    GOSUB ClearDrive
                    Current.Drive = Current.Drive - (Drive.Box.Line - V)
                    Drive.Box.Line = Drive.Box.Line - (Drive.Box.Line - V)
                    GOSUB DisplayDrive
                    Valid = True
                END IF
            END IF
            IF Valid THEN
                I$ = CHR$(13)
                IsMenu = 3
            END IF
            RETURN
        END IF
    END IF
    ' check mouse selection boundaries for file entry area.
    IF MouseX = Xcoor + 1 THEN
        IF MouseY >= Ycoor + 2 AND MouseY <= Ycoor + 39 THEN
            I$ = Nul
            IsMenu = 4
            RETURN
        END IF
    END IF
    ' check mouse selection boundaries for file box help.
    IF MouseX = Xcoor THEN
        IF MouseY = Ycoor + 39 THEN
            I$ = Nul
            CALL DisplayHelp
            GOSUB RedrawScreen
            RETURN
        END IF
    END IF
    ' check mouse selection boundaries for file box exit.
    IF MouseX = Xcoor THEN
        IF MouseY = Ycoor + 40 THEN
            I$ = Nul
            IsMenu = 5
            RETURN
        END IF
    END IF
    RETURN

    ' mouseover for file/dir/drive boxes.
    MouseOverX1:
    ' check mouse selection boundaries for file box.
    IF MouseX >= Xcoor + 5 AND MouseX <= Xcoor + 14 THEN
        IF MouseY >= Ycoor + 3 AND MouseY <= Ycoor + 14 THEN
            IF Num.Files > 0 THEN
                B1 = MouseX - (Xcoor + 4)
                IF B1 > Box.Line THEN
                    B2 = B1 - Box.Line
                    IF B2 <= Num.Files THEN
                        FOR B3 = 1 TO B2
                            IF Current.File! + 1 <= Num.Files THEN
                                IF Box.Line < 10 THEN
                                    GOSUB ClearFilename
                                    Box.Line = Box.Line + 1
                                    Current.File! = Current.File! + 1!
                                    GOSUB DisplayFilename5
                                    GOSUB DisplayLongName2
                                END IF
                            END IF
                        NEXT
                    END IF
                ELSE
                    IF B1 < Box.Line THEN
                        B2 = Box.Line - B1
                        IF B2 > 0 THEN
                            FOR B3 = 1 TO B2
                                IF Current.File! - 1 > 0 THEN
                                    IF Box.Line > 1 THEN
                                        GOSUB ClearFilename
                                        Box.Line = Box.Line - 1
                                        Current.File! = Current.File! - 1!
                                        GOSUB DisplayFilename5
                                        GOSUB DisplayLongName2
                                    END IF
                                END IF
                            NEXT
                        END IF
                    ELSE
                        IF B1 = Box.Line THEN
                            GOSUB ClearFilename
                            GOSUB DisplayFilename5
                            GOSUB DisplayLongName2
                        END IF
                    END IF
                END IF
            END IF
            RETURN
        END IF
    END IF
    ' check mouse selection boundaries for dir box.
    IF MouseX >= Xcoor + 5 AND MouseX <= Xcoor + 14 THEN
        IF MouseY >= Ycoor + 19 AND MouseY <= Ycoor + 31 THEN
            IF Num.Dirs > 0 THEN
                D1 = MouseX - (Xcoor + 4)
                IF D1 > Dir.Box.Line THEN
                    D2 = D1 - Dir.Box.Line
                    IF D2 > 0 THEN
                        IF D2 <= Num.Dirs THEN
                            FOR D3 = 1 TO D2
                                IF Current.Dir! + 1 <= Num.Dirs THEN
                                    IF Dir.Box.Line < 10 THEN
                                        GOSUB ClearDirectory
                                        Dir.Box.Line = Dir.Box.Line + 1
                                        Current.Dir! = Current.Dir! + 1!
                                        GOSUB DisplayDirectory
                                        Q$ = RTRIM$(Directories(Current.Dir!))
                                        GOSUB DisplayLongName1
                                    END IF
                                END IF
                            NEXT
                        END IF
                    END IF
                ELSE
                    IF D1 < Dir.Box.Line THEN
                        D2 = Dir.Box.Line - D1
                        IF D2 > 0 THEN
                            IF D2 <= Num.Dirs THEN
                                FOR D3 = 1 TO D2
                                    IF Current.Dir! - 1 > 0 THEN
                                        IF Dir.Box.Line > 1 THEN
                                            GOSUB ClearDirectory
                                            Dir.Box.Line = Dir.Box.Line - 1
                                            Current.Dir! = Current.Dir! - 1!
                                            GOSUB DisplayDirectory
                                            Q$ = RTRIM$(Directories(Current.Dir!))
                                            GOSUB DisplayLongName1
                                        END IF
                                    END IF
                                NEXT
                            END IF
                        END IF
                    ELSE
                        IF D1 = Dir.Box.Line THEN
                            GOSUB DisplayDirectory
                            Q$ = RTRIM$(Directories(Current.Dir!))
                            GOSUB DisplayLongName1
                        END IF
                    END IF
                END IF
            END IF
            RETURN
        END IF
    END IF
    ' check mouse selection boundaries for drive box.
    IF MouseX >= Xcoor + 5 AND MouseX <= Xcoor + 14 THEN
        IF MouseY >= Ycoor + 35 AND MouseY <= Ycoor + 37 THEN
            X0 = MouseX - (Xcoor + 4)
            IF X0 > Drive.Box.Line THEN
                X1 = Current.Drive + (X0 - Drive.Box.Line)
                IF X1 <= Last.Drive THEN
                    GOSUB ClearDrive
                    Current.Drive = Current.Drive + (X0 - Drive.Box.Line)
                    Drive.Box.Line = Drive.Box.Line + (X0 - Drive.Box.Line)
                    GOSUB DisplayDrive
                END IF
            ELSE
                IF X0 < Drive.Box.Line THEN
                    X1 = Current.Drive - (Drive.Box.Line - X0)
                    IF X1 > 0 THEN
                        GOSUB ClearDrive
                        Current.Drive = Current.Drive - (Drive.Box.Line - X0)
                        Drive.Box.Line = Drive.Box.Line - (Drive.Box.Line - X0)
                        GOSUB DisplayDrive
                    END IF
                ELSE
                    IF X0 = Drive.Box.Line THEN
                        GOSUB DisplayDrive
                    END IF
                END IF
            END IF
        END IF
    END IF
    RETURN

    ' redraws editing screen.
    RedrawScreen:
    Colorf2 White, BackGropund
    CLS
    CALL FileMainMenu
    GOSUB UpdateDisplay
    GOSUB DisplayCurrentPath
    IF Num.Files > 0 THEN
        GOSUB DisplayLongName2
    END IF
    GOSUB DisplayFilename6
    GOSUB DisplayFileLine
    RETURN
END SUB

REM Replacement stub subroutines:
REM  LseekFile()
REM  ReadFile()
REM  Writefile()
REM  LockedFile()
REM  LocateCursor()
REM  LocateCursor2()
REM  LocateHilightCursor()
REM  BytePrint()
REM  DisplayX()
REM  DisplayPosition()
REM  ClearStatus()
REM  DisplayFilename()
REM  DisplayFileTitle()
REM  DisplayPageByte()
REM  ResetHilightBytes()
REM  ResetBytes()
REM  RestoreHilightBytes()
REM  ResetByte()
REM  ClearPageByte()
REM  ClearHilightByte()
REM  DisplayHilightByte()
REM  DisplayStatus1()
REM  DisplayStatus2()
REM  DisplayStatusLine()
REM  DisplayHexPage()
REM  RedrawRightWindow()
REM  RedrawWindow1()
REM  RedrawWindow2()
REM  CheckASCIIValue(S$)
REM  CheckString(S$)
REM  CheckHexValue(S$)
REM  FormatPosition2(V%)
REM  AsciiToHex1(S$)
REM  AsciiToHex2(S$)
REM  CheckAsciiBytes(S$)
REM  CheckHexBytes(S$)
REM  GetShortFilename(S$)

REM position pointer in file.
SUB LseekFile
    SEEK Handle, SeekPosition
END SUB

REM read 1 byte from file.
SUB ReadFile
    GET Handle, SeekPosition, Buffer
END SUB

REM write 1 byte to file.
SUB WriteFile
    Share.Count = 0
    IF FileLocked THEN
        Write.Error = True
        EXIT SUB
    END IF
    Check.Disk = True
    Disk.Ready = False
    Write.Error = False
    Buffer = FileByte
    PUT Handle, SeekPosition, Buffer
    Check.Disk = False
    IF Disk.Ready THEN
        Write.Error = True
    END IF
END SUB

REM display file status message.
SUB LockedFile
    Colorf White
    IF FileLocked THEN
        IF FileLength = False THEN
            Printf "<locked file>"
        ELSE
            Printf "<read-only>"
        END IF
    ELSE
        Printf "<zero-byte>"
    END IF
    Locatef 1, 1, 0
END SUB

REM locate cursor on window.
SUB LocateCursor
    IF FileLength = False THEN
        Locatef 1, 1, 0
        EXIT SUB
    END IF
    IF CurrentWindow = False THEN
        Locatef PageRow + 3, Column + 5, 1
    ELSE
        Locatef PageRow + 3, PageColumn + 54, 1
    END IF
END SUB

REM select cursor on window.
SUB LocateCursor2
    IF CopyPositionStart = False THEN
        CALL LocateCursor
    ELSE
        CALL LocateHilightCursor
    END IF
END SUB

REM locate cursor on window for hilighted area.
SUB LocateHilightCursor
    IF FileLength = False THEN
        Locatef 1, 1, 0
        EXIT SUB
    END IF
    IF CurrentWindow = False THEN
        Locatef PageRow + 3, Column + 7, 1
    ELSE
        Locatef PageRow + 3, PageColumn + 55, 1
    END IF
END SUB

REM print byte at fileposition in edit area.
SUB BytePrint
    SeekPosition = FilePosition
    CALL LseekFile
    CALL ReadFile
    FileByte = Buffer
    ByteValue = ASC(FileByte)
    Column = CalculateColumn
    ' display hex byte.
    Locatef PageRow + 3, Column + 5, 0
    Printf RIGHT$("00" + HEX$(ByteValue), 2)
    ' check right window toggled.
    IF CurrentWindow2 = False THEN
        ' display ascii byte.
        Locatef PageRow + 3, PageColumn + 54, 0
        ' check unprintable
        IF CharPrint THEN
            _CONTROLCHR OFF
            Printf FileByte
            _CONTROLCHR ON
        ELSE
            ' skip unprintable characters.
            SELECT CASE ByteValue
                CASE 0, 7, 9 TO 13, 28 TO 32
                    Printf "."
                CASE ELSE
                    Printf FileByte
            END SELECT
        END IF
    END IF
END SUB

REM display info on file being edited.
SUB DisplayPosition
    Colorf2 Yellow, 0
    StringLength = LEN("Editing file:" + RTRIM$(Filename) + " ") + 5
    Locatef 2, StringLength, 0
    Printf SPACE$(77 - StringLength)
    Locatef 2, StringLength, 0
    IF FileLength = False THEN
        CALL LockedFile
        EXIT SUB
    END IF
    Colorf White
    IF CurrentWindow = False THEN
        Printf "Pos: " + FormatX$(FilePosition - 1, 0) + " "
    ELSE
        Printf "Pos: " + RIGHT$("000000000000" + HEX$(FilePosition - 1), 12) + "x "
    END IF
    Printf "(Asc:" + STR$(AsciiValue)

    ' display ascii control code description
    IF AsciiValue >= 0 AND AsciiValue <= 32 THEN
        Printf " :"
    END IF
    SELECT CASE AsciiValue
        CASE 0
            Printf "nul"
        CASE 1
            Printf "soh"
        CASE 2
            Printf "stx"
        CASE 3
            Printf "etx"
        CASE 4
            Printf "eot"
        CASE 5
            Printf "enq"
        CASE 6
            Printf "ack"
        CASE 7
            Printf "bel"
        CASE 8
            Printf "bs"
        CASE 9
            Printf "tab"
        CASE 10
            Printf "lf"
        CASE 11
            Printf "vt"
        CASE 12
            Printf "np"
        CASE 13
            Printf "cr"
        CASE 14
            Printf "so"
        CASE 15
            Printf "si"
        CASE 16
            Printf "dle"
        CASE 17
            Printf "dc1"
        CASE 18
            Printf "dc2"
        CASE 19
            Printf "dc3"
        CASE 20
            Printf "dc4"
        CASE 21
            Printf "nak"
        CASE 22
            Printf "syn"
        CASE 23
            Printf "etb"
        CASE 24
            Printf "can"
        CASE 25
            Printf "em"
        CASE 26
            Printf "eof"
        CASE 27
            Printf "esc"
        CASE 28
            Printf "fs"
        CASE 29
            Printf "gs"
        CASE 30
            Printf "rs"
        CASE 31
            Printf "us"
        CASE 32
            Printf "spc"
    END SELECT
    Printf ") "
    CALL LocateCursor2
END SUB

REM clear top status area
SUB ClearStatus
    Colorf2 Yellow, 0
    Locatef 2, 4, 0
    Printf SPACE$(74)
    Locatef 2, 4, 0
END SUB

REM display name of file being edited.
SUB DisplayFilename
    CALL DisplayX
    Colorf White
    IF FileLength = False THEN
        CALL LockedFile
        EXIT SUB
    END IF
    CALL DisplayPosition
END SUB

REM display 64-byte name of file being editied.
SUB DisplayFileTitle

    ' redisplay line 3.
    Locatef 3, 4, 0
    Colorf Green
    Printf CHR$(ULcorner) + STRING$(46, Hline) + CHR$(URcorner) + " "
    Printf CHR$(ULcorner) + STRING$(22, Hline) + CHR$(URcorner)

    ' display filename.
    N$ = RTRIM$(CurrentNetPath)
    Z$ = RTRIM$(ShortFilename)
    IF N$ <> Nul THEN
        IF MID$(Z$, 2, 1) = ":" THEN
            Z$ = MID$(Z$, 3)
        END IF
    END IF
    CALL Deconcatenate(N$, Z$, 64)
    Z$ = MID$(STR$(CurrentFile), 2) + ": " + Z$
    Var = INT((80 - (LEN(RTRIM$(Z$))) + 2) / 2) - 1
    Locatef 3, Var, 0
    Colorf2 0, 7
    Printf " " + Z$ + " "
    Colorf2 7, 0
    CALL LocateCursor2
END SUB

REM display current byte being edited.
SUB DisplayPageByte
    ' check filename display.
    IF FileDisplay2 THEN
        FileDisplay2 = False
        CALL DisplayX
        Colorf White
    END IF

    ' check filelength.
    IF FileLength = False THEN
        Locatef 1, 1, 0
        EXIT SUB
    END IF

    ' check hilighted bytes.
    IF CopyPositionStart > 0# THEN
        CALL ResetHilightBytes
    END IF

    ' display byte.
    Colorf Yellow
    CALL BytePrint

    ' store the current byte value being edited.
    AsciiValue = ASC(FileByte)
    CALL DisplayPosition
END SUB

REM reset hilight bytes.
SUB ResetHilightBytes
    CALL ResetBytes

    ' adjust file position.
    IF PageColumn + 1 <= 20 THEN
        IF FilePosition + 1 <= FileLength THEN
            CALL ClearPageByte
            PageColumn = PageColumn + 1
            FilePosition = FilePosition + 1
            CALL DisplayPageByte
        END IF
    END IF
    Colorf Yellow
    CALL BytePrint
END SUB

REM reset hilighted byte.
SUB ResetBytes
    Reset1 = True
    CALL ResetByte
    CopyPositionStart = False
    CopyPositionPivot = False
    CopyPositionEnd = False
    CopyStart = False
END SUB

REM restore hilighted bytes.
SUB RestoreHilightBytes
    CopyPositionStart = File(CurrentFile).CopyPositionStart
    CopyPositionPivot = File(CurrentFile).CopyPositionPivot
    CopyPositionEnd = File(CurrentFile).CopyPositionEnd
    FilePosition = File(CurrentFile).FilePosition
    Reset1 = False
    CALL ResetByte
END SUB

REM draw byte area.
SUB ResetByte
    Temp# = FilePosition
    Temp2# = FilePage
    Var1# = CopyPositionStart
    Var2# = CopyPositionEnd

    ' reset hilighted positions.
    IF Var1# < (Temp2# - 1) * 320 + 1 THEN
        Var1# = (Temp2# - 1) * 320 + 1
    END IF
    IF Var2# > (Temp2# - 1) * 320 + 320 THEN
        Var2# = (Temp2# - 1) * 320 + 320
    END IF
    IF Var2# > FileLength THEN
        Var2# = FileLength
    END IF

    ' draw the bytes.
    FOR FilePosition = Var1# TO Var2#
        CALL CalculatePosition1
        IF Reset1 THEN
            Colorf White
        ELSE
            Colorf2 0, 7
        END IF
        CALL BytePrint
    NEXT
    Colorf2 7, 0
    FilePosition = Temp#
    CALL CalculatePosition1
END SUB

REM clear current byte on screen.
SUB ClearPageByte
    IF FileLength = False THEN
        Locatef 1, 1, 0
        EXIT SUB
    END IF
    IF CopyPositionStart > 0# THEN
        CALL ResetHilightBytes
    END IF
    Colorf White
    CALL BytePrint
END SUB

REM clear current hilighted byte on screen.
SUB ClearHilightByte
    IF FileLength = False THEN
        Locatef 1, 1, 0
        EXIT SUB
    END IF
    Colorf White
    CALL BytePrint
END SUB

REM display current hilight byte being edited.
SUB DisplayHilightByte
    IF FileDisplay2 THEN
        FileDisplay2 = False
        CALL DisplayX
        Colorf White
    END IF

    ' display byte.
    IF FileLength = False THEN
        Locatef 1, 1, 0
        EXIT SUB
    END IF
    Colorf2 0, 7
    CALL BytePrint
    Colorf2 7, 0

    ' store the current byte value being edited.
    AsciiValue = ASC(FileByte)
    CALL DisplayPosition
END SUB

REM display status area.
SUB DisplayX
    CALL ClearStatus
    Printf "Editing file: " + RTRIM$(Filename) + " "
END SUB

REM display status line message and prompt type 1.
SUB DisplayStatus1
    StatusMessage = StatusMessage + " Press <esc>:"
    CALL DisplayStatusLine
END SUB

REM display status line message and prompt type 2.
SUB DisplayStatus2
    StatusMessage = StatusMessage + " Press <esc> to continue:"
    CALL DisplayStatusLine
END SUB

REM display the status line message and prompt for key or mouse click.
SUB DisplayStatusLine
    CALL ClearStatus
    Printf StatusMessage
    CALL LocateCursor2
    CALL PromptEscKey
    CALL DisplayFilename
END SUB

REM display screen of current page of hex/ascii values of file being edited.
SUB DisplayHexPage
    IF FileLength = False THEN
        Row = False
        Column = False
        FOR NextByte = 1 TO 320
            Locatef Row + 4, Column + 6, 0
            Printf "  "
            ColumnSpace = ColumnSpace + 1
            IF ColumnSpace = 4 THEN
                Printf " "
                Column = Column + 1
                ColumnSpace = False
            END IF
            Column = Column + 2
            IF Column > 44 THEN
                Row = Row + 1
                Column = False
            END IF
        NEXT
        CALL RedrawRightWindow
        Locatef 1, 1, 0
        EXIT SUB
    END IF
    Colorf White
    Row = False
    Column = False
    ColumnSpace = False
    FOR NextByte = (FilePage - 1) * 320 + 1 TO (FilePage - 1) * 320 + 320
        Locatef Row + 4, Column + 6, 0
        IF NextByte <= FileLength THEN
            SeekPosition = NextByte
            CALL LseekFile
            CALL ReadFile
            FileByte = Buffer
            Printf RIGHT$("00" + HEX$(ASC(FileByte)), 2)
        ELSE
            Printf "  "
        END IF
        ColumnSpace = ColumnSpace + 1
        IF ColumnSpace = 4 THEN
            Printf " "
            Column = Column + 1
            ColumnSpace = False
        END IF
        Column = Column + 2
        IF Column > 44 THEN
            Row = Row + 1
            Column = False
        END IF
    NEXT
    CALL RedrawRightWindow
END SUB

REM redraw right window.
SUB RedrawRightWindow
    IF CurrentWindow2 = False THEN
        CALL RedrawWindow1
    ELSE
        CALL RedrawWindow2
    END IF
END SUB

REM redraw right window of ascii values.
SUB RedrawWindow1
    IF FileLength = False THEN
        Colorf White
        Row = False
        Column = False
        FOR NextByte = 1 TO 320
            Locatef Row + 4, Column + 55, 0
            Printf " "
            Column = Column + 1
            IF Column > 19 THEN
                Row = Row + 1
                Column = False
            END IF
        NEXT
        Locatef 1, 1, 0
        EXIT SUB
    END IF
    Row = False
    Column = False
    Colorf White
    FOR NextLine = 0 TO 15
        Locatef NextLine + 4, 54, 0
        Printf " "
    NEXT
    FOR NextByte = (FilePage - 1) * 320 + 1 TO (FilePage - 1) * 320 + 320
        Locatef Row + 4, Column + 55, 0
        IF NextByte <= FileLength THEN
            SeekPosition = NextByte
            CALL LseekFile
            CALL ReadFile
            FileByte = Buffer
            ByteValue = ASC(FileByte)
            ' check unprintable
            IF CharPrint THEN
                _CONTROLCHR OFF
                Printf FileByte
                _CONTROLCHR ON
            ELSE
                ' skip unprintable characters
                SELECT CASE ByteValue
                    CASE 0, 7, 9 TO 13, 28 TO 32
                        Printf "."
                    CASE ELSE
                        Printf FileByte
                END SELECT
            END IF
        ELSE
            Printf " "
        END IF
        Column = Column + 1
        IF Column > 19 THEN
            Row = Row + 1
            Column = False
        END IF
    NEXT
END SUB

REM redraw right window of hex ranges.
SUB RedrawWindow2
    Row = False
    FOR NextLine = (FilePage - 1) * 320 + 1 TO (FilePage - 1) * 320 + 320 STEP 20
        Locatef Row + 4, 54, 0
        Row = Row + 1
        IF NextLine <= FileLength THEN
            IF NextLine + 19 <= FileLength THEN
                Colorf White
                Printf "x" + RIGHT$("00000000" + HEX$(NextLine - 1), 8)
                Colorf Yellow
                Printf " - "
                Colorf White
                Printf "x" + RIGHT$("00000000" + HEX$(NextLine + 19 - 1), 8)
            ELSE
                Colorf White
                Printf "x" + RIGHT$("00000000" + HEX$(NextLine - 1), 8)
                Colorf Yellow
                Printf " - "
                Colorf White
                Printf "x" + RIGHT$("00000000" + HEX$(FileLength - 1), 8)
            END IF
        ELSE
            Printf SPACE$(22)
        END IF
    NEXT
END SUB

REM check valid ascii value
SUB CheckASCIIValue (ByteString$)
    ValidASCIIValue = False
    ASCIIValue3 = VAL(ByteString$)
    IF ASCIIValue3 <= 0# OR ASCIIValue3 > 2147483647# THEN
        StatusMessage = "Invalid ascii value."
        CALL DisplayStatus2
        EXIT SUB
    END IF
    ValidASCIIValue = True
END SUB

REM check hex byte string.
SUB CheckString (ByteString$)
    ValidString = True
    FOR HexPosition = 2 TO LEN(ByteString$)
        SELECT CASE UCASE$(MID$(ByteString$, HexPosition, 1))
            CASE "0" TO "9", "A" TO "F"
                ' nul activity
            CASE ELSE
                ValidString = False
                EXIT SUB
        END SELECT
    NEXT
END SUB

REM check hex byte value.
REM input:
REM   ByteString$ is packed hex string.
REM output:
REM   returns ValidHexValue True for valid hex value.
REM   returns HexValue contains value of hex string.
REM parameters:
REM   Hex string must be 8 characters or less.
REM   Hex value from 8000 to ffff return signed bit
REM     and must be incremented by 65536.
REM   Since 7fff ffff is max filesize,
REM     hex values from 8000 0000 to ffff ffff
REM     which are length 8 return negative value.
REM   Since hex values start from an offset of 0
REM     then the maximum value allowed is 7fff fffe.
SUB CheckHexValue (ByteString$)
    ValidHexValue = False
    StringLength2 = LEN(MID$(ByteString$, 2))
    IF StringLength2 > 8 THEN
        StatusMessage = "Invalid hex value."
        CALL DisplayStatus2
        EXIT SUB
    END IF
    CALL CheckString(ByteString$)
    IF ValidString = False THEN
        StatusMessage = "Invalid hex string."
        CALL DisplayStatus2
        EXIT SUB
    END IF
    ByteString$ = MID$(ByteString$, 2)
    DO
        IF LEFT$(ByteString$, 1) = "0" THEN
            ByteString$ = MID$(ByteString$, 2)
        ELSE
            EXIT DO
        END IF
    LOOP
    StringLength2 = LEN(ByteString$)
    ByteString$ = "&H" + ByteString$
    HexValue = VAL(ByteString$)
    ' check signed bit error.
    IF StringLength2 = 4 THEN
        IF HexValue < 0 THEN
            HexValue = HexValue + 65536#
        END IF
    END IF
    IF StringLength2 = 8 THEN
        IF HexValue < 0 THEN
            StatusMessage = "Hex underflow."
            CALL DisplayStatus2
            EXIT SUB
        END IF
    END IF
    IF HexValue >= 2147483647# THEN
        StatusMessage = "Hex overflow."
        CALL DisplayStatus2
        EXIT SUB
    END IF
    ValidHexValue = True
    ' adjust hex offset.
    HexValue = HexValue + 1#
END SUB

REM check ascii byte string.
REM   input: ByteString$ is space-separated 3-byte ascii pair string.
REM   returns: ValidByteString equals true if string is valid,
REM     NumBytes is number of ascii byte pairs,
REM     ByteString$ is concatenated hex byte string.
SUB CheckAsciiBytes (ByteString$)
    AsciiByte$ = Nul
    ByteString$ = LTRIM$(ByteString$)
    ByteString$ = RTRIM$(ByteString$)
    IF LEN(ByteString$) = False THEN
        ValidByteString = False
        EXIT SUB
    END IF
    NumBytes = 1
    ValidByteString = True
    FOR StringPosition = 1 TO LEN(ByteString$)
        Byte$ = MID$(ByteString$, StringPosition, 1)
        IF (StringPosition MOD 4) = False THEN
            IF Byte$ <> " " THEN
                ValidByteString = False
                EXIT SUB
            END IF
            NumBytes = NumBytes + 1
        ELSE
            SELECT CASE Byte$
                CASE "0" TO "9"
                    AsciiByte$ = AsciiByte$ + Byte$
                    IF LEN(AsciiByte$) = 3 THEN
                        ByteValue = VAL(AsciiByte$)
                        IF ByteValue >= False AND ByteValue <= 255 THEN
                            AsciiByte$ = Nul
                        ELSE
                            ValidByteString = False
                            EXIT SUB
                        END IF
                    END IF
                CASE ELSE
                    ValidByteString = False
                    EXIT SUB
            END SELECT
        END IF
    NEXT
    Var1$ = ByteString$
    DO
        Parse = INSTR(Var1$, " ")
        IF Parse THEN
            Var1$ = LEFT$(Var1$, Parse - 1) + MID$(Var1$, Parse + 1)
        ELSE
            EXIT DO
        END IF
    LOOP
    ByteString$ = Var1$
    CALL AsciiToHex1(ByteString$)
END SUB

REM check hex byte string.
REM   input: AllowWildcard true to allow ? character.
REM     ByteString$ is space-separated hex byte pair string.
REM   returns: ValidByteString equals true if string is valid,
REM     NumBytes is number of hex byte pairs,
REM     ByteString$ is concatenated hex byte string.
SUB CheckHexBytes (ByteString$)
    ByteString$ = LTRIM$(ByteString$)
    ByteString$ = RTRIM$(ByteString$)
    IF LEN(ByteString$) = False THEN
        ValidByteString = False
        EXIT SUB
    END IF
    NumBytes = 1
    ValidByteString = True
    FOR StringPosition = 1 TO LEN(ByteString$)
        Byte$ = MID$(ByteString$, StringPosition, 1)
        IF (StringPosition MOD 3) = False THEN
            IF Byte$ <> " " THEN
                ValidByteString = False
                EXIT SUB
            END IF
            NumBytes = NumBytes + 1
        ELSE
            SELECT CASE Byte$
                CASE "0" TO "9", "A" TO "F", "a" TO "f", "?"
                    IF Byte$ = "?" THEN
                        IF AllowWildCard = False THEN
                            ValidByteString = False
                            EXIT SUB
                        END IF
                    END IF
                    MID$(ByteString$, StringPosition, 1) = UCASE$(Byte$)
                CASE ELSE
                    ValidByteString = False
                    EXIT SUB
            END SELECT
        END IF
    NEXT
    Var1$ = ByteString$
    DO
        Parse = INSTR(Var1$, " ")
        IF Parse THEN
            Var1$ = LEFT$(Var1$, Parse - 1) + MID$(Var1$, Parse + 1)
        ELSE
            EXIT DO
        END IF
    LOOP
    ByteString$ = Var1$
END SUB

REM convert a 3-digit packed ascii string to a hex string.
SUB AsciiToHex1 (ByteString$)
    Byte$ = Nul
    NewString$ = Nul
    FOR StringPosition = 1 TO LEN(ByteString$)
        Byte$ = Byte$ + MID$(ByteString$, StringPosition, 1)
        IF LEN(Byte$) = 3 THEN
            NewString$ = NewString$ + RIGHT$("00" + HEX$(VAL(Byte$)), 2)
            Byte$ = Nul
        END IF
    NEXT
    ByteString$ = NewString$
END SUB

REM convert a 1-digit packed ascii string to a hex string.
SUB AsciiToHex2 (ByteString$)
    Byte$ = Nul
    NewString$ = Nul
    FOR StringPosition = 1 TO LEN(ByteString$)
        Byte$ = MID$(ByteString$, StringPosition, 1)
        NewString$ = NewString$ + RIGHT$("00" + HEX$(ASC(Byte$)), 2)
    NEXT
    ByteString$ = NewString$
END SUB

REM display cell position in string format.
SUB FormatPosition2 (Var)
    IF Var = 1 THEN
        Printf "Marker#" + MID$(STR$(MarkerPosition), 2) + ":"
    ELSE
        Printf "Marker#" + MID$(STR$(MarkerPosition), 2) + " Position:"
    END IF
    TempPosition3 = Markers#(MarkerPosition)
    IF CurrentWindow = False THEN
        Printf MID$(STR$(TempPosition3 - 1), 2) + " "
    ELSE
        Printf RIGHT$("00000000" + HEX$(TempPosition3 - 1), 8) + "x "
    END IF
    CALL CalculatePosition2
    IF CurrentWindow = False THEN
        Printf "(page: " + FormatX$(CDBL(FilePage2 - 1), 1) + ","
    ELSE
        Printf "(page:" + RIGHT$("00000000" + HEX$(FilePage2 - 1), 8) + "x,"
    END IF
    Printf "row:" + MID$(STR$(PageRow2), 2) + ","
    Printf "column:" + MID$(STR$(PageColumn2), 2) + ")"
    IF Var = 1 THEN
        Printf " Press <esc>:"
    END IF
END SUB

REM returns ambiguated filename.
SUB GetShortFilename (Short.Filename$)
    ret = GetShortPathName(ASCIIZ, ASCIIZ2, MAX_PATH + 1)
    IF ret > 0 THEN
        Short.Filename$ = ASCIIZ2
    ELSE
        Short.Filename$ = ASCIIZ
    END IF
    Imbedded = INSTR(Short.Filename$, CHR$(0))
    IF Imbedded THEN
        Short.Filename$ = LEFT$(Short.Filename$, Imbedded - 1)
    END IF
END SUB

REM processes mouse activity.
FUNCTION MouseDriver
    STATIC X1 AS INTEGER, Y1 AS INTEGER ' store old values
    MouseX = 0: MouseY = 0
    IF _MOUSEINPUT THEN
        X = CINT(_MOUSEX): Y = CINT(_MOUSEY) ' X,Y return single
        IF X <> X1 OR Y <> Y1 THEN
            X1 = X: Y1 = Y
            MouseX = Y: MouseY = X ' X,Y are reversed
            WHILE _MOUSEINPUT: WEND ' empty buffer
        END IF
        MouseButton1 = _MOUSEBUTTON(1)
        IF MouseButton1 THEN
            MouseX = Y1
            MouseY = X1
        END IF
        MouseButton2 = _MOUSEBUTTON(2)
        IF MouseButton2 THEN
            MouseX = Y1
            MouseY = X1
        END IF
        MouseButton3 = _MOUSEBUTTON(3)
        MouseWheel = _MOUSEWHEEL
    END IF
END FUNCTION

REM Functions:
REM   Conanicalize         --  trims a filename.
REM   CalculateColumn      --  calculate column groups.
REM   CalculateColumn2     --  calculate column groups.
REM   CalculatePosition3#  --  calculate mouse position.
REM   DumpLineRange$       --  format line range.
REM   Directories          --  get a directory from temp data file.
REM   Filenames            --  get a filename from temp data file.
REM   UndoByte             --  get an undo byte from temp data file.
REM   UndoPosition         --  get an undo position from temp data file.
REM   Markers              --  get a marker value from temp data file.

REM conanicalizes filename.
FUNCTION Conanicalize$ (Var$)
    Var1$ = Var$

    ' strip drive letter.
    Var1$ = UCASE$(Var1$)
    IF MID$(Var1$, 2, 1) = ":" THEN
        Var1$ = MID$(Var1$, 3)
    END IF

    ' strip dos path.
    DO
        Path = INSTR(Var1$, "\")
        IF Path THEN
            Var1$ = MID$(Var1$, Path + 1)
        ELSE
            EXIT DO
        END IF
    LOOP
    Conanicalize$ = Var1$
END FUNCTION

REM function to calculate column groups.
FUNCTION CalculateColumn
    SELECT CASE PageColumn
        CASE 1 TO 4
            CalculateColumn = (PageColumn - 1) * 2 + 1
        CASE 5 TO 8
            CalculateColumn = (PageColumn - 1) * 2 + 2
        CASE 9 TO 12
            CalculateColumn = (PageColumn - 1) * 2 + 3
        CASE 13 TO 16
            CalculateColumn = (PageColumn - 1) * 2 + 4
        CASE 17 TO 20
            CalculateColumn = (PageColumn - 1) * 2 + 5
    END SELECT
END FUNCTION

REM function to calculate column groups.
FUNCTION CalculateColumn2
    SELECT CASE PageColumn2
        CASE 1 TO 4
            CalculateColumn2 = (PageColumn2 - 1) * 2 + 1
        CASE 5 TO 8
            CalculateColumn2 = (PageColumn2 - 1) * 2 + 2
        CASE 9 TO 12
            CalculateColumn2 = (PageColumn2 - 1) * 2 + 3
        CASE 13 TO 16
            CalculateColumn2 = (PageColumn2 - 1) * 2 + 4
        CASE 17 TO 20
            CalculateColumn2 = (PageColumn2 - 1) * 2 + 5
    END SELECT
END FUNCTION

REM function to calculate mouse position.
FUNCTION CalculatePosition3#
    Var1# = (FilePage - 1) * 320 + (MouseX - 4) * 20
    SELECT CASE MouseY
        CASE 6, 7
            Var1# = Var1# + 1#
        CASE 8, 9
            Var1# = Var1# + 2#
        CASE 10, 11
            Var1# = Var1# + 3#
        CASE 12, 13
            Var1# = Var1# + 4#
        CASE 15, 16
            Var1# = Var1# + 5#
        CASE 17, 18
            Var1# = Var1# + 6#
        CASE 19, 20
            Var1# = Var1# + 7#
        CASE 21, 22
            Var1# = Var1# + 8#
        CASE 24, 25
            Var1# = Var1# + 9#
        CASE 26, 27
            Var1# = Var1# + 10#
        CASE 28, 29
            Var1# = Var1# + 11#
        CASE 30, 31
            Var1# = Var1# + 12#
        CASE 33, 34
            Var1# = Var1# + 13#
        CASE 35, 36
            Var1# = Var1# + 14#
        CASE 37, 38
            Var1# = Var1# + 15#
        CASE 39, 40
            Var1# = Var1# + 16#
        CASE 42, 43
            Var1# = Var1# + 17#
        CASE 44, 45
            Var1# = Var1# + 18#
        CASE 46, 47
            Var1# = Var1# + 19#
        CASE 48, 49
            Var1# = Var1# + 20#
    END SELECT
    CalculatePosition3# = Var1#
END FUNCTION

REM function to format line range.
FUNCTION DumpLineRange$
    Var$ = "File: " + RTRIM$(Filename) + " Bytes: "
    Var$ = Var$ + FormatX$(FirstByte, 1) + "-"
    IF LastByte <= FileLength THEN
        Var$ = Var$ + FormatX$(LastByte, 1)
    ELSE
        Var$ = Var$ + FormatX$(FileLength, 1)
    END IF
    Var$ = Var$ + " (x" + RIGHT$("000000000000" + HEX$(FirstByte - 1), 12) + "-x"
    IF LastByte <= FileLength THEN
        Var$ = Var$ + RIGHT$("000000000000" + HEX$(LastByte - 1), 12)
    ELSE
        Var$ = Var$ + RIGHT$("000000000000" + HEX$(FileLength - 1), 12)
    END IF
    Var$ = Var$ + ")."
    DumpLineRange$ = Var$
END FUNCTION

' unambiguate filename
FUNCTION UnAmbiguateFile$ (Var$)
    DIM finddata2 AS WIN32_FIND_DATA
    DIM hfind2 AS _UNSIGNED _OFFSET
    DIM TempASCIIZ AS STRING * 260
    File$ = Var$
    TempASCIIZ = Var$ + CHR$(0)
    hfind2 = FindFirstFileA(_OFFSET(TempASCIIZ), _OFFSET(finddata2))
    IF hfind2 <> INVALID_HANDLE_VALUE THEN
        File$ = finddata2.cFileName
        V = INSTR(File$, CHR$(0))
        IF V THEN File$ = LEFT$(File$, V - 1)
        x = FindClose(hfind2)
    END IF
    UnAmbiguateFile$ = File$
END FUNCTION

REM filename structure function.
FUNCTION Filenames$ (Var1!)
    IF Var1! > 0! THEN
        GET #2, Var1!, WinFileStruc
        Filenames$ = WinFileStruc.Name
    ELSE
        Filenames$ = Nul
    END IF
END FUNCTION

REM directory structure function.
FUNCTION Directories$ (Var1!)
    IF Num.Dirs = 0! THEN
        Directories$ = "."
        EXIT FUNCTION
    END IF
    IF Var1! > 0! THEN
        GET #3, Var1!, WinFileStruc
        Directories$ = WinFileStruc.Name
    ELSE
        Directories$ = Nul
    END IF
END FUNCTION

REM undo structure function.
FUNCTION UndoByte% (Var1!)
    GET #6, Var1!, UndoFile
    UndoByte% = CVI(MID$(UndoFile.UndoByte1, (CurrentFile - 1) * 2 + 1, 2))
END FUNCTION

REM undo structure function.
FUNCTION UndoPosition# (Var1!)
    GET #6, Var1!, UndoFile
    UndoPosition# = CVD(MID$(UndoFile.UndoPosition1, (CurrentFile - 1) * 8 + 1, 8))
END FUNCTION

REM marker structure function.
FUNCTION Markers# (Var1!)
    GET #7, Var1!, MarkerFile
    Markers# = CVD(MID$(MarkerFile.Markers1, (CurrentFile - 1) * 8 + 1, 8))
END FUNCTION

REM Functions:
REM   MakeFilename?$  --  constructs filename for file menu box.

FUNCTION MakeFilename$ (N$, C$, D$, X$)
    IF N$ = Nul THEN
        IF D$ = Nul THEN
            MakeFilename$ = C$ + ":\" + X$
        ELSE
            MakeFilename$ = C$ + ":\" + D$ + "\" + X$
        END IF
    ELSE
        IF D$ = Nul THEN
            MakeFilename$ = N$ + "\" + X$
        ELSE
            MakeFilename$ = N$ + "\" + D$ + "\" + X$
        END IF
    END IF
END FUNCTION

FUNCTION MakeFilename2$ (N$, C$, D$)
    IF N$ = Nul THEN
        IF D$ = Nul THEN
            MakeFilename2$ = C$ + ":\"
        ELSE
            IF D$ = "\" THEN
                MakeFilename2$ = C$ + ":\"
            ELSE
                MakeFilename2$ = C$ + ":\" + D$
            END IF
        END IF
    ELSE
        IF D$ = Nul THEN
            MakeFilename2$ = N$ + "\"
        ELSE
            IF D$ = "\" THEN
                MakeFilename2$ = N$ + "\"
            ELSE
                MakeFilename2$ = N$ + "\" + D$
            END IF
        END IF
    END IF
END FUNCTION

FUNCTION MakeFilename3$ (N$, C$, D$)
    IF N$ = Nul THEN
        IF D$ = Nul THEN
            MakeFilename3$ = C$ + ":\*.*"
        ELSE
            IF D$ = "\" THEN
                MakeFilename3$ = C$ + ":\*.*"
            ELSE
                MakeFilename3$ = C$ + ":\" + D$ + "\*.*"
            END IF
        END IF
    ELSE
        IF D$ = Nul THEN
            MakeFilename3$ = N$ + "\*.*"
        ELSE
            IF D$ = "\" THEN
                MakeFilename3$ = N$ + "\*.*"
            ELSE
                MakeFilename3$ = N$ + "\" + D$ + "\*.*"
            END IF
        END IF
    END IF
END FUNCTION

FUNCTION MakeFilename4$ (N$, C$, D$)
    IF N$ = Nul THEN
        MakeFilename4$ = C$ + ":\" + D$
    ELSE
        IF D$ = "\" THEN
            MakeFilename4$ = N$ + "\"
        ELSE
            MakeFilename4$ = N$ + "\" + D$
        END IF
    END IF
END FUNCTION

REM Subroutines:
REM   PressKey()        --  prompts for key press.
REM   PromptInkey()     --  prompts for escape key.
REM   PromptKey()       --  prompts for any key or left mouse click.
REM   PromptEscKey      --  prompts for escape key or left mouse click.

REM prompts for key press.
SUB PressKey
    Colorf White
    Printf "Press a key:"
    DO
        _LIMIT 100
        IF INKEY$ <> "" THEN
            EXIT DO
        END IF
    LOOP
END SUB

' prompt for escape key.
SUB PromptInkey
    Z$ = Nul
    DO
        _LIMIT 100
        Z$ = INKEY$
        ' escape
        IF Z$ = CHR$(27) THEN
            EXIT DO
        END IF
    LOOP
END SUB

REM prompts for any key or left mouse click.
SUB PromptKey
    DO
        _LIMIT 100
        IF INKEY$ <> Nul THEN
            EXIT DO
        END IF

        ' call mouse subroutine.
        Z = MouseDriver

        ' check left mouse button.
        IF MouseButton1 THEN
            EXIT DO
        END IF
    LOOP
END SUB

REM prompts for escape key or left mouse click.
SUB PromptEscKey
    I$ = Nul
    DO
        _LIMIT 100
        I$ = INKEY$
        IF LEN(I$) THEN
            ' check escape key pressed.
            IF I$ = CHR$(27) THEN
                EXIT DO
            END IF
        END IF

        ' call mouse subroutine.
        Z = MouseDriver

        ' check left mouse button.
        IF MouseButton1 THEN
            EXIT DO
        END IF
    LOOP
END SUB

REM Subroutines:
REM   GetFileLength(V%) --  get filelength from handle.
REM   GetFileAttr(Var$) --  get file attributes.
REM   GetDrives()       --  get default drives.
REM   InstrSub(V%,V1$,V2$)  --  match substrings.

REM read filelength from handle.
SUB GetFileLength (Var)
    FileLength = 0
    IF Var > 0 THEN
        FileLength = LOF(Var)
    END IF
END SUB

REM get file attributes.
FUNCTION GetFileAttr (Var$)
    Var = GetFileAttributes(ASCIIZ)
    IF Var < 0 THEN
        Var = 0
    END IF
    GetFileAttr = Var
END FUNCTION

REM get default drives.
SUB GetDrives
    ' get current drive.
    Default.Drive = ASC(LEFT$(_CWD$, 1)) - 65 ' 0=a, 1=b,..

    ' set maximum drive.
    Last.Drive = 26
END SUB

' function to match substring with ?, * characters in substring.
SUB InstrSUB (Var, Var1$, Var2$)

    ' store string match variables
    S2$ = UCASE$(Var2$)
    S3$ = UCASE$(Var1$)

    ' check default instr
    IF INSTR(S2$, "*") = 0 THEN
        IF INSTR(S2$, "?") = 0 THEN
            Var = INSTR(S3$, S2$)
            EXIT SUB
        END IF
    END IF

    Var = -1 ' assume match

    ' see if S2$ matches in S3$ with substrings
    FOR S3 = 1 TO LEN(S3$)
        S1$ = MID$(S3$, S3)
        P1 = 1 ' pointer to S1$
        P2 = 1 ' pointer to S2$
        DO
            ' check token beyond string
            IF P2 >= LEN(S2$) THEN
                EXIT SUB
            END IF

            ' check character in S2$ at P2
            V$ = MID$(S2$, P2, 1)
            SELECT CASE V$
                CASE "*" ' global character
                    ' scan to next char
                    IF P2 >= LEN(S2$) THEN
                        EXIT DO
                    END IF
                    S4$ = MID$(S2$, P2 + 1, 1)
                    SELECT CASE S4$
                        CASE "*", "?" ' imbedded
                            P2 = P2 + 1
                        CASE ELSE
                            DO
                                IF MID$(S1$, P1, 1) = S4$ THEN
                                    EXIT DO
                                END IF
                                IF P1 >= LEN(S1$) THEN
                                    EXIT DO
                                END IF
                                P1 = P1 + 1
                            LOOP
                            P2 = P2 + 1
                    END SELECT
                CASE "?" ' wildcard character
                    P1 = P1 + 1
                    P2 = P2 + 1
                CASE ELSE ' ascii character
                    IF MID$(S1$, P1, 1) <> V$ THEN ' no match
                        EXIT DO
                    END IF
                    P1 = P1 + 1
                    P2 = P2 + 1
            END SELECT
        LOOP
    NEXT
    Var = 0 ' no match
    EXIT SUB
END SUB

REM File/Structure pack subroutines.
REM   Pack.Files1  -  Pack paste undo files w/debug.
REM   Pack.Arrays1  -  Pack byte undo file arrays.
REM   Pack.Arrays2  -  Pack marker file array.

' pack paste undo files.
'   kills current paste undo file.
SUB Pack.Files1
    IF Debug3 THEN
        CLS
    END IF
    CLOSE #4
    CLOSE #5
    V1$ = RTRIM$(MultiFilenames(CurrentFile))
    IF LEN(V1$) THEN
        IF _FILEEXISTS(V1$) THEN
            G$ = V1$ + CHR$(0)
            x = DeleteFileA(G$)
            IF Debug3 THEN
                Colorf White
                PRINT "Killed: " + V1$
            END IF
        END IF
    END IF
    FOR Var = CurrentFile TO MaxFiles - 1
        V1$ = RTRIM$(MultiFilenames(Var))
        V2$ = RTRIM$(MultiFilenames(Var + 1))
        IF LEN(V2$) = 0 THEN
            EXIT FOR
        END IF
        IF _FILEEXISTS(V2$) = 0 THEN
            EXIT FOR
        END IF
        IF LEN(V1$) THEN
            NAME V2$ AS V1$
            IF Debug3 THEN
                Colorf Yellow
                PRINT "Renamed: " + V2$ + " AS " + V1$
            END IF
        END IF
    NEXT
    IF Debug3 THEN
        Colorf White
        PRINT "Press a key:";
        WHILE INKEY$ = Nul
            _LIMIT 100
        WEND
        CLS
        PRINT "Press Alt-R to redraw screen"
    END IF
END SUB

' pack byte undo file.
SUB Pack.Arrays1
    FOR Tmp1! = 1! TO LOF(6) / LEN(UndoFile)
        GET #6, Tmp1!, UndoFile
        FOR Var = CurrentFile TO MaxFiles - 1
            TempM = CVI(MID$(UndoFile.UndoByte1, Var * 2 + 1, 2))
            MID$(UndoFile.UndoByte1, (Var - 1) * 2 + 1, 2) = MKI$(TempM)
            TempM# = CVD(MID$(UndoFile.UndoPosition1, Var * 8 + 1, 8))
            MID$(UndoFile.UndoPosition1, (Var - 1) * 8 + 1, 8) = MKD$(TempM#)
        NEXT
        MID$(UndoFile.UndoByte1, (MaxFiles - 1) * 2 + 1, 2) = MKI$(0%)
        MID$(UndoFile.UndoPosition1, (MaxFiles - 1) * 8 + 1, 8) = MKD$(0#)
        PUT #6, Tmp1!, UndoFile
    NEXT
END SUB

' pack marker file.
SUB Pack.Arrays2
    FOR Tmp1! = 1! TO LOF(7) / LEN(MarkerFile)
        GET #7, Tmp1!, MarkerFile
        FOR Var = CurrentFile TO MaxFiles - 1
            TempM# = CVD(MID$(MarkerFile.Markers1, Var * 8 + 1, 8))
            MID$(MarkerFile.Markers1, (Var - 1) * 8 + 1, 8) = MKD$(TempM#)
        NEXT
        MID$(MarkerFile.Markers1, (MaxFiles - 1) * 8 + 1, 8) = MKD$(0#)
        PUT #7, Tmp1!, MarkerFile
    NEXT
END SUB

